C     utnumb.f 2.1 9/4/91
C
C
C
      SUBROUTINE   CHKINT
     I                    (IMIN,IMAX,IDEF,
     M                     IVAL,
     O                     ICHK)
C
C     + + + PURPOSE + + +
C     Check the integer IVAL against the minimum (IMIN)
C     and maximum (IMAX) values.  IVAL is set to the
C     default (IDEF) if IVAL is zero.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   ICHK,IMIN,IMAX,IDEF,IVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IMIN   - minimum allowable value, -999 if there is no minimum
C     IMAX   - maximum allowable value, -999 if there is no maximum
C     IDEF   - default value, or -999 if there is no default
C     IVAL   - value to be checked
C     ICHK   - indicator flag for valid IVAL
C              0 - invalid IVAL
C              1 - valid IVAL
C
C     + + + END SPECIFICATIONS + + +
C
      ICHK = 0
      IF (IVAL.EQ.0) IVAL = IDEF
      IF (IVAL.GE.IMIN.AND.IVAL.LE.IMAX) ICHK = 1
      IF (IVAL.GE.IMIN.AND.IMAX.EQ.-999) ICHK = 1
      IF (IMIN.EQ.-999.AND.IVAL.LE.IMAX) ICHK = 1
      IF (IMIN.EQ.-999.AND.IMAX.EQ.-999) ICHK = 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHKREA
     I                    (RMIN,RMAX,RDEF,
     M                     RVAL,
     O                     RCHK)
C
C     + + + PURPOSE + + +
C     Check the real RVAL against the minimum (RMIN)
C     and maximum (RMAX) values.  RVAL is set to the
C     default (RDEF) if RVAL is zero.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   RCHK
      REAL      RMIN,RMAX,RDEF,RVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RMIN   - minimum allowable value, -999. if there is no minimum
C     RMAX   - maximum allowable value, -999. if there is no maximum
C     RDEF   - default value, or -999. if there is no default
C     RVAL   - value to be checked
C     RCHK   - indicator flag for valid RVAL
C              0 - invalid RVAL
C              1 - valid RVAL
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MINCHK,MAXCHK
      REAL      FACT
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   NUMINI
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init maching dependent numeric constants (CONST.INC)
      CALL NUMINI
C
      RCHK= 0
Chnb      FACT= 0.999
      FACT= RP1MIN
Chnb      IF (ABS(RVAL).LT.1.0E-20)  RVAL= RDEF
      IF (ABS(RVAL).LE.R0MIN)  RVAL= RDEF
C
      MINCHK= 0
Chnb      IF      ((ABS(RMIN+999.).LT.0.01)
Chnb     1  .OR.  ((RVAL.GE.0.0) .AND. (RVAL.GE.RMIN*FACT))
Chnb     2  .OR.  ((RVAL.LT.0.0) .AND. (RVAL.GT.RMIN/FACT)))
Chnb     3        MINCHK= 1
      IF      ((ABS(RMIN+999.0).LT.(RP1MIN - 1.0))
     1  .OR.  ((RVAL.GE.0.0) .AND. (RVAL.GE.RMIN/FACT))
     2  .OR.  ((RVAL.LT.0.0) .AND. (RVAL.GT.RMIN*FACT)))
     3        MINCHK= 1
C
      MAXCHK= 0
Chnb      IF      ((ABS(RMAX+999.).LT.0.01)
Chnb     1  .OR.  ((RVAL.GE.0.0) .AND. (RVAL.LE.RMAX/FACT))
Chnb     2  .OR.  ((RVAL.LT.0.0) .AND. (RVAL.LT.RMAX/FACT)))
Chnb     3        MAXCHK= 1
      IF      ((ABS(RMAX+999.0).LT.(RP1MIN - 1.0))
     1  .OR.  ((RVAL.GE.0.0) .AND. (RVAL.LE.RMAX*FACT))
     2  .OR.  ((RVAL.LT.0.0) .AND. (RVAL.LT.RMAX/FACT)))
     3        MAXCHK= 1
C
      IF (MINCHK.EQ.1 .AND. MAXCHK.EQ.1)  RCHK= 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHKDPR
     I                    (DMIN,DMAX,DDEF,
     M                     DVAL,
     O                     DCHK)
C
C     + + + PURPOSE + + +
C     Check the double precision DVAL against the minimum (DMIN)
C     and maximum (DMAX) values.  DVAL is set to the
C     default (DDEF) if DVAL is zero.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER          DCHK
      DOUBLE PRECISION DMIN,DMAX,DDEF,DVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DMIN   - minimum allowable value, -999. if there is no minimum
C     DMAX   - maximum allowable value, -999. if there is no maximum
C     DDEF   - default value, or -999. if there is no default
C     DVAL   - value to be checked
C     DCHK   - indicator flag for valid DVAL
C              0 - invalid DVAL
C              1 - valid DVAL
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MINCHK,MAXCHK
      REAL      FACT
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   NUMINI
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init maching dependent numeric constants (CONST.INC)
      CALL NUMINI
C
      DCHK= 0
Chnb      FACT= 0.999
      FACT= DP1MIN
Chnb      IF (ABS(DVAL).LT.1.0E-20)  DVAL= DDEF
      IF (ABS(DVAL).LE.D0MIN)  DVAL= DDEF
C
      MINCHK= 0
Chnb      IF      ((ABS(DMIN+999.).LT.0.01)
Chnb     1  .OR.  ((DVAL.GE.0.0) .AND. (DVAL.GE.DMIN*FACT))
Chnb     2  .OR.  ((DVAL.LT.0.0) .AND. (DVAL.GT.DMIN/FACT)))
Chnb     3        MINCHK= 1
      IF      ((ABS(DMIN+999.0).LT.(DP1MIN - 1.0))
     1  .OR.  ((DVAL.GE.0.0) .AND. (DVAL.GE.DMIN/FACT))
     2  .OR.  ((DVAL.LT.0.0) .AND. (DVAL.GT.DMIN*FACT)))
     3        MINCHK= 1
C
      MAXCHK= 0
Chnb      IF      ((ABS(DMAX+999.).LT.0.01)
Chnb     1  .OR.  ((DVAL.GE.0.0) .AND. (DVAL.LE.DMAX/FACT))
Chnb     2  .OR.  ((DVAL.LT.0.0) .AND. (DVAL.LT.DMAX/FACT)))
Chnb     3        MAXCHK= 1
      IF      ((ABS(DMAX+999.0).LT.(DP1MIN - 1.0))
     1  .OR.  ((DVAL.GE.0.0) .AND. (DVAL.LE.DMAX*FACT))
     2  .OR.  ((DVAL.LT.0.0) .AND. (DVAL.LT.DMAX/FACT)))
     3        MAXCHK= 1
C
      IF (MINCHK.EQ.1 .AND. MAXCHK.EQ.1)  DCHK= 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   NUMINI
C
C     + + + PURPOSE + + +
C     Initialize machine dependent floating point constants.
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + SAVES + + +
      INTEGER       INITFG
      SAVE          INITFG
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       PRECFG
      INTEGER(4)    R2PREC,D2PREC,TI
      REAL(4)       R1,R2,R3,R4,  TR
      REAL(8)       D1,D2,D3,D4
C
C     + + + FUNCTIONS + + +
      REAL(4)  RNOP
      REAL(8)  DNOP

C     + + + INTRINSICS + + +
      INTRINSIC  INT,LOG10
C
C     + + + EQUIVALENCE STATEMENTS + + +
      EQUIVALENCE (TR,TI)
C
C     + + + DATA INITIALIZATIONS + + +
      DATA INITFG /0/
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(' UNKNOWN DOUBLE PRECISION FORMAT, using default double pre
     .cision values!')
 2010 FORMAT(' UNKNOWN MACHINE TYPE, using default precision values!')
C
C     + + + STATEMENT FUNCTION DEFINITIONS + + +
C     No OPperation, used to keep Ryan/McFarland optimization honest
      RNOP(R1) = R1
      DNOP(D1) = D1
C
C     + + + END SPECIFICATIONS + + +
C
      IF (INITFG.EQ.0) THEN
C       Need to calculate machine dependent numeric constants.
C       Set flag to do so only once.
        INITFG= 1
C
C       Determine the number of decimal digits of REAL precision number and
C       the smallest REAL greater than 1.0.
C       First find the number of significant binary digits, then convert
C       it to the number of significant decimal digits.  Any machine used
C       today is going to have more than 7 binary digits of precision
C       (actually, we're cheating, because 1 is added to R2PREC after
C       it is tested.  This usually results in 7 decimal digits of
C       precision, which is usually the case, whereas strictly
C       speaking only 6 decimal digits are guaranteed, and 6 is
C       usually the result if R2PREC is initialized to 6).
        R2PREC = 7
        R1 = 1.0
        R2 = 0.0078125
 100    CONTINUE
C         loop until PRECFG=1
          PRECFG= 0
          R3 = R1 + R2
C         this 'nop' keeps Ryan/McFarland optimization honest.  Without it,
C         the precision of an 80 bit floating point register is computed
C         (instead of a 4-byte real) when R/M optimization is turned on.
C         You can comment out the call to NOP if you observe that by
C         doing so DECCHR doesn't provide extra digits of precision.
          R4 = RNOP(R3)
C         The following conditional causes a warning on the PRIME,
C         but this statement needs to be left as is since we are looking
C         for the case of the two real numbers being exactly the same
C         to help determine the precision of the machine.
          IF (R1 .NE. R3) THEN
             RP1MIN = R3
             R2PREC = R2PREC + 1
             R2 = R2 / 2.0
             PRECFG= 1
          END IF
        IF (PRECFG.EQ.1) GO TO 100
C
        RPREC = INT(LOG10(2.0**R2PREC))
C
C       Determine the number of decimal digits of the typical DOUBLE precision
C       number and the smallest DOUBLE greater than 1.0D0.
        D2PREC = 7
        D1 = 1.0D0
        D2 = 0.0078125D0
 200    CONTINUE
C         loop until PRECFG=1
          PRECFG= 0
          D3 = D1 + D2
C         this 'nop' keeps Ryan/McFarland optimization honest.  Without it,
C         the precision of an 80 bit floating point register is computed
C         (instead of a 4-byte real) when R/M optimization is turned on.
C         You can comment out the call to NOP if you observe that by
C         doing so DECCHR doesn't provide extra digits of precision.
          D4 = DNOP(D3)
C         The following conditional causes a warning on the PRIME,
C         but this statement needs to be left as is since we are looking
C         for the case of the two real numbers being exactly the same
C         to help determine the precision of the machine.
          IF (D1 .NE. D3) THEN
             DP1MIN = D3
             D2PREC = D2PREC + 1
             D2 = D2 / 2.0D0
             PRECFG= 1
          END IF
        IF (PRECFG.EQ.1) GO TO 200
C
        DPREC = INT(LOG10(2.0D0**D2PREC))
C
        TR = 1.0
        IF (TI .EQ. 1065353216) THEN
C         this should be the case for the Sun or Ryan/McFarland
          R1   = 1.0E-19
          R0MIN = 1.1754945E-19 * R1
          R1   = 1.0E+19
          R0MAX = 3.40282347E+19 * R1
C         On DG (unix) system, RP1MIN is calculated a little too small
C         to have the needed correcting effect in DECCHR/DPRCHR when
C         using LOG10 intrinsics on those machines.  Thus, increase it a
C         little bit to force correction. (also see DP1MIN below)
          RP1MIN= RP1MIN**4
          D1   = 1.0D-28
          D0MIN = (2.22507385850720219D-28 * D1**10)
          D1   = 1.0D+28
          D0MAX = (1.7976931348623157D0 * D1**11)
          DP1MIN= DP1MIN**4
        ELSE IF (TI .EQ. 16512) THEN
C         this should be the case for the VAX
          R1   = 1.0E-20
          R0MIN = 2.9387359E-19 * R1
          R1   = 1.0E+18
          R0MAX = 1.7014117E+20 * R1
          IF (DPREC .EQ. 17) THEN
C            this should be the case for the default /NOG_FLOAT compiler option
             D1   = 1.0D-20
             D0MIN = 2.938735877055719D-19 * D1
             D1   = 1.0E+19
             D0MAX = 1.7014118346046923D+19 * D1
          ELSE IF (DPREC .EQ. 16) THEN
C            this should be the case for the /G_FLOAT option
             D3 = 1.0D-21
             D4 = 1.0D-20
             D0MIN = (5.562684646268008D-20)*(D4**5)*(D3**9)
             D3 = 1.0D+21
             D4 = 1.0D+20
             D0MAX = (8.988465674311578D+21) * (D3**6) * (D4**8)
          ELSE
C            assume D_FLOAT real*8 type
             WRITE(*,2000)
             D1   = 1.0D-20
             D0MIN = 2.938735877055719D-19 * D1
             D1   = 1.0E+19
             D0MAX = 1.7014118346046923D+19 * D1
          END IF
        ELSE
C         not quite sure of machine type
          WRITE(*,2010)
          R1    = 1.0E-19
          R0MIN = 1.1754945E-19 * R1
          R1    = 1.0E+18
C         On PRIME system, RP1MIN is calculated a little too small
C         to have the needed correcting effect in DECCHR/DPRCHR when
C         using LOG10 intrinsics on those machines.  Thus, increase it a
C         little bit to force correction. (also see DP1MIN below)
          RP1MIN= RP1MIN**4
          R0MAX = 1.7014117E+20 * R1
          D1    = 1.0D-20
          D0MIN = 2.938735877055719D-19 * D1
          D1    = 1.0E+19
          D0MAX = 1.7014118346046923D+19 * D1
          DP1MIN= DP1MIN**4
        ENDIF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DECPRC
     I                   (SIGDIG,DECPLA,
     M                    RVAL)
C
C     + + + PURPOSE + + +
C     Adjust a real value to contain a specified
C     number of significant digits and decimal places.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SIGDIG,DECPLA
      REAL      RVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SIGDIG - desired number of significant digits
C     DECPLA - desired number of decimal places
C     RVAL   - real value
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,ILEN
      CHARACTER(1)STR(20)
C
C     + + + FUNCTIONS + + +
      INTEGER     LENSTR
      REAL        CHRDEC
C
C     + + + EXTERNALS + + +
      EXTERNAL    LENSTR, CHRDEC, DECCHX
C
C     + + + END SPECIFICATIONS + + +
C
C     put real value into string with desired number of significant digits
      ILEN = 20
      CALL DECCHX (RVAL,ILEN,SIGDIG,DECPLA,
     O             STR)
C     determine output length of string
      I= LENSTR(ILEN,STR)
C     get adjusted real value from string
      RVAL= CHRDEC(I,STR)
C
      RETURN
      END
C
C
C
      SUBROUTINE   SHIFTD
     I                   (LEN, VAL, VALTOL,
     M                    X,
     O                    IPOS)
C
C     + + + PURPOSE + + +
C     Moves all array elements equal to VAL to end of array,
C     shifting remaining elements forward, preserving their order.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER           LEN, IPOS
      DOUBLE PRECISION  VAL, VALTOL, X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - array length
C     VAL    - value to be moved to end of array
C     VALTOL - tolerance for determining how close array elements
C              need to be to VAL to be moved to end of array
C     X      - double precision array
C     IPOS   - position of last "good" value, when all VALs moved to end
C
C     + + + LOCAL VARIABLES + + +
      INTEGER           I, INDX, VALCNT, LENARR
      DOUBLE PRECISION  TMPVAL
C
C     + + + INTRINSICS + + +
      INTRINSIC  ABS
C
C     + + + END SPECIFICATIONS + + +
C
C     determine number of values to be moved to end
      VALCNT = 0
      DO 10 I = 1, LEN
        IF (ABS(X(I) - VAL) .LE. VALTOL) VALCNT = VALCNT + 1
 10   CONTINUE
C
C     determine position of last "good" value when done shifting ele.s
      IPOS = LEN - VALCNT
C
      LENARR = LEN
      INDX = 1
      IF (VALCNT.GT.0 .AND. VALCNT.LT.LEN) THEN
C       at least one value to move, but all elements not equal to VAL
 20     CONTINUE
          IF (ABS(X(INDX) - VAL) .LE. VALTOL) THEN
            TMPVAL = X(INDX)
C           shift array elements left
            DO 25 I = INDX, LENARR-1
              X(I) = X(I+1)
 25         CONTINUE
C           place value in last position
            X(LENARR) = TMPVAL
            LENARR = LENARR - 1
C           decrement number of values to be moved
            VALCNT = VALCNT - 1
          ELSE
            INDX = INDX + 1
          END IF
        IF (VALCNT .NE. 0) GOTO 20
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   SHIFTI
     I                   (LEN, VAL, VALTOL,
     M                    X,
     O                    IPOS)
C
C     + + + PURPOSE + + +
C     Moves all array elements equal to VAL to end of array,
C     shifting remaining elements forward, preserving their order.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   LEN, VAL, VALTOL, X(LEN), IPOS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - array length
C     VAL    - value to be moved to end of array
C     VALTOL - tolerance for determining how close array elements
C              need to be to VAL to be moved to end of array
C     X      - integer array
C     IPOS   - position of last "good" value, when all VALs moved to end
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I, INDX, VALCNT, LENARR, TMPVAL
C
C     + + + INTRINSICS + + +
      INTRINSIC  ABS
C
C     + + + END SPECIFICATIONS + + +
C
C     determine number of values to be moved to end
      VALCNT = 0
      DO 10 I = 1, LEN
        IF (ABS(X(I) - VAL) .LE. VALTOL) VALCNT = VALCNT + 1
 10   CONTINUE
C
C     determine position of last "good" value when done shifting ele.s
      IPOS = LEN - VALCNT
C
      LENARR = LEN
      INDX = 1
      IF (VALCNT.GT.0 .AND. VALCNT.LT.LEN) THEN
C       at least one value to move, but all elements not equal to VAL
 20     CONTINUE
          IF (ABS(X(INDX) - VAL) .LE. VALTOL) THEN
            TMPVAL = X(INDX)
C           shift array elements left
            DO 25 I = INDX, LENARR-1
              X(I) = X(I+1)
 25         CONTINUE
C           place value in last position
            X(LENARR) = TMPVAL
            LENARR = LENARR - 1
C           decrement number of values to be moved
            VALCNT = VALCNT - 1
          ELSE
            INDX = INDX + 1
          END IF
        IF (VALCNT .NE. 0) GOTO 20
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   SHIFTR
     I                   (LEN, VAL, VALTOL,
     M                    X,
     O                    IPOS)
C
C     + + + PURPOSE + + +
C     Moves all array elements equal to VAL to end of array,
C     shifting remaining elements forward, preserving their order.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   LEN, IPOS
      REAL      VAL, VALTOL, X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - array length
C     VAL    - value to be moved to end of array
C     VALTOL - tolerance for determining how close array elements
C              need to be to VAL to be moved to end of array
C     X      - real array
C     IPOS   - position of last "good" value, when all VALs moved to end
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I, INDX, VALCNT, LENARR
      REAL       TMPVAL
C
C     + + + INTRINSICS + + +
      INTRINSIC  ABS
C
C     + + + END SPECIFICATIONS + + +
C
C     determine number of values to be moved to end
      VALCNT = 0
      DO 10 I = 1, LEN
        IF (ABS(X(I) - VAL) .LE. VALTOL) VALCNT = VALCNT + 1
 10   CONTINUE
C
C     determine position of last "good" value when done shifting ele.s
      IPOS = LEN - VALCNT
C
      LENARR = LEN
      INDX = 1
      IF (VALCNT.GT.0 .AND. VALCNT.LT.LEN) THEN
C       at least one value to move, but all elements not equal to VAL
 20     CONTINUE
          IF (ABS(X(INDX) - VAL) .LE. VALTOL) THEN
            TMPVAL = X(INDX)
C           shift array elements left
            DO 25 I = INDX, LENARR-1
              X(I) = X(I+1)
 25         CONTINUE
C           place value in last position
            X(LENARR) = TMPVAL
            LENARR = LENARR - 1
C           decrement number of values to be moved
            VALCNT = VALCNT - 1
          ELSE
            INDX = INDX + 1
          END IF
        IF (VALCNT .NE. 0) GOTO 20
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   UTVRSN
C
C     + + + PURPOSE + + +
C     Dummy routine to include unix what version information for the
C     util library.
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER(64) VERSN
C
C     + + + END SPECIFICATIONS + + +
C
      INCLUDE 'FVERSN.INC'
C
      RETURN
      END

C     utdate.f 2.1 9/4/91
C
C
C
      SUBROUTINE   CKDATE
     I                    (DATE1, DATE2,
     O                     FLAG)
C
C     + + + PURPOSE + + +
C     Determine the calendar order of two dates.  The dates are
C     assumed to be valid.
C     Examples:      DATE1               DATE2         FLAG
C              1980/10/1 00:00:00  1980/10/1 24:00:00   -1
C              1980/10/1 24:00:00  1980/10/1 00:00:00    1
C              1980/10/1 24:00:00  1980/10/2 00:00:00   -1
C              1980/10/2 00:00:00  1980/10/1 24:00:00    1
C              1980/10/1 24:00:00  1980/10/1 24:00:00    0
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE1(6), DATE2(6), FLAG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE1  - first date
C     DATE2  - second date
C     FLAG   - flag indicating order of dates
C               1 - DATE1 follows DATE2
C               0 - DATE1 is the same date as DATE2
C              -1 - DATE2 follows DATE1
C
C     + + + LOCAL VARIABLES + + +
      INTEGER  I
C
C     + + + END SPECIFICATIONS + + +
C
      FLAG = -99
      I = 0
C
 10   CONTINUE
        I = I + 1
C
        IF (DATE1(I) .LT. DATE2(I)) THEN
C         first date is before second date
          FLAG = -1
        ELSE
C         first date follows or equals second date
          IF (DATE1(I) .GT. DATE2(I)) THEN
C           first date follows second date
            FLAG = 1
          ELSE IF (I .EQ. 6) THEN
C           all parts of dates are equal
            FLAG = 0
          END IF
        END IF
C
      IF (I.LT.6 .AND. FLAG.EQ.-99) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   CMPTIM
     I                   ( TCODE1, TSTEP1, TCODE2, TSTEP2,
     O                     TSTEPF, TCDCMP )
C
C     + + + PURPOSE + + +
C     Compare one time unit and step to a second time unit and
C     step.  Two flags are returned.  The first flag indicates
C     compatible/incompatible time steps.  The second flag
C     indicates which time step is smaller.  Time steps are
C     considered compatible if one is an even multiple of the
C     other.  One hour and 30 minutes are compatible; one hour
C     and 90 minutes are incompatible.  Comparison of time units
C     and time steps which cross the day-month boundry are handled
C     a little different.  If the smaller time step is a day or
C     less and is compatible with 1 day and the larger time step
C     is compatible with one month, than the smaller and the
C     larger time steps are considered to be compatible.  The time
C     step of a day or less will be considered to be the smaller
C     time step.
C     EXAMPLES:  TCODE1 TSTEP1 TCODE2 TSTEP2 TSTEPF TCDCMP
C                  3      1      2      60     0      0
C                  3      1      2      90     1      1
C                  3      1      2      30     0      2
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER  TCODE1, TSTEP1, TCODE2, TSTEP2, TSTEPF, TCDCMP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TCODE1 - time units code
C              1 - second    4 - day
C              2 - minute    5 - month
C              3 - hour      6 - year
C     TSTEP1 - time step, in TCODE1 units
C     TCODE2 - time units code
C              1 - second    4 - day
C              2 - minute    5 - month
C              3 - hour      6 - year
C     TSTEP2 - time step in TCODE2 units
C     TSTEPF - time step compatability flag
C              0 - compatible time steps
C              1 - incompatible time steps
C     TCDCMP - flag indicating order of time steps
C               0 - time steps are the same
C               1 - first time step is smaller
C               2 - second time step is smaller
C              -1 - time units span day-month boundry
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    TC(2), TS(2), TSX, TCX, TSFX(2), TCDX(2)
C
C     + + + EXTERNALS + + +
      EXTERNAL   CMPTM2
C
C     + + + END SPECIFICATIONS + + +
C
      TC(1) = TCODE1
      TC(2) = TCODE2
      TS(1) = TSTEP1
      TS(2) = TSTEP2
C
      IF (TC(1) .LT. 1  .OR.  TC(1) .GT. 6     .OR.
     >    TC(2) .LT. 1  .OR.  TC(2) .GT. 6     .OR.
     >    TS(1) .LT. 1  .OR.  TS(1) .GT. 1440  .OR.
     >    TS(2) .LT. 1  .OR.  TS(2) .GT. 1440) THEN
C       an invalid time units code or time step
        TSTEPF = 1
        TCDCMP = -1
      ELSE IF ((TC(1) .LE. 4  .AND.  TC(2) .GE. 5)  .OR.
     >         (TC(2) .LE. 4  .AND.  TC(1) .GE. 5)) THEN
C       special case for time units that cross day-month boundry
        TSTEPF = 1
        TCDCMP = -1
        IF (TC(1) .LE. 4) THEN
C         first time unit is day or smaller, second is month or larger
          TSX = 1
          TCX = 4
          CALL CMPTM2 ( TC(1), TS(1), TCX, TSX, TSFX(1), TCDX(1) )
          TSX = 1
          TCX = 5
          CALL CMPTM2 ( TC(2), TS(2), TCX, TSX, TSFX(2), TCDX(2) )
          IF (TSFX(1) .EQ. 0  .AND.  TSFX(2) .EQ. 0) THEN
C           times compatible with boundaries
            IF ((TCDX(1) .EQ. 0  .OR.  TCDX(1) .EQ. 1)  .AND.
     >          (TCDX(2) .EQ. 0  .OR.  TCDX(2) .EQ. 2)) THEN
C             smaller time a day or less, larger time a month or more
              TSTEPF = 0
              TCDCMP = 1
            END IF
          END IF
        ELSE
C         second time unit is day or smaller, first is month or larger
          TSX = 1
          TCX = 5
          CALL CMPTM2 ( TC(1), TS(1), TCX, TSX, TSFX(1), TCDX(1) )
          TSX = 1
          TCX = 4
          CALL CMPTM2 ( TC(2), TS(2), TCX, TSX, TSFX(2), TCDX(2) )
          IF (TSFX(1) .EQ. 0  .AND.  TSFX(2) .EQ. 0) THEN
C           times compatible with boundaries
            IF ((TCDX(1) .EQ. 0  .OR.  TCDX(1) .EQ. 2)  .AND.
     >          (TCDX(2) .EQ. 0  .OR.  TCDX(2) .EQ. 1)) THEN
C             larger time a month or more, smaller time a day or less
              TSTEPF = 0
              TCDCMP = 2
            END IF
          END IF
        END IF
      ELSE
C       valid time steps and units do not cross day-month boundry
        CALL CMPTM2 ( TC(1), TS(1), TC(2), TS(2), TSTEPF, TCDCMP )
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   CMPTM2
     M                   ( TC1, TS1, TC2, TS2,
     O                     TSTEPF, TCDCMP )
C
C     + + + PURPOSE + + +
C     This routine compares one time unit and step to a second time
C     unit and step.  Two flags are returned.  The first flag
C     indicates compatible/incompatible time steps.  The second flag
C     indicates which timestep is smaller.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER  TC1, TC2, TS1, TS2, TSTEPF, TCDCMP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TC1    - time units code
C              1 - second    4 - day
C              2 - minute    5 - month
C              3 - hour      6 - year
C     TS1    - time step, in TC1 units
C     TC2    - time units code, see TC1
C     TS2    - time step, in TC2 units
C     TSTEPF - time step compatability flag
C              0 - compatible time series
C              1 - incompatible time steps
C     TCDCMP - flag indicating order of time steps
C               0 - time steps are the same
C               1 - first time step is smaller
C               2 - second time step is smaller
C              -1 - time units span day-month boundry
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    CONVDN(7)
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  CONVDN / 0, 60, 60, 24, 0, 12, 100 /
C
C     + + + END SPECIFICATIONS + + +
C
      IF ((TC1 .LE. 4  .AND.  TC2 .GT. 4)  .OR.
     >    (TC1 .GT. 4  .AND.  TC2 .LE. 4)) THEN
C       time units span day-month boundry
        TSTEPF = 1
        TCDCMP = -1
      ELSE
C       acceptable time units
        IF (TC1 .NE. TC2) THEN
C         time units not same, adjust larger to agree with smaller
          IF (TC1 .LT. TC2) THEN
C           Adjust second time units to agree with first
 100        CONTINUE
              TS2 = TS2 * CONVDN(TC2)
              TC2 = TC2 - 1
            IF (TC1 .LT. TC2) GO TO 100
          ELSE
C           Adjust first time units to agree with second
 120        CONTINUE
              TS1 = TS1 * CONVDN(TC1)
              TC1 = TC1 - 1
            IF (TC2 .LT. TC1) GO TO 120
          END IF
        END IF
C
C       Time units converted, check time step
        TSTEPF = 0
        IF (TS1 .EQ. TS2) THEN
C         Same time step
          TCDCMP = 0
        ELSE IF (TS1 .LT. TS2) THEN
C         First time step smaller
          TCDCMP = 1
          IF (MOD(TS2,TS1) .NE. 0) TSTEPF = 1
        ELSE
C         Second time step smaller
          TCDCMP = 2
          IF (MOD(TS1,TS2) .NE. 0) TSTEPF = 1
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DATCHK
     I                   (DATE,
     O                    ERROR)
C
C     + + + PURPOSE + + +
C     Check DATE for valid entries.  For each valid element in
C     DATE, the corresponding element in ERROR is set to zero.
C     For each invalid element in DATE, the corresponding element
C     in ERROR is set to one.
C     Valid date elements are:
C       1800 <= year   <= 2080
C         1  <= month  <= 12
C         1  <= day    <= 31 or as appropriate for month and year
C         0  <= hour   <= 24
C         0  <= minute <= 60
C         0  <= second <= 60
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE(6),ERROR(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE   - Date to be checked
C     ERROR  - Array containing flags for valid DATE elements:
C              0 - good, 1 - invalid
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,DS,YR,MO,DY,HR,MI,SC
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL   DAYMON, ZIPI
C
C     + + + END SPECIFICATIONS + + +
C
      YR = DATE(1)
      MO = DATE(2)
      DY = DATE(3)
      HR = DATE(4)
      MI = DATE(5)
      SC = DATE(6)
C
      I= 6
      J= 0
      CALL ZIPI (I,J,ERROR)
C
C     check range on each number
      IF (YR.LT.1800.OR.YR.GE.2080) THEN
        ERROR(1) = 1
      END IF
      IF (MO.LT.1.OR.MO.GT.12) THEN
        ERROR(2) = 1
        DS = 31
      ELSE
        DS = DAYMON(YR,MO)
      END IF
      IF (DY.LT.1.OR.DY.GT.DS) THEN
        ERROR(3) = 1
      END IF
      IF (HR.LT.0.OR.HR.GT.24) THEN
        ERROR(4) = 1
      END IF
      IF (MI.LT.0.OR.MI.GT.60) THEN
        ERROR(5) = 1
      END IF
      IF (SC.LT.0.OR.SC.GT.60) THEN
        ERROR(6) = 1
      END IF
C
C     if day or month are zero, then hour,min,sec should be zero
      IF (MO.EQ.0.AND.DY.NE.0) ERROR(3) = 1
      IF (MO.EQ.0.AND.HR.NE.0) ERROR(4) = 1
      IF (MO.EQ.0.AND.MI.NE.0) ERROR(5) = 1
      IF (MO.EQ.0.AND.SC.NE.0) ERROR(6) = 1
      IF (DY.EQ.0.AND.HR.NE.0) ERROR(4) = 1
      IF (DY.EQ.0.AND.MI.NE.0) ERROR(5) = 1
      IF (DY.EQ.0.AND.SC.NE.0) ERROR(6) = 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   DATNXT
     I                   (INTRVL,UPBACK,
     M                    DATE)
C
C     + + + PURPOSE + + +
C     Based on the value of UPBACK, this routine adds or subtracts
C     the time interval INTRVL from the current date and time DATE.
C     The time convention has midnite as 24:00 of previous day, not
C     as 00:00 of next day.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE(6),UPBACK
      INTEGER(4)INTRVL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INTRVL - time step, in minutes
C     UPBACK - flag indicating direction in time to move:
C              >0  - move forward in time
C              <=0 - move back in time
C     DATE   - date to be modified
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   YEAR,MONTH,DAY,HR,MIN,SEC
      INTEGER(4)DHR,DMIN,TT,I4T24,I4T60,I4T0
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
      I4T24= 24
      I4T60= 60
      I4T0 = 0
C
      YEAR = DATE(1)
      MONTH = DATE(2)
      DAY = DATE(3)
      HR = DATE(4)
      MIN = DATE(5)
      SEC = DATE(6)
C
      DMIN = MIN
      DHR = HR
C
      IF (UPBACK.GT.0) THEN
C       move forward in time
        DMIN = DMIN + INTRVL
        IF (DMIN.LT.I4T60.AND.DHR.LT.I4T24) GO TO 49
          TT = DMIN/60
          DMIN = DMIN - TT*60
          DHR = DHR + TT
          IF (DHR.LT.I4T24) GO TO 48
          IF (DHR.EQ.I4T24.AND.DMIN.EQ.I4T0) GO TO 48
            TT = DHR/24
C           special case for daily timestep to keep convention
            IF (MOD(DHR,I4T24).EQ.0.AND.DMIN.EQ.I4T0) TT = TT-1
            DHR = DHR - TT*24
            DAY = DAY + TT
 40         CONTINUE
            IF (DAY.GT.DAYMON(YEAR,MONTH)) THEN
              DAY = DAY - DAYMON(YEAR,MONTH)
              MONTH = MONTH + 1
              IF (MONTH.GT.12) THEN
                MONTH = 1
                YEAR = YEAR + 1
              END IF
              GO TO 40
            END IF
 48       CONTINUE
 49     CONTINUE
      ELSE
C       move back in time
        DMIN = DMIN - INTRVL
        IF (DMIN.LE.I4T0) THEN
          TT = DMIN/60 - 1
          DMIN = DMIN-TT*60
          DHR = DHR + TT
          IF (DMIN.EQ.I4T60) THEN
            DMIN = 0
            DHR = DHR + 1
          END IF
          IF (DHR.LE.I4T0) THEN
            TT = DHR/24 - 1
            DHR = DHR-TT*24
            DAY = DAY + TT
  70        CONTINUE
            IF (DAY.LE.0) THEN
              MONTH = MONTH - 1
              IF (MONTH.LE.0) THEN
                MONTH = 12
                YEAR = YEAR - 1
              END IF
              DAY = DAYMON(YEAR,MONTH) + DAY
              GO TO 70
            END IF
          END IF
        END IF
      END IF
C
      MIN = DMIN
      HR = DHR
      DATE(1) = YEAR
      DATE(2) = MONTH
      DATE(3) = DAY
      DATE(4) = HR
      DATE(5) = MIN
      DATE(6) = SEC
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   DAYMON
     I                           (YR,MON)
C
C     + + + PURPOSE + + +
C     Return the number of days in the given month for the given
C     year, with leap year taken into account.  For an invalid
C     month, -1 is returned.  For an invalid year and a valid month,
C     the correct number of days is returned, with February = 28.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER    MON,YR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YR     - year, valid range is 1 - 2080
C     MON    - month, valid range is 1 - 12
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I4,I100,I400,NDAMON(12)
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + DATA INITIALIZATIONS + + +
      DATA NDAMON/31,28,31,30,31,30,31,31,30,31,30,31/
C
C     + + + END SPECIFICATIONS + + +
C
CJLK  CALL DCALCT(5)
      I4 = 4
      I100 = 100
      I400 = 400
      IF (MON.EQ.2) THEN
        IF (YR .LE. 0  .OR.  YR .GT. 9999) THEN
C         invalid year
          DAYMON = 28
        ELSE IF (MOD(YR,I100).EQ.0) THEN
C         check whether this is a leap year on a century boundary
          IF (MOD(YR,I400).EQ.0) THEN
C           on a 400 year boundary
            DAYMON = 29
          ELSE
            DAYMON = 28
          END IF
        ELSE
          IF (MOD(YR,I4).EQ.0) THEN
C           leap year
            DAYMON = 29
          ELSE
            DAYMON = 28
          END IF
        END IF
C
      ELSE IF (MON.GE.1 .AND. MON.LE.12) THEN
C       no problem
        DAYMON = NDAMON(MON)
      ELSE
C       invalid month
        DAYMON = -1
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DLIMIT
     I                   ( DATES, NDSN, FSLS,
     O                     DATE )
C
C     + + + PURPOSE + + +
C     Depending on the value of FSLS, find the earliest or
C     latest date in the array of dates DATES.  CKDATE is
C     used to determine the calendar order between dates.
C     The dates are assumed to be valid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   NDSN, FSLS, DATE(6)
      INTEGER   DATES(6,NDSN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATES  - array of NDSN dates
C     NDSN   - number of dates
C     FSLS   - indicator for type of date to look for
C              1 - finds first date
C              2 - finds last date
C     DATE   - depending on the value of FSLS, the first or last
C              date in DATES
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   N, FLG, L
C
C     + + + EXTERNALS + + +
      EXTERNAL   CKDATE, COPYI
C
C     + + + END SPECIFICATIONS + + +
C
C     assume first/last
      L = 6
      CALL COPYI ( L, DATES, DATE )
      IF (FSLS .EQ. 1) THEN
C       find any before assumed first
        DO 100 N = 2, NDSN
          CALL CKDATE( DATE, DATES(1,N), FLG )
          IF (FLG .EQ. 1) THEN
C           new first
            CALL COPYI (L,DATES(1,N),DATE)
          END IF
 100    CONTINUE
      ELSE IF (FSLS .EQ. 2) THEN
C       find any after assumed last
        DO 200 N = 1, NDSN
          CALL CKDATE( DATE, DATES(1,N), FLG )
          IF (FLG .EQ. -1) THEN
C           new last
            CALL COPYI (L,DATES(1,N),DATE)
          END IF
 200    CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   JDMODY
     I                    (YEAR,JDAY,
     O                     MON,DAY)
C
C     + + + PURPOSE + + +
C     Convert a julian day to month and day, leap year taken
C     into account.  YEAR and JDAY are assumed to be valid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   YEAR,JDAY,MON,DAY
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YEAR   - year
C     JDAY   - julian date
C     MON    - month
C     DAY    - day
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   LPFG,MOCUM(12,2)
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + DATA INITIALIZATIONS + + +
      DATA MOCUM /31,59,90,120,151,181,212,243,273,304,334,365,
     1            31,60,91,121,152,182,213,244,274,305,335,366/
C
C     + + + END SPECIFICATIONS + + +
C
C     check for leap year
      LPFG= 1
Cy2k  IF (MOD(YEAR,4).EQ.0.AND.MOD(YEAR,100).NE.0) LPFG= 2
      IF (MOD(YEAR,4).EQ.0.AND.
     1   (MOD(YEAR,100).NE.0.OR.MOD(YEAR,400).EQ.0)) LPFG= 2
C
      MON= 0
 10   CONTINUE
        MON= MON+ 1
      IF (JDAY.GT.MOCUM(MON,LPFG)) GOTO 10
C
      DAY= JDAY
      IF (MON.GT.1) DAY= JDAY- MOCUM(MON-1,LPFG)
C
      RETURN
      END
C
C
C
      SUBROUTINE   NUMPTS
     I                   (DATE1,DATE2,DELT,
     O                    NPTS)
C
C     + + + PURPOSE + + +
C     Calculate the number of time steps between two dates.
C     If the second date is before the first date, a zero is
C     returned.  The first date is assumed to be at the end
C     of the first time step.  The dates are assumed to be valid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE1(6),DATE2(6),DELT,NPTS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE1  - first (start) date
C     DATE2  - second (end) date
C     DELT   - time step, in minutes
C     NPTS   - number of time steps between first and second date
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   NPD,YR,M,SYR,SMO,SDY,SHR,SMI,EYR,EMO,EDY,EHR,EMI,
     1          ERRFLG
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL   CKDATE, DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
      SYR = DATE1(1)
      SMO = DATE1(2)
      SDY = DATE1(3)
      SHR = DATE1(4)
      SMI = DATE1(5)
      EYR = DATE2(1)
      EMO = DATE2(2)
      EDY = DATE2(3)
      EHR = DATE2(4)
      EMI = DATE2(5)
C
      NPTS = 0
C     number per day
      NPD = 1440/DELT
      YR = SYR
      M = SMO
C
C     if end date before start date, return npts of 0
      CALL CKDATE (DATE1,DATE2,ERRFLG)
      IF (ERRFLG.LE.0) THEN
C
        IF (SMO.LT.EMO.OR.YR.LT.EYR) THEN
C         start and stop not same month
          NPTS = NPTS + (DAYMON(SYR,SMO)+1-SDY)*NPD
C
C         middle months
 56       CONTINUE
            M = M + 1
            IF (M.GT.12) THEN
              M = 1
              YR = YR + 1
            END IF
C
            IF (M.EQ.EMO.AND.YR.GE.EYR) GO TO 58
              NPTS = NPTS + DAYMON(YR,M)*NPD
              GO TO 56
C
 58       CONTINUE
C         final month
          NPTS = NPTS + EDY*NPD
        ELSE
C         start and stop in the same month
          NPTS = NPTS + (EDY+1-SDY)*NPD
        END IF
C
C       have correct number of days
        IF (NPD.GT.1) THEN
C         for timesteps less than one day
C         first day
          NPTS = NPTS - (SHR*60 + SMI)/DELT + 1
C         last day
          NPTS = NPTS - ((23-EHR)*60 + (60-EMI))/DELT
        END IF
C
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   TIMADD
     I                    (DATE1,TCODE,TSTEP,NVALS,
     O                     DATE2)
C
C     + + + PURPOSE + + +
C     Add NVALS time steps to first date to compute second date.
C     The first date is assumed to be valid.
C
C     + + + HISTORY + + +
C     jlk 00/04/12  fix problem where time was coming up 24:15:00
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE1(6),TCODE,TSTEP,DATE2(6)
      INTEGER   NVALS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE1  - starting date
C     TCODE  - time units
C              1 - second          5 - month
C              2 - minute          6 - year
C              3 - hour            7 - century
C              4 - day
C     TSTEP  - time step in TCODE units
C     NVALS  - number of time steps to be added
C     DATE2  - new date
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   CARRY,DPM,TYR,TMO,TDY,THR,TMN,TSC,STPOS,DONFG
      INTEGER   I,DATEL1(6)
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL  DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
CJLK  CALL DCALCT(1)
Ckmf
Ckmf  write(99,*) '      timadd:  date1 =', date1
Ckmf  write(99,*) '               date2 =', date2
Ckmf  write(99,*) '               tcode =', tcode
Ckmf  write(99,*) '               tstep =', tstep
Ckmf  write(99,*) '               nvals =', nvals
Ckmf
C
C     make a local copy of start date as it might change
      DO 10 I= 1,6
        DATEL1(I)= DATE1(I)
 10   CONTINUE
Ckmf  IF (DATEL1(4).EQ.24) THEN
      IF (TCODE.LT.4 .AND. DATEL1(4).EQ.24) THEN
C       convert local start date to midnight is 0 convention
        CALL TIMCVT(DATEL1)
      END IF
C
      TYR= DATEL1(1)
      TMO= DATEL1(2)
      TDY= DATEL1(3)
      THR= DATEL1(4)
      TMN= DATEL1(5)
      TSC= DATEL1(6)
C
C     figure out how much time to add and where to start
      CARRY= NVALS* TSTEP
      STPOS= TCODE
      IF (STPOS.EQ.7) THEN
C       the time units are centuries, convert to years
        STPOS= 6
        CARRY= CARRY* 100
      END IF
C
C     add the time, not changing insig. parts
      IF (STPOS.EQ.1) THEN
C       seconds
        TSC  = TSC+ CARRY
        CARRY= TSC/ 60
        TSC  = TSC- (CARRY*60)
      END IF
      IF (STPOS.LE.2 .AND. CARRY.GT.0) THEN
C       minutes
        TMN  = TMN+ CARRY
        CARRY= TMN/ 60
        TMN  = TMN- (CARRY*60)
      END IF
      IF (STPOS.LE.3 .AND. CARRY.GT.0) THEN
C       hours
        THR  = THR+ CARRY
        CARRY= THR/ 24
        THR  = THR- (CARRY*24)
        IF (THR.EQ.0 .AND.TMN.EQ.0.AND. TSC.EQ.0) THEN
C         this is the day boundry problem
          THR  = 24
          CARRY= CARRY- 1
        END IF
      END IF
      IF (STPOS.LE.4 .AND. CARRY.GT.0) THEN
C       days
        TDY  = TDY+ CARRY
        IF (TDY.GT.28) THEN
C         may need month/year adjustment
          DONFG= 0
 45       CONTINUE
CJLK        CALL DCALCT(4)
            DPM= DAYMON(TYR,TMO)
            IF (TDY .GT. DPM) THEN
C             add another month
              TDY= TDY- DPM
              TMO= TMO+ 1
              IF (TMO .GT. 12) THEN
                TMO= 1
                TYR= TYR+ 1
              END IF
            ELSE IF (TDY .LE. 0) THEN
C             subtract another month
              TMO= TMO- 1
              IF (TMO .EQ. 0) THEN
                TYR= TYR- 1
                TMO= 12
              END IF
              TDY= TDY- DAYMON(TYR,TMO)
            ELSE
              DONFG= 1
            END IF
          IF (DONFG.EQ.0) GO TO 45
        END IF
C       month and year updated here all done
      END IF
C
      IF (STPOS.GE.5) THEN
        IF (STPOS.EQ.5) THEN
C         months
          TMO  = TMO+ CARRY
          CARRY= (TMO-1)/ 12
          TMO  = TMO- (CARRY*12)
        END IF
        IF (STPOS.LE.6 .AND. CARRY.GT.0) THEN
C         years
          TYR  = TYR+ CARRY
        END IF
C
C       check days/month
        DPM= DAYMON(TYR,TMO)
        IF (DPM .LT. TDY) THEN
          TDY= DPM
        END IF
        IF (DAYMON(DATE1(1),DATE1(2)).EQ.DATE1(3)) THEN
          TDY= DPM
        END IF
      END IF
C
      DATE2(1)= TYR
      DATE2(2)= TMO
      DATE2(3)= TDY
      DATE2(4)= THR
      DATE2(5)= TMN
      DATE2(6)= TSC
Ckmf  try commenting just this part out
Ckmf  IF (DATE2(4).EQ.24) THEN
Ckmf    convert to midnight is 0 convention
Ckmf    CALL TIMCVT(DATE2)
Ckmf  END IF
Ckmf
Ckmf  write(99,*) '        done:  date2 =', date2
Ckmf
C
      RETURN
      END
C
C
C
      SUBROUTINE   TIMBAK
     I                    (TCODE,
     M                     DATE)
C
C     + + + PURPOSE + + +
C     Subtract one time interval at the given units TCODE from DATE.
C     The date is assumed to be valid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   TCODE,DATE(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TCODE  - time units code
C              1 - seconds            5 - months
C              2 - minutes            6 - years
C              3 - hours              7 - centuries
C              4 - days
C     DATE   - date
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DONE,I,NEWDAY
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL   DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
      I     = TCODE
      NEWDAY= 0
C
 5    CONTINUE
C
        GO TO (10,20,30,40,50,60,70),I
C
 10     CONTINUE
C         seconds
          DATE(6)  = DATE(6)-1
          IF (DATE(6).LT.0) THEN
            DATE(6)= 59
            I     = I+ 1
            DONE  = 0
          ELSE
            DONE  = 1
          END IF
          GO TO 80
C
 20     CONTINUE
C         minutes
          DATE(5)  = DATE(5)-1
          IF (DATE(5).LT.0) THEN
            DATE(5)= 59
            I     = I+ 1
            DONE  = 0
          ELSE
            DONE  = 1
          END IF
          GO TO 80
C
 30     CONTINUE
C         hours
          DATE(4)  = DATE(4)-1
          IF (DATE(4).LT.0) THEN
            DATE(4)= 23
            I     = I+ 1
            DONE  = 0
          ELSE IF (DATE(4).EQ.0.AND.DATE(5).EQ.0.AND.DATE(6).EQ.0) THEN
            DATE(4)= 24
            I     = I+ 1
            DONE  = 0
          ELSE
            DONE= 1
          END IF
          GO TO 80
C
 40     CONTINUE
C         days
          DATE(3)= DATE(3)-1
          IF (DATE(3).LE.0) THEN
            NEWDAY= 1
            I   = I+ 1
            DONE= 0
          ELSE
            DONE= 1
          END IF
          GO TO 80
C
 50     CONTINUE
C         months
          DATE(2)= DATE(2)-1
          IF (DATE(2).LE.0) THEN
            DATE(2)= 12
            I   = I+ 1
            DONE= 0
          ELSE
            DONE= 1
          END IF
          GO TO 80
C
 60     CONTINUE
C         years
          DATE(1)= DATE(1)-1
          DONE= 1
          GO TO 80
C
 70     CONTINUE
C         centuries
          DATE(1)= DATE(1)-100
          DONE= 1
          GO TO 80
C
 80     CONTINUE
      IF (DONE.EQ.0) GO TO 5
C
      IF (NEWDAY.EQ.1) THEN
        DATE(3)= DAYMON(DATE(1),DATE(2))
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   TIMCHK
     I                            (DATE1,DATE2)
C
C     + + + PURPOSE + + +
C     Determine the calendar order of two dates.
C     The dates are assumed to be valid.
C     TIMCHK = 1 if DATE1 < DATE2
C            = 0 if DATE1 = DATE2
C            =-1 if DATE1 > DATE2
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE1(6),DATE2(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE1  - first date
C     DATE2  - second date
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,SDAT(6),EDAT(6),LEN
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (SDAT(1),SYR),(SDAT(2),SMO),(SDAT(3),SDY),
     #            (SDAT(4),SHR),(SDAT(5),SMN),(SDAT(6),SSC)
      INTEGER   SYR,SMO,SDY,SHR,SMN,SSC
      EQUIVALENCE (EDAT(1),EYR),(EDAT(2),EMO),(EDAT(3),EDY),
     #            (EDAT(4),EHR),(EDAT(5),EMN),(EDAT(6),ESC)
      INTEGER   EYR,EMO,EDY,EHR,EMN,ESC
C
C
C     + + + EXTERNALS + + +
      EXTERNAL  TIMCNV, COPYI
C
C     + + + END SPECIFICATIONS + + +
C
CJLK  CALL DCALCT(3)
C     make a copy of the dates
      LEN = 6
      CALL COPYI(LEN,DATE1,
     O           SDAT)
      CALL COPYI(LEN,DATE2,
     O           EDAT)
C     convert dates to old format
      CALL TIMCNV (SDAT)
      CALL TIMCNV (EDAT)
C
C     ***************************
C     how about trying this??? jlk 9/95 - 35% slower in wdtget test
C     CALL CKDATE (EDAT,SDAT,I)
C     instead of the rest of this wonderful code
C     ***************************
C
C     check years
      IF (SYR .LT. EYR) THEN
        I= 1
      ELSE IF (SYR .GT. EYR) THEN
        I= -1
      ELSE IF (SMO .LT. EMO) THEN
C     checking months
        I= 1
      ELSE IF (SMO .GT. EMO) THEN
        I= -1
      ELSE IF (SDY .LT. EDY) THEN
C     checking days
        I= 1
      ELSE IF (SDY .GT. EDY) THEN
        I= -1
      ELSE IF (SHR .LT. EHR) THEN
C     checking hours
        I= 1
      ELSE IF (SHR .GT. EHR) THEN
        I= -1
      ELSE IF (SMN .LT. EMN) THEN
C     checking minutes
        I= 1
      ELSE IF (SMN .GT. EMN) THEN
        I= -1
      ELSE IF (SSC .LT. ESC) THEN
C     checking seconds
        I= 1
      ELSE IF (SSC .GT. ESC) THEN
        I= -1
      ELSE
        I= 0
      END IF
C
      TIMCHK= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   TIMCNV
     M                    (DATE)
C
C     + + + PURPOSE + + +
C     Convert a date that uses the midnight convention of 00:00
C     to the convention 24:00.  For example, 1982/10/01 00:00:00
C     would be converted to the date 1982/09/30 24:00:00.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE   - date being converted
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL  DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
      IF (DATE(4).EQ.0) THEN
        IF (DATE(5).EQ.0 .AND. DATE(6).EQ.0) THEN
C         date using new day boundry convention, convert to old
          DATE(4)= 24
          DATE(3)= DATE(3)- 1
          IF (DATE(3).EQ.0) THEN
            DATE(2)= DATE(2)- 1
            IF (DATE(2).EQ.0) THEN
              DATE(1)= DATE(1)- 1
              DATE(2)= 12
            END IF
            DATE(3)= DAYMON(DATE(1),DATE(2))
          END IF
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   TIMCVT
     M                   (DATE)
C
C     + + + PURPOSE + + +
C     Convert a date that uses the midnight convention of 24:00
C     to the convention 00:00.  For example, 1982/09/30 24:00:00
C     would be converted to the date 1982/10/01 00:00:00.
C
C     + + + HISTORY + + +
C     jlk  00/04/13  check hour 24 but now ignore value for
C                    minute and second.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE   - date being converted
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL  DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
Cjlk  IF (DATE(4).EQ.24 .AND. DATE(5).EQ.0 .AND. DATE(6).EQ.0) THEN
      IF (DATE(4).EQ.24) THEN
C       old midnight convention, convert to new
        DATE(4) = 0
        DATE(3) = DATE(3) + 1
        IF (DATE(3) .GT. DAYMON(DATE(1),DATE(2))) THEN
C         month boundry
          DATE(3) = 1
          DATE(2) = DATE(2) + 1
          IF (DATE(2) .GT. 12) THEN
C           year boundry
            DATE(2) = 1
            DATE(1) = DATE(1) + 1
          END IF
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   TIMDIF
     I                    (DATE1,DATE2,TCODE,TSTEP,
     O                     NVALS)
C
C     + + + PURPOSE + + +
C     Calculate the number of time steps between two dates.  Part
C     intervals at a time step less than TCODE and TSSTEP are not
C     included.  If the second date is before the first date, or the
C     second date is the same as the first date, the number of time
C     steps will be returned as 0.  Dates are assumed to be valid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE1(6),DATE2(6),TCODE,TSTEP,NVALS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE1  - first (starting) date
C     DATE2  - second (ending) date
C     TCODE  - time units code
C              1 - seconds     5 - months
C              2 - minutes     6 - years
C              3 - hours       7 - centuries
C              4 - days
C     TSTEP  - time step in TCODE units
C     NVALS  - number of time steps between DATE1 and DATE2
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   NDAYS,DONFG,NADJ,TMPSTR(6),TMPEND(6),LEN
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON, TIMCHK
C
C     + + + EXTERNALS + + +
      EXTERNAL  DAYMON, TIMCNV, COPYI, TIMADD, TIMCHK
C
C     + + + END SPECIFICATIONS + + +
C
CJLK  CALL DCALCT(2)
      IF (TIMCHK(DATE1,DATE2) .EQ. 1) THEN
C       end date follows start date, make temp copies of dates
        LEN = 6
        CALL COPYI (LEN,DATE1,TMPSTR)
        CALL COPYI (LEN,DATE2,TMPEND)
C
C       convert dates to old format
        CALL TIMCNV (TMPSTR)
        CALL TIMCNV (TMPEND)
C
        GO TO (5,5,5,5,50,60,70), TCODE
 5      CONTINUE
C         figure out how many days
          DONFG= 0
          NDAYS= -TMPSTR(3)
 8        CONTINUE
            IF (TMPSTR(1).LT.TMPEND(1).OR.
     1        (TMPSTR(1).EQ.TMPEND(1).AND.TMPSTR(2).LT.TMPEND(2))) THEN
              NDAYS= NDAYS+ DAYMON(TMPSTR(1),TMPSTR(2))
              TMPSTR(2)= TMPSTR(2)+ 1
              IF (TMPSTR(2).EQ.13) THEN
                TMPSTR(2)= 1
                TMPSTR(1)= TMPSTR(1)+ 1
              END IF
            ELSE
              DONFG= 1
            END IF
          IF (DONFG.EQ.0) GO TO 8
          NDAYS= NDAYS+ TMPEND(3)
C
          IF (TCODE .EQ. 1) THEN
C           seconds
            NVALS= ((((NDAYS*24)+
     1               TMPEND(4)-TMPSTR(4))* 60+
     2              TMPEND(5)-TMPSTR(5))* 60+
     3             TMPEND(6)-TMPSTR(6))/ TSTEP
          ELSE IF (TCODE .EQ. 2) THEN
C           minutes
            NVALS= (((NDAYS*24)+
     1              TMPEND(4)-TMPSTR(4))* 60+
     2             TMPEND(5)-TMPSTR(5))/ TSTEP
          ELSE IF (TCODE .EQ. 3) THEN
C           hours
            NVALS= ((NDAYS*24)+
     1             TMPEND(4)- TMPSTR(4))/ TSTEP
          ELSE IF (TCODE .EQ. 4) THEN
C           days
            NVALS= NDAYS/ TSTEP
          END IF
          GO TO 90
C
 50     CONTINUE
C         months
          NVALS= ((TMPEND(1)-TMPSTR(1))*12+TMPEND(2)-TMPSTR(2))/TSTEP
          GO TO 90
C
 60     CONTINUE
C         years
          NVALS= (TMPEND(1)-TMPSTR(1))/ TSTEP
          GO TO 90
C
 70     CONTINUE
C         centuries
          NVALS= (TMPEND(1)-TMPSTR(1))/(TSTEP*100)
          GO TO 90
C
 90     CONTINUE
C
        DONFG= 0
100     CONTINUE
          CALL TIMADD (DATE1,TCODE,TSTEP,NVALS,
     O                 TMPEND)
          NADJ= TIMCHK(DATE2,TMPEND)
          IF (NADJ.EQ.1.AND.NVALS.GE.1) THEN
C           estimate too high
            NVALS= NVALS- 1
          ELSE
C           estimate ok
            DONFG= 1
          END IF
        IF (DONFG.EQ.0) GO TO 100
      ELSE
C       end date is the same as or before start date
        NVALS = 0
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   TIMDFX
     I                    (DATE1,DATE2,
     O                     NVALS,TCODE,TSTEP)
C
C     + + + PURPOSE + + +
C     Calculate the number of values between two dates, including
C     units and time step.  First tries at one year time step, then
C     TCODE is decreased by one and tried again until the exact
C     time difference is determined.  Dates are assumed to be valid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATE1(6),DATE2(6),TCODE,TSTEP
      INTEGER(4)NVALS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE1  - first (starting) date
C     DATE2  - second (ending) date
C     NVALS  - number of values at the output TSTEP and TCODE
C     TCODE  - time units code
C              1 - seconds     5 - months
C              2 - minutes     6 - years
C              3 - hours       7 - centuries
C              4 - days
C     TSTEP  - time step in TCODE units
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DONFG,TIMTMP(6)
C
C     + + + FUNCTIONS + + +
      INTEGER   TIMCHK
C
C     + + + EXTERNALS + + +
      EXTERNAL   TIMADD, TIMCHK, TIMDIF
C
C     + + + END SPECIFICATIONS + + +
C
      TCODE= 6
      TSTEP= 1
      DONFG= 0
C
 10   CONTINUE
        CALL TIMDIF (DATE1,DATE2,TCODE,TSTEP,
     O               NVALS)
        CALL TIMADD (DATE1,TCODE,TSTEP,NVALS,
     O               TIMTMP)
        IF (TIMCHK(DATE2,TIMTMP).EQ.0) THEN
C         we have call exact units, etc
          DONFG= 1
        ELSE
C         try again with shorter units
          TCODE= TCODE- 1
Cy2k      IF (TCODE.EQ.0) WRITE (*,*) 'BAD TIMDFX',DATE1,DATE2
          IF (TCODE.EQ.0) THEN
C           problem with dates
            WRITE (*,*) 'BAD TIMDFX',DATE1,DATE2
            DONFG = 1
          END IF
        END IF
C
      IF (DONFG.EQ.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   DTMCMN
     I                   ( NDAT, STRT, STOP, TSTEP, TCODE,
     O                     SDAT, EDAT, TS, TC, RETCOD )
C
C     + + + PURPOSE + + +
C     Determine the time period common to a number of pairs of dates.
C     Determine the smallest common time step and unit.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   NDAT, STRT(6,NDAT), STOP(6,NDAT), TSTEP(NDAT),
     $          TCODE(NDAT), SDAT(6), EDAT(6), TS, TC,
     $          RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NDAT   - number of pairs of dates
C     STRT   - array of beginning dates
C     STOP   - array of ending dates
C     TSTEP  - array of time steps
C     TCODE  - array of time units codes
C              1 - second        4 - day
C              2 - minute        5 - month
C              3 - hour          6 - year
C     SDAT   - common starting date
C     EDAT   - common ending date
C     TS     - smallest common time step
C     TC     - smallest common time units
C              1 - second        4 - day
C              2 - minute        5 - month
C              3 - hour          6 - year
C     RETCOD - return code
C               0 - there is a common time period and time step and units
C              -1 - there is no common time period
C              -2 - there is a common time period, but the time step and
C                    time units are not compatible
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RETC, N, TSTEPF, TCDCMP, LN
C
C     + + + LOCAL DEFINITIONS + + +
C     TSTEPF - time step compatibility flag
C              0 - compatible time steps
C              1 - incompatible time steps
C     TCDCMP - flag indicating order of time steps
C               0 - time steps are the same
C               1 - first time step is smaller
C               2 - second time step is smaller
C              -1 - time units span day-month boundry
C
C     + + + EXTERNALS + + +
      EXTERNAL  DATCMN, CMPTIM, ZIPI
C
C     + + + END SPECIFICATIONS + + +
C
      RETC = 0
C     get common time period
      CALL DATCMN ( NDAT, STRT, STOP, SDAT, EDAT, RETC )
      IF (RETC .EQ. 0) THEN
C       get common time step and units
        TS = TSTEP(1)
        TC = TCODE(1)
        IF (NDAT.GT.1) THEN
C         check others
          N  = 1
 100      CONTINUE
C           look for smallest common time step and unit
            N = N + 1
            CALL CMPTIM ( TCODE(N), TSTEP(N), TC, TS, TSTEPF, TCDCMP )
            IF (TSTEPF .EQ. 0  .AND.  TCDCMP .NE. -1) THEN
C             compatible time steps, do not span day-month boundry
              IF (TCDCMP .EQ. 2) THEN
C               new larger time step
                TS = TSTEP(N)
                TC = TCODE(N)
              END IF
            ELSE
C             incompatible time steps or time units span day-month boundry
              RETC = -2
            END IF
          IF (N .LT. NDAT  .AND.  RETC .EQ. 0) GO TO 100
          IF (RETC .EQ. -2) THEN
C           time step and time units are not all compatible
            TS = 0
            TC = 0
          END IF
        END IF
      ELSE
C       no common time period
        RETC = -1
        LN = 6
        N  = 0
        CALL ZIPI ( LN, N, SDAT )
        CALL ZIPI ( LN, N, EDAT )
        TS = 0
        TC = 0
      END IF
      RETCOD = RETC
C
      RETURN
      END
C              
C
C
      SUBROUTINE   DATCMN
     I                   ( NDAT, STRT, STOP,
     O                     SDAT, EDAT, RETCOD )
C
C     + + + PURPOSE + + +
C     Determine the time period common to a number of pairs of dates.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   NDAT, STRT(6,NDAT), STOP(6,NDAT), SDAT(6), EDAT(6),
     $          RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NDAT   - number of pairs of dates
C     STRT   - array of beginning dates
C     STOP   - array of ending dates
C     SDAT   - common starting data
C     EDAT   - common ending date
C     RETCOD - return code
C               0 - there is a common time period
C              -1 - there is no common time period
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   FSLS, DATE(6,2), RETC, LEN, ZIP
C     INTEGER   I, J
C
C     + + + EXTERNALS + + +
      EXTERNAL  DLIMIT, CKDATE, COPYI, ZIPI
C
C     + + + END SPECIFICATIONS + + +
C
C     write(*,*) 'DATCMN',NDAT
C     DO I= 1,NDAT
C       WRITE(*,*) '  STRT',I,(STRT(J,I),J=1,4)
C     END DO
C     get latest start date
      FSLS = 2
      CALL DLIMIT ( STRT, NDAT, FSLS, DATE(1,1) )
C     WRITE(*,*) '  LAST',FSLS,(DATE(J,1),J=1,4)
C     DO I= 1,NDAT
C       WRITE(*,*) '  STOP',I,(STOP(J,I),J=1,4)
C     END DO
C     get earliest end date
      FSLS = 1
      CALL DLIMIT ( STOP, NDAT, FSLS, DATE(1,2) )
C     WRITE(*,*) '  FRST',FSLS,(DATE(J,2),J=1,4)
C     is start data before end date?
      CALL CKDATE ( DATE(1,1), DATE(1,2), RETC )
      IF (RETC .EQ. -1) THEN
C       common start date before common end date, as hoped for
        LEN = 6
        CALL COPYI ( LEN, DATE(1,1), SDAT )
        CALL COPYI ( LEN, DATE(1,2), EDAT )
        RETCOD = 0
      ELSE
C       begin and end the same (0) or common start after common end (1)
        LEN = 6
        ZIP = 0
        CALL ZIPI ( LEN, ZIP, SDAT )
        CALL ZIPI ( LEN, ZIP, EDAT )
        RETCOD = -1
      END IF
C     WRITE(*,*) '  CHCK',RETC,RETCOD
C
      RETURN
      END
C
C
C
      SUBROUTINE   GTMONC
     I                   ( INDX, LEN, LORU,
     M                     LENO, MONTH )
C
C     + + + PURPOSE + + +
C     Given the number of the month and a length, returns the
C     character string for that month.
C     For LEN >= 9, the full month is returned.
C     For LEN  = 3, the standard 3-character abbreviation is returned.
C     For LEN  = 1, the first character of the month is returned
C     For LEN  = 2, the first 2 characters of the standard 3-character
C                   abbreviation are returned
C     For LEN < 9 & > 4, the first LEN characters of the full month
C                   are returned.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     INDX, LEN, LORU, LENO
      CHARACTER(1)MONTH(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INDX   - index number of the month (1-jan,2-feb,...,12-dec)
C     LEN    - available length for month
C     LORU   - flag for case
C              1 - first letter upper case, remaining letters lower case
C              2 - all letters upper case
C     LENO   - actual characters in month
C              returns 0 if indx not a valid month or len < 1
C     MONTH  - character string of lenght LEN containing name of month
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      NOC(12), CASE, I, LENL
      CHARACTER(3) MOS(12,2)
      CHARACTER(9) MOL(12,2)
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  MOS / 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
     $            'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec',
     $            'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     $            'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC' /
      DATA  MOL / 'January  ', 'February ', 'March    ', 'April    ',
     $            'May      ', 'June     ', 'July     ', 'August   ',
     $            'September', 'October  ', 'November ', 'December ',
     $            'JANUARY  ', 'FEBRUARY ', 'MARCH    ', 'APRIL    ',
     $            'MAY      ', 'JUNE     ', 'JULY     ', 'AUGUST   ',
     $            'SEPTEMBER', 'OCTOBER  ', 'NOVEMBER ', 'DECEMBER ' /
      DATA  NOC /  7,           8,           5,           5,
     $             3,           4,           4,           6,
     $             9,           7,           8,           8 /
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT ( 9A1 )
C
C     + + + END SPECIFICATIONS + + +
C
      IF (LORU .EQ. 1  .OR.  LORU .EQ. 2) THEN
C       valid case flag
        CASE = LORU
      ELSE
C       invalid case flag, default to mixed case
        CASE = 1
      END IF
C
      IF (INDX .LT. 1  .OR.  INDX .GT. 12) THEN
C       invalid month
        LENO = 0
      ELSE IF (LEN .LT. 1) THEN
C       invalid length, return nothing
        LENO = 0
      ELSE IF (LEN .GE. 1  .AND.  LEN .LE. 3) THEN
C       return short month
        READ (MOS(INDX,CASE),1000) (MONTH(I), I = 1, LEN)
        LENO = LEN
      ELSE IF (LEN .GE. 9) THEN
C       return full month
        LENL = 9
        READ (MOL(INDX,CASE),1000) (MONTH(I), I = 1, LENL)
        LENO = NOC(INDX)
      ELSE
C       return as much of full month as allowed
        READ (MOL(INDX,CASE),1000) (MONTH(I), I = 1, LEN)
        IF (LEN .LT. NOC(INDX)) THEN
C         not enough room for full length
          LENO = LEN
        ELSE
C         month fit
          LENO = NOC(INDX)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DHLEAP
     I                   ( DATBGN, STMO, EDMO,
     O                     LPDAY, LPYRS )
C
C     + + + PURPOSE + + +
C     Given a starting date and the season begin and end months,
C     determine where leap day occurs in the series and determine
C     when the the first leap year occurs.  Assumptions: (1) datbgn
C     is a valid date and (2) the STMO and EDMO months define a season
C     equal to or shorter than a full year.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATBGN(6), STMO, EDMO, LPDAY, LPYRS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATBGN - beginning date
C     STMO   - beginning month of season
C     EDMO   - ending month of season
C     LPDAY  - postion in season where leap day occurs,
C              returns 0 if leap day not contained in season
C     LPYRS  - offset to first leap year in time series
C              0 - current season contains leap day
C              1 - second season in series will contain leap day
C              2 - third season in series will contain leap day
C              3 - fourth season in series will contain leap day
C
C     + + + LOCAL VARIALBES + + +
      INTEGER   DATLEP(6), TUNITS, TSSTEP
C
C     + + + FUNCTIONS + + +
      INTEGER     DHLPYR
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   TIMDIF, DHLPYR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  DATLEP / 0,2,28,24,0,0 /
C
C     + + + END SPECIFICATIONS + + +
C
      TUNITS = 4
      TSSTEP = 1
C
      IF ((STMO .EQ. 2  .OR.   EDMO .EQ. 2)  .OR.
     $    (STMO .GT. 2  .AND.  EDMO .GE. 2  .AND.  STMO .GT. EDMO)  .OR.
     $    (STMO .EQ. 1  .AND.  EDMO .GE. 2)) THEN
C       February is included in season, which positon is leap day
        IF (STMO .LE. 2) THEN
C         February in starting year of season
          DATLEP(1) = DATBGN(1)
Cy2k      LPYRS = MOD ( DATBGN(1), 4 )
          LPYRS = DHLPYR ( DATBGN(1) )
        ELSE
C         February in second year of season
          DATLEP(1) = DATBGN(1) + 1
Cy2k      LPYRS = MOD ( DATBGN(1)+1, 4 )
          LPYRS = DHLPYR ( DATBGN(1)+1 )
        END IF
C       find Feb 28 and increment by 1 to the 29th
        CALL TIMDIF ( DATBGN, DATLEP, TUNITS, TSSTEP, LPDAY )
        LPDAY = LPDAY + 1
      ELSE
C       February is not included in season
        LPDAY = 0
Cy2k    LPYRS = MOD ( DATBGN(1), 4 )
        LPYRS = DHLPYR ( DATBGN(1) )
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DHBEGN
     I                   ( DATBGN, DATEND, STMO, EDMO,
     O                     SEASON, SEASBG, SEASND, IPT )
C
C     + + + PURPOSE + + +
C     Given a period of record and the beginning and ending months of
C     the season to be analyzed, determine the start and end dates
C     of the first season.  Assumptions:  (1) the dates input
C     are valid, (2) the STMO and EDMO months define a season
C     equal to or shorter than a full year, (3) full months are
C     used, and (4) the first season will end at the end of the season.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DATBGN(6), DATEND(6), STMO, EDMO,
     $          SEASON(12), SEASBG(6), SEASND(6), IPT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATBGN - beginning date of time series
C     DATEND - ending date of time series
C     STMO   - beginning month of season
C     EDMO   - ending month of season
C     SEASON - available begin date and end date for first season
C     SEASBG - start date for first season
C     SEASND - start date for last season
C     IPT    - pointer to position in time series for first data
C              value in first season
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    TUNITS, TSSTEP, I6
C
C     + + + FUNCTIONS + + +
      INTEGER    DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL   DAYMON, TIMDIF, COPYI
C
C     + + + END SPECIFICATIONS + + +
C
      TUNITS = 4
      TSSTEP = 1
      I6     = 6
C
      CALL COPYI ( I6, DATBGN, SEASON )
      SEASON(8)  = EDMO
      SEASON(10) = 24
      SEASON(11) = 0
      SEASON(12) = 0
      SEASBG(2)  = STMO
      SEASBG(3)  = 1
      SEASBG(4)  = 0
      SEASBG(5)  = 0
      SEASBG(6)  = 0
      SEASND(2)  = STMO
      SEASND(3)  = 1
      SEASND(4)  = 0
      SEASND(5)  = 0
      SEASND(6)  = 0
      IF (STMO .LE. EDMO) THEN
C       season begins and ends in same calendar year
        IF (DATBGN(2) .LE. EDMO) THEN
C         start date begins before end of season
          SEASON(7) = DATBGN(1)
          SEASBG(1) = DATBGN(1)
        ELSE
C         start date begins after end of season, next year
          SEASON(1) = DATBGN(1) + 1
          SEASON(2) = STMO
          SEASON(7) = DATBGN(1) + 1
          SEASBG(1) = DATBGN(1) + 1
        END IF
        IF (DATEND(2) .GE. STMO) THEN
C         end date ends after end of season
          SEASND(1) = DATEND(1)
        ELSE
C         end date ends before beginning of season, previous year
          SEASND(1) = DATEND(1) - 1
        END IF
      ELSE
C       season spans calendar years
        IF (DATBGN(2) .GE. STMO) THEN
C         start date begins before Jan 1, season ends in next year
          SEASON(7) = DATBGN(1) + 1
          SEASBG(1) = DATBGN(1)
        ELSE
C         start date begins after Jan 1, season ends in same year
          SEASON(7) = DATBGN(1)
          SEASBG(1) = DATBGN(1) - 1
        END IF
        IF (DATEND(2) .LE. EDMO) THEN
C         end date is after Jan 1, last season begins in previous year
          SEASND(1) = DATEND(1) - 1
        ELSE
C         end date is before Jan 1, last season begins in same year
          SEASND(1) = DATEND(1)
        END IF
      END IF
      SEASON(9) = DAYMON ( SEASON(7), SEASON(8) )
C
C     where in season does data begin
      CALL TIMDIF ( SEASBG, SEASON, TUNITS, TSSTEP, IPT )
      IPT = IPT + 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   DHINCR
     I                   ( SEASBG, SEASND, DATBGN, DATEND,
     M                     SEASON, MORE )
C
C     + + + PURPOSE + + +
C     Increment begin and end dates to next season.  Assumes that a
C     season is one year or shorter in length.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SEASBG(6), SEASND(6), DATBGN(6), DATEND(6),
     $          SEASON(12), MORE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SEASBG - start date for first season
C     SEASND - start date for last season
C     DATBGN - beginning date of time series
C     DATEND - ending date of time series
C     SEASON - input as previous time period, incremented to next
C     MORE   - indicator for time period
C              -1 - new time period defined
C               0 - already at end of time period
C
C     + + + END SPECIFICATIONS + + +
C
      IF (SEASON(1) .EQ. DATBGN(1)  .AND.
     $    SEASON(2) .EQ. DATBGN(2)) THEN
C       first season may not have been full, make sure next is
        SEASON(1) = SEASBG(1)
        SEASON(2) = SEASBG(2)
        SEASON(3) = 1
      END IF
C
      IF (SEASON(1) .EQ. SEASND(1)  .AND.
     $    SEASON(2) .EQ. SEASND(2)) THEN
C       have reached end of time period, done
        MORE = 0
      ELSE
C       not at end, increment dates
        MORE = -1
        SEASON(1) = SEASON(1) + 1
        IF (SEASON(1) .EQ. SEASND(1)  .AND.
     $      SEASON(2) .EQ. SEASND(2)) THEN
C         last season may not be full year
          SEASON(7) = DATEND(1)
          SEASON(8) = DATEND(2)
          SEASON(9) = DATEND(3)
        ELSE
C         increment end year
          SEASON(7) = SEASON(7) + 1
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DBNDRY
     I                    ( FWDBAK,
     M                      DATE )
C
C     + + + PURPOSE + + +
C     Force a date to a day boundary
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FWDBAK, DATE(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FWDBAK - indicator flag for action to be taken is not day boundary
C              1 - move forward to next day
C              2 - move back to previous day
C     DATE   - date (year,month,day,hour,minute,second)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   TCODE, TSTEP, NVAL, DATE2(6), LEN6
C
C     + + + EXTERNALS + + +
      EXTERNAL   TIMADD, TIMBAK, COPYI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  TCODE, TSTEP, NVAL, LEN6
     $     /    4,     1,    1,    6 /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (FWDBAK .EQ. 1  .AND.
     $   (DATE(4) .NE. 0 .OR. DATE(5) .NE. 0 .OR. DATE(6) .NE. 0)) THEN
C       start date does not begin at 00:00:00
        DATE(4) = 0
        DATE(5) = 0
        DATE(6) = 0
        CALL TIMADD ( DATE, TCODE, TSTEP, NVAL,
     O                DATE2 )
        CALL COPYI ( LEN6, DATE2, DATE )
      ELSE IF (FWDBAK .EQ. 2  .AND.
     $  (DATE(4) .NE. 24 .OR. DATE(5) .NE. 0 .OR. DATE(6) .NE. 0)) THEN
        DATE(4) = 24
        DATE(5) = 0
        DATE(6) = 0
        CALL TIMBAK ( TCODE, DATE )
      END IF
C       
      RETURN
      END
C
C
C
      SUBROUTINE   DCALCT
     I                   (IND)
C
C     + + + PURPOSE + + +
C     count calls to selected date routines
C
C     + + + DUMMY ARGUEMENTS + + +
      INTEGER   IND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IND    - index of counter to incremnt, <0:other
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   CNT(5)
      SAVE      CNT
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (20I8)
C
C     + + + END SPECIFICATIONS + + +
C
      IF (IND .GT. 0) THEN
        CNT(IND)= CNT(IND)+ 1
      ELSE IF (IND .EQ. 0) THEN
        CNT(1) = 0
        CNT(2) = 0
        CNT(3) = 0
        CNT(4) = 0
        CNT(5) = 0
      ELSE IF (IND .EQ. -1) THEN
        WRITE(98,2000) CNT
        CNT(1) = 0
        CNT(2) = 0
        CNT(3) = 0
        CNT(4) = 0
        CNT(5) = 0
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   DHLPYR
     I                            ( YEAR )
C
C     + + + PURPOSE + + +
C     Determine if year provided is a leap year.  A 2-digit
C     year is assumed to be in the first century and not just
C     an abbreviation for the current century.  Recognizes
C     400-century as leap year.
C     DHLPYR = 0 - when year is a leap year
C              1 - when year is 1 year past leap year
C              2 - when year is 2 years past leap year
C              3 - when year is 3 years past leap year
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   YEAR
C
C     + + + ARGUMENT DEFININTIONS + + +
C     YEAR   - calendar year
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   LEAP
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      IF (MOD(YEAR,4) .EQ. 0  .AND.
     $   (MOD(YEAR,100).NE.0  .OR.  MOD(YEAR,400).EQ. 0)) THEN
C       leap year
        LEAP = 0
      ELSE IF (MOD(YEAR+1,4) .EQ. 0  .AND.
     $   (MOD(YEAR+1,100).NE.0  .OR.  MOD(YEAR+1,400).EQ. 0)) THEN
C       leap year is the next year
        LEAP = 1
      ELSE IF (MOD(YEAR+2,4) .EQ. 0  .AND.
     $   (MOD(YEAR+2,100).NE.0  .OR.  MOD(YEAR+2,400).EQ. 0)) THEN
C       leap year is two years later
        LEAP = 2
      ELSE IF (MOD(YEAR+3,4) .EQ. 0  .AND.
     $   (MOD(YEAR+3,100).NE.0  .OR.  MOD(YEAR+3,400).EQ. 0)) THEN
C       leap year is three years later
        LEAP = 3
      END IF
C
      DHLPYR = LEAP
C
      RETURN
      END
C
C
C
      SUBROUTINE   SBNDRY
     I                   ( FWDBAK, MON, DAY,
     M                     DATE )
C
C     + + + PURPOSE + + +
C     Force a date to a season boundary.  Does not consider
C     hour, minute, or second.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FWDBAK, MON, DAY, DATE(3)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FWDBAK - indicator flag for action to be taken
C              1 - move forward to start of season
C              2 - move back to end of season
C     MON    - month season begins (fwdbak=1) or ends (fwdbak=2)
C     DAY    - day season begins (fwdbak=1) or ends (fwdbak=2)
C     DATE   - date (year,month,day)
C
C     + + + END SPECIFICATIONS + + +
C
      IF (FWDBAK .EQ. 1) THEN
C       force date to start at season boundary
        IF (DATE(2) .GT. MON) THEN
C         date is after start of season, advance to next year
          DATE(1) = DATE(1) + 1
          DATE(2) = MON
          DATE(3) = DAY
        ELSE IF (DATE(2) .LT. MON) THEN
C         date month is before start of season, advance to season
          DATE(2) = MON
          DATE(3) = DAY
        ELSE IF (DATE(3) .GT. DAY) THEN
C         month ok, but day after requested start, advance next year
          DATE(1) = DATE(1) + 1
          DATE(2) = MON
          DATE(3) = DAY
        ELSE IF (DATE(3) .LT. DAY) THEN
C         start day is before start of season, advance to season
          DATE(3) = DAY
        END IF
      ELSE IF (FWDBAK .EQ. 2) THEN
C       force date to end at season boundary
        IF (DATE(2) .LT. MON) THEN
C         date is before end of season, fall back a year
          DATE(1) = DATE(1) - 1
          DATE(2) = MON
          DATE(3) = DAY
        ELSE IF (DATE(2) .GT. MON) THEN
C         date month is after end of season, fall back to season
          DATE(2) = MON
          DATE(3) = DAY
        ELSE IF (DATE(3) .LT. DAY) THEN
C         month ok, but day is before requested end, fall back a year
          DATE(1) = DATE(1) - 1
          DATE(2) = MON
          DATE(3) = DAY
        ELSE IF (DATE(3) .GT. DAY) THEN
C         end day is after end of season, fall back to season
          DATE(3) = DAY
        END IF
      END IF
C
      RETURN
      END

C
C
C
      SUBROUTINE   WADGTN
     I                   (MESSFL,ATIND,
     O                    ATNAM)
C
C     + + + PURPOSE + + +
C     given attribute index, return attribute name
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,ATIND
      CHARACTER(1)ATNAM(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL  - Fortran unit number for WDM message file
C     ATIND   - attribute index
C     ATNAM   - attribute name
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDSAGY
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDSAGY (MESSFL,ATIND,
     O             ATNAM,I,I,I,I,I)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADGRA
     I                   (MESSFL,DPTR,ATTYP,
     O                    ATMIN,ATMAX)
C
C     + + + PURPOSE + + +
C     get the min and max values for an attribute off the message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,DPTR,ATTYP
      REAL      ATMIN,ATMAX
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     DPTR   - pointer to start of details for this attribute
C     ATTYP  - attribute type
C     ATMIN  - minimum value for attribute
C     ATMAX  - maximum value for attribute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,DREC,DPOS,BCWORD,ID,TLEN,IVAL(2)
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (RVAL,IVAL)
      REAL         RVAL(2)
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP, WDNXDV, WDPRPS, WATWDS, WMSSKB
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDPTSP (DPTR,
     O             DREC,DPOS)
C     back up one data value, then get the next one to get first value
      CALL WDPRPS (MESSFL,
     M             DREC,DPOS,
     O             I)
      CALL WDNXDV (MESSFL,
     M             DREC,DPOS,
     O             BCWORD)
      CALL WATWDS (BCWORD,
     O             ID,TLEN)
C
 10   CONTINUE
C       loop through details until range is found
        IF (ID.EQ.3) THEN
C         range found
          DO 20 I= 1,2
C           get min and max off message file
            CALL WDNXDV (MESSFL,
     M                   DREC,DPOS,
     O                   IVAL(I))
  20      CONTINUE
          IF (ATTYP.EQ.1) THEN
            ATMIN= IVAL(1)
            ATMAX= IVAL(2)
          ELSE
            ATMIN= RVAL(1)
            ATMAX= RVAL(2)
          END IF
          ID= 0
        ELSE
C         skip to the next block of info
          CALL WMSSKB (MESSFL,TLEN,
     M                 DREC,DPOS)
          CALL WDNXDV (MESSFL,
     M                 DREC,DPOS,
     O                 BCWORD)
          CALL WATWDS (BCWORD,
     O                 ID,TLEN)
        END IF
      IF (ID.GT.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADGVA
     I                   (MESSFL,DPTR,MXLEN,
     O                    CLEN,SATVAL)
C
C     + + + PURPOSE + + +
C     get the valid values for an attribute off the message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,DPTR,MXLEN,CLEN
      CHARACTER(1)SATVAL(MXLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     DPTR   - pointer to start of details for this attribute
C     MXLEN  - maximum length of valid values
C     CLEN   - total length of valid values
C     SATVAL - array of valid values for attribute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,DREC,DPOS,BCWORD,ID,TLEN,MLEN,GLEN,CONT,OLEN,OPOS
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP, WDNXDV, WDPRPS, WATWDS, WMSSKB, WMSGTE
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDPTSP (DPTR,
     O             DREC,DPOS)
C     back up one data value, then get the next one to get first value
      CALL WDPRPS (MESSFL,
     M             DREC,DPOS,
     O             I)
      CALL WDNXDV (MESSFL,
     M             DREC,DPOS,
     O             BCWORD)
      CALL WATWDS (BCWORD,
     O             ID,TLEN)
C
 10   CONTINUE
C       loop through details until valid is found
        IF (ID.EQ.4) THEN
C         valids found
          GLEN= 0
          MLEN= 0
          I   = 130
          OPOS= 1
 20       CONTINUE
            CALL WMSGTE (MESSFL,TLEN,I,
     M                   DREC,DPOS,GLEN,MLEN,
     O                   OLEN,SATVAL(OPOS),CONT)
            OPOS= OPOS+ OLEN
          IF (CONT.EQ.1) GO TO 20
          ID= 0
        ELSE
C         skip to the next block of info
          CALL WMSSKB (MESSFL,TLEN,
     M                 DREC,DPOS)
          CALL WDNXDV (MESSFL,
     M                 DREC,DPOS,
     O                 BCWORD)
          CALL WATWDS (BCWORD,
     O                 ID,TLEN)
        END IF
      IF (ID.GT.0) GO TO 10
C
      CLEN= TLEN
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADGDF
     I                   (MESSFL,DPTR,ATTYP,
     O                    ATDEF)
C
C     + + + PURPOSE + + +
C     get the default value for an attribute off the message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,DPTR,ATTYP
      REAL      ATDEF
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     DPTR   - pointer to start of details for this attribute
C     ATTYP  - attribute type
C     ATDEF  - default value for attribute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,DREC,DPOS,IVAL,BCWORD,ID,TLEN
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (RVAL,IVAL)
      REAL         RVAL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP, WDNXDV, WDPRPS, WATWDS, WMSSKB
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDPTSP (DPTR,
     O             DREC,DPOS)
C     back up one data value, then get the next one to get first value
      CALL WDPRPS (MESSFL,
     M             DREC,DPOS,
     O             I)
      CALL WDNXDV (MESSFL,
     M             DREC,DPOS,
     O             BCWORD)
      CALL WATWDS (BCWORD,
     O             ID,TLEN)
C
 10   CONTINUE
C       loop through details until default is found
        IF (ID.EQ.5) THEN
C         default found
          CALL WDNXDV (MESSFL,
     M                 DREC,DPOS,
     O                 IVAL)
          IF (ATTYP.EQ.1) THEN
            ATDEF= IVAL
          ELSE
            ATDEF= RVAL
          END IF
          ID= 0
        ELSE
C         skip to the next block of info
          CALL WMSSKB (MESSFL,TLEN,
     M                 DREC,DPOS)
          CALL WDNXDV (MESSFL,
     M                 DREC,DPOS,
     O                 BCWORD)
          CALL WATWDS (BCWORD,
     O                 ID,TLEN)
        END IF
      IF (ID.GT.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADGDS
     I                   (MESSFL,DPTR,
     O                    SADESC)
C
C     + + + PURPOSE + + +
C     get the description for an attribute off the message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,DPTR
      CHARACTER(1)SADESC(47)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     DPTR   - pointer to start of details for this attribute
C     SADESC - description for attribute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,DREC,DPOS,BCWORD,ID,TLEN,MLEN,GLEN,CONT,OLEN
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP, WDNXDV, WDPRPS, WATWDS, WMSSKB, WMSGTE
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDPTSP (DPTR,
     O             DREC,DPOS)
C     back up one data value, then get the next one to get first value
      CALL WDPRPS (MESSFL,
     M             DREC,DPOS,
     O             I)
      CALL WDNXDV (MESSFL,
     M             DREC,DPOS,
     O             BCWORD)
      CALL WATWDS (BCWORD,
     O             ID,TLEN)
C
 10   CONTINUE
C       loop through details until description is found
        IF (ID.EQ.6) THEN
C         description found
          GLEN= 0
          MLEN= 0
          I   = 47
          CALL WMSGTE (MESSFL,TLEN,I,
     M                 DREC,DPOS,GLEN,MLEN,
     O                 OLEN,SADESC,CONT)
          ID= 0
        ELSE
C         skip to the next block of info
          CALL WMSSKB (MESSFL,TLEN,
     M                 DREC,DPOS)
          CALL WDNXDV (MESSFL,
     M                 DREC,DPOS,
     O                 BCWORD)
          CALL WATWDS (BCWORD,
     O                 ID,TLEN)
        END IF
      IF (ID.GT.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADGHL
     I                   (MESSFL,DPTR,
     O                    TLEN,DREC,DPOS)
C
C     + + + PURPOSE + + +
C     get the length and starting record/pos of the help info
C     for an attribute off the message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,DPTR,TLEN,DREC,DPOS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     DPTR   - pointer to start of details for this attribute
C     TLEN   - length of help info (0 - no help)
C     DREC   - record on which help info starts
C     DPOS   - position on record where help starts
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,ID,BCWORD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP, WDNXDV, WDPRPS, WATWDS, WMSSKB
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDPTSP (DPTR,
     O             DREC,DPOS)
C     back up one data value, then get the next one to get first value
      CALL WDPRPS (MESSFL,
     M             DREC,DPOS,
     O             I)
      CALL WDNXDV (MESSFL,
     M             DREC,DPOS,
     O             BCWORD)
      CALL WATWDS (BCWORD,
     O             ID,TLEN)
C
 10   CONTINUE
C       loop through details until help is found
        IF (ID.EQ.7) THEN
C         start of help found
          ID= 0
         ELSE
C         skip to the next block of info
          CALL WMSSKB (MESSFL,TLEN,
     M                 DREC,DPOS)
          CALL WDNXDV (MESSFL,
     M                 DREC,DPOS,
     O                 BCWORD)
          CALL WATWDS (BCWORD,
     O                 ID,TLEN)
        END IF
      IF (ID.GT.0) GO TO 10
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDSAGY
     I                    (MESSFL,SAIND,
     O                     SANAM,DPTR,SATYP,SALEN,SARQWD,SAUPFG)
C
C     + + + PURPOSE + + +
C     gets general detail information about specified attribute
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SAIND,DPTR,SATYP,SALEN,SARQWD,SAUPFG
      CHARACTER(1)SANAM(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - message file unit number
C     SAIND  - attribute index number
C     SANAM  - name of search attribute
C     DPTR   - pointer to other details of attribute
C     SALEN  - length of attribute
C     SATYP  - type of attribute
C     SARQWD - word containing attribute requirements by dsn type
C     SAUPFG - attribute update flag
C
C     + + + PARAMETERS + + +
      INTEGER    DSNMAX
      PARAMETER (DSNMAX=10)
C
C     + + + SAVES + + +
      INTEGER     DSINIT,DSNCNT,DSN(DSNMAX),ATTIND(2,DSNMAX)
      SAVE        DSINIT,DSNCNT,DSN,ATTIND
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,IGOT
      CHARACTER(1)BLNK
C
C     + + + EXTERNALS + + +
      EXTERNAL    WADDSI, WADGTL, ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA DSINIT / 0 /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (DSINIT.EQ.0) THEN
C       determine first and last attributes on data sets
        CALL WADDSI (MESSFL,DSNMAX,
     O               DSNCNT,DSN,ATTIND)
        DSINIT= 1
      END IF
C
      I   = 0
      IGOT= 0
 10   CONTINUE
        I= I+ 1
        IF (SAIND.GE.ATTIND(1,I) .AND. SAIND.LE.ATTIND(2,I)) THEN
C         attribute is on this data set
          IGOT= 1
C         get all the label info
          CALL WADGTL (MESSFL,DSN(I),SAIND,
     O                 SANAM,DPTR,SATYP,SALEN,SARQWD,SAUPFG)
        END IF
      IF (IGOT.EQ.0 .AND. I.LT.DSNMAX) GO TO 10
      IF (IGOT.EQ.0) THEN
C       attribute index not found, set output arguments to undefined
        I     = 6
        BLNK  = ' '
        CALL ZIPC (I,BLNK,SANAM)
        DPTR  = 0
        SATYP = 0
        SALEN = 0
        SARQWD= 0
        SAUPFG= 0
      END IF
C
C     write(*,*) SANAM,DPTR,SATYP,SALEN,SARQWD,SAUPFG
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSAC
     I                    (WDMSFL,DSN,MESSFL,SAIND,SALEN,SAVAL,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     adds (or modifies) character search attribute on given dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,DSN,MESSFL,SAIND,SALEN,RETCOD
      CHARACTER(1)SAVAL(SALEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number being modified
C     MESSFL - message file unit number
C     SAIND  - index number of attribute or
C              highest attribure number if printing
C     SALEN  - length of attribute
C     SAVAL  - value of attribute
C     RETCOD - return code indicating if add or mod was successful
C                0 - successful
C              -81 - data set does not exist
C             -101 - incorrect character value for attribute
C             -103 - no room on label for attribute
C             -104 - data present, can't update attribute
C             -105 - attribute not allowed for this type data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + PARAMETERS + + +
      INTEGER     MLEN
      PARAMETER  (MLEN=300)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,K,RREC,RIND,PSAVAL,DPTR,DELFG,
     1            CNUM,CLEN,SATYP,SAUPFG,SARQWD,LWDMFL,LDSN
      CHARACTER(1)LCBUF(MLEN)
      CHARACTER(4)C4DUM
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO, CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDDSCK, WDRCGO, WDRCUP, CHKSTR
      EXTERNAL    WDSASP, WDSAGY, WADGVA, WDDPAR, WID2UD
C
C     + + + INPUT FORMATS + + +
 1020 FORMAT (A4)
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (4A1)
C
C     + + + END SPECIFICATIONS + + +
C
      DELFG = 0
      RETCOD= 0
      SATYP = 3
      CALL WDSAGY (MESSFL,SAIND,
     O             LCBUF(295),DPTR,I,I,SARQWD,SAUPFG)
C     get valid attribute values
      CALL WADGVA (MESSFL,DPTR,MLEN,
     O             CLEN,LCBUF)
C     determine number of valid values
      CNUM= CLEN/SALEN
      IF (CNUM.GT.0) THEN
C       valid values exist
        I= CHKSTR(SALEN,CNUM,SAVAL,LCBUF)
        IF (I.EQ.0) THEN
C         not a valid character attribute value
          RETCOD= -101
        END IF
      END IF
      IF (RETCOD.EQ.0) THEN
C       adjust wdm and dsn as needed
        CALL WID2UD (WDMSFL,DSN,
     O               LWDMFL,LDSN)
C       does data set exist?
        CALL WDDSCK(LWDMFL,LDSN,
     O              RREC,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         it does, get the label
          RIND= WDRCGO(LWDMFL,RREC)
C         is it ok to add/update the attribute?
          CALL WDDPAR (RREC,SARQWD,SAUPFG,WIBUFF(1,RIND),DELFG,
     O                 RETCOD)
        END IF
      END IF
      IF (RETCOD.EQ.0) THEN
C       add the attribute, first get where it starts
        CALL WDSASP (SAIND,SALEN,SATYP,
     M               WIBUFF(1,RIND),
     O               PSAVAL,RETCOD)
        IF (RETCOD.EQ.-102) THEN
C         no problem, it was already on label so adding not required
          RETCOD= 0
        END IF
        IF (PSAVAL.GT.0) THEN
C         ok to add/modify, do it
          K= -1
          DO 30 I= 1,SALEN,4
            K= K+ 1
            WRITE(C4DUM,2000) (SAVAL(J),J=I,I+3)
            READ (C4DUM,1020) WIBUFF(PSAVAL+K,RIND)
 30       CONTINUE
          CALL WDRCUP(LWDMFL,RIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSAI
     I                    (WDMSFL,DSN,MESSFL,SAIND,SALEN,SAVAL,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     adds (or modifies) integer search attribute on given dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,MESSFL,SAIND,SALEN,RETCOD
      INTEGER   SAVAL(SALEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number being modified
C     MESSFL - message file unit number
C     SAIND  - index number of attribute or
C              highest attribure number if printing
C     SALEN  - length of attribute
C     SAVAL  - value of attribute
C     RETCOD - return code indicating if add or mod was successful
C                0 - successful
C              -81 - data set does not exist
C             -103 - no room on label for attribute
C             -104 - data present, can't update attribute
C             -105 - attribute not allowed for this type data set
C             -108 - incorrect integer value for attribute
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,I0,RREC,RIND,IMIN,IMAX,PSAVAL,DPTR,DELFG,
     1            ICHK,SATYP,SAUPFG,SARQWD,LWDMFL,LDSN
      REAL        RMIN,RMAX
      CHARACTER(1)TBUFF(6)
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDDSCK, WDRCGO, WDRCUP, WDSASP
      EXTERNAL    WDSAGY, WADGRA, CHKINT, WDDPAR, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
      I0    = 0
      DELFG = 0
      RETCOD= 0
      SATYP = 1
      CALL WDSAGY (MESSFL,SAIND,
     O             TBUFF,DPTR,I,I,SARQWD,SAUPFG)
C     get min, max, default for attribute
      CALL WADGRA (MESSFL,DPTR,SATYP,
     O             RMIN,RMAX)
      IMIN= RMIN
      IMAX= RMAX
      DO 10 I= 1,SALEN
        CALL CHKINT (IMIN,IMAX,I0,SAVAL(I),ICHK)
        IF (ICHK.EQ.0) THEN
C         bad value for integer attribute
          RETCOD= -108
        END IF
 10   CONTINUE
      IF (RETCOD.EQ.0) THEN
C       adjust wdm and dsn as needed
        CALL WID2UD (WDMSFL,DSN,
     O               LWDMFL,LDSN)
C       does data set exist
        CALL WDDSCK(LWDMFL,LDSN,
     M              RREC,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         data set exists
          RIND  = WDRCGO(LWDMFL,RREC)
C         is it ok to add/update the attribute?
          CALL WDDPAR (RREC,SARQWD,SAUPFG,WIBUFF(1,RIND),DELFG,
     O                 RETCOD)
        END IF
      END IF
      IF (RETCOD.EQ.0) THEN
C       add the attribute, first get where it starts
        CALL WDSASP (SAIND,SALEN,SATYP,
     M               WIBUFF(1,RIND),
     O               PSAVAL,RETCOD)
        IF (RETCOD.EQ.-102) THEN
C         no problem, it was already on label so adding not required
          RETCOD= 0
        END IF
        IF (PSAVAL.GT.0) THEN
C         ok to add/modify, do it
          DO 30 I= 1,SALEN
            WIBUFF(PSAVAL+I-1,RIND)= SAVAL(I)
 30       CONTINUE
          CALL WDRCUP(LWDMFL,RIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSAR
     I                    (WDMSFL,DSN,MESSFL,SAIND,SALEN,SAVAL,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     adds (or modifies) real search attribute on given dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,DSN,MESSFL,SAIND,SALEN,RETCOD
      REAL        SAVAL(SALEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number being modified
C     MESSFL - message file unit number
C     SAIND  - index number of attribute or
C              highest attribure number if printing
C     SALEN  - length of attribute
C     SAVAL  - value of attribute
C     RETCOD - flag indicating if modification or addition was successful
C                0 - successful
C              -81 - data set does not exist
C             -103 - no room on label for attribute
C             -104 - data present, can't update attribute
C             -105 - attribute not allowed for this type data set
C             -109 - incorrect real value for attribute
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,RREC,RIND,PSAVAL,ICHK,SATYP,DPTR,SAUPFG,SARQWD,
     1            DELFG,LWDMFL,LDSN
      REAL        RMIN,RMAX,R0
      CHARACTER(1)TBUFF(6)
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDDSCK, WDRCGO, WDRCUP, WDSASP
      EXTERNAL    WDSAGY, CHKREA, WADGRA, WDDPAR, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
      R0    = 0.0
      DELFG = 0
      RETCOD= 0
      SATYP = 2
      CALL WDSAGY (MESSFL,SAIND,
     O             TBUFF,DPTR,I,I,SARQWD,SAUPFG)
      CALL WADGRA (MESSFL,DPTR,SATYP,
     O             RMIN,RMAX)
      DO 10 I= 1,SALEN
        CALL CHKREA (RMIN,RMAX,R0,SAVAL(I),ICHK)
        IF (ICHK.EQ.0) THEN
          RETCOD= -109
        END IF
 10   CONTINUE
      IF (RETCOD.EQ.0) THEN
C       adjust wdm and dsn as needed
        CALL WID2UD (WDMSFL,DSN,
     O               LWDMFL,LDSN)
C       does data set exist
        CALL WDDSCK(LWDMFL,LDSN,
     O              RREC,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         data set exists
          RIND  = WDRCGO(LWDMFL,RREC)
C         is it ok to add/update the attribute?
          CALL WDDPAR (RREC,SARQWD,SAUPFG,WIBUFF(1,RIND),DELFG,
     O                 RETCOD)
        END IF
      END IF
      IF (RETCOD.EQ.0) THEN
C       add the attribute, first get where it starts
        CALL WDSASP (SAIND,SALEN,SATYP,
     M               WIBUFF(1,RIND),
     O               PSAVAL,RETCOD)
        IF (RETCOD.EQ.-102) THEN
C         no problem, it was already on label so adding not required
          RETCOD= 0
        END IF
        IF (PSAVAL.GT.0) THEN
C         ok to add/modify, do it
          DO 30 I= 1,SALEN
            WRBUFF(PSAVAL+I-1,RIND)= SAVAL(I)
 30       CONTINUE
          CALL WDRCUP(LWDMFL,RIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSAD
     I                    (WDMSFL,DSN,SAIND,
     I                     SAUPFG,SARQWD,SALEN,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     deletes search attribute on given dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,SAIND,SAUPFG,SARQWD,SALEN,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number being modified
C     SAIND  - index number of attribute
C     SAUPFG - update allowed if data present flag(0-yes)
C     SARQWD - search attribute required word
C     SALEN  - length of attribute
C     RETCOD - flag indicating if deletion successful
C                0 - deletion successful
C              -81 - data set does not exist
C             -104 - data present, can't delete attribute
C             -106 - attribute required for this type data set, can't delete
C             -107 - attribute not present on this data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,RIND,PSA,PDAT,PSAVAL,I,J,K,SACNT,DELFG,LWDMFL,LDSN
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDSAFL, WDRCUP, WDDPAR, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
      DELFG = 1
      RETCOD= 0
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
C     does specified data set exist
      CALL WDDSCK(LWDMFL,LDSN,
     O            RREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       get info about data set
        RIND= WDRCGO(LWDMFL,RREC)
C       is it ok to delete the attribute?
        CALL WDDPAR (RREC,SARQWD,SAUPFG,WIBUFF(1,RIND),DELFG,
     O               RETCOD)
      END IF
      IF (RETCOD.EQ.0) THEN
C       get where attribute starts
        CALL WDSAFL (SAIND,WIBUFF(1,RIND),
     O               PSAVAL,RETCOD)
        IF (PSAVAL.GT.0) THEN
C         attribue exists and ok to delete, do it
          PSA  = WIBUFF(10,RIND)
          SACNT= WIBUFF(PSA,RIND)
          PDAT = WIBUFF(11,RIND)
          I    = 0
 10       CONTINUE
            I= I+ 1
            J= PSA+ I* 2
          IF (WIBUFF(J,RIND).NE.SAIND) GO TO 10
C
          IF (I.LT.SACNT) THEN
C           fix pointers for later attributes
            DO 20 K= I,SACNT- 1
              J= PSA+ K* 2
              WIBUFF(J,RIND)  = WIBUFF(J+2,RIND)
              WIBUFF(J+1,RIND)= WIBUFF(J+3,RIND)- SALEN
 20         CONTINUE
C           reuse attribute data space by compacting
            DO 30 K= PSAVAL,PDAT- SALEN- 1
              WIBUFF(K,RIND)= WIBUFF(K+SALEN,RIND)
 30         CONTINUE
          END IF
C         remove last attribute pointers
          J= PSA+ SACNT* 2
          WIBUFF(J,RIND)  = 0
          WIBUFF(J+1,RIND)= 0
C         remove last attribute data
          DO 40 K= PDAT-SALEN,PDAT-1
            WIBUFF(K,RIND)= -999
 40       CONTINUE
C         reduce attribute counter
          SACNT= SACNT- 1
          WIBUFF(PSA,RIND)= SACNT
C         save revised label
          CALL WDRCUP(LWDMFL,RIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSAFL
     I                   (SAIND,TIBUFF,
     O                    SAPOS,RETCOD)
C
C     + + + PURPOSE + + +
C     determines where values for particular search attribute
C     start within data-set label, returns 0 if attribute is
C     not present
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SAIND,SAPOS,RETCOD
      INTEGER(4)TIBUFF(512)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SAIND  - index of particular search attribute
C     TIBUFF - buffer of search attributes
C     SAPOS  - position of search attribute on label
C     RETCOD - return code
C                 0 - attribute found, position returned
C              -107 - attribute not present on this data set
C
C     + + + FUNCTIONS + + +
      INTEGER   WDSASV
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSASV
C
C     + + + END DECLARATIONS + + +
C
      RETCOD= 0
      SAPOS = WDSASV(SAIND,TIBUFF)
C
      IF (SAPOS.EQ.0) THEN
C       attribute not found
        RETCOD= -107
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDDPAR
     I                   (RREC,SARQWD,SAUPFG,TIBUFF,DELFG,
     O                    RETCOD)
C
C     + + + PURPOSE + + +
C     determines if either data is present and attribute can't be updated
C     or attribute is not allowed for this dataset type
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   RREC,SARQWD,SAUPFG,DELFG,RETCOD
      INTEGER(4)TIBUFF(512)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RREC   - record containing data-set label
C     SARQWD - search attribute required word
C     SAUPFG - flag indicating if attribute may be updated if data present
C              0 - yes, 1 - no
C     TIBUFF - array containing data-set label
C     DELFG  - delete attribute indicator
C              0 - not trying to delete
C              1 - trying to delete
C     RETCOD - return code
C                0 - attribute can be added or updated
C             -104 - data present, can't update attribue
C             -105 - attribute not allowed for this type dataset
C             -106 - attribute required for this type data set, can't delete
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DSTYPE,SAREQ(10),DPFLG
C
C     + + + FUNCTIONS + + +
      INTEGER   WDDTFG
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDTFG,WATTUS
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
C     what type data set
      DSTYPE= TIBUFF(6)
C     is data present
      DPFLG = WDDTFG(RREC,TIBUFF(1))
C     determine required attributes for data sets
      CALL WATTUS (SARQWD,
     O             SAREQ)
      IF (DPFLG.EQ.1 .AND. SAUPFG.EQ.1) THEN
C       data present, cant update attribute
        RETCOD= -104
      ELSE IF (SAREQ(DSTYPE).EQ.0) THEN
C       attribute not allowed for this type data set
        RETCOD= -105
      ELSE IF (SAREQ(DSTYPE).EQ.2 .AND. DELFG.EQ.1) THEN
C       attribute required for this type data set
        RETCOD= -106
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSAFI
     I                   (MESSFL,
     M                    SAFNAM,SAIND,
     O                    SANAM,RETCOD)
C
C     + + + PURPOSE + + +
C     Given the attribute name SAFNAM, starting at attribute
C     index SAIND, find the first attribute name which matches
C     SAFNAM.  Return the index of the next attribute which
C     also matches SAFNAM, if one exists.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SAIND,RETCOD
      CHARACTER(1)SAFNAM(6),SANAM(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     SAFNAM - character array containing attribute name to search for
C     SAIND  - index of next matching attribute, if one exists,
C              otherwise, index of matching attribute
C     SANAM  - character array of first attribute name matching SAFNAM
C     RETCOD - return code
C              -110 - attributes not found on message file
C              -111 - attribute name not found (no match)
C              -112 - more attributes exist which match SAFNAM
C
C     + + + PARAMETERS + + +
      INTEGER     MXSAT,MAXDSN
      PARAMETER  (MXSAT=480,MAXDSN=10)
C
C     + + + SAVES + + +
      INTEGER     SACNT,SAVIND(MXSAT)
      CHARACTER(1)SAVNAM(6,MXSAT)
      SAVE        SACNT,SAVNAM,SAVIND
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,I0,I6,K,K1,CURIND,DONE,CHK,
     1            DSNBUF(MAXDSN),DSNCNT,ATTIND(2,MAXDSN),LSAIND
      CHARACTER(1)BLNK,TMPNAM(6)
C
C     + + + FUNCTIONS + + +
      INTEGER     LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    LENSTR, CHRCHR, QUPCAS, WADDSI, WADGTN
      EXTERNAL    ZIPC, ZIPI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK,I0,I6,SACNT/' ',0,6,0/
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
C     save original input attribute index
      LSAIND= SAIND
C
      IF (SACNT.EQ.0) THEN
C       get offset for attribute names on messfl, only on first call
        CALL ZIPI (MXSAT,I0,SAVIND)
        CALL ZIPC (6*MXSAT,BLNK,SAVNAM)
        DONE = 0
C       get buffer of datasets containing attributes on message file
        CALL WADDSI (MESSFL,MAXDSN,
     O               DSNCNT,DSNBUF,ATTIND)
        IF (DSNCNT.GT.0) THEN
C         attributes found, continue
          SACNT= 0
          DO 10 I= 1,DSNCNT
C           go through datasets containing attributes
            SAIND= ATTIND(1,I)
 20         CONTINUE
C             get the next attribute name from the message file
              CALL WADGTN (MESSFL,SAIND,
     O                     TMPNAM)
              IF (LENSTR(I6,TMPNAM).GT.0) THEN
C               valid name, put in save buffer
                SACNT= SACNT+ 1
                CALL CHRCHR (I6,TMPNAM,SAVNAM(1,SACNT))
                SAVIND(SACNT)= SAIND
              END IF
              SAIND= SAIND+ 1
            IF (SAIND.LE.ATTIND(2,I)) GO TO 20
 10       CONTINUE
C
C         start at original index
          SAIND= LSAIND
        ELSE
C         attributes not found on message file
          RETCOD= -110
        END IF
      END IF
C
      IF (RETCOD.EQ.0) THEN
C       start search for attribute name
C       determine index position to begin search
        I= 0
 25     CONTINUE
          I= I+ 1
          IF (SAVIND(I).EQ.SAIND) THEN
C           number in index position I matches absolute index number
            SAIND= I
            I= MXSAT
          END IF
        IF (I.LT.MXSAT) GO TO 25
C       convert to upper case for search
        CALL QUPCAS (I6,
     M               SAFNAM)
C       init output attribute name
        CALL ZIPC (I6,BLNK,SANAM)
        DONE  = 0
        LSAIND= SAIND
        CURIND= SAIND
 30     CONTINUE
          IF (CURIND.LE.SACNT) THEN
C           check strings
            K= 0
 40         CONTINUE
              K  = K+ 1
              CHK= 0
              IF (SAVNAM(K,CURIND).EQ.SAFNAM(K) .OR.
     1            SAFNAM(K).EQ.BLNK) THEN
C               characters match or blank search name
                CHK= 1
              END IF
              IF (CHK.EQ.1) THEN
                IF (K.EQ.I6) THEN
C                 sure unique match
                  SAIND= CURIND
                  DONE = 1
                ELSE
                  K1= K+ 1
                  IF (SAFNAM(K1).EQ.BLNK) THEN
C                   possible match
                    IF (SAIND.EQ.LSAIND) THEN
C                     first match, save whole name
                      CALL CHRCHR (I6,SAVNAM(1,CURIND),SANAM)
C                     save index
                      SAIND = CURIND
                    ELSE
C                     conflict match
                      RETCOD= -112
C                     done searching for this time through
                      DONE= 1
                    END IF
C                   force exit from inner loop
                    K= 7
                  END IF
                END IF
              END IF
            IF (CHK.EQ.1 .AND. K.LT.6 .AND. DONE.EQ.0) GO TO 40
            IF (DONE.EQ.0) THEN
C             try next index
              CURIND= CURIND+ 1
            END IF
          ELSE
            DONE= 1
          END IF
        IF (DONE.EQ.0) GO TO 30
C
        IF (SAIND.EQ.LSAIND .AND. CURIND.GT.SAIND .AND.
     1      LENSTR(I6,SANAM).EQ.0) THEN
C         no match was found (and searched past original index)
          RETCOD= -111
        END IF
C
C       convert index position back to absolute index number
        SAIND= SAVIND(SAIND)
      END IF
C
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSGX
     I                    (MESSFL,
     M                     SANAM,
     O                     SAIND,SATYP,SALEN)
C
C     + + + PURPOSE + + +
C     routine gets information about search attribute from
C     message file, returns 0 if name is not an attribute
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SAIND,SATYP,SALEN
      CHARACTER(1)SANAM(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - message file unit number
C     SANAM  - name of search attribute
C     SAIND  - search attribute index number
C     SATYP  - type of attribute
C     SALEN  - length of attribute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,RETCOD
      CHARACTER(1)SAFNAM(6)
C
C     + + + EXTERNALS + + +
      EXTERNAL    CHRCHR, WDSAFI, WDSAGY
C
C     + + + END SPECIFICATIONS + + +
C
      I= 6
      CALL CHRCHR (I,SANAM,SAFNAM)
      SAIND= 1
      CALL WDSAFI (MESSFL,SAFNAM,
     M             SAIND,
     O             SANAM,RETCOD)
      IF (((SAIND.GT.0 .AND. SAIND.LT.37) .OR. SAIND.GT.39)
     1    .AND. RETCOD.EQ.0) THEN
C       valid name, get rest of info
        CALL WDSAGY (MESSFL,SAIND,
     O               SANAM,I,SATYP,SALEN,I,I)
      ELSE
C       bad name or help, done, all, fill other info with 0
        SALEN = 0
        SATYP = 0
        IF (RETCOD.NE.0) THEN
C         bad name, set index to not found
          SAIND= 0
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFNDS
     I                    (WDMSFL,TYPE,SACNT,SAIND,SATYP,SABEG,SAVAL,
     I                     SALEN,SAIMIN,SAIMAX,SARMIN,SARMAX,SACOND,
     I                     SAOR,MAXDSN,DSNMIN,DSNMAX,
     M                     DSN,DSNCNT,
     O                     DSBFUL)
C
C     + + + PURPOSE + + +
C     search WDM file for datasets matching search criteria
C     This is a non-interactive version of PRWFDS.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,TYPE,SACNT,DSBFUL,MAXDSN,
     1          DSNCNT,DSNMIN,DSNMAX
      INTEGER   SAIND(*),SATYP(*),SABEG(*),SACOND(*),
     1          SALEN(*),SAIMIN(*),SAIMAX(*),SAOR(*),
     2          DSN(MAXDSN)
      INTEGER(4)SAVAL(30)
      REAL      SARMIN(*),SARMAX(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     TYPE   - type of dataset searching for, 1- timeseries
C     SACNT  - number of search attributes to be considered
C     SAIND  - array of search attribute index numbers
C     SATYP  - array of search attribute type indicators
C              1 - integer number
C              2 - real number
C              3 - alphanumeric character
C     SABEG  - array of beginning positions in value arrays
C     SAVAL  - array of character values
C     SALEN  - array of search attribute lengths
C     SAIMIN - array of minimum acceptable values, integer attributes
C     SAIMAX - array of maximum acceptable values, integer attributes
C     SARMIN - array of minimum acceptable values, real attributes
C     SARMAX - array of maximum acceptable values, real attributes
C     SACOND - array of condition values,
C              1 - true
C              2 - false
C     SAOR   - array of or condition values
C     MAXDSN - maximum number of dataset numbers allowed
C     DSNMIN - minimum dataset number to consider
C     DSNMAX - maxiumu dataset number to consider
C     DSN    - array of dataset numbers
C     DSNCNT - count of dataset numbers found
C     DSBFUL - indicator flag for full DSN array
C              0 - no
C              1 - yes
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CDRLOC.INC'
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,RIND,DSNTMP,NDSN,PFDSN,ODSNCT,
     1          I,J,NOSA,NOMAT,NOADD,NOCHK,RETC
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO, WDDSCK, WDFNCK
C
C     + + + END SPECIFICATIONS + + +
C
      ODSNCT= DSNCNT
      NOSA  = 0
      NOMAT = 0
      NOCHK = 0
      NOADD = 0
      IF (TYPE .GE. 0) THEN
        I   = 0
 10     CONTINUE
C         loop looking by type
          I= I+ 1
          IF (I .EQ. TYPE .OR. TYPE .EQ. 0) THEN
C           bring file definition record into memory
            RREC  = 1
            RIND  = WDRCGO(WDMSFL,RREC)
C           calculate pointers within file definition record
            PFDSN = PTSNUM+ (I-1)* 2+ 1
            DSNTMP= WIBUFF(PFDSN,RIND)
C
            IF (DSNTMP .GT. 0) THEN
 20           CONTINUE
C               loop to check datasets
                CALL WDDSCK (WDMSFL,DSNTMP,RREC,RETC)
                RIND= WDRCGO(WDMSFL,RREC)
                NDSN= WIBUFF(2,RIND)
                CALL WDFNCK (DSNTMP,WIBUFF(1,RIND),WRBUFF(1,RIND),
     I                       SACNT,SAIND,SATYP,SABEG,SAVAL,SALEN,
     I                       SAIMIN,SAIMAX,SARMIN,SARMAX,SACOND,SAOR,
     I                       MAXDSN,
     M                       NOSA,NOMAT,NOCHK,NOADD,DSN,DSNCNT,
     O                       DSBFUL)
                DSNTMP= NDSN
              IF (DSBFUL .EQ. 0 .AND. DSNTMP .GT. 0) GO TO 20
            END IF
          END IF
        IF (DSBFUL .EQ. 0 .AND. I .LT. 9) GO TO 10
      ELSE IF (TYPE .EQ. -1) THEN
C       loop looking by dsn range
        DSNTMP= DSNMIN
 40     CONTINUE
          CALL WDDSCK (WDMSFL,DSNTMP,RREC,RETC)
          IF (RETC .EQ. 0) THEN
            RIND= WDRCGO(WDMSFL,RREC)
            CALL WDFNCK (DSNTMP,WIBUFF(1,RIND),WRBUFF(1,RIND),
     I                   SACNT,SAIND,SATYP,SABEG,SAVAL,SALEN,
     I                   SAIMIN,SAIMAX,SARMIN,SARMAX,SACOND,SAOR,
     I                   MAXDSN,
     M                   NOSA,NOMAT,NOCHK,NOADD,DSN,DSNCNT,
     O                   DSBFUL)
          END IF
          DSNTMP= DSNTMP+ 1
        IF (DSNTMP .LE. DSNMAX .AND. DSBFUL .EQ. 0) GO TO 40
      ELSE
C       loop looking for buffer subset
        I= 1
 50     CONTINUE
          DSNTMP= DSN(I)
          CALL WDDSCK (WDMSFL,DSNTMP,RREC,RETC)
          RIND  = WDRCGO(WDMSFL,RREC)
          CALL WDFNCK (DSNTMP,WIBUFF(1,RIND),WRBUFF(1,RIND),
     I                 SACNT,SAIND,SATYP,SABEG,SAVAL,SALEN,
     I                 SAIMIN,SAIMAX,SARMIN,SARMAX,SACOND,SAOR,
     I                 MAXDSN,
     M                 NOSA,NOMAT,NOCHK,NOADD,DSN,DSNCNT,
     O                 DSBFUL)
          IF (NOADD .GT. 0) THEN
C           dataset met the search criteria
            I    = I+ 1
            NOADD= 0
          ELSE
C           not a match, dataset in buffer, remove it
            J= I
            IF (J .LT. DSNCNT) THEN
 60           CONTINUE
                DSN(J)= DSN(J+1)
                J= J+ 1
              IF (J .LT. DSNCNT) GO TO 60
            END IF
            DSN(DSNCNT)= 0
            DSNCNT= DSNCNT- 1
          END IF
        IF (I .LE. DSNCNT) GO TO 50
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFNCK
     I                    (DSNTMP,TIBUFF,TRBUFF,
     I                     SACNT,SAIND,SATYP,SABEG,SAVAL,SALEN,
     I                     SAIMIN,SAIMAX,SARMIN,SARMAX,SACOND,SAOR,
     I                     MAXDSN,
     M                     NOSA,NOMAT,NOCHK,NOADD,DSN,DSNCNT,
     O                     DSBFUL)
C
C     + + + PURPOSE + + +
C     checks datasets for match of specified search attributes
C     This is a non-interactive version of PRWFCK.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DSNTMP,SACNT,NOSA,NOMAT,NOADD,DSBFUL,NOCHK,
     1          MAXDSN,DSNCNT
      INTEGER   SAIND(*),SATYP(*),SABEG(*),SACOND(*),
     1          SALEN(*),SAIMIN(*),SAIMAX(*),SAOR(*),
     2          DSN(MAXDSN)
      INTEGER(4)SAVAL(30),TIBUFF(512)
      REAL      TRBUFF(512)
      REAL      SARMIN(*),SARMAX(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DSNTMP - current dsn being checked
C     TIBUFF - integer version of current label
C     TRBUFF - real version of current label
C     SACNT  - number of search attributes to be considered
C     SAIND  - array of search attribute index numbers
C     SATYP  - array of search attribute type indicators
C              1 - integer number
C              2 - real number
C              3 - alphanumeric character
C     SABEG  - array of beginning positions in value arrays
C     SAVAL  - array of character values
C     SALEN  - array of search attribute lengths
C     SAIMIN - array of minimum acceptable values, integer attributes
C     SAIMAX - array of maximum acceptable values, integer attributes
C     SARMIN - array of minimum acceptable values, real attributes
C     SARMAX - array of maximum acceptable values, real attributes
C     SACOND - array of condition values,
C              1 - true
C              2 - false
C     SAOR   - array of or condition values
C     MAXDSN - maximum number of dataset numbers
C     NOSA   - num dsn missing attributes
C     NOMAT  - num dsn not matching
C     NOCHK  - num dsn checked
C     NOADD  - num dsn added to buffer
C     DSN    - array of dataset numbers
C     DSNCNT - count of dataset numbers in DSN
C     DSBFUL - indicator flag for full DSN array
C              0 - no
C              1 - yes
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SAMAT,I,SAORIX,SAORFG,DSADD,SAPOS,ITMP,J,K
      REAL      RTMP
C
C     + + + FUNCTIONS + + +
      INTEGER   WDSASV
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSASV
C
C     + + + END SPECIFICATIONS + + +
C
      DSBFUL= 0
      SAORIX= 1
      IF (SACNT .NE. 0) THEN
C       check individual attributes
        SAORFG= 1
        I     = 0
 10     CONTINUE
          SAMAT= 1
 20       CONTINUE
            I= I+ 1
            SAPOS= WDSASV (SAIND(I),TIBUFF)
            IF (SAPOS .GT. 0) THEN
C             attribute present, check value
              GO TO (30,40,50), SATYP(I)
 30           CONTINUE
C               integer
                ITMP= TIBUFF(SAPOS)
                IF (ITMP.LT.SAIMIN(I).OR.ITMP.GT.SAIMAX(I)) SAMAT= 0
                GO TO 60
 40           CONTINUE
C               real
                RTMP= TRBUFF(SAPOS)
                IF (RTMP.LT.SARMIN(I).OR.RTMP.GT.SARMAX(I)) SAMAT= 0
                GO TO 60
 50           CONTINUE
C               character
                K= SABEG(I)
                J= 0
 55             CONTINUE
                  J= J+ 1
                  IF (TIBUFF(SAPOS+J-1).NE.SAVAL(K)) THEN
C                   not a match
                    SAMAT= 0
                  END IF
                  K= K+ 1
                IF (J .LT. (SALEN(I)/4) .AND. SAMAT .EQ. 1) GO TO 55
 60           CONTINUE
              IF (SACOND(I) .EQ. 2) THEN
C               use not true condition
                IF (SAMAT .EQ. 0) THEN
                  SAMAT= 1
                ELSE
                  SAMAT= 0
                END IF
              END IF
            ELSE
              SAMAT= 0
C             only count missing attribute if on last 'or'
              IF (SAOR(SAORIX) .EQ. SACNT) THEN
C               count it
                NOSA = NOSA+ 1
              END IF
            END IF
          IF (SAMAT .EQ. 1 .AND. I .LT. SAOR(SAORIX)) GO TO 20
C         maybe we will make it on an 'or' condition
          IF (SAOR(SAORIX) .GE. SACNT) THEN
C           no or
            SAORFG= 0
          ELSE
C           or case, point to correct attribute
            I= SAOR(SAORIX)
            SAORIX= SAORIX+ 1
          END IF
        IF (SAMAT .EQ. 0 .AND. SAORFG .NE. 0) GO TO 10
        IF (SAMAT.EQ.0) NOMAT= NOMAT+ 1
      ELSE
C       no search criteria, all match
        SAMAT = 1
      END IF
C
      IF (SAMAT .EQ. 1) THEN
C       add dsn to buffer if not there
        DSADD= 1
        DO 110 I= 1,DSNCNT
          IF (DSN(I).EQ.DSNTMP) THEN
C           already there
            DSADD= 0
          END IF
 110    CONTINUE
C
        IF (DSADD.EQ.1) THEN
          IF (DSNCNT .LT. MAXDSN) THEN
C           add new dataset
            DSNCNT= DSNCNT+ 1
            DSN(DSNCNT)= DSNTMP
          ELSE
C           buffer full
            DSBFUL= 1
          END IF
        ELSE
C         didnt add it
          NOADD= NOADD+ 1
        END IF
      END IF
C
      NOCHK= NOCHK+ 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDVRSN
C
C     + + + PURPOSE + + +
C     Dummy routine to include unix what version information for the
C     wdm library.
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER(64) VERSN
C
C     + + + END SPECIFICATIONS + + +
C
      INCLUDE 'FVERSN.INC'
C
      RETURN
      END

C     utwdmf.f 2.1 9/4/91
C
C
C
      SUBROUTINE   WMSQCK
     I                   (WDMSFL,DSN,GNUM,
     O                    QCHK)
C
C     + + + PURPOSE + + +
C     Check to see if a group already exists in a data set on WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,GNUM,QCHK
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DSN    - data-set number on WDM file
C     GNUM   - group number being checked
C     QCHK   - flag indicating existance,
C                0 - data set does not exist or bad group number
C                1 - group exists
C              -81 - data set does not exist
C              -82 - data set exists, but is not a message type data set
C              -84 - data set number out of range
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    IDUM,LREC,LIND,RETCOD,PDAT,PDATV,LPOS,DSTYP,MXGNUM
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDSCHK
C
C     + + + END SPECIFICATIONS + + +
C
      DSTYP= 9
      CALL WDSCHK (WDMSFL,DSN,DSTYP,
     O             LREC,IDUM,RETCOD)
C
      IF (RETCOD.EQ.0) THEN
C       see if group exists
        LIND  = WDRCGO(WDMSFL,LREC)
        PDAT  = WIBUFF(11,LIND)
        PDATV = WIBUFF(12,LIND)
        MXGNUM= PDATV- PDAT- 2
        IF (GNUM.GT.0 .AND. GNUM.LE.MXGNUM) THEN
C         reasonable GNUM
          LPOS= PDAT+ GNUM+ 1
          IF (WIBUFF(LPOS,LIND).EQ.0) THEN
C           doesnt exist
            QCHK= 0
          ELSE
            QCHK= 1
          END IF
        ELSE
C         bad GNUM, doesn't exist
          QCHK= 0
        END IF
      ELSE
        QCHK= RETCOD
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSANG
     I                   (WDMSFL,DSN,GNUM,
     O                    LREC,DREC,DPOS,GRCNT,
     O                    PDAT,PDATVL,RETCOD)
C
C     + + + PURPOSE + + +
C     Check that data-set DSN exists and that there is space
C     in the data set for a new group.  Determines pointers
C     to start of new group.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,GNUM,LREC,DREC,DPOS,GRCNT,
     1          PDAT,PDATVL,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DSN    - data-set number on WDM file
C     GNUM   - group number in data set
C     LREC   - first record number of DSN on WDM file (contains label)
C     DREC   - record number on WDM file for start of group-number GNUM
C     DPOS   - position on DREC for start of group-number GNUM
C     GRCNT  - counter for number of groups on data set (including this group)
C     PDAT   - pointer to the start of group pointers
C     PDATVL - pointer to beginning of data for this group
C     RETCOD - return code
C                0 - group successfully added to data set
C                1 - exists
C               -3 - data set does not exist
C              -22 - data set exists, but is not message data-set type
C              -26 - no room for another group on data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    PDATV,MXNGR,DIND,LIND,IDUM,DSTYP
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGO, WDRCGX, WDPTCL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDRCGX, WDPTCL, WDSCHK, WDPTSP
C
C     + + + END SPECIFICATIONS + + +
C
      IDUM  = 0
      RETCOD= 0
      DSTYP = 9
C     check existance
      CALL WDSCHK (WDMSFL,DSN,DSTYP,
     O             LREC,GRCNT,RETCOD)
C
      IF (RETCOD.EQ.0) THEN
C       space for another group
        LIND = WDRCGO(WDMSFL,LREC)
        PDAT = WIBUFF(11,LIND)
        PDATV= WIBUFF(12,LIND)
        MXNGR= PDATV- PDAT- 1
        IF (GNUM.GT.MXNGR) RETCOD= -26
      END IF
C
      IF (RETCOD.EQ.0) THEN
C       ok to add the group to this data set
        PDATVL= WIBUFF(PDAT+1,LIND)
C       increment group count
        GRCNT = GRCNT+ 1
C       get start of data (record and position)
        CALL WDPTSP (PDATVL,
     O               DREC,DPOS)
        DIND  = WDRCGO(WDMSFL,DREC)
        IF (DPOS.EQ.0) THEN
C         start the group on the next record,
C         first reset record to current value
          DREC= DREC- 1
          DIND= WDRCGX(WDMSFL,IDUM,DREC)
          DREC= RECNO(DIND)
          DPOS= 5
          PDATVL= WDPTCL(DREC,DPOS)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSADI
     I                   (WDMSFL,DSN,GNUM,CLASS,ID,ORDER,
     I                    ILEN,IBUFF,INUM,IVAL,IFLG)
C
C     + + + PURPOSE + + +
C     Add portion of group-number GNUM information to DSN.
C     Will be called more than once to define a given group.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,DSN,GNUM,CLASS,ID,ORDER,ILEN,INUM,IFLG
      INTEGER     IVAL(INUM)
      CHARACTER(1)IBUFF(ILEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DSN    - data-set number on WDM file,
C              negative value indicates termination of group
C              and updating of label
C     GNUM   - group number being added
C     CLASS  - class of information being added
C              1 - 1-dimensional parameter      4 - menu
C              2 - 2-dimensional parameter      5 - file
C              3 - text
C     ID     - id for portion of group being added
C              examples:  CLASS  ID  Description
C                           1     4  default value for parameter field
C                           4     6  help for menu screen
C                           5     3  status of file
C     ORDER  - order of information being added
C     ILEN   - length of input buffer (minimum of 1)
C     IBUFF  - input buffer of character data to add
C     INUM   - number of integer values to add (minimum of 1)
C     IVAL   - input buffer of integer parameters to add
C     IFLG   - flag indicating type of data being added
C              0 - character data
C              1 - integer data
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + SAVES + + +
      INTEGER     DPOS,DIND,DREC,LDSN,LGNUM,LID,LORDER,TLEN,GLEN,
     1            BREC,BPOS,LREC,PDAT,GRCNT,PDATVL,ADIFG
      SAVE        DPOS,DIND,DREC,LDSN,LGNUM,LID,LORDER,TLEN,GLEN,
     1            BREC,BPOS,LREC,PDAT,GRCNT,PDATVL,ADIFG
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,LIND,RETCOD,BCWORD,NEWPOS,BIND,LPOS,
     1            CTLEN,RDWRFG,INEW
C
C     + + + FUNCTIONS + + +
      INTEGER    LENSTR, WDRCGO, WDPTCL, WMSBCV
C
C     + + + EXTERNALS + + +
      EXTERNAL   LENSTR, WDRCGO, WDRCUP, WDPTCL, WMSBCV
      EXTERNAL   WDNXPS, WMSANG, WMSPTE
C
C     + + + DATA INITIALIZATIONS + + +
      DATA DPOS,DIND,DREC,LDSN,LGNUM,BIND,BPOS,GLEN,ADIFG
     1    / 0,   0,   0,   0,    0,    0,   0,   0,   0/
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 2
      RETCOD= 0
      INEW  = 0
C
      IF (DSN.LT.0 .AND. ADIFG.GT.0) THEN
C       end of group and some info was added, put 0 in for terminator
        CALL WDNXPS (WDMSFL,RDWRFG,
     M               DREC,DPOS,
     O               DIND)
        WIBUFF(DPOS,DIND)= 0
        CALL WDRCUP(WDMSFL,DIND)
C       new free data position
        CALL WDNXPS (WDMSFL,RDWRFG,
     M               DREC,DPOS,
     O               DIND)
        NEWPOS= WDPTCL(DREC,DPOS)
C       store new label info
        LIND= WDRCGO(WDMSFL,LREC)
        WIBUFF(PDAT,LIND)  = GRCNT
        WIBUFF(PDAT+1,LIND)= NEWPOS
        LPOS= PDAT+ GNUM+ 1
        WIBUFF(LPOS,LIND)  = PDATVL
        CALL WDRCUP(WDMSFL,LIND)
C       reinit flag indicating information has been added
        ADIFG= 0
        LDSN = DSN
      ELSE IF (DSN.NE.LDSN .OR. GNUM.NE.LGNUM) THEN
C       new group
        INEW  = 1
        LDSN  = DSN
        LGNUM = GNUM
        LID   = -1
        LORDER= -1
C       set up and get parms for new group
        CALL WMSANG (WDMSFL,DSN,GNUM,
     O               LREC,DREC,DPOS,GRCNT,
     O               PDAT,PDATVL,RETCOD)
C       update flag indicating information has been added
        ADIFG= 1
      END IF
C
      IF (RETCOD.EQ.0 .AND. DSN.GT.0) THEN
C       store this portion of group block control word
        IF (IFLG.EQ.0) THEN
C         storing character data
          CTLEN= LENSTR(ILEN,IBUFF)
          IF (CTLEN.EQ.0) THEN
C           blank line, leave blank characters
            CTLEN= 1
          END IF
        ELSE
C         storing integer parms, length of 4 for each value
          CTLEN= (4* INUM)- 1
        END IF
        IF (LID.EQ.ID .AND. LORDER.EQ.ORDER .AND. ID.NE.23) THEN
C         continuation of previous information (not HIDE info)
          TLEN= TLEN+ CTLEN+ 1
        ELSE
C         new portion of group, update length and block pos
          GLEN  = 0
          TLEN  = CTLEN+ 1
          IF (INEW.EQ.0) THEN
C           only skip to next free data position if continuing group
            CALL WDNXPS (WDMSFL,RDWRFG,
     M                   DREC,DPOS,
     O                   DIND)
          END IF
          BPOS  = DPOS
          BREC  = DREC
          LID   = ID
          LORDER= ORDER
        END IF
        BIND   = WDRCGO(WDMSFL,BREC)
        BCWORD = WMSBCV(CLASS,ID,ORDER,TLEN)
        WIBUFF(BPOS,BIND)= BCWORD
        CALL WDRCUP(WDMSFL,BIND)
C
        IF (IFLG.EQ.0) THEN
C         buffer to store
          CALL WMSPTE (WDMSFL,CTLEN,IBUFF,
     M                 DREC,DPOS,GLEN)
        ELSE
C         store integer word(s)
          DO 10 I= 1,INUM
            CALL WDNXPS (WDMSFL,RDWRFG,
     M                   DREC,DPOS,
     O                   DIND)
            WIBUFF(DPOS,DIND)= IVAL(I)
 10       CONTINUE
          CALL WDRCUP(WDMSFL,DIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDNXPS
     I                   (WDMSFL,RDWRFG,
     M                    DREC,DPOS,
     O                    DIND)
C
C     + + + PURPOSE + + +
C     Get the next data position on a WDM file.  If RDWRFG is 1 and
C     a new record is needed, the next data record is brought into
C     the WDM buffer of records.  If RDWRFG is 2 and a new record
C     is needed, the current record is updated and the next free
C     record is brought into the WDM buffer of records.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,RDWRFG,DREC,DPOS,DIND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     RDWRFG - read/write flag (1- read, 2- write)
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record (both DREC and DIND)
C     DIND   - index of record in WDM buffer of records
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    IDUM
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGX, WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCUP, WDRCGX, WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      IDUM= 0
      DIND= WDRCGO (WDMSFL,DREC)
      DPOS= DPOS+ 1
      IF (DPOS.GT.512) THEN
C       next record
        IF (RDWRFG.EQ.1) THEN
C         reading, bring next record into buffer
          DREC= WIBUFF(4,DIND)
          DIND= WDRCGO (WDMSFL,DREC)
        ELSE
C         writing, update current record, bring in new one
          CALL WDRCUP(WDMSFL,DIND)
          DIND= WDRCGX(WDMSFL,IDUM,DREC)
          DREC= RECNO(DIND)
        END IF
        DPOS= 5
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDNXDV
     I                   (WDMSFL,
     M                    DREC,DPOS,
     O                    DVAL)
C
C     + + + PURPOSE + + +
C     Move to the next data position and return the
C     integer equivalent of the data value.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DREC,DPOS,DVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record (both DREC and DIND)
C     DVAL   - data value on WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    DIND,RDWRFG
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDNXPS
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 1
C     move to next data position
      CALL WDNXPS (WDMSFL,RDWRFG,
     M             DREC,DPOS,
     O             DIND)
C
C     get the data value
      DVAL= WIBUFF(DPOS,DIND)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDPRPS
     I                   (WDMSFL,
     M                    DREC,DPOS,
     O                    DIND)
C
C     + + + PURPOSE + + +
C     Get the previous data position on a WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DREC,DPOS,DIND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record (both DREC and DIND)
C     DIND   - index of record in WDM buffer of records
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      DIND= WDRCGO (WDMSFL,DREC)
      DPOS= DPOS- 1
      IF (DPOS.LT.5) THEN
C       bring previous record into buffer
        DREC= WIBUFF(3,DIND)
        DIND= WDRCGO (WDMSFL,DREC)
        DPOS= 512
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSPTE
     I                   (WDMSFL,CTLEN,IBUFF,
     M                    DREC,DPOS,GLEN)
C
C     + + + PURPOSE + + +
C     Add one record of text to WDM file.  May be called more
C     than once if text is multiple lines (e.g. help information).
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,CTLEN,DREC,DPOS,GLEN
      CHARACTER(1)IBUFF(CTLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     CTLEN  - text length being added this call (minimum of 1)
C     IBUFF  - array of size CTLEN to be put on WDM file
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record
C     GLEN   - counter to keep track of when to write to WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + SAVES + + +
      INTEGER     DIND
      CHARACTER(4)CTXT4
      SAVE        DIND,CTXT4
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     J,ILEN,RDWRFG,CFLG
      CHARACTER(1)CNULL
C
C     + + + INTRINSICS + + +
      INTRINSIC  MOD, CHAR
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDNXPS
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT(A4)
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 2
      CNULL = CHAR(0)
C
      IF (MOD(GLEN,4).EQ.0) THEN
C       not continuing an old group with space in last pos
        CFLG = 0
        CTXT4= ' '
      ELSE
C       continue old group
        CFLG = 1
      END IF
C
      ILEN = 0
 100  CONTINUE
        ILEN= ILEN+ 1
        GLEN= GLEN+ 1
        IF (ILEN.LE.CTLEN) THEN
          CTXT4(GLEN:GLEN)= IBUFF(ILEN)
        ELSE
C         write null to terminate record
          CTXT4(GLEN:GLEN)= CNULL
        END IF
        IF (MOD(GLEN,4).EQ.0) THEN
C         time to put in buffer
          GLEN= 0
          IF (CFLG.EQ.0) THEN
C           get next data position
            CALL WDNXPS (WDMSFL,RDWRFG,
     M                   DREC,DPOS,
     O                   DIND)
          END IF
          CFLG= 0
          READ (CTXT4,1000) WIBUFF(DPOS,DIND)
          CTXT4= ' '
        END IF
      IF (ILEN.LE.CTLEN) GO TO 100
C
      J= MOD(GLEN,4)
      IF (J.GT.0) THEN
C       characters left
        IF (CFLG.EQ.0) THEN
C         get next data position
          CALL WDNXPS (WDMSFL,RDWRFG,
     M                 DREC,DPOS,
     O                 DIND)
        END IF
        READ (CTXT4,1000) WIBUFF(DPOS,DIND)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSGTE
     I                   (WDMSFL,TLEN,LLEN,
     M                    DREC,DPOS,GLEN,MLEN,
     O                    OLEN,OBUFF,CONT)
C
C     + + + PURPOSE + + +
C     Get one record of text off WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,TLEN,LLEN,DREC,DPOS,GLEN,MLEN,OLEN,CONT
      CHARACTER(1)OBUFF(LLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     TLEN   - total length of text (may be more than one record)
C     LLEN   - maximum size of record to get
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record
C     GLEN   - counter to keep track of when to read off WDM file
C              should be initialized to 0 for first call
C     MLEN   - number of characters retrieved so far (must be <= TLEN)
C              should be initialized to 0 for first call
C     OLEN   - actual size of record retreived
C     OBUFF  - array of size LLEN containing OLEN characters retrieved
C     CONT   - indicator flag for text
C              0 - no more text available
C              1 - more text available
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     DONFG,RDWRFG,DIND,INULL,ITMP
      CHARACTER(1)BLNK,CTMP
      CHARACTER(4)CTXT4
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD, ICHAR
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDRCGO, ZIPC, WDNXPS
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (A4)
C
C     + + + END SPECIFICATIONS + + +
C
      BLNK  = ' '
      INULL = 0
      OLEN  = 0
      CONT  = 1
      DONFG = 0
      RDWRFG= 1
      CALL ZIPC (LLEN,BLNK,OBUFF)
      DIND  = WDRCGO(WDMSFL,DREC)
      WRITE (CTXT4,2000) WIBUFF(DPOS,DIND)
C
 10   CONTINUE
C       read until null character
        IF (MOD(GLEN,4).EQ.0) THEN
C         read off WDM file (next position if already read some)
          CALL WDNXPS (WDMSFL,RDWRFG,
     M                 DREC,DPOS,
     O                 DIND)
C         read more text
          WRITE (CTXT4,2000) WIBUFF(DPOS,DIND)
          GLEN= 0
        END IF
        GLEN= GLEN+ 1
        MLEN= MLEN+ 1
        CTMP= CTXT4(GLEN:GLEN)
        ITMP= MOD(ICHAR(CTMP),128)
        IF (ITMP.EQ.INULL) THEN
C         record terminator
          DONFG= 1
        ELSE IF (OLEN.LT.LLEN) THEN
C         save character in output buffer
          OLEN= OLEN+ 1
          OBUFF(OLEN)= CTMP
        END IF
        IF (MLEN.GE.TLEN) THEN
C         end of group text
          CONT = 0
          CTXT4= ' '
          DONFG= 1
        END IF
      IF (DONFG.EQ.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSBTR
     I                   (WDMSFL,NREC,
     M                    DREC,DPOS,MLEN,GLEN,
     O                    TOPFG)
C
C     + + + PURPOSE + + +
C     Back up NREC text records in a text group and reset the
C     pointers for that record.  Usually used in conjunction
C     with WMSGTE for reviewing text in a scrolling window.
C     Input values of GLEN and MLEN are set by previous call
C     to WMSGTE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,NREC,DREC,DPOS,MLEN,GLEN,TOPFG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     NREC   - number of records to back up
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record
C     GLEN   - counter to keep track of when to read off WDM file
C     MLEN   - number of characters retrieved so far (must be <= TLEN)
C     TOPFG  - indicator flag for beginning of group
C              0 - not the beginning of the group
C              1 - beginning of group reached
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + SAVES + + +
      CHARACTER(4)CTXT4
      SAVE        CTXT4
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     DONFG,DIND,INULL,ITMP,CREC
      CHARACTER(1)CTMP
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC   ICHAR, MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDRCGO, WDPRPS
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CTXT4/'    '/
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (A4)
C
C     + + + END SPECIFICATIONS + + +
C
      INULL = 0
      TOPFG = 0
      CREC  = 0
C     get current data value in CTXT4
      DIND= WDRCGO (WDMSFL,DREC)
      WRITE (CTXT4,2000) WIBUFF(DPOS,DIND)
C
 10   CONTINUE
        DONFG= 0
        CREC = CREC+ 1
 20     CONTINUE
C         back up until null character
          GLEN= GLEN- 1
          IF (GLEN.EQ.0) THEN
C           read off WDM file (previous position)
            CALL WDPRPS (WDMSFL,
     M                   DREC,DPOS,
     O                   DIND)
C           read more text
            WRITE (CTXT4,2000) WIBUFF(DPOS,DIND)
            GLEN= 4
          END IF
          MLEN= MLEN- 1
          IF (MLEN.EQ.0) THEN
C           beginning of group
            TOPFG= 1
          END IF
          CTMP= CTXT4(GLEN:GLEN)
          ITMP= MOD(ICHAR(CTMP),128)
          IF (ITMP.EQ.INULL) THEN
C           record terminator
            DONFG= 1
          END IF
        IF (DONFG.EQ.0 .AND. TOPFG.EQ.0) GO TO 20
      IF (CREC.LT.NREC .AND. TOPFG.EQ.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSGTO
     I                   (WDMSFL,SUCIFL,TLEN,
     M                    DREC,DPOS)
C
C     + + + PURPOSE + + +
C     Starting at the input DREC and DPOS, get and write text to a
C     sequential file until end of text is reached.  DREC and DPOS
C     are output as the position at the end of the text.  Usually
C     used to export text portions of message data-set groups.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,SUCIFL,TLEN,DREC,DPOS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     SUCIFL - Fortran unit number for output file
C     TLEN   - total length of text
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,GLEN,MLEN,I256,OLEN,CONT
      CHARACTER(1)OBUFF(256)
C
C     + + + FUNCTIONS + + +
      INTEGER     LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    LENSTR, WMSGTE
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (256A1)
C
C     + + + END SPECIFICATIONS + + +
C
      I256= 256
      GLEN= 0
      MLEN= 0
C
 10   CONTINUE
C       write text lines until cont is 0
        CALL WMSGTE (WDMSFL,TLEN,I256,
     M               DREC,DPOS,GLEN,MLEN,
     O               OLEN,OBUFF,CONT)
        IF (OLEN.GT.0) THEN
C         output string, then cr/lf
          J = LENSTR(OLEN,OBUFF)
          WRITE (SUCIFL,2000) (OBUFF(I),I=1,J)
        ELSE
C         only write a cr/lf
          WRITE (SUCIFL,2000)
        END IF
      IF (CONT.EQ.1) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSBCX
     I                   (WDMSFL,BCWPTR,
     O                    DREC,DPOS,CLASS,ID,ORDER,TLEN)
C
C     + + + PURPOSE + + +
C     Given pointer to a block control word, return its
C     record number and position, and the information
C     stored there (CLASS,ID,ORDER,TLEN).  Usually used
C     to find start of help information.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,BCWPTR,DREC,DPOS,CLASS,ID,ORDER,TLEN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     BCWPTR - pointer to block control word
C     DREC   - record number of data on WDM file
C     DPOS   - position of data on data record
C     CLASS  - class of information being added
C              1 - 1-dimensional parameter      4 - menu
C              2 - 2-dimensional parameter      5 - file
C              3 - text
C     ID     - id for portion of group being added
C              examples:  CLASS  ID  Description
C                           1     4  default value for parameter field
C                           4     6  help for menu screen
C                           5     3  status of file
C     ORDER  - order of information
C     TLEN   - total number of characters in the block
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    DIND
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP, WMSBCS, WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
C     split pointer into record/offset
      CALL WDPTSP (BCWPTR,
     O             DREC,DPOS)
      IF (DPOS.EQ.0) THEN
C       if position was 512, WDPTSP will return as 0, reset to 512
        DPOS= 512
        DREC= DREC- 1
        WRITE (99,*) 'In WMSBCX:  Reset DPOS from 0 to 512, DREC-1'
      END IF
      DIND= WDRCGO (WDMSFL,DREC)
      CALL WMSBCS (WIBUFF(DPOS,DIND),
     O             CLASS,ID,ORDER,TLEN)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSFBC
     I                    (WDMSFL,DSN,GNUM,
     O                     DREC,DPOS,BCWORD)
C
C     + + + PURPOSE + + +
C     Get first block control word and its position
C     for group GNUM in a message data set.
C     A STOP is encountered when group GNUM does not exist.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,GNUM,DREC,DPOS,BCWORD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DSN    - data-set number
C     GNUM   - group number
C     DREC   - record number of block control word on WDM file
C     DPOS   - position of block control word on DREC
C     BCWORD - block control word
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RETCOD,LREC,LPOS,LIND,PDAT
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WMSQCK, WDPTSP
C
C     + + + END SPECIFICATIONS + + +
C
C     assume group doesnt exist
      BCWORD= 0
C
C     check existence of DSN
      CALL WMSQCK (WDMSFL,DSN,GNUM,
     O             RETCOD)
C
      IF (RETCOD.EQ.1) THEN
C       all ok, get label index
        CALL WDDSCK (WDMSFL,DSN,
     O               LREC,RETCOD)
        LIND= WDRCGO(WDMSFL,LREC)
C       get needed pointers
        PDAT= WIBUFF(11,LIND)
        LPOS= PDAT+ GNUM+ 1
        CALL WDPTSP (WIBUFF(LPOS,LIND),
     O               DREC,DPOS)
        LIND = WDRCGO(WDMSFL,DREC)
        BCWORD= WIBUFF(DPOS,LIND)
      ELSE
C       bad group number
        OPEN (UNIT=88,FILE='BADWDM.FIL',STATUS='UNKNOWN')
        WRITE (88,*)
        WRITE (88,*) 'BAD WDMSFL,DSN,GNUM,RETCOD',WDMSFL,DSN,GNUM,RETCOD
        WRITE (88,*)
        CLOSE (UNIT=88)
        STOP
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSIDP
     I                   (WDMSFL,DSN,GNUM,ID,
     O                    DREC,DPOS)
C
C     + + + PURPOSE + + +
C     Return the record number and position on the WDM
C     file for the given ID.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,GNUM,ID,DREC,DPOS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DSN    - data-set number on WDM file
C     GNUM   - group number in data set
C     ID     - identification of information
C     DREC   - record number on WDM file (0 returned if no match)
C     DPOS   - position on record (0 returned if no match)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,CLASS,LID,ORDER,TLEN,ILEN,IMATCH,DIND,BCWORD,RDWRFG
C
C     + + + INTRINSICS + + +
      INTRINSIC  MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WMSFBC, WMSBCS, WDNXPS, WDNXDV
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 1
      IMATCH= 0
C     get first block control word for group
      CALL WMSFBC (WDMSFL,DSN,GNUM,
     O             DREC,DPOS,BCWORD)
C
 10   CONTINUE
C       look through group for matching ids
        IF (BCWORD.EQ.0) THEN
C         ids never matched or bad group
          DREC  = 0
          DPOS  = 0
          IMATCH= -1
        ELSE
C         split block control word
          CALL WMSBCS (BCWORD,
     O                 CLASS,LID,ORDER,TLEN)
C         do ids match
          IF (LID.EQ.ID) THEN
C           ids match, return record and position
            IMATCH= 1
          ELSE
C           ids dont match, skip to next BCWORD
            ILEN= TLEN/4
            IF (MOD(TLEN,4).NE.0) THEN
C             one more value to skip
              ILEN= ILEN+ 1
            END IF
            DO 100 I= 1,ILEN
              CALL WDNXPS (WDMSFL,RDWRFG,
     M                     DREC,DPOS,
     O                     DIND)
 100        CONTINUE
C           get the next block control word
            CALL WDNXDV (WDMSFL,
     M                   DREC,DPOS,
     O                   BCWORD)
          END IF
        END IF
      IF (IMATCH.EQ.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSSKB
     I                    (WDMSFL,TLEN,
     M                     DREC,DPOS)
C
C     + + + PURPOSE + + +
C     Position DREC and DPOS at the end of the current data block.
C     DREC and DPOS are assumed to be input as the start of the block.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,TLEN,DREC,DPOS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     TLEN   - total number of characters to skip
C     DREC   - record number on WDM file
C     DPOS   - position on record DREC
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,HLEN,RDWRFG,LIND
C
C     + + + INTRINSICS + + +
      INTRINSIC  MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDNXPS
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 1
      HLEN  = TLEN/4
      IF (MOD(TLEN,4).GT.0) HLEN= HLEN+ 1
      DO 100 I= 1,HLEN
        CALL WDNXPS (WDMSFL,RDWRFG,
     M               DREC,DPOS,
     O               LIND)
 100  CONTINUE
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDBCRL
     I                    (WDMSFL,DSN,DSTYPE,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     add a label to a wdmsfl
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DSTYPE,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number to add
C     DSTYPE - type of data set, 1- timeseries, 2-table, ...
C     RETCOD - return code,
C                0 - label added
C              -71 - data set already exists
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   PSA,RREC,LWDMFL,LDSN
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDLBAD, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
      CALL WDDSCK (LWDMFL,LDSN,
     O             RREC,RETCOD)
C
      IF (RETCOD.EQ.-81) THEN
C       data set does not exist, add the label
        CALL WDLBAD(LWDMFL,LDSN,DSTYPE,
     O              PSA)
        RETCOD= 0
      ELSE
C       data set already exists, can not add a label
        RETCOD= -71
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSGC
     I                    (WDMSFL,DSN,SAIND,SALEN,
     O                     SAVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     gets values of character search attribute for a dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,SAIND,SALEN,DSN,RETCOD
      CHARACTER(1)SAVAL(SALEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number to add
C     SAIND  - index number of attribute
C     SALEN  - length of attribute
C     SAVAL  - value of attribute
C     RETCOD - return code,
C                 0 - attribute value returned
C               -81 - data set does not exist
C              -107 - attribute not present on this data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     SAPOS,RREC,RIND,I,J,K,LWDMFL,LDSN
      CHARACTER(4)C4DUM
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDDSCK, WDRCGO, WDSAFL, WID2UD
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT (4A1)
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (A4)
C
C     + + + END SPECIFICATIONS + + +
C
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
      CALL WDDSCK (LWDMFL,LDSN,
     O             RREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       data set exists, get position within buffer
        RIND= WDRCGO(LWDMFL,RREC)
C       get starting position for search attribute
        CALL WDSAFL (SAIND,WIBUFF(1,RIND),
     O               SAPOS,RETCOD)
        IF (RETCOD.EQ.0) THEN
          J= SAPOS
          DO 10 I= 1,SALEN,4
            WRITE (C4DUM,2000) WIBUFF(J,RIND)
            READ  (C4DUM,1000) (SAVAL(K),K=I,I+3)
            J= J+ 1
 10       CONTINUE
        END IF
      END IF
      IF (RETCOD.NE.0) THEN
C       no value found, return blanks
        DO 20 I= 1,SALEN
          SAVAL(I)= ' '
 20     CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSGI
     I                    (WDMSFL,DSN,SAIND,SALEN,
     O                     SAVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     gets the values of integer search attribute for a dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,SAIND,SALEN,DSN,RETCOD
      INTEGER   SAVAL(SALEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number to add
C     SAIND  - index number of attribute
C     SALEN  - length of attribute
C     SAVAL  - value of attribute
C     RETCOD - return code,
C                 0 - attribute value returned
C               -81 - data set does not exist
C              -107 - attribute not present on this data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SAPOS,RREC,RIND,I,J,LWDMFL,LDSN
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDSAFL, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
      CALL WDDSCK(LWDMFL,LDSN,
     O            RREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       data set exists, get position within buffer
        RIND= WDRCGO(LWDMFL,RREC)
C       get starting position for search attribute
        CALL WDSAFL (SAIND,WIBUFF(1,RIND),
     O               SAPOS,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         get the value
          DO 10 I= 1,SALEN
            J= SAPOS+I-1
            SAVAL(I)= WIBUFF(J,RIND)
 10       CONTINUE
        END IF
      END IF
      IF (RETCOD.NE.0) THEN
C       no value found, return dummy value
        DO 20 I= 1,SALEN
          SAVAL(I)= -999
 20     CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBSGR
     I                    (WDMSFL,DSN,SAIND,SALEN,
     O                     SAVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     Get the values of real search attribute for a data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,SAIND,SALEN,DSN,RETCOD
      REAL      SAVAL(SALEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number to add
C     SAIND  - index number of attribute
C     SALEN  - length of attribute
C     SAVAL  - value of attribute
C     RETCOD - return code
C                 0 - attribute value returned
C               -81 - data set does not exist
C              -107 - attribute not present on this data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SAPOS,RREC,RIND,I,J,LWDMFL,LDSN
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDSAFL, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
      CALL WDDSCK (LWDMFL,LDSN,
     O             RREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       data set exists, get position within buffer
        RIND= WDRCGO(LWDMFL,RREC)
C       get starting position for search attribute
        CALL WDSAFL (SAIND,WIBUFF(1,RIND),
     O               SAPOS,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         get the value
          DO 10 I= 1,SALEN
            J= SAPOS+I-1
            SAVAL(I)= WRBUFF(J,RIND)
 10       CONTINUE
        END IF
      END IF
      IF (RETCOD.NE.0) THEN
C       no value found, return dummy value
        DO 20 I= 1,SALEN
          SAVAL(I)= -999.
 20     CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDDSRN
     I                    (WDMSFL,ODSN,NDSN,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     routine to renumber data sets with no user interaction
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,ODSN,NDSN,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     ODSN   - old data-set number
C     NDSN   - new data-set number
C     RETCOD - return code
C                0 - renumber successfully completed
C              -72 - old data set does not exist
C              -73 - new data set already exists
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,OREC,NREC,RREC,RIND,DSTYPE,PRDSN,NXDSN
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO, WDRCUP, WDDSCK, WDFDUP
C
C     + + + END SPECIFICATIONS + + +
C
C     does old data set exist?
      CALL WDDSCK (WDMSFL,ODSN,
     O             OREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       old exists, does new data set exist?
        CALL WDDSCK (WDMSFL,NDSN,
     O               NREC,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         it does, can't renumber
          RETCOD= -73
        ELSE
C         it does not, reset return code
          RETCOD= 0
        END IF
      ELSE
C       no old data set
        RETCOD= -72
      END IF
      IF (RETCOD.EQ.0) THEN
C       old data set exists, new data set does not
        RIND= WDRCGO (WDMSFL,OREC)
        I= 5
        WIBUFF(I,RIND)= NDSN
        CALL WDRCUP (WDMSFL,RIND)
        I= 6
        DSTYPE= WIBUFF(I,RIND)
        I= 1
        PRDSN = WIBUFF(I,RIND)
        I= 2
        NXDSN = WIBUFF(I,RIND)
C       update directory records, delete old entry
        I= 0
        CALL WDFDUP (WDMSFL,ODSN,I)
C       add new entry
        CALL WDFDUP (WDMSFL,NDSN,OREC)
C       update data set chain
        IF (NXDSN.GT.0) THEN
C         update next data set's back pointer
          CALL WDDSCK (WDMSFL,NXDSN,
     O                 RREC,RETCOD)
          RIND= WDRCGO (WDMSFL,RREC)
          WIBUFF(1,RIND)= NDSN
          CALL WDRCUP (WDMSFL,RIND)
        END IF
        IF (PRDSN.GT.0) THEN
C         update previous data-set next pointer
          CALL WDDSCK (WDMSFL,PRDSN,
     O                 RREC,RETCOD)
          RIND= WDRCGO (WDMSFL,RREC)
          I   = 2
          WIBUFF(I,RIND)= NDSN
          CALL WDRCUP (WDMSFL,RIND)
        ELSE
C         update file label record chain DSN
          RREC= 1
          RIND= WDRCGO (WDMSFL,RREC)
          I   = PTSNUM+ (DSTYPE-1)*2+ 1
          WIBUFF(I,RIND)= NDSN
          CALL WDRCUP (WDMSFL,RIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDDSCL
     I                     (OWDMFL,ODSN,NWDMFL,NDSN,NTYPE,
     O                      RETCOD)
C
C     + + + PURPOSE + + +
C     copies an old data-set label into a new data-set label
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   OWDMFL,ODSN,NWDMFL,NDSN,NTYPE,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OWDMFL - old watershed data management file unit number
C     ODSN   - old data-set number
C     NWDMFL - new watershed data management file unit number
C     NDSN   - new data-set number
C     NTYPE  - new data-set type, 0 - same as old,
C                1 - timeseries, 2-table, etc.
C     RETCOD - return code
C                0 - copy complete
C              -61 - old data set doesn't exist
C              -62 - new data set already exists
C              -63 - data-set type out of range
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OFREC,OIND,NFREC,NIND,DSTYPE,I,PRNREC,PDAT
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO,WDRCGX,WDPTCL
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDFCUP, WDFDUP, WDPTCL, WDRCGO, WDRCGX, WDRCUP
      EXTERNAL  WDCRDT
C
C     + + + END SPECIFICATIONS + + +
C
C     write(99,*) 'WDDSCL:',OWDMFL,ODSN,NWDMFL,NDSN,NTYPE
      RETCOD= 0
C     check for old data set
      CALL WDDSCK (OWDMFL,ODSN,
     O             OFREC,RETCOD)
      IF (OFREC.EQ.0) THEN
C       old data set does not exist
        RETCOD= -61
      ELSE IF (NTYPE.LT.0 .OR. NTYPE.GT.9) THEN
C       bad dataset type
        RETCOD= -63
      ELSE
C       check for new data set
        CALL WDDSCK(NWDMFL,NDSN,
     O              NFREC,RETCOD)
        IF (NFREC.GT.0) THEN
C         new data set already exists
          RETCOD= -62
        ELSE
C         ok to copy
          RETCOD= 0
        END IF
      END IF
C
      IF (RETCOD.EQ.0) THEN
C       ok to copy
        OIND  = WDRCGO(OWDMFL,OFREC)
C       type of data set
        IF (NTYPE .EQ. 0) THEN
C         use old data set type
          DSTYPE= WIBUFF(6,OIND)
        ELSE
C         new data set type specified
          DSTYPE= NTYPE
        END IF
C       where data pointers start
        PDAT  = WIBUFF(11,OIND)
C       get a new record with no pointers
        PRNREC= 0
        I     = 0
        NIND  = WDRCGX(NWDMFL,I,PRNREC)
        PRNREC= RECNO(NIND)
C       write(99,*) '  oind,nind,ofrec,prnrec,dstype:',
C    1                 OIND,NIND,OFREC,PRNREC,DSTYPE
C       fill in new dsn
        WIBUFF(5,NIND)= NDSN
C       fill in new data set type
        WIBUFF(6,NIND)= DSTYPE
C       update new record
        CALL WDRCUP(NWDMFL,NIND)
C       add new dsn to directories
C       first data set directory
        CALL WDFDUP (NWDMFL,NDSN,PRNREC)
C       next pointer in file def rec and dsn pointers
        I= 1
        CALL WDFCUP (NWDMFL,DSTYPE,NDSN,I)
C
C       be sure old label is still in memory
        OIND= WDRCGO(OWDMFL,OFREC)
C       be sure old label is still in memory
        NIND= WDRCGO(NWDMFL,PRNREC)
C       write(99,*) '  oind,rec,nind,rec:',OIND,RECNO(OIND),
C    1                                     NIND,RECNO(NIND)
C
C       dont copy data pointers
C       copy information from old record
        DO 10 I= 7,PDAT-1
          WIBUFF(I,NIND)= WIBUFF(I,OIND)
 10     CONTINUE
C       update free data space pointer to first data value pos
        WIBUFF(PDAT+1,NIND)= WDPTCL(RECNO(NIND),WIBUFF(12,OIND))
C       update the new record
        CALL WDRCUP(NWDMFL,NIND)
C       write(99,*) '  nwdmfl,nind:',NWDMFL,NIND
C       set dataset creation date attribute
        CALL WDCRDT (NWDMFL,NDSN)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDLBAD
     I                    (WDMSFL,DSN,DSTYPE,
     O                     PSA)
C
C     + + + PURPOSE + + +
C     ** not normally called by applications, use WDBCRL **
C     add a new data set label, but no search attributes or data,
C     use default label sizing
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DSTYPE,PSA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DSTYPE - type of data set
C     PSA    - pointer to search attribute space
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   NDN,NUP,NSA,NSASP,NDP
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDLBAX
C
C     + + + END SPECIFICATIONS + + +
C
      NDN  = 1
      NUP  = 1
      NSA  = 35
      NSASP= 70
      NDP  = 100
C
      CALL WDLBAX (WDMSFL,DSN,DSTYPE,NDN,NUP,NSA,NSASP,NDP,
     O             PSA)
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDSYSD
     O                   (IDATE)
C
C     + + + PURPOSE + + +
C     Fetch system date and time for DSN creation/modification
C     attributes.  *** FORTRAN 90 ONLY ***
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IDATE(4)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IDATE  - integer array containing character representation of date
C              (1) - 4-digit year
C              (2) - 2-digit month and 2-digit day
C              (3) - 2-digit hour and 2-digit month
C              (4) - 2-digit second and 2 blanks
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   VALUES(8)
      CHARACTER(10)DATE,TIME,ZONE
C
C     + + + INTRINSICS + + +
      INTRINSIC DATE_AND_TIME
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT (2A4)
 1010 FORMAT (A4,A2,2X)
C
C     + + + END SPECIFICATIONS + + +
C
      CALL DATE_AND_TIME (DATE,TIME,ZONE,VALUES)
      READ (DATE(1:8),1000) IDATE(1),IDATE(2)
      READ (TIME(1:6),1010) IDATE(3),IDATE(4)
C
      RETURN
      END
C
C
C
      SUBROUTINE   SYDATM
     O                   ( YR, MO, DY, HR, MN, SC )
C
C     + + + PURPOSE + + +
C     Returns the current date and time.  Calls the Fortran 90
C     intrinsic date_and_time for the date and time.
Cy2k  Note:  Returns a 2-digit year for backwords compatability
Cy2k  with older code.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   YR, MO, DY, HR, MN, SC
C
C     + + + ARGUMENT DEFINITIONS
C     YR     - year (2-digit)
C     MO     - month
C     DY     - day
C     HR     - hour
C     MN     - minute
C     SC     - second
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   VALUES(8)
      CHARACTER(10)DATE,TIME,ZONE
C
C     + + + INTRINSICS + + +
      INTRINSIC DATE_AND_TIME
C
C     + + + END SPECIFICATIONS + + +
C
      CALL DATE_AND_TIME (DATE,TIME,ZONE,VALUES)
      YR = VALUES(1)
      YR = MOD ( YR, 100 )
      MO = VALUES(2)
      DY = VALUES(3)
      HR = VALUES(5)
      MN = VALUES(6)
      SC = VALUES(7)
C
      RETURN
      END
C
C
C
      SUBROUTINE   SYDATE
     O                   ( YR, MO, DA )
C
C     + + + PURPOSE + + +
C     This subroutine is used to retrieve the system date.
C     Uses the Fortran 90 intrinsic date_and_time.
Cy2k  Note:  Returns a 2-digit year for backwords compatability
Cy2k  with older code.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   YR, MO, DA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YR     - year (2-digit)
C     MO     - month
C     DA     - day
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   VALUES(8)
      CHARACTER(10)DATE,TIME,ZONE
C
C     + + + INTRINSICS + + +
      INTRINSIC DATE_AND_TIME
C
C     + + + END SPECIFICATIONS + + +
C
      CALL DATE_AND_TIME (DATE,TIME,ZONE,VALUES)
      YR = VALUES(1)
      YR = MOD ( YR, 100 )
      MO = VALUES(2)
      DA = VALUES(3)
C
      RETURN
      END
C
C
C
      SUBROUTINE   SYTIME
     O                   ( HR, MN, SC )
C
C     + + + PURPOSE + + +
C     This subroutine is used to retrieve the system time.
C     Uses the Fortran 90 intrinsic date_and_time.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   HR, MN, SC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     HR     - Number of hours since midnight
C     MN     - Number of minutes since hour
C     SC     - Number of seconds since minute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   VALUES(8)
      CHARACTER(10)DATE,TIME,ZONE
C
C     + + + INTRINSICS + + +
      INTRINSIC DATE_AND_TIME
C
C     + + + END SPECIFICATIONS + + +
C
      CALL DATE_AND_TIME (DATE,TIME,ZONE,VALUES)
      HR = VALUES(5)
      MN = VALUES(6)
      SC = VALUES(7)
C
      RETURN
      END

C     utwdt1.f 2.1 9/4/91
C
C
C
      INTEGER(4)FUNCTION   WDPTCL
     I                           (PREC,POFF)
C
C     + + + PURPOSE + + +
C     Calculate a pointer value from record number
C     and the offset within the record.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   PREC,POFF
C
C     + + + ARGUMENT DEFINITIONS + + +
C     PREC   - record number
C     POFF   - offset within the record
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)I
C
C     + + + END SPECIFICATIONS + + +
C
      I= PREC
      WDPTCL = (I*512)+ POFF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDPTSP
     I                   (PTR,
     O                    PREC,POFF)
C
C     + + + PURPOSE + + +
C     split up a pointer into record number and offset within record.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER(4)PTR
      INTEGER   PREC,POFF
C
C     + + + ARGUMENT DEFINITIONS + + +
C     PTR    - pointer value
C     PREC   - record number
C     POFF   - offset within the record
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      PREC= PTR/ 512
      POFF= MOD(PTR,512)
C
      IF (PREC .LT. 1 .OR. PREC .GE. 2097152) THEN
        WRITE(99,*) ' IN WDPTSP: PREC,POFF,PTR=',PREC,POFF,PTR
        WRITE (*,*) ' IN WDPTSP: PREC,POFF,PTR=',PREC,POFF,PTR
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WBCWSP
     I                   (BCW,
     O                    NOV,TSTEP,TCODE,COMPCD,QUALCD)
C
C     + + + PURPOSE + + +
C     Split up a block control word for a time-series type data set
C     to determine the information stored in it.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER(4)BCW,NOV
      INTEGER   TSTEP,TCODE,COMPCD,QUALCD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     BCW    - block control word
C     NOV    - number of data values in the block
C     TSTEP  - time step of data block in TCODE units
C     TCODE  - time units code
C              1 - second    4 - day
C              2 - minute    5 - month
C              3 - hour      6 - year
C                            7 - century
C     COMPCD - compression code
C              1 - compressed block of data
C              2 - uncompressed block of data
C     QUALCD - quality code, 0 <= QUALCD <= 31
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)TMP
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      TMP= BCW
      IF (TMP.LT.0) THEN
C       neg value, integers are in 2's comp form
        TMP   = -TMP
        NOV   = 65536- (TMP/65536)- 1
        TSTEP = 64   - MOD((TMP/1024),64)-1
        TCODE =  8   - MOD((TMP/128) ,8) -1
        COMPCD=  4   - MOD((TMP/32 ) ,4) -1
        QUALCD= 32   - MOD (TMP      ,32)
      ELSE
        NOV   =     (TMP/65536)
        TSTEP = MOD((TMP/1024),64)
        TCODE = MOD((TMP/128) ,8)
        COMPCD= MOD((TMP/32 ) ,4)
        QUALCD= MOD (TMP      ,32)
      END IF
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WBCWCL
     I                           (NOV,TSTEP,TCODE,COMPCD,QUALCD)
C
C     + + + PURPOSE + + +
C     Calculate a block control word for time-series type data.
C     Returns a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   TSTEP,TCODE,COMPCD,QUALCD
      INTEGER(4)NOV
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NOV    - number of data values in the block
C     TSTEP  - time step of data block in TCODE units
C     TCODE  - time units code
C              1 - second    4 - day
C              2 - minute    5 - month
C              3 - hour      6 - year
C                            7 - century
C     COMPCD - compression code
C              1 - compressed block of data
C              2 - uncompressed block of data
C     QUALCD - quality code, 0 <= QUALCD <= 31
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)BCW
C
C     + + + END SPECIFICATIONS + + +
C
      IF (NOV.LE.0.OR.NOV.GT.65535.OR.TSTEP.LT.0.OR.TSTEP.GT.63.OR.
     1  TCODE.LT.0.OR.TCODE.GT.7.OR.COMPCD.LT.0.OR.COMPCD.GT.3.OR.
     2  QUALCD.LT.0.OR.QUALCD.GT.31) THEN
C       bad value, cant make a BCW
        BCW= 0
      ELSE
        BCW= NOV*65536+ TSTEP*1024+ TCODE*128+ COMPCD*32+ QUALCD
      END IF
C
      WBCWCL= BCW
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDATSP
     I                   (DATWRD,
     O                    DAT)
C
C     + + + PURPOSE + + +
C     Split up a WDMS date word.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER(4)DATWRD
      INTEGER   DAT(4)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATWRD - date in compressed format
C     DAT    - date (year, month, day, hour)
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
C     year
      DAT(1) = MOD((DATWRD/16384),131072)
C     month
      DAT(2) = MOD((DATWRD/1024) ,16)
C     day
      DAT(3) = MOD((DATWRD/32)   ,32)
C     hour
      DAT(4) = MOD (DATWRD       ,32)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WDATCL
     I                           (DAT)
C
C     + + + PURPOSE + + +
C     Calculate a date in compressed format from
C     its components (year- hour).  Returns a 0 if
C     any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DAT(4)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DAT    - date (year, month, day, hour)
C              0 <= hour <= 24
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)  DATWRD,YEAR,MONTH,DAY,HOUR
C
C     + + + END SPECIFICATIONS + + +
C
      YEAR = DAT(1)
      MONTH= DAT(2)
      DAY  = DAT(3)
      HOUR = DAT(4)
      IF (YEAR.LE.0.OR.YEAR.GT.131071.OR.MONTH.LE.0.OR.MONTH.GT.12.
     1  .OR.DAY.LE.0.OR.DAY.GT.31.OR.HOUR.LT.0.OR.HOUR.GT.24) THEN
C       bad value, cant make a date word
        DATWRD= 0
      ELSE
        DATWRD= YEAR*16384+ MONTH*1024+ DAY*32+ HOUR
      END IF
C
      WDATCL= DATWRD
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WTBICL
     I                           (MSFLID,MCLU,MGRP)
C
C     + + + PURPOSE + + +
C     Calculate the identifier for a table type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MCLU,MGRP
      CHARACTER(1)MSFLID(2)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSFLID - message file name id
C     MCLU   - message file cluster for table
C     MGRP   - message file group number for table
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)I
C
C     + + + INTRINSICS + + +
      INTRINSIC   ICHAR
C
C     + + + END SPECIFICATIONS + + +
C
      I= ICHAR(MSFLID(1))
      I= I*256+ ICHAR(MSFLID(2))
      I= I*256+ MCLU- 1
      WTBICL= I*128+ MGRP- 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTBISP
     I                   (TABID,
     O                    MSFLID,MCLU,MGRP)
C
C     + + + PURPOSE + + +
C     Split up an identifier for a table type
C     data set into its components.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     TABID,MCLU,MGRP
      CHARACTER(1)MSFLID(2)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TABID  - table identifier
C     MSFLID - message file name id
C     MCLU   - message file cluster for table
C     MGRP   - message file group number for table
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD, CHAR
C
C     + + + END SPECIFICATIONS + + +
C
      MSFLID(1)= CHAR(TABID/8388608)
      MSFLID(2)= CHAR(MOD((TABID/32768),256))
      MCLU= MOD((TABID/128),256)+ 1
      MGRP= MOD(TABID,128)+ 1
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WTBDCL
     I                           (TABIND,NROW,NCOL,NEXT)
C
C     + + + PURPOSE + + +
C     Calculate the table dimension for a table type data set.
C     Returns a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   TABIND,NROW,NCOL,NEXT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TABIND - table index number, 0 < TABIND <= 128
C     NROW   - number of rows in table, 0 < NROW <= 512
C     NCOL   - space for each column(words), 0 < NCOL <= 128
C     NEXT   - amount of table extension space (words), 0 < NEXT <= 255
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (TABIND.LE.0.OR.TABIND.GT.128.OR.NROW.LE.0.OR.NROW.GT.512.
     1  .OR.NCOL.LE.0.OR.NCOL.GT.128.OR.NEXT.LT.0.OR.NEXT.GT.255) THEN
C       bad parameter, cant make a table dimension word
        I= 0
      ELSE
        I= ((TABIND-1)*16777216)+ ((NROW-1)*32768)+ ((NCOL-1)*256)+ NEXT
      END IF
C
      WTBDCL= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTBDSP
     I                   (TABDIM,
     O                    TABIND,NROW,NCOL,NEXT)
C
C     + + + PURPOSE + + +
C     Split up dimension variable for table type
C     data set into its components.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   TABDIM,TABIND,NROW,NCOL,NEXT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TABDIM - table dimension variable
C     TABIND - table index number
C     NROW   - number of rows in table
C     NCOL   - space for each column(words)
C     NEXT   - amount of table extension space (words)
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      TABIND= (TABDIM/16777216)+ 1
      NROW  = MOD((TABDIM/32768),512)+ 1
      NCOL  = MOD((TABDIM/256),128) + 1
      NEXT  = MOD(TABDIM,256)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WBCWSQ
     I                   (BCW,
     O                    NOV,TSTEP,TCODE,COMPCD,QUALCD)
C
C     + + + PURPOSE + + +
C     Split up a block control word for time-series type data set.
C     Adjusts TSTEP and NOV for faster operation, if possible.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER(4)BCW,NOV
      INTEGER   TSTEP,TCODE,COMPCD,QUALCD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     BCW    - block control word
C     NOV    - number of data values in the block
C     TSTEP  - time step of data block in TCODE units
C     TCODE  - time units code
C              1 - second    4 - day
C              2 - minute    5 - month
C              3 - hour      6 - year
C                            7 - century
C     COMPCD - compression code
C              1 - compressed block of data
C              2 - uncompressed block of data
C     QUALCD - quality code, 0 <= QUALCD <= 31
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DONFG
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WBCWSP
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WBCWSP (BCW,
     O             NOV,TSTEP,TCODE,COMPCD,QUALCD)
C
      IF (COMPCD.EQ.1) THEN
C       try to adjust units and timestep for faster operation
        DONFG= 0
 20     CONTINUE
          IF (MOD(NOV,7).EQ.0.AND.TSTEP.LT.4000) THEN
            TSTEP= TSTEP* 7
            NOV  = NOV/ 7
          ELSE IF (MOD(NOV,5).EQ.0.AND.TSTEP.LT.6000) THEN
            TSTEP= TSTEP* 5
            NOV  = NOV/ 5
          ELSE IF (MOD(NOV,3).EQ.0.AND.TSTEP.LT.10000) THEN
            TSTEP= TSTEP* 3
            NOV  = NOV/ 3
          ELSE IF (MOD(NOV,2).EQ.0.AND.TSTEP.LT.15000) THEN
            TSTEP= TSTEP* 2
            NOV  = NOV/ 2
          ELSE
C           no more adjustment possible
            DONFG= 1
          END IF
        IF (DONFG.EQ.0) GO TO 20
      END IF
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WMSBCV
     I                           (CLASS,ID,ORDER,TLEN)
C
C     + + + PURPOSE + + +
C     Calculate a block control word for message type data set.
C     Returns a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   CLASS,ID,ORDER,TLEN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CLASS  - class of information
C              1 - 1-dimensional parameter      4 - menu
C              2 - 2-dimensional parameter      5 - file
C              3 - text
C     ID     - id for portion of group
C              examples:  CLASS  ID  Description
C                           1     4  default value for parameter field
C                           4     6  help for menu screen
C                           5     3  status of file
C     ORDER  - order of information
C     TLEN   - total number of characters in the block
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (CLASS.LE.0.OR.CLASS.GT.16.OR.ID.LT.0.OR.ID.GT.64.OR.
     1    ORDER.LT.0.OR.ORDER.GT.64.OR.TLEN.LT.0.OR.TLEN.GT.32768) THEN
C       bad parameter, cant make message block control word
        I= 0
      ELSE
        I= (CLASS*134217728)+ (ID*2097152)+ (ORDER*32768)+ TLEN
      END IF
C
      WMSBCV= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSBCS
     I                   (QWORD,
     O                    CLASS,ID,ORDER,TLEN)
C
C     + + + PURPOSE + + +
C     Split up a block control word for a message
C     type data set into its components.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   QWORD,CLASS,ID,ORDER,TLEN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     QWORD  - message type dataset block control word
C     CLASS  - class of information
C              1 - 1-dimensional parameter      4 - menu
C              2 - 2-dimensional parameter      5 - file
C              3 - text
C     ID     - id for portion of group
C              examples:  CLASS  ID  Description
C                           1     4  default value for parameter field
C                           4     6  help for menu screen
C                           5     3  status of file
C     ORDER  - order of information
C     TLEN   - total number of characters in the block
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      CLASS= (QWORD/134217728)
      ID   = MOD((QWORD/2097152),64)
      ORDER= MOD((QWORD/32768),64)
      TLEN = MOD(QWORD,32768)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WMSMNV
     I                           (IVAL)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters for a message
C     type data-set menu.  Returns a 0 if any one of the
C     components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IVAL(5)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IVAL   - components of the word
C              (1)- default response value, 0 < IVAL(1) <= 64
C              (2)- response length, 0 < IVAL(2) <= 64
C              (3)- number menu options flag
C                   0 - no numbers
C                   1 - numbers
C              (4)- width of columns, 0 < IVAL(4) <= 128
C              (5)- length of columns, 0 < IVAL(5) <= 16
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (IVAL(1).LT.0.OR.IVAL(1).GT.64 .OR. IVAL(2).LT.0.OR.
     1    IVAL(2).GT.64 .OR. IVAL(3).LT.0.OR.IVAL(3).GT.1 .OR.
     2    IVAL(4).LT.0.OR.IVAL(4).GT.128 .OR. IVAL(5).LT.0.OR.
     3    IVAL(5).GT.16) THEN
C       bad parameter value
        I= 0
      ELSE
        I= (IVAL(1)*262144)+ (IVAL(2)*4096)+ (IVAL(3)*2048)+
     1     (IVAL(4)*16)+ IVAL(5)
      END IF
C
      WMSMNV= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSMNS
     I                   (IMNVAL,
     O                    IDEF,ILEN,INNU,IWID,ICOL)
C
C     + + + PURPOSE + + +
C     Split up a word containing integer parameters
C     for a message type data-set menu.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IMNVAL,IDEF,ILEN,INNU,IWID,ICOL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IMNVAL - the word
C     IDEF   - default response value
C     ILEN   - response length
C     INNU   - nonumber option
C              0 - no numbers
C              1 - numbers
C     IWID   - width of columns
C     ICOL   - length of columns
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      IDEF= (IMNVAL/262144)
      ILEN= MOD((IMNVAL/4096),64)
      INNU= MOD((IMNVAL/2048),2)
      IWID= MOD((IMNVAL/16),128)
      ICOL= MOD(IMNVAL,16)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WMSPIV
     I                           (IVL1,IVL2)
C
C     + + + PURPOSE + + +
C     Calculate a word from two integer values
C     (1st value- 16 bits, 2nd- 15 bits).
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IVL1,IVL2
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IVL1   - first integer value, 0 <= IVL1 <= 65536
C     IVL2   - second integer value, 0 <= IVL2 <= 32768
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (IVL1.LT.0 .OR. IVL1.GT.65536 .OR.
     1    IVL2.LT.0 .OR. IVL2.GT.32768) THEN
C       bad parameter
        I= 0
      ELSE
        I = (IVL1*32768)+ IVL2
      END IF
C
      WMSPIV= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSPIS
     I                   (IVAL,
     O                    IVL1,IVL2)
C
C     + + + PURPOSE + + +
C     Split up a word into two integer values.
C
C     + + + DUMMY ARUGMENTS + + +
      INTEGER   IVAL,IVL1,IVL2
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IVAL   - the word
C     IVL1   - 1st integer value
C     IVL2   - 2nd integer value
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      IVL1= IVAL/32768
      IVL2= MOD(IVAL,32768)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WMSP2V
     I                           (FTYP,FLEN,FORDER,FPROT,FCOL)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters for a message
C     type data-set PRM2 class screen.  Return a 0 if any
C     one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FTYP,FLEN,FORDER,FPROT,FCOL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FTYP   - data field type, 0 <= FTYP <= 16
C              1 - integer
C              2 - real
C              3 - double precision
C              4 - character
C     FLEN   - data field length, 0 <= FLEN <= 128
C     FORDER - data field ordering, 0 <= FORDER <= 4
C              0 - no ordering
C              1 - ascending order
C              2 - descending order
C     FPROT  - data field protection, 0 <= FPROT <= 4
C              0 - no protection
C              1 - value must be in specified range
C              2 - value may not be modified
C     FCOL   - data field starting column, 0 <= FCOL <= 128
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (FTYP.LT.0.OR.FTYP.GT.16 .OR. FLEN.LT.0.OR.FLEN.GT.128 .OR.
     1    FORDER.LT.0.OR.FORDER.GT.4 .OR. FPROT.LT.0.OR.FPROT.GT.4 .OR.
     2    FCOL.LT.0.OR. FCOL.GT.128) THEN
C       bad parameter value
        I= 0
      ELSE
        I= (FTYP*262144)+ (FLEN*2048)+ (FORDER*512)+ (FPROT*128)+ FCOL
      END IF
C
      WMSP2V= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSP2S
     I                   (IP2VAL,
     O                    FTYP,FLEN,FORDER,FPROT,FCOL)
C
C     + + + PURPOSE + + +
C     Split up a word containing integer parameters for
C     a message type data-set PRM2 screen.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IP2VAL,FTYP,FLEN,FORDER,FPROT,FCOL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IP2VAL - the word
C     FTYP   - data field type
C     FLEN   - data field length
C     FORDER - data field ordering
C     FPROT  - data field protection
C     FCOL   - data field starting column
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      FTYP  = (IP2VAL/262144)
      FLEN  = MOD((IP2VAL/2048),128)
      FORDER= MOD((IP2VAL/512),4)
      FPROT = MOD((IP2VAL/128),4)
      FCOL  = MOD(IP2VAL,128)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WDLICV
     I                           (ITYPE,ATT1,ATT2,BLCNT)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters for
C     a vector (DLG) type data set.  Return a 0
C     if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   ITYPE,ATT1,ATT2,BLCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ITYPE  - vector (DLG) data type, 0 <= ITYPE <= 3
C              1- Line
C              2- Area
C              3- Node
C     ATT1   - major attribute, 0 <= ATT1 <= 1023
C     ATT2   - minor attribute, 0 <= ATT2 <= 2047
C     BLCNT  - number of blocks in group, 0 <= BLCNT <= 255
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (ITYPE.LT.0.OR.ITYPE.GT.3 .OR. ATT1.LT.0.OR.ATT1.GT.1023 .OR.
     1    ATT2.LT.0.OR.ATT2.GT.2047 .OR. BLCNT.LT.0.OR.BLCNT.GT.255)THEN
C       bad paramter value
        I= 0
      ELSE
        I= (ITYPE*536870912)+ (ATT1*524288)+ (ATT2*256)+ BLCNT
      END IF
C
      WDLICV= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDLISP
     I                   (IWORD,
     O                    ITYPE,ATT1,ATT2,BLCNT)
C
C     + + + PURPOSE + + +
C     Split up a word containing parameters for
C     a vector (DLG) type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IWORD,ITYPE,ATT1,ATT2,BLCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IWORD  - DLG parameters integer word
C     ITYPE  - DLG data type
C              1- Line
C              2- Area
C              3- Node
C     ATT1   - major attribute
C     ATT2   - minor attribute
C     BLCNT  - count of blocks
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      ITYPE= (IWORD/536870912)
      ATT1 = MOD((IWORD/524288),1024)
      ATT2 = MOD((IWORD/256),2048)
      BLCNT= MOD(IWORD,256)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WDLBCV
     I                           (ID,DTYPE,INUM,ILEN)
C
C     + + + PURPOSE + + +
C     Calculate a block control word for vector (DLG) type data set.
C     Return a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   ID,DTYPE,INUM,ILEN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ID     - block type, 0 <= ID <= 15
C              1- integer number
C              2- coordinatess
C              3- associated table
C     DTYPE  - vector (DLG) data type, 0 <= DTYPE <= 3
C              1- line
C              2- area
C              3- node
C     INUM   - internal number, 0 <= INUM <= 4095
C     ILEN   - length of information in block, 0 <= INUM <= 8191
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (ID.LT.0.OR.ID.GT.15 .OR. DTYPE.LT.0.OR.DTYPE.GT.3 .OR.
     1    INUM.LT.0.OR.INUM.GT.4095 .OR. ILEN.LT.0.OR.ILEN.GT.8191) THEN
C       bad paramter value
        I= 0
      ELSE
        I= (ID*134217728)+ (DTYPE*33554432)+ (INUM*8192)+ ILEN
      END IF
C
      WDLBCV= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDLBSP
     I                   (BWORD,
     O                    ID,DTYPE,INUM,ILEN)
C
C     + + + PURPOSE + + +
C     Split up a block control word for vector (DLG) type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   BWORD,ID,DTYPE,INUM,ILEN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     BWORD  - block control word
C     ID     - block type
C              1- integer number
C              2- coordinates
C              3- associated table
C     DTYPE  - vector (DLG) data type
C              1- line
C              2- area
C              3- node
C     INUM   - internal number
C     ILEN   - length of information in block
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      ID   = (BWORD/134217728)
      DTYPE= MOD((BWORD/33554432),4)
      INUM = MOD((BWORD/8192),4096)
      ILEN = MOD(BWORD,8192)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WATTCL
     I                           (ATTYP,ATLEN,ATUSE,ATUPD)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters for attribute type
C     data set.  Return a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   ATTYP,ATLEN,ATUSE(10),ATUPD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ATTYP  - attribute type, 0 <= ATTYP <= 8
C              1- integer
C              2- real
C              3- character
C     ATLEN  - attribute length, 1 <= ATLEN <= 128
C              ATTYP= 1 or 2 - number of words
C              ATTYP= 3 - number of characters
C     ATUSE  - array of indicator flags for data-set
C              attribute usage, ATUSE(n) = 0, 1, or 2
C              0 - attribute not allowed for data-set type
C              1 - attribute optional for data-set type
C              2 - attribute required for data-set type
C     ATUPD  - attribute update flag, ATPUD = 0 or 1
C              0 - don't update attribute
C              1 - update attribute if data exists
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,ITMP,IEXP
C
C     + + + END SPECIFICATIONS + + +
C
      IF (ATTYP.LT.1.OR.ATTYP.GT.8 .OR. ATLEN.LT.1.OR.ATLEN.GT.128 .OR.
     1    ATUPD.LT.0.OR.ATUPD.GT.1) THEN
C       bad parameter value
        I= 0
      ELSE
        ITMP= 0
        IEXP= 262144
        DO 10 I= 1,10
          ITMP= ITMP+ IEXP*ATUSE(I)
          IEXP= IEXP/4
 10     CONTINUE
        I= (ATTYP-1)*268435456+ ATLEN*2097152+ ITMP*2+ ATUPD
      END IF
C
      WATTCL= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WATTSP
     I                   (IATVL,
     O                    ATTYP,ATLEN,ATUSE,ATUPD)
C
C     + + + PURPOSE + + +
C     Split up a word containing parameters for
C     attribute type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IATVL,ATTYP,ATLEN,ATUSE,ATUPD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IATVL  - attribute parameters integer word
C     ATTYP  - attribute type
C              1- integer
C              2- real
C              3- character
C     ATLEN  - attribute length
C              ATTYP= 1 or 2 - number of words
C              ATTYP= 3 - number of characters
C     ATUSE  - array of indicator flags for data-set attribute usage
C              0 - attribute not allowed for data-set type
C              1 - attribute optional for data-set type
C              2 - attribute required for data-set type
C     ATUPD  - attribute update flag
C              0 - don't update attribute
C              1 - update attribute if data exists
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      ATTYP= IATVL/268435456+ 1
      ATLEN= MOD((IATVL/2097152),128)
      ATUSE= MOD((IATVL/2),1048576)
      ATUPD= MOD(IATVL,2)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WATTUS
     I                   (ATUSWD,
     O                    ATUSE)
C
C     + + + PURPOSE + + +
C     Split up word containing array of indicator flags
C     for dataset attribute usage.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER  ATUSWD,ATUSE(10)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ATUSWD - attribute usage word
C     ATUSE  - array of indicator flags for data-set attribute usage
C              0 - attribute not allowed for data-set type
C              1 - attribute optional for data-set type
C              2 - attribute required for data-set type
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,IEXP
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      IEXP = 262144
      DO 10 I= 1,10
        ATUSE(I)= MOD((ATUSWD/IEXP),4)
        IEXP= IEXP/4
 10   CONTINUE
C
      RETURN
      END
C
C
C
      INTEGER FUNCTION   WATWDC
     I                         (IVAL1,IVAL2)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters
C     for attribute type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IVAL1,IVAL2
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IVAL1  - either last 2 characters of name or
C              id of info, 0 <= IVAL1 <= 4194304
C     IVAL2  - either attribute index or
C              length of info, 0 <= IVAL2 <= 512
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (IVAL1.LT.0 .OR. IVAL1.GT.4194304 .OR.
     1    IVAL2.LT.0 .OR. IVAL2.GT.512) THEN
        I= 0
      ELSE
        I= (IVAL1*512)+ IVAL2
      END IF
C
      WATWDC= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WATWDS
     I                   (IWORD,
     O                    IVAL1,IVAL2)
C
C     + + + PURPOSE + + +
C     Split up a word containing parameters for attribute type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER    IWORD,IVAL1,IVAL2
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IWORD  - attribute parameters integer word
C     IVAL1  - either last 2 characters of name or id of info
C     IVAL2  - either attribute index or length of info
C
C     + + + INTRINSICS + + +
      INTRINSIC  MOD
C
C     + + + END SPECIFICATIONS + + +
C
      IVAL1= IWORD/ 512
      IVAL2= MOD(IWORD,512)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WSTGCL
     I                           (STMIN,STSEC,TUNITS,TSTEP,NOV)
C
C     + + + PURPOSE + + +
C     Calculate a block control word for space-time type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   STMIN,STSEC,TUNITS,TSTEP,NOV
C
C     + + + ARGUMENT DEFINITIONS + + +
C     STMIN  - starting time of group-minutes, 0 <= STMIN <= 60
C     STSEC  - starting time of group-seconds, 0 <= STSEC <= 60
C     TUNITS - time units of group, 0 <= TUNITS <= 7
C     TSTEP  - time step of group, 0 <= STMIN <= 63
C     NOV    - number of values in group, 0 < STMIN <= 1023
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GCW
C
C     + + + END SPECIFCATIONS + + +
C
      IF (STMIN.LT.0 .OR. STMIN.GT.60 .OR.
     1    STSEC.LT.0 .OR. STSEC.GT.60 .OR.
     2    TUNITS.LT.0.OR. TUNITS.GT.7 .OR.
     3    TSTEP.LT.0 .OR. TSTEP.GT.63 .OR.
     4    NOV.LE.0   .OR. NOV.GT.1023) THEN
C       bad parameter, cant make group info control word
        GCW= 0
      ELSE
        GCW= STMIN*33554432+ STSEC*524288+ TUNITS*65536+ TSTEP*1024+ NOV
      END IF
C
      WSTGCL= GCW
C
      RETURN
      END
C
C
C
      SUBROUTINE   WSTGSP
     I                   (GCW,
     O                    STMIN,STSEC,TUNITS,TSTEP,NOV)
C
C     + + + PURPOSE + + +
C     Split up a block control word for space-time type data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   GCW,STMIN,STSEC,TUNITS,TSTEP,NOV
C
C     + + + ARGUMENT DEFINITIONS + + +
C     GCW    - block control word
C     STMIN  - starting time of group-minutes
C     STSEC  - starting time of group-seconds
C     TUNITS - time units of group
C     TSTEP  - time step of group
C     NOV    - number of values in group
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     TMP
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFCATIONS + + +
C
      TMP   = GCW
      STMIN =     (TMP/33554432)
      STSEC = MOD((TMP/524288),64)
      TUNITS= MOD((TMP/65536),8)
      TSTEP = MOD((TMP/1024) ,64)
      NOV   = MOD (TMP       ,1024)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WMSPOV
     I                           (OPSET,OPSTNO,OPDEF,
     I                            OPWID,OPHIDE,OPBOX)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters for a message
C     type data-set PRM1 screen data field of type Option.
C     Return a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   OPSET,OPSTNO,OPDEF,OPWID,OPHIDE,OPBOX
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OPSET  - set number for this option field, 0 <= OPSET <= 64
C     OPSTNO - order number within set of this field, 0 <= OPSTNO <= 64
C     OPDEF  - default value of option field, 0 <= OPDEF <= 1
C              0 - OFF, 1 - ON
C     OPWID  - width of field to highlight, 0 <= OPWID <= 128
C     OPHIDE - flag indicating field is to be hidden on output, 0 <= OPHIDE <=1
C     OPBOX  - flag indicating to draw box next to field, 0 <= OPBOX <= 1
C              0 - do not draw box
C              1 - draw box to left of option field
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (OPSET.LT.0.OR.OPSET.GT.64 .OR. OPSTNO.LT.0.OR.OPSTNO.GT.64
     1    .OR. OPDEF.LT.0.OR.OPDEF.GT.1 .OR. OPWID.LT.0.OR.OPWID.GT.128
     2    .OR. OPHIDE.LT.0.OR.OPHIDE.GT.1
     3    .OR. OPBOX.LT.0.OR.OPBOX.GT.1) THEN
C       bad parameter value
        I= 0
      ELSE
        I= (OPSET*65536)+ (OPSTNO*1024)+ (OPDEF*512)+
     1     (OPWID*4)+ (OPHIDE*2)+ OPBOX
      END IF
C
      WMSPOV= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WMSPOS
     I                   (IOPVAL,
     O                    OPSET,OPSTNO,OPDEF,OPWID,OPHIDE,OPBOX)
C
C     + + + PURPOSE + + +
C     Split up a word containing integer parameters for
C     a message type data-set PRM1 screen option type field.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IOPVAL,OPSET,OPSTNO,OPDEF,OPWID,OPHIDE,OPBOX
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IOPVAL - the word
C     OPSET  - set number for this option field
C     OPSTNO - order number within set of this field, 0 <= OPSTNO <= 64
C     OPDEF  - default value of option field
C              0 - OFF, 1 - ON
C     OPWID  - width of field to highlight
C     OPHIDE - flag indicating field is to be hidden on output,
C              0 - don't hide field
C              1 - hide field
C     OPBOX  - flag indicating to draw box next to field,
C              0 - do not draw box
C              1 - draw box to left of option field
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      OPSET = (IOPVAL/65536)
      OPSTNO= MOD((IOPVAL/1024),64)
      OPDEF = MOD((IOPVAL/512),2)
      OPWID = MOD((IOPVAL/4),128)
      OPHIDE= MOD((IOPVAL/2),2)
      OPBOX = MOD(IOPVAL,2)
C
      RETURN
      END
C
C
C
      INTEGER(4)FUNCTION   WOPWDC
     I                           (IVAL1,IVAL2,IVAL3,IVAL4)
C
C     + + + PURPOSE + + +
C     Calculate a word containing parameters for conditionals on
C     option type data fields (generic for 4 values of 7 bits each).
C     Return a 0 if any one of the components is invalid.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   IVAL1,IVAL2,IVAL3,IVAL4
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IVAL1  - first value in word, 0 <= IVAL1 <= 128
C     IVAL2  - second value in word, 0 <= IVAL2 <= 128
C     IVAL3  - third value in word, 0 <= IVAL3 <= 128
C     IVAL4  - fourth value in word, 0 <= IVAL4 <= 128
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (IVAL1.LT.0.OR.IVAL1.GT.128 .OR.
     1    IVAL2.LT.0.OR.IVAL2.GT.128 .OR.
     1    IVAL3.LT.0.OR.IVAL3.GT.128 .OR.
     2    IVAL4.LT.0.OR.IVAL4.GT.128) THEN
C       bad parameter value
        I= 0
      ELSE
        I= (IVAL1*2097152)+ (IVAL2*16384)+ (IVAL3*128)+ IVAL4
      END IF
C
      WOPWDC= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   WOPWDS
     I                   (OPWORD,
     O                    IVAL1,IVAL2,IVAL3,IVAL4)
C
C     + + + PURPOSE + + +
C     Split up a word containing integer parameters for conditionals
C     for option type data fields (generic for 4 values of 7 bits each).
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   OPWORD,IVAL1,IVAL2,IVAL3,IVAL4
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OPWORD - the word
C     IVAL1  - first value in word, 0 <= IVAL1 <= 128
C     IVAL2  - second value in word, 0 <= IVAL2 <= 128
C     IVAL3  - third value in word, 0 <= IVAL3 <= 128
C     IVAL4  - fourth value in word, 0 <= IVAL4 <= 128
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + END SPECIFICATIONS + + +
C
      IVAL1 = (OPWORD/2097152)
      IVAL2 = MOD((OPWORD/16384),128)
      IVAL3 = MOD((OPWORD/128),128)
      IVAL4 = MOD(OPWORD,128)
C
      RETURN
      END

C
C
C
      SUBROUTINE   WADQCK
     I                   (MESSFL,DSN,ATIND,
     O                    ATCHK)
C
C     + + + PURPOSE + + +
C     given attribute offset for this data set check to see
C     if the attribute already exists on WDM file, return
C     0 if not exist, otherwise return absolute index number
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,DSN,ATIND,ATCHK
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for WDM message file
C     DSN    - data-set number on WDM file
C     ATIND  - attribute number being checked
C     ATCHK  - flag indicating attribute existance,
C              0 - doesnt exist, 1 - exists, (-) - bad return code value
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    IDUM,LREC,LIND,RETCOD,PDAT,PDATV,LPOS,DSTYP,
     1           MXQNUM,ITMP
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDSCHK, WATWDS
C
C     + + + END SPECIFICATIONS + + +
C
      DSTYP= 8
      CALL WDSCHK (MESSFL,DSN,DSTYP,
     O             LREC,IDUM,RETCOD)
C
C     see if question exists
      LIND  = WDRCGO(MESSFL,LREC)
      PDAT  = WIBUFF(11,LIND)
      PDATV = WIBUFF(12,LIND)
      MXQNUM= PDATV- PDAT- 2
      IF (ATIND.GT.0 .AND. ATIND.LE.MXQNUM) THEN
C       reasonable ATIND
        LPOS= PDAT+ 2+ 4*(ATIND-1)
        IF (WIBUFF(LPOS,LIND).EQ.0) THEN
C         doesnt exist
          ATCHK= 0
        ELSE
C         get absolute attribute index
          ITMP= WIBUFF(LPOS+1,LIND)
          CALL WATWDS (ITMP,
     O                 IDUM,ATCHK)
        END IF
      ELSE
C       bad QNUM, doesn't exist
        ATCHK= 0
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADNSA
     I                   (MESSFL,DSINIT,
     M                    SAIND)
C
C     + + + PURPOSE + + +
C     given a search attribute index, determine if it exists
C     on the message file, if not return the next existing
C     index or value of 0 for no more attributes
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,DSINIT,SAIND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     DSINIT - flag indicating if data-set buffer is to be updated
C     SAIND  - attribute index
C
C     + + + PARAMETERS + + +
      INTEGER    MAXDSN
      PARAMETER (MAXDSN=10)
C
C     + + + SAVES + + +
      INTEGER    ATTIND(2,MAXDSN),DSNCNT,DSNBUF(MAXDSN)
      SAVE       ATTIND,DSNCNT,DSNBUF
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,LSAIND,DONFG
C
C     + + + EXTERNALS + + +
      EXTERNAL   WADDSI,WADQCK
C
C     + + + END SPECIFICATIONS + + +
C
C     WRITE(*,*) 'wadnsa:',MESSFL,DSINIT,SAIND
      IF (DSINIT.EQ.1) THEN
C       update buffers of data-set numbers and start/end attributes
        CALL WADDSI (MESSFL,MAXDSN,
     O               DSNCNT,DSNBUF,ATTIND)
      END IF
C
      IF (DSNCNT.GT.0) THEN
C       attribute data sets exist
        DONFG= 0
        I    = 0
 10     CONTINUE
          I= I+ 1
          IF (SAIND.GE.ATTIND(1,I) .AND. SAIND.LE.ATTIND(2,I)) THEN
C           current index would be on this data set
            DONFG = 1
            LSAIND= SAIND- ATTIND(1,I)
C           move along data set to find first valid attribute
 20         CONTINUE
C             see if this attribute exists
              LSAIND= LSAIND+ 1
              CALL WADQCK (MESSFL,DSNBUF(I),LSAIND,
     O                     SAIND)
            IF (SAIND.EQ.0) GO TO 20
          ELSE IF (SAIND.LT.ATTIND(1,I)) THEN
C           some missing, this is the next one
            SAIND= ATTIND(1,I)
            DONFG= 1
          END IF
        IF (I.LT.DSNCNT .AND. DONFG.EQ.0) GO TO 10
C
        IF (DONFG.EQ.0) THEN
C         index not out on message file
          SAIND= 0
        END IF
      ELSE
C       no attributes exist
        SAIND= 0
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADADI
     I                   (MESSFL,DSN,ATIND,ID,
     I                    ILEN,IBUFF,INUM,IVAL)
C
C     + + + PURPOSE + + +
C     put attribute data set information on WDM message file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,DSN,ATIND,ID,ILEN,INUM
      INTEGER     IVAL(INUM)
      CHARACTER(1)IBUFF(ILEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for WDM message file
C     DSN    - data-set number on WDM file
C     ATIND  - question number being added
C     ID     - id for portion of attribute being stored
C     ILEN   - length of input buffer
C     IBUFF  - input buffer of character data to store
C     INUM   - number of integer values to store
C     IVAL   - input buffer of integer parameters to store
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + SAVES + + +
      INTEGER    DPOS,DIND,DREC,LID,TLEN,GLEN,BREC,BPOS,LREC,
     1           PDAT,GRCNT,PDATVL,BATIND,LDSN
      SAVE       DPOS,DIND,DREC,LID,TLEN,GLEN,BREC,BPOS,LREC,
     1           PDAT,GRCNT,PDATVL,BATIND,LDSN
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,LIND,LPOS,DSTYP,PDATV,MXNGR,RETCOD,QWORD,NEWPOS,
     1           BIND,IFLG,CTLEN,RDWRFG,IDUM
C
C     + + + FUNCTIONS + + +
      INTEGER    LENSTR, WDRCGO, WDRCGX, WDPTCL, WATWDC
C
C     + + + EXTERNALS + + +
      EXTERNAL   LENSTR, WDRCGO, WDRCGX, WDRCUP, WDPTCL, WATWDC
      EXTERNAL   WDNXPS, WMSPTE, WDSCHK, WDPTSP
C
C     + + + DATA INITIALIZATIONS + + +
      DATA DPOS,DIND,DREC,BIND,BPOS,GLEN,LDSN
     1    / 0,   0,   0,   0,   0,   0,   0/
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 2
      RETCOD= 0
C
      IF (ID.EQ.2) THEN
C       end of group, finish label definition and update pointers
        CALL WDNXPS (MESSFL,RDWRFG,
     M               DREC,DPOS,
     O               DIND)
        WIBUFF(DPOS,DIND)= 0
        CALL WDRCUP(MESSFL,DIND)
C       new free data position
        CALL WDNXPS (MESSFL,RDWRFG,
     M               DREC,DPOS,
     O               DIND)
        NEWPOS= WDPTCL(DREC,DPOS)
C       update label pointer to free data position
        LIND= WDRCGO(MESSFL,LREC)
        WIBUFF(PDAT+1,LIND)= NEWPOS
C       put type, length, data set usage, update flag in 4th label pos
        LPOS= PDAT+ 2+ 4*(ATIND-BATIND)
        WIBUFF(LPOS+3,LIND)= IVAL(1)
        CALL WDRCUP(MESSFL,LIND)
      ELSE IF (ID.EQ.1) THEN
C       new group
        DSTYP= 8
C       check existance of data set
        CALL WDSCHK (MESSFL,DSN,DSTYP,
     O               LREC,GRCNT,RETCOD)
C
        IF (DSN.NE.LDSN) THEN
C         on a new data set, set base attribute index
          LDSN= DSN
          BATIND= ATIND
        END IF
C
        IF (RETCOD.EQ.0) THEN
C         space for another attribute?
          LIND = WDRCGO(MESSFL,LREC)
          PDAT = WIBUFF(11,LIND)
          PDATV= WIBUFF(12,LIND)
          MXNGR= (PDATV-PDAT-1)/4
          IF (ATIND-BATIND+1.GT.MXNGR) THEN
C           no more room for more attributes on this dsn
            RETCOD= -121
          END IF
        END IF
C
        IF (RETCOD.EQ.0) THEN
C         ok to add attribute to this data set
          GRCNT= GRCNT+ 1
          WIBUFF(PDAT,LIND)= GRCNT
C         get free data pos
          PDATVL= WIBUFF(PDAT+1,LIND)
          CALL WDPTSP (PDATVL,
     O                 DREC,DPOS)
          DIND= WDRCGO(MESSFL,DREC)
          IF (DPOS.EQ.0) THEN
C           start the question on the next record,
C           first reset record to current value
            IDUM = 0
            DREC= DREC- 1
            DIND= WDRCGX(MESSFL,IDUM,DREC)
            DREC= RECNO(DIND)
            DPOS= 5
            PDATVL= WDPTCL(DREC,DPOS)
          END IF
C         put name, index, and pointer to details on start of label
          LIND= WDRCGO(MESSFL,LREC)
          LPOS= PDAT+ 2+ 4*(ATIND-BATIND)
          WIBUFF(LPOS,LIND)  = IVAL(1)
          WIBUFF(LPOS+1,LIND)= IVAL(2)
          WIBUFF(LPOS+2,LIND)= PDATVL
          CALL WDRCUP(MESSFL,LIND)
        END IF
        LID= 1
      ELSE
C       store this portion of group block control word
        IF (ID.EQ.3 .OR. ID.EQ.5) THEN
C         storing integer parms, length of 4 for each value
          CTLEN= (4* INUM)- 1
          IFLG = 1
        ELSE
C         storing character data
          CTLEN= LENSTR(ILEN,IBUFF)
          IF (CTLEN.EQ.0) THEN
C           blank line, leave blank characters
            CTLEN= 1
          END IF
          IFLG= 0
        END IF
        IF (LID.EQ.ID) THEN
C         continuation of previous information
          TLEN= TLEN+ CTLEN+ 1
        ELSE
C         new portion of group, update length and block pos
          GLEN= 0
          TLEN= CTLEN+ 1
          IF (LID.NE.1) THEN
C           DREC/DPOS at end of last info put, need to update
            CALL WDNXPS (MESSFL,RDWRFG,
     M                   DREC,DPOS,
     O                   DIND)
          END IF
          BPOS= DPOS
          BREC= DREC
          LID = ID
        END IF
C       put block control word at start of info
        BIND = WDRCGO(MESSFL,BREC)
        QWORD= WATWDC(ID,TLEN)
        WIBUFF(BPOS,BIND)= QWORD
        CALL WDRCUP(MESSFL,BIND)
C
        IF (IFLG.EQ.0) THEN
C         character buffer to store
          CALL WMSPTE (MESSFL,CTLEN,IBUFF,
     M                 DREC,DPOS,GLEN)
C
        ELSE
C         store integer word(s)
          DO 10 I= 1,INUM
            CALL WDNXPS (MESSFL,RDWRFG,
     M                   DREC,DPOS,
     O                   DIND)
            WIBUFF(DPOS,DIND)= IVAL(I)
 10       CONTINUE
          CALL WDRCUP(MESSFL,DIND)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADGTL
     I                   (MESSFL,DSN,ATIND,
     O                    ATNAM,DPTR,ATTYP,ATLEN,ATUSWD,ATUPD)
C
C     + + + PURPOSE + + +
C     given attribute index, get type, length, data set usage,
C     and update flag as well as starting pos of other data
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,DSN,ATIND,DPTR,ATTYP,ATLEN,ATUSWD,ATUPD
      CHARACTER(1)ATNAM(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for WDM message file
C     DSN    - data-set number on WDM file
C     ATIND  - attribute index
C     ATNAM  - attribute name
C     DPTR   - pointer to start of other attribute data
C     ATTYP  - attribute typ
C     ATLEN  - attribute length
C     ATUSWD - integer word of required and optional data set usage
C     ATUPD  - attribute update flag
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,ITMP,IVAL(2),LREC,LPOS,LIND,PDAT,BATIND,RETCOD
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC   CHAR, MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDDSCK, WDRCGO, WATWDS, WATTSP
C
C     + + + END SPECIFICATIONS + + +
C
C     get label index
      CALL WDDSCK(MESSFL,DSN,
     O            LREC,RETCOD)
      LIND= WDRCGO(MESSFL,LREC)
C     get needed pointers
      PDAT= WIBUFF(11,LIND)
C     find base attribute
      LPOS= PDAT+ 3
      ITMP= WIBUFF(LPOS,LIND)
      CALL WATWDS (ITMP,
     O             I,BATIND)
C     now find attribute position based on offset of base index
      LPOS= PDAT+ 2+ 4*(ATIND-BATIND)
C     get first two words to build name
      IVAL(1)= WIBUFF(LPOS,LIND)
      ITMP   = WIBUFF(LPOS+1,LIND)
C     split second word into last part of name
      CALL WATWDS (ITMP,
     O             IVAL(2),I)
C     build name
      ITMP= IVAL(1)
      DO 10 J= 1,6
        ATNAM(J)= CHAR(MOD(ITMP,256))
        IF (J.EQ.4) THEN
C         switch to second word
          ITMP= IVAL(2)
        ELSE
          ITMP= ITMP/256
        END IF
 10   CONTINUE
C     get pointer to start of data
      DPTR= WIBUFF(LPOS+2,LIND)
C     get last word of label containing attribute parms
      IVAL(1)= WIBUFF(LPOS+3,LIND)
      CALL WATTSP (IVAL(1),
     O             ATTYP,ATLEN,ATUSWD,ATUPD)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WADDSI
     I                   (MESSFL,DSNMAX,
     O                    DSNCNT,DSN,ATTIND)
C
C     + + + PURPOSE + + +
C     determine the data-set numbers containing the attribute data sets
C     and the first and last attributes on each data set
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,DSNMAX,DSNCNT,DSN(DSNMAX),ATTIND(2,DSNMAX)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for WDM message file
C     DSNMAX - maximum number of attribute data sets
C     DSNCNT - number of data sets containing attributes
C     DSN    - array of data-set numbers containing attributes
C     ATTIND - array of first and last attributes on each data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CDRLOC.INC'
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,J,LPDAT,PDATV,LREC,LIND,LPOS,ITMP,IVAL,RETCOD
C
C     + + + FUNCTIONS + + +
      INTEGER    WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDDSCK, WDRCGO, WATWDS, ZIPI
C
C     + + + END SPCIFICATIONS + + +
C
C     WRITE(*,*) 'waddsi:',MESSFL,DSNMAX
      J= 0
      CALL ZIPI(DSNMAX,J,DSN)
      I= DSNMAX*2
      CALL ZIPI(I,J,ATTIND)
C
      DSNCNT= 1
 10   CONTINUE
C       try the next data set
        IF (DSN(DSNCNT).GT.0) THEN
C         need to increment counter
          DSNCNT= DSNCNT+ 1
        END IF
C
        IF (DSNCNT.EQ.1) THEN
C         get first data set from main record label
          LREC= 1
          LIND= WDRCGO (MESSFL,LREC)
          I   = PTSNUM+ 15
          DSN(DSNCNT)= WIBUFF(I,LIND)
        ELSE
C         get next data set from last data-set label
          DSN(DSNCNT)= WIBUFF(2,LIND)
        END IF
C       WRITE(*,*) 'next attr data set:',DSNCNT,DSN(DSNCNT)
        IF (DSN(DSNCNT).GT.0) THEN
C         process this data set
          CALL WDDSCK(MESSFL,DSN(DSNCNT),
     O                LREC,RETCOD)
          LIND = WDRCGO(MESSFL,LREC)
          LPDAT= WIBUFF(11,LIND)
          PDATV= WIBUFF(12,LIND)
          LPOS = LPDAT+ 2
          IF (WIBUFF(LPOS,LIND).GT.0) THEN
C           get first label index
            IVAL= WIBUFF(LPOS+1,LIND)
            CALL WATWDS (IVAL,
     O                   I,ATTIND(1,DSNCNT))
C           now find last label
            LPOS= PDATV
 20         CONTINUE
C             back up to last label and get index
              LPOS= LPOS- 4
            IF (WIBUFF(LPOS,LIND).EQ.0) GO TO 20
C           get last label index
            IVAL= WIBUFF(LPOS+1,LIND)
            CALL WATWDS (IVAL,
     O                   I,ATTIND(2,DSNCNT))
C           WRITE(*,*) 'found:',DSNCNT,ATTIND(1,DSNCNT),ATTIND(2,DSNCNT)
          ELSE
C           nothing out on this data set, ignore it
            DSN(DSNCNT)= 0
C           WRITE(*,*) 'nothing in data set'
          END IF
          IF (DSNCNT.GT.1) THEN
C           sort indices
            I= DSNCNT
 30         CONTINUE
              IF (ATTIND(1,I).LT.ATTIND(1,I-1)) THEN
C               need to switch these indices
                ITMP= ATTIND(1,I)
                ATTIND(1,I)  = ATTIND(1,I-1)
                ATTIND(1,I-1)= ITMP
                ITMP= ATTIND(2,I)
                ATTIND(2,I)  = ATTIND(2,I-1)
                ATTIND(2,I-1)= ITMP
                ITMP    = DSN(I)
                DSN(I)  = DSN(I-1)
                DSN(I-1)= ITMP
              END IF
              I= I- 1
            IF (I.GT.1) GO TO 30
          END IF
        END IF
      IF (DSN(DSNCNT).GT.0 .AND. DSNCNT.LT.DSNMAX) GO TO 10
C
      IF (DSN(DSNCNT).EQ.0) THEN
C       count is one ahead of actual total
        DSNCNT= DSNCNT- 1
      END IF
C
C     WRITE(*,*) 'WADDSI:',DSNCNT,DSNMAX
C     IF (DSNCNT.GT.0) THEN
C       DO 40 I= 1,DSNMAX
C         WRITE(*,*) I,DSN(I),ATTIND(1,I),ATTIND(2,I)
C40     CONTINUE
C     END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDCRDT
     I                   (WDMSFL,DSN)
C
C     + + + PURPOSE + + +
C     set 16-character DSN creation date attribute
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - timeseries data-set number
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SAIND, DATE(4)
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSYSD,WDSETD,WDMODT
C
C     + + + END SPECIFICATIONS + + +
C
      SAIND= 443
      CALL WDSYSD
     O            (DATE)
      CALL WDSETD (WDMSFL,DSN,SAIND,DATE)
      CALL WDMODT (WDMSFL,DSN)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDMODT
     I                   (WDMSFL,DSN)
C
C     + + + PURPOSE + + +
C     set 16-character DSN modification date attribute
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - timeseries data-set number
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SAIND, DATE(4)
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSYSD,WDSETD
C
C     + + + END SPECIFICATIONS + + +
C
      SAIND= 444
      CALL WDSYSD
     O            (DATE)
      CALL WDSETD (WDMSFL,DSN,SAIND,DATE)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSETD
     I                   (WDMSFL,DSN,SAIND,DATE)
C
C     + + + PURPOSE + + +
C     set 16-character date attribute
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,SAIND,DATE(4)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - timeseries data-set number
C     SAIND  - search attribute index (443 for DATCRE, 444 for DATMOD)
C     DATE   - integer array containing character representation of date
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   TDSFRC,RETCOD,RIND,SATYP,SALEN,PSAVAL,I
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK,WDSASP,WDRCGO,WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
C     determine where data set starts
      CALL WDDSCK (WDMSFL,DSN,
     O             TDSFRC,RETCOD)
      IF (RETCOD .EQ. 0) THEN
C       bring label into memory
        RIND= WDRCGO(WDMSFL,TDSFRC)
        IF ((RIND .LE. 0) .OR. (RIND .GT. 512)) THEN
C         invalid record
          WRITE (99,*) 'BAD RIND:  WDMSFL,DSN,TDSFRC,RIND',WDMSFL,DSN,
     $                  TDSFRC,RIND
        ELSE
C         look for attribute
          SALEN= 16
          SATYP= 3
C         where do we put it?
          CALL WDSASP (SAIND,SALEN,SATYP,
     M                 WIBUFF(1,RIND),
     O                 PSAVAL,RETCOD)
          IF ((RETCOD .EQ. -102) .OR. (RETCOD.EQ.0)) THEN
C           attribute already present or successfully added, fill in value
            DO 10 I= 1, 4
             WIBUFF(PSAVAL+ I- 1,RIND)= DATE(I)
 10         CONTINUE
            CALL WDRCUP(WDMSFL,RIND)
          END IF
        END IF
      END IF
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDDSDL
     I                    (WDMSFL,DSN,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     routine to delete a data set from the WDMSFL with no user interaction
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - dataser number to be deleted
C     RETCOD - return code
C                 0 - data set successfully deleted
C               -81 - data set does not exist
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,RREC,RIND,DSTYPE
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO, WDRCDL
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDRCDL, WDFCUP, WDFDUP
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDDSCK (WDMSFL,DSN,
     O             RREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       what dsn type?
        RIND= WDRCGO (WDMSFL,RREC)
        I= 6
        DSTYPE= WIBUFF(I,RIND)
C       fix pointers to other data sets
        I= 2
        CALL WDFCUP (WDMSFL,DSTYPE,DSN,I)
C       delete directory entry
        I= 0
        CALL WDFDUP (WDMSFL,DSN,I)
C       delete actual data set records
 100    CONTINUE
          RREC= WDRCDL (WDMSFL,RREC)
        IF (RREC.GT.0) GO TO 100
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSASP
     I                    (SAIND,SALEN,SATYP,
     M                     TIBUFF,
     O                     PSAVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     adds space for search attribute on a dsn label if not present on it
C
C     + + + HISTORY + + +
C     08/30/94  kmf  added code for case where no space for index (-103)
C     05/25/01  kmf  Corrected calculation of the last available space
C                    for the attribute value.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SAIND,SALEN,SATYP,PSAVAL,RETCOD
      INTEGER(4)TIBUFF(512)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SAIND  - index number of search attribute to look for
C     SALEN  - length of search attribute
C     SATYP  - type of search attribute
C     TIBUFF - array containing data-set label
C     PSAVAL - pointer to search attribute information if available
C     RETCOD - flag indicating status of search attribute locate
C                 0 - attribute space added
C              -102 - attribute already on label
C              -103 - no space for this attribute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   PSA,SACNT,SANMX,SASMX,SASTR,TSALEN
C
C     + + + FUNCTIONS + + +
      INTEGER   WDSASV
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSASV
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
      TSALEN= SALEN
      IF (SATYP.EQ.3) THEN
C       character attribute, adjust size from characters to words
        TSALEN= TSALEN/4
      END IF
C
      PSAVAL= WDSASV (SAIND,TIBUFF)
      IF (PSAVAL.GT.0) THEN
C       attribute already on label
        RETCOD= -102
      ELSE
C       not there yet, try to add it
C       get pointer to search attribute start
        PSA  = TIBUFF(10)
C       current number of search attributes
        SACNT= TIBUFF(PSA)+ 1
C       max number of search attributes allowed
        SANMX= (TIBUFF(PSA+1)- PSA- 2)/2
C       last space to put search attributes in
        SASMX= TIBUFF(11)- 1
        IF (SACNT.LE.SANMX) THEN
C         space available for index, now check for space for value
          SASTR = PSA+ (SACNT*2)
          PSAVAL= TIBUFF(SASTR-1)
          IF (SACNT.GT.1) THEN
C           look for free space after last attribute
 10         CONTINUE
              PSAVAL= PSAVAL+ 1
            IF (TIBUFF(PSAVAL).NE.-999) GO TO 10
          END IF
C         check to see that enough space available
Ckmf      IF (PSAVAL+TSALEN.GT.SASMX) THEN
          IF (PSAVAL+TSALEN-1.GT.SASMX) THEN
C           oops, it wont fit
            PSAVAL= 0
            RETCOD= -103
          ELSE
C           update the label values
            TIBUFF(PSA)    = SACNT
            TIBUFF(SASTR)  = SAIND
            TIBUFF(SASTR+1)= PSAVAL
          END IF
        ELSE
C         no space for index for attribute
          RETCOD = -103
        END IF
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDDTFG
     I                            (DREC,TIBUFF)
C
C     + + + PURPOSE + + +
C     determines if data is present in a WDMS data set,
C       returns 1 for yes, 0 for no
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DREC
      INTEGER(4)TIBUFF(512)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DREC   - label record number
C     TIBUFF - array containing data-set label information
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   PREC,POFF,DATFLG,PDATV
      INTEGER(4)TDFREE,PDAT
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTSP
C
C     + + + END SPECIFICATIONS + + +
C
      PDAT  = TIBUFF(11)
      PDATV = TIBUFF(12)
      TDFREE= TIBUFF(PDAT+1)
      CALL WDPTSP (TDFREE,
     O             PREC,POFF)
      IF (PREC.EQ.DREC.AND.POFF.EQ.PDATV) THEN
C       no data present on dataset
        DATFLG= 0
      ELSE
C       free space not first possible space, data is present
        DATFLG= 1
      END IF
C
      WDDTFG= DATFLG
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFDUP
     I                    (WDMSFL,DSN,DSFREC)
C
C     + + + PURPOSE + + +
C     updates a WDMS file directory record,
C     adds value if DSFREC> 0, deletes if DSFREC<=0
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DSFREC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DSFREC - data-set first record number, <0 for delete
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DIND,DREC,OPT,I,DELFLG
C
C     + + + FUNCTIONS + + +
      INTEGER   WDDRRC,WDRCGO,WDRCDL
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDDRRC, WDRCDL, WDRCGO, WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
      OPT = 1
      DREC= WDDRRC(WDMSFL,DSN,OPT)
      DIND= WDRCGO(WDMSFL,DREC)
      I   = MOD(DSN,500)+ 4
      IF (I.EQ.4) THEN
C       last position, not first
        I= 504
      END IF
      DELFLG= 0
      IF (DSFREC.GT.0) THEN
C       add this data set
        WIBUFF(  I,DIND)= DSFREC
        WIBUFF(512,DIND)= WIBUFF(512,DIND)+ 1
      ELSE
C       delete this data set
        WIBUFF(  I,DIND)= 0
        WIBUFF(512,DIND)= WIBUFF(512,DIND)- 1
        IF (WIBUFF(512,DIND).EQ.0) THEN
C         delete directory record, no more data sets in it
          I= WDRCDL(WDMSFL,RECNO(DIND))
C         update file def record, delete the reference to this record
          OPT= 2
          I= WDDRRC(WDMSFL,DSN,OPT)
          DELFLG= 1
        END IF
      END IF
      IF (DELFLG.EQ.0) THEN
C       update the changed directory record
        CALL WDRCUP(WDMSFL,DIND)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFCUP
     I                    (WDMSFL,DSTYPE,DSN,OPT)
C
C     + + + PURPOSE + + +
C     updates file defintions record data set counters and
C     pointers, also prev and next record pointers in dsn recs are
C     updated.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, DSTYPE, DSN, OPT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSTYPE - type of DSN
C     DSN    - data set number
C     OPT    - option, 1=add, 2= delete DSN
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,RREC,PCNT,PFDSN,OFDSN,NXDSN,PRDSN,CDSN,RETCOD
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
C     bring file definition record into memory
      RREC = 1
      RIND = WDRCGO(WDMSFL,RREC)
C     calculate pointers within file definition record
      PCNT = PTSNUM + (DSTYPE-1)* 2
      PFDSN= PCNT+ 1
C     save old first dsn
      OFDSN= WIBUFF(PFDSN,RIND)
C
      IF (OPT.EQ.1) THEN
C       add a dsn
C       update first dsn
        WIBUFF(PFDSN,RIND)= DSN
C       update count of data sets
        WIBUFF(PCNT,RIND) = WIBUFF(PCNT,RIND)+ 1
C       write out updated file def record
        CALL WDRCUP(WDMSFL,RIND)
C       update pointers in old first dsn if it exists
        IF (OFDSN.GT.0) THEN
C         it does exist
          CALL WDDSCK(WDMSFL,OFDSN,
     O                RREC,RETCOD)
          RIND= WDRCGO(WDMSFL,RREC)
          WIBUFF(1,RIND)= DSN
          CALL WDRCUP(WDMSFL,RIND)
        END IF
C       update pointers in new first dsn
        CALL WDDSCK(WDMSFL,DSN,
     O              RREC,RETCOD)
        RIND= WDRCGO(WDMSFL,RREC)
        WIBUFF(2,RIND)= OFDSN
        CALL WDRCUP(WDMSFL,RIND)
      ELSE
C       delete a dsn
        CDSN= OFDSN
 10     CONTINUE
          CALL WDDSCK(WDMSFL,CDSN,
     O                RREC,RETCOD)
          RIND = WDRCGO(WDMSFL,RREC)
          NXDSN= WIBUFF(2,RIND)
          IF (CDSN.EQ.DSN) THEN
C           this is the data set to delete
            PRDSN= WIBUFF(1,RIND)
            IF (DSN.EQ.OFDSN) THEN
C             update old first dsn, it is being deleted
              OFDSN= NXDSN
            END IF
            IF (NXDSN.GT.0) THEN
C             update back pointer in next record
              CALL WDDSCK(WDMSFL,NXDSN,
     O                    RREC,RETCOD)
              RIND= WDRCGO(WDMSFL,RREC)
              WIBUFF(1,RIND)= PRDSN
              CALL WDRCUP(WDMSFL,RIND)
            END IF
            IF (PRDSN.GT.0) THEN
C             update forward pointer in prev record
              CALL WDDSCK(WDMSFL,PRDSN,
     O                    RREC,RETCOD)
              RIND= WDRCGO(WDMSFL,RREC)
              WIBUFF(2,RIND)= NXDSN
              CALL WDRCUP(WDMSFL,RIND)
            END IF
          ELSE
C           have not found the right dsn yet, get ready to try next one
            CDSN= NXDSN
          END IF
        IF (CDSN.NE.DSN.AND.CDSN.GT.0) GO TO 10
C       update counter in first record
        RREC= 1
        RIND= WDRCGO(WDMSFL,RREC)
        WIBUFF(PCNT,RIND)= WIBUFF(PCNT,RIND)- 1
C       update first dsn
        WIBUFF(PFDSN,RIND)= OFDSN
        CALL WDRCUP(WDMSFL,RIND)
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDRCDL
     I                            (WDMSFL,DREC)
C
C     + + + PURPOSE + + +
C     deletes a record in the WDMSFL and updates pointers as required
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DREC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DREC   - record to delete
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CDRLOC.INC'
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,RREC,PRNXRC,PRBKRC,SCNXRC,SCBKRC,FREREC,I,RETCOD
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
C     get pointers for record to delete
      RIND  = WDRCGO(WDMSFL,DREC)
      PRBKRC= WIBUFF(1,RIND)
      PRNXRC= WIBUFF(2,RIND)
      SCBKRC= WIBUFF(3,RIND)
      SCNXRC= WIBUFF(4,RIND)
      IF (PRBKRC.GT.0) THEN
C       a primary backward pointer exists, update that rec
        CALL WDDSCK (WDMSFL,PRBKRC,
     O               RREC,RETCOD)
        RIND= WDRCGO(WDMSFL,RREC)
        WIBUFF(2,RIND)= PRNXRC
        CALL WDRCUP(WDMSFL,RIND)
      END IF
      IF (PRNXRC.GT.0) THEN
C       a primary forward pointer exists, update that rec
        CALL WDDSCK (WDMSFL,PRNXRC,
     O               RREC,RETCOD)
        RIND= WDRCGO(WDMSFL,RREC)
        WIBUFF(1,RIND)= PRBKRC
        CALL WDRCUP(WDMSFL,RIND)
      END IF
      IF (SCBKRC.GT.0) THEN
C       a secondary backward pointer exists, update that rec
        RIND= WDRCGO(WDMSFL,SCBKRC)
        WIBUFF(4,RIND)= SCNXRC
        CALL WDRCUP(WDMSFL,RIND)
      END IF
      IF (SCNXRC.GT.0) THEN
C       a secondary forward pointer exists, update that rec
        RIND= WDRCGO(WDMSFL,SCNXRC)
        WIBUFF(3,RIND)= SCBKRC
        CALL WDRCUP(WDMSFL,RIND)
      END IF
C
C     get directory record
      RREC= 1
      RIND= WDRCGO(WDMSFL,RREC)
C
C     determine current free record
      FREREC= WIBUFF(PFRREC,RIND)
C
C     initialize current record with 0 and free rec pointer
      RIND= WDRCGO(WDMSFL,DREC)
      DO 10 I= 1,512
        WIBUFF(I,RIND) = 0
 10   CONTINUE
      WIBUFF(2,RIND)= FREREC
C     update current record
      CALL WDRCUP(WDMSFL,RIND)
C     update free record
      RIND= WDRCGO(WDMSFL,RREC)
      WIBUFF(PFRREC,RIND)= DREC
      CALL WDRCUP(WDMSFL,RIND)
C
      WDRCDL= SCNXRC
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDLBAX
     I                    (WDMSFL,DSN,DSTYPE,NDN,NUP,NSA,NSASP,NDP,
     O                     PSA)
C
C     + + + PURPOSE + + +
C     add a new data-set label, but no search attributes or data.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DSTYPE,NDN,NUP,NSA,NSASP,NDP,PSA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DSTYPE - type of data set
C     NDN    - number of down pointers
C     NUP    - number of up pointers
C     NSA    - number of search attributes
C     NSASP  - amount of search attribute space
C     NDP    - number of data pointers
C     PSA    - pointer to search attribute space
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   NIND,I,PRNREC,PDP,PUP,PDAT,PDATV,PSASTR
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGX, WDRCGO, WDPTCL
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDFCUP, WDFDUP, WDPTCL, WDRCGO, WDRCGX, WDRCUP, WDCRDT
C
C     + + + END SPECIFICATIONS + + +
C
C     get a record to put label on
      I     = 0
      PRNREC= 0
      NIND  = WDRCGX (WDMSFL,I,PRNREC)
      PRNREC= RECNO(NIND)
C     fill in new data-set number
      WIBUFF(5,NIND)= DSN
C     fill in new data-set type
      WIBUFF(6,NIND)= DSTYPE
C     update new record
      CALL WDRCUP (WDMSFL,NIND)
C     add new data set to directories
C     first, the data set directory
      CALL WDFDUP (WDMSFL,DSN,PRNREC)
C     next pointer in file def rec and dsn pointers
      I= 1
      CALL WDFCUP (WDMSFL,DSTYPE,DSN,I)
C
C     get NIND again since RECNO array may have changed
      NIND = WDRCGO(WDMSFL,PRNREC)
C
C     reserve position 7 for future use
      WIBUFF(7,NIND)= 0
C     set down position pointer
      PDP= 13
      WIBUFF(8,NIND)= PDP
C     set up position pointer
      PUP= PDP+ 1+ NDN
      WIBUFF(9,NIND)= PUP
C
C     set search attribute position pointer
      PSA= PUP+ 1+ NUP
      WIBUFF(10,NIND)= PSA
C     set search attribute start value pointer
      PSASTR= PSA+ 2+ (2* NSA)
      WIBUFF(PSA+1,NIND)= PSASTR
C     fill in undefined search attribute values
      DO 10 I= PSASTR, PSASTR+ NSASP- 1
        WIBUFF(I,NIND)= -999
 10   CONTINUE
C
C     set data group position pointer
      PDAT= PSASTR+ NSASP
      WIBUFF(11,NIND)= PDAT
C
C     set data group pointer counter
      WIBUFF(PDAT,NIND) = 0
C
C     set data position pointer
      PDATV= PDAT+ 2+ NDP
      WIBUFF(12,NIND)= PDATV
C
C     pointer to first free data position
      WIBUFF(PDAT+1,NIND)= WDPTCL(RECNO(NIND),PDATV)
C
C     update new data-set label
      CALL WDRCUP(WDMSFL,NIND)
C
C     set dataset creation date attribute
      CALL WDCRDT (WDMSFL,DSN)
C
      RETURN
      END
C
C
C 
      SUBROUTINE   WDGTAT 
     I                   (WDMSFL,DSN,SAPOS,
     O                    SAIND,SAVAL)
C
C     + + + PURPOSE + + +
C     retrieve search attributes by position in label
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,SAPOS,SAIND,SAVAL(256)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     SAPOS  - search attribute position
C     SAIND  - search attribute id
C     SAVAL  - search attribute value
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,RETCOD,RIND,PSA,PSASTR,PSAPOS,SALEN,SACNT,I,J
C    
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDDSCK (WDMSFL,DSN,
     O             RREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       what dsn type?
        RIND= WDRCGO (WDMSFL,RREC)
        I= 10
        PSA= WIBUFF(I,RIND)
        SACNT = WIBUFF(PSA,RIND)
        PSASTR= WIBUFF(PSA+1,RIND)
        PSAPOS= PSA+ (2 * SAPOS)
        IF (SAPOS .LT. SACNT) THEN
          SALEN= WIBUFF(PSAPOS+3,RIND)- WIBUFF(PSAPOS+1,RIND)
        ELSE IF (SAPOS .EQ. SACNT) THEN
          SALEN= WIBUFF(11,RIND)- WIBUFF(PSAPOS+1,RIND)
        ELSE        
          SALEN= 0
        END IF
        IF (SAPOS .EQ. 1) THEN
C         WRITE(*,*) SACNT, PSASTR,PSAPOS
        END IF
        IF (SALEN .GT. 0) THEN
          SAIND = WIBUFF(PSAPOS,RIND)
          J= WIBUFF(PSAPOS+1,RIND) - 1
          DO 10 I = 1, SALEN
            SAVAL(I)= WIBUFF(I+J,RIND)          
            IF (I .EQ. 1) THEN
C             WRITE(*,*) SAPOS,SALEN,SAIND,J,SAVAL(I)
            END IF
 10       CONTINUE     
        ELSE
C         done
          SAIND = 0
        END IF
      ELSE
        SAIND = 0
      END IF
C   
      RETURN
      END 

C
C
C
      SUBROUTINE   COPYC
     I                   (LEN, ZIP,
     O                    X)
C
C     + + + PURPOSE + + +
C     Copy the character array ZIP of size LEN to
C     the character array X of size LEN.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)ZIP(LEN),X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character arrays
C     ZIP    - input character array
C     X      - output character array
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   COPYD
     I                   (LEN, ZIP,
     O                    X)
C
C     + + + PURPOSE + + +
C     Copy the double precision array ZIP of size LEN
C     to the double precision array X.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      DOUBLE PRECISION   ZIP(LEN), X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of arrays
C     ZIP    - input array of size LEN
C     X      - output array of size LEN
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   COPYI
     I                   (LEN, ZIP,
     O                    X)
C
C     + + + PURPOSE + + +
C     Copy the integer array ZIP of size LEN to
C     the integer array X.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      INTEGER     ZIP(LEN), X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of arrays
C     ZIP    - input array of size LEN
C     X      - output array of size LEN
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   COPYR
     I                   (LEN, ZIP,
     O                    X)
C
C     + + + PURPOSE + + +
C     Copy the real array ZIP of size LEN to the
C     real array X.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      REAL        ZIP(LEN), X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of arrays
C     ZIP    - input array of size LEN
C     X      - output array of size LEN
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   ZIPC
     I                  (LEN, ZIP,
     O                   X)
C
C     Fill the character array X of size LEN with
C     the given value ZIP.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)ZIP,X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     ZIP    - character to fill array
C     X      - character array to be filled
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   ZIPD
     I                  (LEN, ZIP,
     O                   X)
C
C     + + + PURPOSE + + +
C     Fill the double precision array X of size LEN
C     with the given value ZIP.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      DOUBLE PRECISION   ZIP, X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of array
C     ZIP    - value to fill array
C     X      - output array of size LEN
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   ZIPI
     I                  (LEN, ZIP,
     O                   X)
C
C     + + + PURPOSE + + +
C     Fill the integer array X of size LEN with
C     the given value ZIP.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN, ZIP
      INTEGER     X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of array
C     ZIP    - value to fill array
C     X      - output array of size LEN
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END
C
C
C
      SUBROUTINE   ZIPR
     I                  (LEN, ZIP,
     O                   X)
C
C     + + + PURPOSE + + +
C     Fill the real array X of size LEN with the
C     given value ZIP.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      REAL        ZIP, X(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of array
C     ZIP    - value to fill array
C     X      - output array of size LEN
C
C     + + + END SPECIFICATIONS + + +
C
      X = ZIP
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDTGET
     I                    (WDMSFL,DSN,DELT,DATES,NVAL,
     I                     DTRAN,QUALFG,TUNITS,
     O                     RVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     gets timeseries information from the WDMSFL
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DELT,DATES(6),NVAL,DTRAN,QUALFG,
     1          TUNITS,RETCOD
      REAL      RVAL(NVAL)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DELT   - time step for get
C     DATES  - starting date
C     NVAL   - number of values
C     DTRAN  - transformation code
C              0 - ave,same
C              1 - sum,div
C              2 - max
C              3 - min
C     QUALFG - allowed quality code
C     TUNITS - time units for get
C     RVAL   - array to place retrieved values in
C     RETCOD - return code
C                0 - everything O.K.
C               -8 - invalid date
C              -14 - date specified not within valid range for data set
C              -20 - problem with one or more of following:
C                    GPFLG, DXX, NVAL, QUALVL, LTSTEP, LTUNIT
C              -21 - date from WDM doesn't match expected date
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GPFLG,GPOSEN,GPIND,LTSTEP,LTUNIT,TDSFRC,TGROUP,TSPTAD,
     1          ENDDAT(6),GPSDAT(6),GETDAT(6),TSPSC1,TSPSC2,
     2          COMPFG,TSFORM,VBTIME,TSSTEP,TCODE,GETQK,RIND,
     3          LWDMFL,LDSN
      INTEGER(4)I4NVAL
      REAL      DEFVAL,TOLR,TSFILL,GETQRA,RTMP
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC FLOAT, MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPR, WTPMCK, WTFNDG, WDATCP, WTGTVL, WDRCGO, WTDSPX
      EXTERNAL  WTSCSC,WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
      I4NVAL= NVAL
      LTSTEP= DELT
      LTUNIT= TUNITS
      GPFLG = 1
      TSFILL= 0.0
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
C
C     check the user supplied parameters
      CALL WTPMCK (GPFLG,DTRAN,DATES,NVAL,QUALFG,
     M             LTSTEP,LTUNIT,
     O             RETCOD)
      IF (RETCOD.EQ.0) THEN
C       check the data set and figure out which groups have been req.
        CALL WTFNDG (LWDMFL,LDSN,GPFLG,DATES,LTSTEP,LTUNIT,I4NVAL,
     O               TDSFRC,TSFILL,TGROUP,TOLR,TSPTAD,
     1               GPIND,GPOSEN,GPSDAT,ENDDAT,RETCOD)
      END IF
C     fill in RVAL with defaults
      DEFVAL= TSFILL
C     max
      IF (DTRAN.EQ.2) DEFVAL= -1.0E30
C     min
      IF (DTRAN.EQ.3) DEFVAL= 1.0E30
      CALL ZIPR (NVAL,DEFVAL,
     O           RVAL)
C
      IF (RETCOD.EQ.0) THEN
C       get additional parameters
        RIND= WDRCGO(LWDMFL,TDSFRC)
        CALL WTDSPX (WIBUFF(1,RIND),
     O               COMPFG,TSFORM,VBTIME,TSSTEP,TCODE)
        GETQK= 0
C       can we do a quick get?
        IF (VBTIME.EQ.1) THEN
C         yes, if time units and step ok
          IF (TCODE.LE.4.AND.LTUNIT.LE.4) THEN
C           time units days or shorter, a quick get may work
            CALL WTSCSC (LTUNIT,LTSTEP,TSPSC1)
            CALL WTSCSC (TCODE,TSSTEP,TSPSC2)
            GETQRA= 1.0E-8+ FLOAT(TSPSC2)/FLOAT(TSPSC1)
            RTMP  = GETQRA
            IF (RTMP.LT.1.0) THEN
C             wdm interval less than user interval
              RTMP= 1.0/ GETQRA
            END IF
            IF (MOD(RTMP,1.0).LT.1.0E-6) THEN
C             ok to do a quick get
              GETQK= 1
            END IF
          ELSE IF (TCODE.EQ.LTUNIT) THEN
C           time units are the same, a quick get will work
            GETQK = 1
            GETQRA= 1.0E-8+ FLOAT(TSSTEP)/FLOAT(LTSTEP)
          END IF
        ELSE
C         do a general get
          GETQK= 0
        END IF
C       make a working copy of the starting date
        CALL WDATCP (DATES,GETDAT)
C       get the data
        CALL WTGTVL (LWDMFL,LDSN,GPOSEN,NVAL,LTUNIT,LTSTEP,DTRAN,
     I               QUALFG,ENDDAT,TDSFRC,TSFILL,TGROUP,
     I               GETQK,GETQRA,VBTIME,
     M               RVAL,GETDAT,GPSDAT,GPIND,
     O               RETCOD)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTSCSC
     I                    (TUNITS,TSSTEP,
     I                     TSPSEC)
C
C     + + + PURPOSE + + +
C     converts the given time units and time step to seconds
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   TUNITS,TSSTEP,TSPSEC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TUNITS - time units
C     TSSTEP - time step
C     TSPSEC - time in seconds
C
C     + + + END SPECIFICATIONS + + +
C
      TSPSEC= TSSTEP
      GO TO (40,30,20,10), TUNITS
 10   CONTINUE
C       day units to hours
        TSPSEC= TSPSEC* 24
 20   CONTINUE
C       hours to minutes
        TSPSEC= TSPSEC* 60
 30   CONTINUE
C       minutes to seconds
        TSPSEC= TSPSEC* 60
 40   CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTPMCK
     I                    (GPFLG,DXX,DATES,NVAL,QUALVL,
     M                     LTSTEP,LTUNIT,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     checks the parameters supplied to either WDTPUT or WDTGET
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   GPFLG,LTSTEP,DXX,DATES(6),NVAL,QUALVL,LTUNIT,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     GPFLG  - get/put flag
C              1 - get
C              2 - put
C     DXX    - transform or overwrite flag
C     DATES  - starting date
C     NVAL   - number of values
C     QUALVL - quality of data code
C     LTSTEP - time step
C     LTUNIT - time units
C     RETCOD - return code
C                0 - everything is O.K.
C               -8 - invalid date
C              -20 - problem with one or more of following:
C                    GPFLG, DXX, NVAL, QUALVL, LTSTEP, LTUNIT
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DONFG,I,CONV(7)
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL  TSBINI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CONV/60,60,24,999,12,100,999/
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
C
C     may need to initialize time-series buffer stuff
      CALL TSBINI
C
C     check dates
      IF (DATES(1).LT.1.OR.DATES(1).GT.32000  .OR.
     1    DATES(2).LT.1.OR.DATES(2).GT.12     .OR.
     2    DATES(3).LT.1.OR.DATES(3).GT.31     .OR.
     3    DATES(4).LT.0.OR.DATES(4).GT.24     .OR.
     4    DATES(5).LT.0.OR.DATES(5).GT.59     .OR.
     5    DATES(6).LT.0.OR.DATES(6).GT.59) RETCOD= -8
C     check DXX (DTRAN for get, DTOVWR for put)
      IF (DXX.LT.0.OR.(GPFLG.EQ.1.AND.DXX.GT.3).OR.
     1    (GPFLG.EQ.2.AND.DXX.GT.0)) THEN
C       bad parameter
        RETCOD= -20
      END IF
C     check other parameters
      IF (NVAL.LT.1.OR.
     1    LTUNIT.LT.1.OR.LTUNIT.GT.7.OR.
     2    QUALVL.LT.0.OR.QUALVL.GT.31) THEN
C       bad parameter
        RETCOD= -20
      END IF
      IF (RETCOD.EQ.0) THEN
C       check LTSTEP with regard to specified LTUNIT
        I= LTUNIT
        DONFG= 0
 10     CONTINUE
          IF (MOD(LTSTEP,CONV(I)).EQ.0) THEN
            LTSTEP= LTSTEP/CONV(I)
            I= I+ 1
            LTUNIT= I
          ELSE
            DONFG= 1
          END IF
        IF (DONFG.EQ.0) GO TO 10
        IF (LTSTEP.LT.1.OR.LTSTEP.GT.63) THEN
C         bad parameter
          RETCOD= -20
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTFNDG
     I                    (WDMSFL,DSN,GPFLG,DATES,LTSTEP,LTUNIT,I4NVAL,
     O                     TDSFRC,TSFILL,TGROUP,TOLR,TSPTAD,
     O                     GPOSST,GPOSEN,GPSDAT,ENDDAT,RETCOD)
C
C     + + + PURPOSE + + +
C     check the data set,
C     computes ending date, start and end group pointers and
C     number of values to skip in first group
C
C     + + + HISTORY + + +
C     kmf May 25, 2001 - corrected problem reading last group in a
C                        time series data set.  Comparison between
C                        GRPOFF and TGRNUM changed from .GE. to .GT.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,GPFLG,DATES(6),LTSTEP,LTUNIT,
     1          TDSFRC,TGROUP,TSPTAD,GPOSST,GPOSEN,
     2          ENDDAT(6),GPSDAT(6),RETCOD
      INTEGER(4)I4NVAL
      REAL      TSFILL,TOLR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - timeseries data-set number
C     GPFLG  - get/put flag
C              1 - get
C              2 - put
C     DATES  - starting date
C     LTSTEP - time step
C     LTUNIT - time units
C     I4NVAL - number of values
C     TDSFRC - first record in data set
C     TSFILL - missing data filler code
C     TGROUP - data group pointer units
C     TOLR   - compression tolerance
C     TSPTAD - put data transform code
C     GPOSST - start data group pointer index
C     GPOSEN - end data group pointer index
C     GPSDAT - start date of first group
C     ENDDAT - end date for get or put
C     RETCOD - return code
C                0 - everything O.K.
C              -14 - date specified not within valid range for data set
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,TBSDAT(6),TGRPST,RIND,PDAT,PDATV,DSTYP,GRCNT
      INTEGER(4)GRPOFF,TGRNUM
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO, TIMCHK
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSCHA, WDRCGO, WTDSPM, TIMADD, TIMCNV, WTSGRP, TIMDIF
      EXTERNAL  TIMCHK
C
C     + + + END SPECIFICATIONS + + +
C
C     check basics about data set
      DSTYP= 1
      CALL WDSCHA (WDMSFL,DSN,DSTYP,GPFLG,
     O             TDSFRC,GRCNT,RETCOD)
C
      IF (RETCOD.EQ.0) THEN
C       get data-set parameters
        RIND= WDRCGO(WDMSFL,TDSFRC)
        CALL WTDSPM (WDMSFL,WIBUFF(1,RIND),WRBUFF(1,RIND),
     O               TSFILL,TGROUP,TOLR,TBSDAT,TSPTAD)
C
C       calculate pointer to first group pointer
        PDAT  = WIBUFF(11,RIND)
        TGRPST= PDAT+ 2
C
C       calculate max number of group pointers
        PDATV = WIBUFF(12,RIND)
        TGRNUM= PDATV- PDAT- 2
C
C       calculate ending date
        CALL TIMADD (DATES,LTUNIT,LTSTEP,I4NVAL,
     O               ENDDAT)
C
C       convert end date to old date format
        CALL TIMCNV (ENDDAT)
C
C       determine beginning of first group
        CALL WTSGRP (DATES,TGROUP,
     O               GPSDAT)
C
        IF (TIMCHK(TBSDAT,GPSDAT).EQ.-1) THEN
C         base year after start of data to add
          GRPOFF= -1
        ELSE
C         determine starting pointer index
          I= 1
          CALL TIMDIF (TBSDAT,GPSDAT,TGROUP,I,
     O                 GRPOFF)
        END IF
Ckmf    IF (GRPOFF.LT.0 .OR. GRPOFF.GE.TGRNUM) THEN
        IF (GRPOFF.LT.0 .OR. GRPOFF.GT.TGRNUM) THEN
C         date specified not within valid range for data set
          RETCOD= -14
        END IF
        GPOSST= TGRPST+ GRPOFF
C
C       determine ending pointer index
        I= 1
        CALL TIMDIF (TBSDAT,ENDDAT,TGROUP,I,
     O               GRPOFF)
Ckmf    IF (GRPOFF.LT.0 .OR. GRPOFF.GE.TGRNUM) THEN
        IF (GRPOFF.LT.0 .OR. GRPOFF.GT.TGRNUM) THEN
C         date specified not within valid range for data set
          RETCOD= -14
        ELSE
C         do we end exactly on boundary
          CALL WTSGRP (ENDDAT,TGROUP,
     O                 TBSDAT)
          IF (TIMCHK(ENDDAT,TBSDAT).EQ.0) THEN
C           yes, we do
            GRPOFF= GRPOFF- 1
          END IF
          GPOSEN= TGRPST+ GRPOFF
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTDSPM
     I                    (WDMSFL,TIBUFF,TRBUFF,
     O                     TSFILL,TGROUP,TOLR,TBSDAT,TSPTAD)
C
C     + + + PURPOSE + + +
C     obtains values for a variety of TIMSER parms from labels
C     or defaults
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,TGROUP,TBSDAT(6),TSPTAD
      INTEGER(4)TIBUFF(512)
      REAL      TRBUFF(512),TSFILL,TOLR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     TIBUFF - data-set label - integer version
C     TRBUFF - data-set label - decimal version
C     TSFILL - missing data filler code
C     TGROUP - data group pointer units
C     TOLR   - compression tolerance
C     TBSDAT - beginning date of data
C     TSPTAD - put data transform code
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,SAIND,POS
C
C     + + + FUNCTIONS + + +
      INTEGER   WDSASV
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSASV, WTBYFX
C
C     + + + END SPECIFICATIONS + + +
C
C     set default dates
      TBSDAT(1)= -999
      TBSDAT(2)= 1
      TBSDAT(3)= 1
      TBSDAT(4)= 0
      TBSDAT(5)= 0
      TBSDAT(6)= 0
C
C     get beginning date pointers
      DO 10 I= 1,4
        SAIND= I+ 26
        POS  = WDSASV(SAIND,TIBUFF)
        IF (POS.GT.0) THEN
C         from label
          TBSDAT(I)= TIBUFF(POS)
        END IF
 10   CONTINUE
C
C     get missing data filler code
      SAIND= 32
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       from label
        TSFILL= TRBUFF(POS)
      ELSE
C       default
        TSFILL= 0.0
      END IF
C
C     get units for data group pointer
      SAIND= 34
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       from label
        TGROUP= TIBUFF(POS)
      ELSE
C       default
        TGROUP= 6
      END IF
C
C     get compression tolerance
      SAIND= 36
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       from label
        TOLR= TRBUFF(POS)
      ELSE
C       default
        TOLR= 1.0E-8
      END IF
C
C     get put transform code
      SAIND= 60
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       from label
        TSPTAD= TIBUFF(POS)
      ELSE
C       default
        TSPTAD= 0
      END IF
C
      IF (TBSDAT(1).EQ.-999) THEN
C       missing base year attribute, add it
        CALL WTBYFX (WDMSFL,TIBUFF(5),TGROUP,
     O               TBSDAT(1))
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTBYFX
     I                   (WDMSFL,DSN,TGROUP,
     O                    TBSYR)
C
C     + + + PURPOSE + + +
C     add base year attribute to a timeseries data set
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,TGROUP,TBSYR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - timeseries data-set number
C     TGROUP - data group pointer units
C     TBSYR  - base year
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   TDSFRC,RETCOD,RIND,PDAT,DPCNT,I,
     1          GPIND,GPPTR,GREC,GOFF,GIND,GPDAT(6),BASDAT(6),GVAL,
     2          SAIND,SATYP,SALEN,PSAVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK,WDSASP,WDRCGO,WDRCUP,TIMDIF,WDATSP,WDPTSP
C
C     + + + END SPECIFICATIONS + + +
C
C     determine where data set starts
      CALL WDDSCK (WDMSFL,DSN,
     O             TDSFRC,RETCOD)
C     bring label into memory
      RIND= WDRCGO(WDMSFL,TDSFRC)
C     where does data start
      PDAT= WIBUFF(11,RIND)
C     how many data groups are present
      DPCNT= WIBUFF(PDAT,RIND)
      IF (DPCNT.GT.0) THEN
C       data is present, find out what base year was assumed to be
        GPPTR= 0
        GPIND= PDAT+ 1
C       loop to look for data
 10     CONTINUE
          GPIND= GPIND+ 1
          IF (WIBUFF(GPIND,RIND).GT.0) THEN
C           data exist in this group
            GPPTR= WIBUFF(GPIND,RIND)
C           find where group starts
            CALL WDPTSP (GPPTR,
     O                   GREC,GOFF)
            GIND= WDRCGO(WDMSFL,GREC)
C           find group where data begins
            CALL WDATSP (WIBUFF(GOFF,GIND),
     O                   GPDAT)
C           set other dates
            GPDAT(5) = 0
            GPDAT(6) = 0
            BASDAT(1)= 1899
            BASDAT(2)= 1
            BASDAT(3)= 1
            BASDAT(4)= 0
            BASDAT(5)= 0
            BASDAT(6)= 0
            I =1
            CALL TIMDIF (BASDAT,GPDAT,TGROUP,I,
     O                   GVAL)
C           convert units to groups
            GPIND= GPIND- PDAT- 2
            IF (GPIND.EQ.GVAL) THEN
C             old case
              TBSYR= 1899
            ELSE
C             new case
              TBSYR= 1900
            END IF
          END IF
        IF (GPPTR.EQ.0) GO TO 10
      ELSE
C       no data, default base year
        TBSYR= 1900
      END IF
C     write base year attribute on label to avoid this next time
      SAIND= 27
      SALEN= 1
      SATYP= 1
C     be sure label in memory
      RIND= WDRCGO(WDMSFL,TDSFRC)
C     where do we put it?
      CALL WDSASP (SAIND,SALEN,SATYP,
     M             WIBUFF(1,RIND),
     O             PSAVAL,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       added attribute space successfully, fill in value
        WIBUFF(PSAVAL,RIND)= TBSYR
        CALL WDRCUP(WDMSFL,RIND)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTDSPX
     I                    (TIBUFF,
     O                     COMPFG,TSFORM,VBTIME,TSSTEP,TCODE)
C
C     + + + PURPOSE + + +
C     obtains values for a variety of timeseries parms from labels
C     or defaults
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   COMPFG,TSFORM,VBTIME,TSSTEP,TCODE
      INTEGER(4)TIBUFF(512)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TIBUFF - data-set label - integer version
C     COMPFG - compression flag
C     TSFORM - form of data
C     VBTIME - variable time step option
C     TSSTEP - timeseries timestep
C     TCODE  - timeseries time code
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SAIND,POS
C
C     + + + FUNCTIONS + + +
      INTEGER   WDSASV
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSASV
C
C     + + + END SPECIFICATIONS + + +
C
C     get compression flag
      SAIND= 83
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       available from label
        COMPFG= TIBUFF(POS)
C       write(99,*) 'compfg from label:',COMPFG
      ELSE
C       default to compressed
        COMPFG= 1
      END IF
C
C     form of data
      SAIND= 84
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       available from label
        TSFORM= TIBUFF(POS)
      ELSE
C       default to mean
        TSFORM= 1
      END IF
C
C     variable time step option
      SAIND= 85
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       available from label
        VBTIME= TIBUFF(POS)
      ELSE
C       default to time step may vary
        VBTIME= 2
      END IF
C
C     time step
      SAIND= 33
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       available from label
        TSSTEP= TIBUFF(POS)
      ELSE
C       no default
        TSSTEP= -999
      END IF
C
C     time units
      SAIND= 17
      POS  = WDSASV(SAIND,TIBUFF)
      IF (POS.GT.0) THEN
C       available from label
        TCODE= TIBUFF(POS)
      ELSE
C       no default
        TCODE= -999
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTSKVL
     I                    (WDMSFL,GPIND,GPSDAT,STDAT,
     I                     TDSFRC,TSFILL,TGROUP,BADJFG,ADDAFG,VBTIME,
     O                     CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O                     CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     skips values within a WDMSFL timeseries group, also
C     outputs current block information in common CWTSDS, also
C     end of group date
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,GPIND,GPSDAT(6),STDAT(6),RETCOD,TDSFRC,TGROUP,
     1          BADJFG,ADDAFG,VBTIME,CURREC,
     2          CURBKS,CURPOS,CURTST,CURTUN,CURCMP,CURQUA,CURDAT(6)
      INTEGER(4)CURNOV,CURCNT
      REAL      TSFILL,CURVAL,PREVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     GPIND  - group index number
C     GPSDAT - starting date of group
C     STDAT  - date to skip to
C     TDSFRC - first record in data set
C     TSFILL - missing data filler code
C     TGROUP - data group pointer units
C     BADJFG - block adjustment for efficiency flag
C              0 - no
C              1 - yes
C     ADDAFG - data present flag
C     VBTIME - variable timestep indicator
C     CURREC - current record number
C     CURBKS - starting position of current block within current record
C     CURPOS - current position in current block
C     CURNOV - current number of values in current block
C     CURVAL - current value
C     PREVAL - previous value
C     CURTST - current time step
C     CURTUN - current time units
C     CURCMP - current compression code
C     CURQUA - current quality code
C     CURCNT - current position within block
C     CURDAT - current date of start of current value
C     RETCOD - return code
C                  0 - everything O.K.
C                -10 - no data in this group
C                -11 - no non missing data, data has not started yet
C                -21 - date from WDM doesn't match expected date
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   BLEDAT(6),BLSDAT(6)
C
C     + + + EXTERNALS + + +
      EXTERNAL  WTSKVX
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WTSKVX (WDMSFL,GPIND,GPSDAT,STDAT,
     I             TDSFRC,TSFILL,TGROUP,BADJFG,ADDAFG,VBTIME,
     O             CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O             CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O             RETCOD,BLSDAT,BLEDAT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTSKVX
     I                    (WDMSFL,GPIND,GPSDAT,STDAT,
     I                     TDSFRC,TSFILL,TGROUP,BADJFG,ADDAFG,VBTIME,
     O                     CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O                     CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O                     RETCOD,BLSDAT,BLEDAT)
C
C     + + + PURPOSE + + +
C     skips values within a WDMSFL TIMESERIES group, also
C     returns current block information and end of group date
C     can fill an empty group with dummy data if ADDAFG=1
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,GPIND,GPSDAT(6),STDAT(6),
     1          RETCOD,BADJFG,ADDAFG,VBTIME,
     2          CURREC,CURBKS,CURPOS,CURTST,CURTUN,CURCMP,CURQUA,
     3          CURDAT(6),TDSFRC,TGROUP,BLSDAT(6),BLEDAT(6)
      INTEGER(4)CURNOV,CURCNT
      REAL      TSFILL,CURVAL,PREVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     GPIND  - group index number
C     GPSDAT - starting date of group
C     STDAT  - data to skip to
C     TDSFRC - first record in data set
C     TSFILL - missing data filler code
C     TGROUP - data group pointer units
C     BADJFG - block adjustment for efficiency flag
C              0 - no
C              1 - yes
C     ADDAFG - data present flag
C     VBTIME - variable timestep indicator
C     CURREC - current record number
C     CURBKS - starting position of current block within current record
C     CURPOS - current position in current block
C     CURNOV - current number of values in current block
C     CURVAL - current value
C     PREVAL - previous value
C     CURTST - current time step
C     CURTUN - current time units
C     CURCMP - current compression code
C     CURQUA - current quality code
C     CURCNT - current position within block
C     CURDAT - current date of start of current value
C     RETCOD - return code
C                  0 - everything O.K.
C                -10 - no data in this group
C                -11 - no non missing data, data has not started yet
C                -21 - date from WDM doesn't match expected date
C     BLSDAT - block start date array
C     BLEDAT - block end date
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DIND,RIND,CHK,PDAT,TSPREC,SAIND,I,GTUNIT,GTSTEP,
     1          TDAT(6),EGPFLG,GPEDAT(6),TSTDAT(6),MINQUA,POS
      INTEGER(4)GPPTR,BCW,I4ZRO,NUMSKP,I4ONE,TDFREE,GVAL,LVAL,I4TMP,
     1          SVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO,TIMCHK,WDSASV,WDRCGX
      INTEGER(4)WDPTCL,WDATCL,WBCWCL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDSASV, WDPTSP, WDRCGX, WDPTCL, WDATCL, WTEGRP
      EXTERNAL   TIMDIF, TIMADD, TIMCHK, WBCWCL, WTNWBK, WDRCUP, WDATSP
      EXTERNAL   WDSKBK, WBCWSP, WBCWSQ, WDATCP
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
      I4ZRO = 0
      I4ONE = 1
      DIND  = WDRCGO (WDMSFL,TDSFRC)
      GPPTR = WIBUFF(GPIND,DIND)
      IF (GPPTR.EQ.I4ZRO) THEN
        IF (ADDAFG.EQ.0) THEN
C         no data in this group
          RETCOD= -10
        ELSE
C         this group doesnt exist yet, create it with dummy data
C         time step
          SAIND= 33
          POS  = WDSASV(SAIND,WIBUFF(1,DIND))
          IF (POS.GT.0) THEN
C           from label
            GTSTEP= WIBUFF(POS,DIND)
          ELSE
C           default
            GTSTEP= 1
          END IF
C         figure out where free space starts
          PDAT  = WIBUFF(11,DIND)
          TDFREE= WIBUFF(PDAT+1,DIND)
C         get pointer record flag from label if available
          SAIND = 31
          I     = WDSASV(SAIND,WIBUFF(1,DIND))
          IF (I.GT.0) THEN
C           from label
            TSPREC= WIBUFF(I,DIND)
          ELSE
C           default pointer new record flag to no
            TSPREC= 0
          END IF
          CALL WDPTSP (TDFREE,
     O                 CURREC,CURPOS)
          IF (TSPREC.EQ.1.OR.CURPOS.GT.510.OR.CURPOS.EQ.0) THEN
C           the new group will start on a new record, it follows current
            I   = 0
            RIND  = WDRCGX(WDMSFL,I,CURREC)
            CURPOS= 5
            CURREC= RECNO(RIND)
          END IF
C         calc the group pointer to go into the directory later
          GPPTR = WDPTCL(CURREC,CURPOS)
C         fill in date field and undefined values in the new group
          RIND  = WDRCGO(WDMSFL,CURREC)
          WIBUFF(CURPOS,RIND)= WDATCL(GPSDAT)
          CURBKS= CURPOS+ 1
          CURPOS= CURBKS+ 1
          CURCMP= 1
          CURQUA= 31
          IF (VBTIME.NE.2) THEN
C           need constant interval data
            GTUNIT= ADDAFG
          ELSE
C           use most efficient units
            GTUNIT= TGROUP
            GTSTEP= 1
          END IF
C         find end of group
          CALL WTEGRP (GPSDAT,TGROUP,
     O                 GPEDAT)
 10       CONTINUE
C           find number of intervals in group
            CALL TIMDIF (GPSDAT,GPEDAT,GTUNIT,GTSTEP,
     O                   GVAL)
C           be sure we end on a group boundary
Ckmf
Ckmf  write(99,*) '      wtskvx: gpsdat =', gpsdat
Ckmf  write(99,*) '                tdat =',  tdat
Ckmf  write(99,*) '              gtunit =', gtunit
Ckmf  write(99,*) '              gtstep =', gtstep
Ckmf  write(99,*) '                gval =',  gval
Ckmf  write(99,*) ' -->  timadd'
            CALL TIMADD (GPSDAT,GTUNIT,GTSTEP,GVAL,
     O                   TDAT)
Ckmf  write(99,*) ' <--  timadd:   tdat =', tdat
C           check boundary of starting date
            CALL TIMDIF (GPSDAT,STDAT,
     O                   GTUNIT,GTSTEP,SVAL)
            CALL TIMADD (GPSDAT,GTUNIT,GTSTEP,SVAL,
     O                   TSTDAT)
            EGPFLG= 0
            IF (TIMCHK(TDAT,GPEDAT).NE.0.OR.
     1          TIMCHK(TSTDAT,STDAT).NE.0) THEN
C             oops, did not end on a group boundary
C             or data start not on boundary
              EGPFLG= 1
              GTUNIT= GTUNIT- 1
            END IF
          IF (EGPFLG.EQ.1) GO TO 10
C         fill new group with dummy values
 20       CONTINUE
            LVAL = GVAL
            I4TMP= 32767
            IF (LVAL.GT.I4TMP) LVAL= I4TMP
            WIBUFF(CURBKS,RIND)=WBCWCL(LVAL,GTSTEP,GTUNIT,CURCMP,CURQUA)
            WRBUFF(CURPOS,RIND)= TSFILL
            CURPOS= CURPOS+ 1
            CALL WTNWBK (WDMSFL,
     M                   CURREC,CURPOS,
     O                   CURBKS)
            RIND= WDRCGO(WDMSFL,CURREC)
            GVAL= GVAL- LVAL
          IF (GVAL.GT.I4ZRO) GO TO 20
          CALL WDRCUP(WDMSFL,RIND)
C         update the directory
          DIND  = WDRCGO(WDMSFL,TDSFRC)
          PDAT  = WIBUFF(11,DIND)
C         update active group counter
          WIBUFF(PDAT,DIND)  = WIBUFF(PDAT,DIND)+ 1
C         update the data-set free space pointer
          TDFREE= WDPTCL(CURREC,CURBKS)
          WIBUFF(PDAT+1,DIND)= TDFREE
C         pointer to this groups data
          WIBUFF(GPIND,DIND) = GPPTR
C         write out the revised directory
          CALL WDRCUP(WDMSFL,DIND)
        END IF
      END IF
C
      IF (RETCOD.EQ.0) THEN
C       split up the pointer into record and offset
        CALL WDPTSP (GPPTR,
     O               CURREC,CURPOS)
C       get the starting record of the group
        DIND= WDRCGO (WDMSFL,CURREC)
C       check date from WDMS with expected date
        CALL WDATSP (WIBUFF(CURPOS,DIND),
     O               BLSDAT)
        BLSDAT(5)= 0
        BLSDAT(6)= 0
        IF (TIMCHK(BLSDAT,GPSDAT).NE.0) THEN
C         date from WDM doesn't match expected date
          RETCOD= -21
        END IF
      END IF
      IF (RETCOD.EQ.0) THEN
C       increment the offset to position of first BCW
        CURBKS= CURPOS
        NUMSKP= 1
        MINQUA= 31
 30     CONTINUE
C         skip to next BCW
          CALL WDSKBK (WDMSFL,NUMSKP,
     M                 CURREC,CURBKS)
C         be sure record is in buffer
          DIND= WDRCGO (WDMSFL,CURREC)
C         get the BCW
          BCW= WIBUFF(CURBKS,DIND)
C         split up the BCW
          IF (BADJFG.EQ.0) THEN
            CALL WBCWSP (BCW,
     O                   CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
          ELSE
            CALL WBCWSQ (BCW,
     O                   CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
          END IF
          IF (CURQUA.LT.MINQUA) MINQUA= CURQUA
C         find the end of this block
          CALL TIMADD (BLSDAT,CURTUN,CURTST,CURNOV,
     O                 BLEDAT)
C         are we before of after the start we are after
          CHK= TIMCHK (BLEDAT,STDAT)
          IF (CHK.GE.0) THEN
C           more values to skip, prepare to skip to next block
            NUMSKP= 2
            IF (CURCMP.EQ.0) THEN
C             uncompressed, skip number of values + bcw
              NUMSKP= CURNOV+ 1
            END IF
            CALL WDATCP (BLEDAT,BLSDAT)
          ELSE
C           we are in the block we want
C           recalc BCW without adjustment JLK 3/18/87
            CALL WBCWSP (BCW,
     O                   CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
C           set NUMSKP to stop skipping
            NUMSKP= 0
C           figure out where in block
            CALL TIMDIF (BLSDAT,STDAT,CURTUN,CURTST,
     O                   CURCNT)
            IF (CURCNT.LT.0) THEN
C             reset boundary case
              CURCNT= 0
            END IF
C           figure out which date we are on
            CALL TIMADD (BLSDAT,CURTUN,CURTST,CURCNT,
     O                   CURDAT)
C           update the current position if on boundary
            CHK= TIMCHK(CURDAT,STDAT)
            IF (CHK.GE.0) THEN
C             reset boundary case
              CURCNT= CURCNT+ 1
            END IF
            IF (CURCNT.GT.CURNOV) THEN
C             we are at the beginning of next block, skip to it
              NUMSKP= 2
              IF (CURCMP.EQ.0) THEN
C               uncompressed, skip number of values + bcw
                NUMSKP= CURNOV+ 1
              END IF
              CALL WDATCP (BLEDAT,BLSDAT)
            END IF
          END IF
        IF (NUMSKP.NE.I4ZRO) GO TO 30
C       calculate the current value
        CURPOS= CURBKS+ 1
        IF (CURCMP.EQ.0) THEN
C         where is the current value
          CURPOS= CURBKS+ CURCNT
        END IF
        CURVAL= WRBUFF(CURPOS,DIND)
C       calculate the previous value
        IF (CURCNT.GT.I4ONE) THEN
C         skip ahead
          NUMSKP= CURBKS+ 1
          IF (CURCMP.EQ.0) THEN
C           where is the previous value
            NUMSKP= CURBKS+ CURCNT- 1
          END IF
          PREVAL= WRBUFF(NUMSKP,DIND)
        ELSE
C         don't know where previous value is
          PREVAL= TSFILL
        END IF
        IF (ADDAFG.EQ.0.AND.MINQUA.EQ.31) THEN
C         no non missing data, data has not started yet
          RETCOD= -11
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSKBK
     I                    (WDMSFL,NUMSKP,
     M                     CURREC,CURPOS)
C
C     + + + PURPOSE + + +
C     skips to next WDMSFL block
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,CURREC,CURPOS
      INTEGER(4)NUMSKP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     NUMSKP - number of elements to skip
C     CURREC - current record number
C     CURPOS - current position within record
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      CURPOS= CURPOS+ NUMSKP
      IF (CURPOS.EQ.512) THEN
C       force new record
        CURPOS= 513
      END IF
      IF (CURPOS.GT.512) THEN
C       new record needed
 10     CONTINUE
          RIND= WDRCGO(WDMSFL,CURREC)
C         get the pointer to next record
          CURREC= WIBUFF(4,RIND)
          CURPOS= CURPOS- 508
        IF (CURPOS.GT.512) GO TO 10
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTGTVL
     I                    (WDMSFL,DSN,GPOSEN,NVAL,GTTUN,GTTST,GTTRN,
     I                     QUALFG,ENDDAT,TDSFRC,TSFILL,TGROUP,
     I                     GETQK,GETQRA,VBTIME,
     M                     RVAL,GETDAT,GPSDAT,GPIND,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     fills in RVAL array with data values from WDMS DSN
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER    WDMSFL,DSN,GPOSEN,NVAL,GTTUN,GTTST,GTTRN,
     1           QUALFG,ENDDAT(6),TDSFRC,TGROUP,GETQK,
     1           VBTIME,GETDAT(6),GPSDAT(6),GPIND,RETCOD
      REAL       RVAL(NVAL),TSFILL,GETQRA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - timeseries data set number
C     GPOSEN - end data group pointer index
C     NVAL   - number of values
C     GTTUN  - get time units
C     GTTST  - get time step
C     GTTRN  - get transformation code
C     QUALFG - get quality code
C     ENDDAT - end of get date array
C     TDSFRC - first record in data set
C     TSFILL - missing data filler code
C     TGROUP - data group pointer units
C     GETQK  - do a quick get
C     GETQRA - quick get time step ratio (user/dsn)
C     VBTIME - variable timestep indicator
C     RVAL   - array of values retrieved from WDMS file
C     GETDAT - current get date array
C     GPSDAT - start date of first group
C     GPIND  - get group index number
C     RETCOD - return code
C                  0 - everything O.K.
C                -21 - date from WDM doesn't match expected date
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CWTSDS.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   CURNXT(6),GETNXT(6),TMPNXT(6),WDADD,GTADD,IONE,CHK,ICNT,
     1          CHKS,TMPTUN,GPEDAT(6),NEWGRP,BADJFG,ADDAFG,EGPOS,TMPOS,
     2          I,TMPDAT(6)
      INTEGER(4)GETSPN,TMPSPN,CURSPN,I4ONE,I4NVAL,DPOS
      REAL      FRAC,CFRAC,RTMP
C
C     + + + FUNCTIONS + + +
      INTEGER   TIMCHK
C
C     + + + INTRINSICS + + +
      INTRINSIC FLOAT,ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDATCP, WTEGRP, WTSKVL, WTGTNV, TIMADD, TIMDIF, TIMCHK
C
C     + + + END SPECIFICATIONS + + +
C
C     always calculate ending intervals on first time through
      WDADD = 1
      GTADD = 1
      NEWGRP= 1
      IONE  = 1
      I4ONE = 1
      DPOS  = 1
      BADJFG= 1
      ADDAFG= 0
      I4NVAL= NVAL
      FRAC  = 0.0
      CFRAC = 0.0
      EGPOS = 0
      CALL WDATCP (GETDAT,TMPDAT)
C
 10   CONTINUE
        IF (NEWGRP.GE.1) THEN
C         find out the end of the group
          CALL WTEGRP (GPSDAT,TGROUP,
     O                 GPEDAT)
          IF (GPIND.EQ.GPOSEN) THEN
C           this is the last group, dont fill too far
            CALL WDATCP (ENDDAT,GPEDAT)
          END IF
C         skip values in group as required
          CALL WTSKVL (WDMSFL,GPIND,GPSDAT,TMPDAT,
     I                 TDSFRC,TSFILL,TGROUP,BADJFG,ADDAFG,VBTIME,
     O                 CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O                 CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O                 RETCOD)
          IF (RETCOD.EQ.-11) THEN
C           data has not started yet, this is ok
            RETCOD= 0
          END IF
C         how many intervals in group
          CALL TIMDIF (TMPDAT,GPEDAT,GTTUN,GTTST,
     O                 TMPOS)
          EGPOS = EGPOS+ TMPOS
          IF (GETQK.NE.0.AND.EGPOS.EQ.TMPOS) THEN
C           first quick get, be sure to use correct boundary
            CALL TIMDIF (CURDAT,GETDAT,GTTUN,GTTST,
     O                   GETQK)
            GETQK= GETQK+ 1
          END IF
          NEWGRP= 0
        END IF
        IF (RETCOD.EQ.0) THEN
          IF (WDADD.EQ.1) THEN
C           calculate new ending date on WDMS date
C           get the next WDS value
            CALL WTGTNV (WDMSFL,
     M                   CURCNT,CURNOV,CURCMP,CURREC,CURBKS,CURTST,
     1                   CURTUN,CURQUA,CURPOS,CURDAT,
     O                   CURVAL,CURNXT)
            TMPTUN= GTTUN
            IF (CURTUN.LT.TMPTUN) TMPTUN= CURTUN
          END IF
          IF (GETQK.EQ.0) THEN
C           not a quick get, do it all
            IF (GTADD.EQ.1) THEN
C             calculate new ending date for RVAL
              CALL TIMADD (GETDAT,GTTUN,GTTST,I4ONE,
     O                     GETNXT)
C             how many short units in get and WDMS block
              CALL TIMDIF (GETDAT,GETNXT,TMPTUN,IONE,
     O                     GETSPN)
              IF (GTTRN .LE. 1) THEN
C               some sort of data available, so initialize to zero
                RVAL(DPOS) = 0.0
              END IF
            END IF
C
C           figure out which interval should be incremented
            CHK= TIMCHK(GETNXT,CURNXT)
            IF (CHK.EQ.1) THEN
C             add interval to get counter
              GTADD= 1
              WDADD= 0
            ELSE IF (CHK.EQ.0) THEN
C             add intervals to both counters
              GTADD= 1
              WDADD= 1
            ELSE
C             add interval to WDMS fill counter
              GTADD= 0
              WDADD= 1
            END IF
C
            IF (QUALFG.GE.CURQUA) THEN
C             only process data of acceptable quality
              IF (GTTRN.LE.1) THEN
C               store end of this interval
                IF (CHK.EQ.1) THEN
C                 interval ends due to get
                  CALL WDATCP (GETNXT,TMPNXT)
                ELSE
C                 interval ends due to wdm or both
                  CALL WDATCP (CURNXT,TMPNXT)
                END IF
C               calc short units to end of interval
                CHKS= TIMCHK(GETDAT,CURDAT)
                IF (CHKS.EQ.1) THEN
                  CALL TIMDIF (CURDAT,TMPNXT,TMPTUN,IONE,
     O                         TMPSPN)
                ELSE
                  CALL TIMDIF (GETDAT,TMPNXT,TMPTUN,IONE,
     O                         TMPSPN)
                END IF
C
                IF (GTTRN.EQ.0) THEN
C                 transform is ave,same
                  FRAC= FLOAT(TMPSPN)/FLOAT(GETSPN)
                  RVAL(DPOS)= RVAL(DPOS)+ FRAC* CURVAL
                  CFRAC= CFRAC+ FRAC
C
                ELSE IF (GTTRN.EQ.1) THEN
C                 transform is sum,div
C                 how many short units spanned in WDMS interval
                  CALL TIMDIF (CURDAT,CURNXT,TMPTUN,IONE,
     O                         CURSPN)
                  FRAC= FLOAT(TMPSPN)/ FLOAT(CURSPN)
                  RVAL(DPOS)= RVAL(DPOS)+ FRAC* CURVAL
                  CFRAC= CFRAC+ (FLOAT(TMPSPN)/FLOAT(GETSPN))
                END IF
                IF (FRAC.GT.1.0) THEN
                  WRITE (*,*) 'BAD FRAC,TMPSPN:',FRAC,TMPSPN
                  WRITE (*,*) '  DSN,CTST,CTUN:',DSN,CURTST,CURTUN
                  WRITE (*,*) '  GETSPN,CURSPN:',GETSPN,CURSPN
                  WRITE (*,*) '  CURDAT:       ',CURDAT
                  WRITE (*,*) '  CURNXT:       ',CURNXT
                  WRITE (*,*) '  GETDAT:       ',GETDAT
                  WRITE (*,*) '  GETNXT:       ',GETNXT
                  WRITE (*,*) '  TMPNXT:       ',TMPNXT
                END IF
              ELSE IF (GTTRN.EQ.2) THEN
C               transform is max
                IF (RVAL(DPOS).LT.CURVAL) THEN
                  RVAL(DPOS)= CURVAL
                  CFRAC     = 1.0
                END IF
              ELSE IF (GTTRN.EQ.3) THEN
C               transform is min
                IF (RVAL(DPOS).GT.CURVAL) THEN
                  RVAL(DPOS)= CURVAL
                  CFRAC     = 1.0
                END IF
              END IF
            END IF
C
            IF (GTADD.EQ.1) THEN
C             get ready to increment get counter
              CALL WDATCP (GETNXT,GETDAT)
C             adjust value if some data didnt meet quality
              IF (CFRAC.LT.1.0.AND.CFRAC.GT.0.0) THEN
                RVAL(DPOS)= RVAL(DPOS)/ CFRAC
              ELSE IF (CFRAC.LE.0.0) THEN
                RVAL(DPOS)= TSFILL
              END IF
              CFRAC= 0.0
              DPOS = DPOS+ 1
            END IF
C
            IF (WDADD.EQ.1) THEN
C             get ready to increment WDMS counter
              CALL WDATCP (CURNXT,CURDAT)
              CURCNT= CURCNT+ 1
              IF (TIMCHK(CURDAT,GPEDAT).LE.0) THEN
C               at the group boundary, update start of group date
                CALL WDATCP (GPEDAT,GPSDAT)
                CALL WDATCP (GPEDAT,TMPDAT)
                NEWGRP= 1
                GPIND = GPIND+ 1
              END IF
            END IF
          ELSE
C           a quick get
            FRAC= FRAC+ GETQRA
            IF (ABS(GETQRA-1.0).LT.1.0E-5) THEN
C             no transform required
              IF (QUALFG.GE.CURQUA) THEN
C               only use data of acceptable quality
                RVAL(DPOS)= CURVAL
              END IF
              DPOS= DPOS+ 1
              FRAC= 0.0
            ELSE IF (GETQRA.LT.1.0) THEN
C             dsn interval less than user requested
              IF (QUALFG.GE.CURQUA) THEN
C               only use data of acceptable quality
                IF (GTTRN.LE.1 .AND. CFRAC.LT.1.0E-20) THEN
C                 data available & 1st time,   so initialize to zero
                  RVAL(DPOS) = 0.0
                END IF
                CFRAC= CFRAC+ GETQRA
                IF (GTTRN.EQ.0) THEN
C                 transform is aver
                  RVAL(DPOS)= RVAL(DPOS)+ GETQRA* CURVAL
                ELSE IF (GTTRN.EQ.1) THEN
C                 transform is sum
                  RVAL(DPOS)= RVAL(DPOS)+ CURVAL
                ELSE IF (GTTRN.EQ.2) THEN
C                 transform is max
                  IF (CURVAL.GT.RVAL(DPOS)) RVAL(DPOS)= CURVAL
                ELSE IF (GTTRN.EQ.3) THEN
C                 transform is min
                  IF (CURVAL.LT.RVAL(DPOS)) RVAL(DPOS)= CURVAL
                END IF
              END IF
              IF (ABS(FRAC-1.0).LT.1.0E-5) THEN
C               completed this user interval
                IF (ABS(CFRAC-1.0).GT.1.0E-5) THEN
C                 some missing data
                  IF (GTTRN.LE.1.AND.CFRAC.GT.0.0) THEN
C                   adjust result
                    RVAL(DPOS)= RVAL(DPOS)/CFRAC
                  END IF
                END IF
                DPOS = DPOS+ 1
                FRAC = 0.0
                CFRAC= 0.0
              END IF
            ELSE
C             dsn interval greater than user requested
              ICNT= GETQRA
C             may not start of wdm data boundary
              I   = GETQK
              RTMP= CURVAL
              IF (GTTRN.EQ.1) THEN
C               transform is sum/div
                RTMP= RTMP/GETQRA
              END IF
 20           CONTINUE
                IF (QUALFG.GE.CURQUA) THEN
C                 only use data of acceptable quality
                  RVAL(DPOS)= RTMP
                END IF
                DPOS= DPOS+ 1
                I   = I+ 1
              IF (I.LE.ICNT.AND.DPOS.LE.I4NVAL) GO TO 20
C             assume start on data boundary next time
              GETQK= 1
            END IF
C           always get the next dsn data value
            CALL WDATCP (CURNXT,CURDAT)
            CURCNT= CURCNT+ 1
          END IF
        ELSE IF (RETCOD.EQ.-10) THEN
C         missing entire group
          DPOS  = EGPOS+ 1
C         reset where we are in process of getting data
          CALL WDATCP (GPEDAT,GETDAT)
          GTADD = 1
          RETCOD= 0
        END IF
C
        IF (DPOS.GT.EGPOS .AND. NEWGRP.EQ.0) THEN
C         at the group boundary, update start of group date
          CALL WDATCP (GPEDAT,GPSDAT)
          CALL WDATCP (GPEDAT,TMPDAT)
          NEWGRP= 1
          GPIND = GPIND+ 1
        END IF
C
      IF (DPOS.LE.I4NVAL.AND.RETCOD.EQ.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTGTNV
     I                    (WDMSFL,
     M                     CURCNT,CURNOV,CURCMP,CURREC,CURBKS,CURTST,
     M                     CURTUN,CURQUA,CURPOS,CURDAT,
     O                     CURVAL,CURNXT)
C
C     + + + PURPOSE + + +
C     routine to get the next value from a WDS timeseries DSN
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,CURCMP,CURREC,CURBKS,CURTST,CURTUN,CURQUA,
     1          CURPOS,CURDAT(6),CURNXT(6)
      INTEGER(4)CURCNT,CURNOV
      REAL      CURVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     CURCNT - current position within block
C     CURNOV - current number of values in current block
C     CURCMP - current compression code
C     CURREC - current record number
C     CURBKS - starting position of current block within current record
C     CURTST - current time step
C     CURTUN - current time units
C     CURQUA - current quality code
C     CURPOS - current position in current block
C     CURDAT - current date of start of current value
C     CURVAL - current value
C     CURNXT - internal end date array
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND
      INTEGER(4)NUMSKP,BCW,I4ONE
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSKBK, WDRCGO, WBCWSP, TIMADD
C
C     + + + END SPECIFICATIONS + + +
C
      I4ONE= 1
C
      IF (CURCNT.GT.CURNOV) THEN
C       time for a new block
        NUMSKP= 2
        IF (CURCMP.EQ.0) NUMSKP= CURNOV+ 1
C       skip to next BCW
        CALL WDSKBK (WDMSFL,NUMSKP,
     M               CURREC,CURBKS)
C       be sure record is in buffer
        RIND= WDRCGO (WDMSFL,CURREC)
C       get the BCW
        BCW= WIBUFF(CURBKS,RIND)
        CURVAL= WRBUFF(CURBKS+1,RIND)
C       split the BCW
        IF (ABS(CURVAL).GT.1.0E-3) THEN
C         zero maybe compressed (JLK 3/12/86 NOT ALL CASES,TEMP OLD WAY)
          CALL WBCWSP (BCW,
     O                 CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
        ELSE
C         non zero, dont adjust CURTST and CURNOV
          CALL WBCWSP (BCW,
     O                 CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
        END IF
C
        CURCNT= 1
      ELSE
C       be sure record is in buffer
        RIND= WDRCGO(WDMSFL,CURREC)
      END IF
C     get the current value
      CURPOS= CURBKS+ 1
      IF (CURCMP.EQ.0.AND.CURCNT.GT.0) CURPOS= CURBKS+ CURCNT
      CURVAL= WRBUFF(CURPOS,RIND)
C     calculate new ending date on WDMS interval
      CALL TIMADD (CURDAT,CURTUN,CURTST,I4ONE,
     O             CURNXT)
      RETURN
      END
C
C
C
      SUBROUTINE   WDTPFX
     I                    (WDMSFL,DSN,DELT,DATES,NVAL,
     I                     DTOVWR,QUALFG,TUNITS,RVAL,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     puts timeseries information into the WDMSFL.  This routine
C     was originally called WDTPUT.  There is a known problem with the
C     DTOVWR = 1 option.  The new WDTPUT traps that condition and has
C     a work-around for it.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DELT,DATES(6),NVAL,DTOVWR,QUALFG,
     1          TUNITS,RETCOD
      REAL      RVAL(NVAL)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DELT   - time step for put
C     DATES  - starting date
C     NVAL   - number of values
C     DTOVWR - data overwrite flag,
C              0 - dont overwrite
C              1 - overwrite O.K.
C     QUALFG - allowed quality code
C     TUNITS - time units for put
C     RVAL   - array for writing out values
C     RETCOD - return code
C                0 - everything is O.K.
C               -8 - invalid date
C               -9 - data not present in current group
C              -10 - no data in this group
C              -11 - no non missing data, data has not started yet
C              -14 - date specified not within valid range for data set
C              -15 - VBTIME=1 and DELT,TUNITS do not agree
C                    with the data set
C              -20 - problem with one or more of following:
C                    DTOVWR, NVAL, QUALFG, TUNITS, DELT
C              -21 - date from WDM doesn't match expected date
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CWTSDS.INC'
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GPFLG,GPOSEN,GPIND,LTSTEP,LTUNIT,ALTERD,
     1          ENDDAT(6),GPSDAT(6),GPEDAT(6),DATNOW(6),TDAT(6),
     2          TDSFRC,TGROUP,TSPTAD,REMTUN,REMTST,RIND,
     3          COMPFG,TSFORM,VBTIME,TSSTEP,TCODE,TSTEPF,TCDCMP
      INTEGER(4)TVAL,DPOS,I4NVAL,I4ONE
      REAL      TOLR,TSFILL,REMVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WTPMCK, WTFNDG, WDATCP, WTEGRP, WTGPCK, TIMADD, TIMDIF
      EXTERNAL   WTPTVL, WDRCGO, WTDSPX, CMPTIM
C
C     + + + END SPECIFICATIONS + + +
C
      I4NVAL= NVAL
      I4ONE = 1
      LTSTEP= DELT
      LTUNIT= TUNITS
      GPFLG = 2
      REMTUN= 0
      ALTERD= 0
C
C     check the user supplied parameters
      CALL WTPMCK (GPFLG,DTOVWR,DATES,NVAL,QUALFG,
     M             LTSTEP,LTUNIT,
     O             RETCOD)
      IF (RETCOD.EQ.0) THEN
C       check the data set and figure out which groups have been req.
        CALL WTFNDG (WDMSFL,DSN,GPFLG,DATES,LTSTEP,LTUNIT,I4NVAL,
     O               TDSFRC,TSFILL,TGROUP,TOLR,TSPTAD,
     1               GPIND,GPOSEN,GPSDAT,ENDDAT,RETCOD)
      END IF
      IF (RETCOD.EQ.0) THEN
C       get additional parameters
        RIND= WDRCGO(WDMSFL,TDSFRC)
        CALL WTDSPX (WIBUFF(1,RIND),
     O               COMPFG,TSFORM,VBTIME,TSSTEP,TCODE)
        IF (VBTIME.EQ.1) THEN
C         the time units and step must be exactly right
          CALL CMPTIM ( LTUNIT, LTSTEP, TCODE, TSSTEP, TSTEPF, TCDCMP )
          IF (TCDCMP .NE. 0) THEN
C           not a match, quick get wont work
            RETCOD= -15
          END IF
        END IF
      END IF
      IF (RETCOD.EQ.0) THEN
        CALL WDATCP (DATES,DATNOW)
        DPOS= 1
 10     CONTINUE
C         find end of group
          CALL WTEGRP (GPSDAT,TGROUP,
     O                 GPEDAT)
C
C         skip values in this group as required
          CALL WTGPCK (WDMSFL,GPIND,GPSDAT,DATNOW,LTUNIT,
     I                 TDSFRC,TSFILL,TGROUP,VBTIME,
     O                 CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O                 CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O                 RETCOD)
          IF (RETCOD.EQ.0) THEN
C           update current date if part value starts this group
            IF (REMTUN.GT.0) THEN
              CALL TIMADD (DATNOW,REMTUN,REMTST,I4ONE,
     M                     TDAT)
C              WRITE (*,*) 'WDTPUT:     DATNW1:',DATNOW
C              WRITE (*,*) '            DATNW2:',TDAT
C              WRITE (*,*) '       RTUN,RTST,1:',REMTUN,REMTST,I4ONE
              CALL WDATCP (TDAT,DATNOW)
            END IF
C           find how many values we need to write
            CALL TIMDIF (DATNOW,GPEDAT,LTUNIT,LTSTEP,
     O                   TVAL)
C           put the data for this group
            CALL WTPTVL (WDMSFL,NVAL,LTUNIT,LTSTEP,
     1                   TDSFRC,TSFILL,TOLR,QUALFG,RVAL,TVAL,TSPTAD,
     2                   GPEDAT,COMPFG,
     M                   CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     1                   CURTST,CURTUN,CURCMP,CURQUA,CURDAT,
     2                   DPOS,REMTUN,REMTST,REMVAL)
            GPIND= GPIND+ 1
            ALTERD= 1
C
C           update the current date
            CALL WDATCP (GPEDAT,DATNOW)
C           update date to start group
            CALL WDATCP (DATNOW,GPSDAT)
          END IF
        IF (RETCOD.EQ.0.AND.GPIND.LE.GPOSEN.AND.DPOS.LE.I4NVAL) GO TO 10
      END IF
C
      IF (ALTERD .EQ. 1) THEN
C       set dataset modification date attribute
        CALL WDMODT (WDMSFL,DSN)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTGPCK
     I                    (WDMSFL,GPIND,GPSDAT,DATNOW,LTUNIT,
     I                     TDSFRC,TSFILL,TGROUP,VBTIME,
     O                     CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O                     CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     checks information related to a group, skip to starting
C     value, fill in current information
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,GPIND,GPSDAT(6),DATNOW(6),LTUNIT,
     1          CURREC,CURBKS,CURPOS,CURTST,CURTUN,CURCMP,CURQUA,
     2          CURDAT(6),RETCOD,TDSFRC,TGROUP,VBTIME
      INTEGER(4)CURNOV,CURCNT
      REAL      TSFILL,CURVAL,PREVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     GPIND  - group index number
C     GPSDAT - starting date of group
C     DATNOW - current date
C     LTUNIT - time units
C     TDSFRC - first record in data set
C     TSFILL - missing data filler code
C     TGROUP - data group pointer units
C     VBTIME - variable timestep flag
C     CURREC - current record number
C     CURBKS - starting position of current block within current record
C     CURPOS - current position in current block
C     CURNOV - current number of values in current block
C     CURVAL - current value
C     PREVAL - previous value
C     CURTST - current time step
C     CURTUN - current time units
C     CURCMP - current compression code
C     CURQUA - current quality code
C     CURCNT - current position within block
C     CURDAT - current date of start of current value
C     RETCOD - return code
C                  0 - everything O.K.
C                 -9 - data not present in current group
C                -10 - no data in this group
C                -11 - no non missing data, data has not started yet
C                -21 - date from WDM doesn't match expected date
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,DIND,SIND,JX,JY,JZ,TREC,TPOS,SREC,SPOS,SQUA,
     1          PDAT,BADJFG,ADDAFG,OREC,DREC
      INTEGER(4)TDFREE,SNOV,I4TMP
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO,WDRCDL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WTSKVL, WDSKBK, WDRCGO, WBCWSP, WDPTSP, WDRCDL
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
      DREC  = 0
      BADJFG= 0
      ADDAFG= LTUNIT
C
C     skip to place to start write
      CALL WTSKVL (WDMSFL,GPIND,GPSDAT,DATNOW,
     I             TDSFRC,TSFILL,TGROUP,BADJFG,ADDAFG,VBTIME,
     O             CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     O             CURTST,CURTUN,CURCMP,CURQUA,CURCNT,CURDAT,
     O             RETCOD)
C
      IF (RETCOD.EQ.0) THEN
C       update CURNOV for overwriting
        CURNOV= CURCNT- 1
C
C       check for defined values in rest of group and record
C       because overwriting not allowed
        IF (CURQUA.NE.31) THEN
C         data present in current group
          RETCOD= -9
        ELSE
C         may be additional groups on this record unless free
C         skip other undef values if available
          SREC= CURREC
          SPOS= CURBKS
 10       CONTINUE
            OREC= SREC
            I4TMP= 2
            CALL WDSKBK (WDMSFL,I4TMP,
     M                   SREC,SPOS)
            IF (OREC.NE.SREC) THEN
C             we have moved on to a new rec which only contains fillers
              DREC= SREC
            END IF
            IF (SREC.GT.0) THEN
              SIND= WDRCGO(WDMSFL,SREC)
              I4TMP= WIBUFF(SPOS,SIND)
              IF (I4TMP.GT.0) THEN
                CALL WBCWSP (I4TMP,
     O                       SNOV,JX,JY,JZ,SQUA)
              ELSE
                SQUA= 0
              END IF
            ELSE
C             we are at the end of the record chain for this DSN
              SQUA= -1
            END IF
          IF (SQUA.EQ.31) GO TO 10
C
          IF (SQUA.GE.0) THEN
C           check to see if free space points to where we skipped to
            DIND  = WDRCGO(WDMSFL,TDSFRC)
            PDAT  = WIBUFF(11,DIND)
            TDFREE= WIBUFF(PDAT+1,DIND)
            CALL WDPTSP (TDFREE,
     O                   TREC,TPOS)
            IF (TREC.NE.SREC.OR.TPOS.NE.SPOS) THEN
C             data not present in current group
              RETCOD= -9
            END IF
          END IF
        END IF
C
        IF (RETCOD.EQ.0.AND.DREC.NE.0) THEN
C         delete the record containing only fillers
          I= WDRCDL(WDMSFL,DREC)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTPTVL
     I                    (WDMSFL,NVAL,LTUNIT,LTSTEP,
     I                     TDSFRC,TSFILL,TOLR,QUALFG,RVAL,TVAL,TSPTAD,
     I                     GPEDAT,COMPFG,
     M                     CURREC,CURBKS,CURPOS,CURNOV,CURVAL,PREVAL,
     M                     CURTST,CURTUN,CURCMP,CURQUA,CURDAT,
     M                     DPOS,REMTUN,REMTST,REMVAL)
C
C     + + + PURPOSE + + +
C     writes all or part of a WDMS group into a WDMS timeseries data set
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,NVAL,LTUNIT,LTSTEP,QUALFG,
     1          TDSFRC,TSPTAD,GPEDAT(6),COMPFG,REMTUN,REMTST,
     2          CURREC,CURBKS,CURPOS,CURTST,CURTUN,CURCMP,CURQUA,
     3          CURDAT(6)
      INTEGER(4)TVAL,DPOS,CURNOV
      REAL      TSFILL,TOLR,RVAL(NVAL),REMVAL,CURVAL,PREVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     NVAL   - number of values
C     LTUNIT - time units
C     LTSTEP - time step
C     TDSFRC - first record in data set
C     TSFILL - missing data filler code
C     TOLR   - compression tolerance
C     QUALFG - get quality code
C     RVAL   - array of data values to put on WDMS file
C     TVAL   - number of values to write in this group
C     TSPTAD - disaggregation code
C              0 - same
C              1 - div
C     GPEDAT - group ending date
C     COMPFG - compression flag
C              1 - alow compression
C              2 - no compression
C     CURREC - current record number
C     CURBKS - starting position of current block within current record
C     CURPOS - current position in current block
C     CURNOV - current number of values in current block
C     CURVAL - current value
C     PREVAL - previous value
C     CURTST - current time step
C     CURTUN - current time units
C     CURCMP - current compression code
C     CURQUA - current quality code
C     CURDAT - current date of start of current value
C     DPOS   - current position within RVAL
C     REMTUN - remaining time unit across group border
C     REMTST - remaining time step across group border
C     REMVAL - remaining data value across group border
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,CHK,I,DIND,PDAT,TDAT(6),EGPFLG,LCMPFG
      INTEGER(4)BCW,TDFREE,I4ZRO,I4ONE,CVAL,I4NVAL,FVAL,XVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   TIMCHK,WDRCGO
      INTEGER(4)WBCWCL,WDPTCL
C
C     + + + INTRINSICS + + +
      INTRINSIC ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO, WBCWCL, WTNWBK, TIMADD, WDATCP, TIMCHK, TIMDIF
      EXTERNAL  WDRCUP, WDPTCL
C
C     + + + END SPECIFICATIONS + + +
C
      I4ZRO = 0
      I4ONE = 1
      I4NVAL= NVAL
      CVAL  = 0
      IF (QUALFG .LT. 31) THEN
        LCMPFG= COMPFG
      ELSE
C       always allow compression of missing data
        LCMPFG= 1
      END IF
C
      RIND  = WDRCGO(WDMSFL,CURREC)
C
C     WRITE (*,*) 'WTPTVL:     GPEDAT:',GPEDAT
C     WRITE (*,*) '            CURDAT:',CURDAT
C     WRITE (*,*) '              TVAL:',TVAL
      IF (REMTUN.GT.0) THEN
C       WRITE (*,*) 'STRT:REMTUN,REMTST:',REMTUN,REMTST
C       the current value is partly in the last group
        CURVAL= REMVAL
        CURTST= REMTST
        CURTUN= REMTUN
        REMTUN= 0
        BCW   = WBCWCL (I4ONE,CURTST,CURTUN,I4ZRO,QUALFG)
        WIBUFF(CURBKS,RIND)= BCW
        WRBUFF(CURPOS,RIND)= CURVAL
        CURPOS= CURPOS+ 1
        CALL WTNWBK (WDMSFL,
     M               CURREC,CURPOS,
     O               CURBKS)
        RIND = WDRCGO (WDMSFL,CURREC)
C
        CALL TIMADD (CURDAT,CURTUN,CURTST,I4ONE,
     O               TDAT)
        CALL WDATCP (TDAT,CURDAT)
C       update pointer to current value
        DPOS= DPOS+ 1
      END IF
C
      CURVAL= RVAL(DPOS)
C     figure out if we can continue the last block
      IF (LTSTEP.NE.CURTST.OR.LTUNIT.NE.CURTUN.OR.QUALFG.NE.CURQUA) THEN
C       we cant continue
        CHK= 0
      ELSE
C       ok to continue
        CHK= 1
      END IF
C
C     write (99,*) 'write:  ',CURDAT(1),CURDAT(2),CURDAT(3),CURCMP
C     write (99,*) '        ',CHK,CURNOV,LCMPFG,COMPFG
C     write (99,*) '        ',CURVAL,PREVAL,TOLR
      IF (TVAL.GT.0) THEN
 10     CONTINUE
          CVAL= CVAL+ 1
C
          IF (ABS(CURVAL-PREVAL).LE.TOLR.AND.CHK.EQ.1.AND.
     1        CURNOV.LT.32000.AND.LCMPFG.EQ.1) THEN
C           we want to be compressed
            IF (CURCMP.EQ.1) THEN
C             we already are
              CURNOV= CURNOV+ 1
            ELSE
C             currently uncompressed, finish old block
C             delete last value from old block
              CURNOV= CURNOV- 1
              CURPOS= CURPOS- 1
              IF (CURNOV.GT.I4ZRO) THEN
                BCW= WBCWCL(CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
                WIBUFF(CURBKS,RIND)= BCW
                CALL WTNWBK (WDMSFL,
     M                       CURREC,CURPOS,
     O                       CURBKS)
                RIND = WDRCGO( WDMSFL, CURREC )
C               write (99,*) 'now cmp:',TVAL,CURREC,CURPOS,CURNOV,CURQUA
              END IF
              WRBUFF(CURPOS,RIND)= PREVAL
              CURNOV= 2
              CURCMP= 1
            END IF
          ELSE
C           we want to be uncompressed
            IF (CHK.NE.1.OR.CURCMP.EQ.1) THEN
              IF (CURNOV.GT.I4ZRO) THEN
C               finish the old block
                BCW= WBCWCL(CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
                WIBUFF(CURBKS,RIND)= BCW
                IF (CURCMP.EQ.1.OR.CHK.EQ.0) CURPOS= CURPOS+ 1
                CALL WTNWBK (WDMSFL,
     M                       CURREC,CURPOS,
     O                       CURBKS)
                RIND  = WDRCGO(WDMSFL,CURREC)
C               write (99,*) 'now unc:',TVAL,CURREC,CURPOS,CURNOV,CURQUA
                CURNOV= 0
              END IF
              IF (CHK.EQ.0) THEN
                CURQUA= QUALFG
                CURTUN= LTUNIT
                CURTST= LTSTEP
              ELSE IF (CHK.EQ.-1) THEN
                CURQUA= 31
              END IF
            END IF
            CURCMP= 0
            WRBUFF(CURPOS,RIND)= CURVAL
            CURPOS= CURPOS+ 1
            CURNOV= CURNOV+ 1
            IF (CURPOS.GT.512.AND.CVAL.LT.TVAL) THEN
C             out of space in this record, finish block
              BCW= WBCWCL (CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
              WIBUFF(CURBKS,RIND)= BCW
              CALL WTNWBK (WDMSFL,
     M                     CURREC,CURPOS,
     O                     CURBKS)
              RIND= WDRCGO(WDMSFL,CURREC)
C             write (99,*) 'end rec:',TVAL,CURREC,CURPOS,CURNOV,CURQUA
              CURNOV= 0
            END IF
          END IF
          CHK= 1
C         dont allow compression across record boundary
          IF (CURNOV.EQ.I4ZRO) THEN
C           jlk 11/89, insure quality code on trailing data
            CHK= 0
            CURQUA= QUALFG
          END IF
C
          IF (CURCMP.EQ.0) THEN
C           update value to compare next value for compressed values
            PREVAL= CURVAL
          END IF
          DPOS= DPOS+ 1
          IF (DPOS.LE.I4NVAL) THEN
            CURVAL= RVAL(DPOS)
          ELSE
            CURVAL= TSFILL
            IF (CURQUA.NE.31) THEN
C             allow compression of trailing values
              LCMPFG= 1
              CHK= -1
            END IF
          END IF
C
        IF (CVAL.LT.TVAL) GO TO 10
C
C       finish the last block
        BCW= WBCWCL(CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
        WIBUFF(CURBKS,RIND)= BCW
C       write (99,*) 'lst blk:',TVAL,CURREC,CURPOS,CURNOV,CURQUA
C       update the current position
        IF (CURCMP.EQ.1) CURPOS= CURPOS+ 1
C
      END IF
C
C     calculate the current date
      CALL TIMADD (CURDAT,LTUNIT,LTSTEP,TVAL,
     O             TDAT)
      CALL WDATCP (TDAT,CURDAT)
C     are we at the end of the group?
      IF (TIMCHK(CURDAT,GPEDAT).NE.0) THEN
C       no, better fill in, how much?
        CURTUN= LTUNIT
        CURTST= 1
 20     CONTINUE
          CALL TIMDIF (CURDAT,GPEDAT,CURTUN,CURTST,
     O                 FVAL)
          CALL TIMADD (CURDAT,CURTUN,CURTST,FVAL,
     O                 TDAT)
C         WRITE (*,*) 'EGRP:       CURDAT:',CURDAT
          EGPFLG= 0
          IF (TIMCHK(TDAT,GPEDAT).NE.0) THEN
C           still not at even end of group
            CURTUN= CURTUN- 1
            IF (CURTUN.LE.0) THEN
              STOP 'BIG PROBLEM, END OF GROUP CURTUN=0'
            END IF
            EGPFLG= 1
          END IF
        IF (EGPFLG.EQ.1) GO TO 20
C
        IF (FVAL.GT.1) THEN
          CURTST= FVAL
          IF (CURTST.GT.63) THEN
            WRITE(99,*) 'BIG PROBLEM FILLING UP GROUP,STEP:',CURTST
            WRITE (*,*) 'BIG PROBLEM FILLING UP GROUP,STEP:',CURTST
          END IF
        END IF
C       figure out how much goes into next group
        CALL TIMADD (CURDAT,LTUNIT,LTSTEP,I4ONE,
     O               TDAT)
        I= 1
        CALL TIMDIF (GPEDAT,TDAT,CURTUN,I,
     O               XVAL)
        REMTST= XVAL
        IF (REMTST.GT.63) THEN
          WRITE(99,*) 'BIG PROBLEM STARTING GROUP,STEP:',REMTST
          WRITE (*,*) 'BIG PROBLEM STARTING GROUP,STEP:',REMTST
        END IF
        REMTUN= CURTUN
C
        CURNOV= 1
        CURCMP= 0
C
C       figure out what the fill value and quality is
        IF (DPOS.LE.I4NVAL) THEN
          IF (TSPTAD.EQ.0) THEN
C           disagg code is same
            CURVAL= RVAL(DPOS)
            REMVAL= CURVAL
          ELSE
C           disagg code is div
            CALL TIMADD (CURDAT,LTUNIT,LTSTEP,I4ONE,
     O                   TDAT)
            CALL TIMDIF (CURDAT,TDAT,CURTUN,CURTST,
     O                   CVAL)
            CURVAL= (RVAL(DPOS)* FVAL)/ CVAL
            REMVAL= RVAL(DPOS)- CURVAL
          END IF
        ELSE
          CURVAL= TSFILL
          REMVAL= TSFILL
          CURQUA= 31
        END IF
C
C       get the next block
        CALL WTNWBK (WDMSFL,
     M               CURREC,CURPOS,
     O               CURBKS)
        RIND= WDRCGO(WDMSFL,CURREC)
C
        BCW= WBCWCL(CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
        WIBUFF(CURBKS,RIND)= BCW
        WRBUFF(CURPOS,RIND)= CURVAL
        CURPOS= CURPOS+ 1
      END IF
C
C     update the current record
      CALL WDRCUP(WDMSFL,RIND)
C     update the data-set free space pointer
      IF (CURPOS.GT.511) CURPOS = 511
      TDFREE= WDPTCL (CURREC,CURPOS)
      DIND  = WDRCGO(WDMSFL,TDSFRC)
      PDAT  = WIBUFF(11,DIND)
      WIBUFF(PDAT+1,DIND)= TDFREE
      CALL WDRCUP(WDMSFL,DIND)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTNWBK
     I                    (WDMSFL,
     M                     CURREC,CURPOS,
     O                     CURBKS)
C
C     + + + PURPOSE + + +
C     starts a new WDMS timeseries block, on a new record if req.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,CURREC,CURPOS,CURBKS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     CURREC - current record number
C     CURPOS - current position in current block
C     CURBKS - starting position of current block within current record
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   CIND,I
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO,WDRCGX
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDRCUP, WDRCGX
C
C     + + + END SPECIFICATIONS + + +
C
      IF (CURPOS.GT.511) THEN
C       update the old record
        CIND= WDRCGO(WDMSFL,CURREC)
        CALL WDRCUP (WDMSFL,CIND)
C       new block nust start on new record
        I= 0
C       write(1,*) 'WTNWBK,782: wdmsfl,i,currec=',wdmsfl,i,currec
        CIND  = WDRCGX(WDMSFL,I,CURREC)
        CURREC= RECNO(CIND)
        CURPOS= 5
      END IF
C
      CURBKS= CURPOS
      CURPOS= CURPOS+ 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDTPUT
     I                    (WDMSFL,DSN,DELT,DATES,NVAL,
     I                     DTOVWR,QUALFG,TUNITS,RVAL,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     Puts time series data into a WDM file.  This routine traps the
C     problem with overwritting existing data.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DELT,DATES(6),NVAL,DTOVWR,QUALFG,
     1          TUNITS,RETCOD
      REAL      RVAL(NVAL)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DELT   - time step for put
C     DATES  - starting date
C     NVAL   - number of values
C     DTOVWR - data overwrite flag,
C              0 - dont overwrite
C              1 - overwrite O.K.
C     QUALFG - allowed quality code
C     TUNITS - time units for put
C     RVAL   - array for writing out values
C     RETCOD - return code
C                0 - everything is O.K.
C               -8 - invalid date
C               -9 - data not present in current group
C              -10 - no data in this group
C              -11 - no non missing data, data has not started yet
C              -14 - date specified not within valid range for data set
C              -15 - VBTIME=1 and DELT,TUNITS do not agree
C                    with the data set
C              -20 - problem with one or more of following:
C                    DTOVWR, NVAL, QUALFG, TUNITS, DELT
C              -21 - date from WDM doesn't match expected date
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   ALLFLG, DXX, LWDMFL, LDSN
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDTPFX, WTDDEL, TSBCLR, WID2UD
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   ALLFLG, DXX
     #     /      0,   0 /
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
C     try to put time series data into WDM file
      CALL WDTPFX ( LWDMFL, LDSN, DELT, DATES, NVAL,
     I              DXX, QUALFG, TUNITS, RVAL,
     O              RETCOD )
      IF (RETCOD .EQ. -9  .AND.  DTOVWR .EQ. 1) THEN
C       data existed, delete it
        CALL WTDDEL ( LWDMFL, LDSN, DATES, ALLFLG,
     O                RETCOD )
        IF (RETCOD .EQ. 0) THEN
C         data successfully deleted, add data
          CALL WDTPFX ( LWDMFL, LDSN, DELT, DATES, NVAL,
     I                  DXX, QUALFG, TUNITS, RVAL,
     O                  RETCOD )
        END IF
      END IF
C     clear modified data from time-series buffer
      CALL TSBCLR (LWDMFL,LDSN)
C
      RETURN
      END

C
C
C
      SUBROUTINE   WTFNDT
     I                    (WDMSFL,DSN,GPFLG,
     O                     TDSFRC,SDAT,EDAT,RETCOD)
C
C     + + + PURPOSE + + +
C     determine starting and ending dates of data in data set
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,GPFLG,TDSFRC,SDAT(6),EDAT(6),RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     GPFLG  - get(1)/put(2) flag
C     TDSFRC - data-set first record number
C     SDAT   - starting date of data in dsn
C     EDAT   - ending date of data in dsn
C     RETCOD - return code
C                0 - everything is O.K.
C               -6 - no data present
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -85 - trying to write to a read-only data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GRPSTR,GRPEND,GRPIND,GRSPOS,GREPOS,
     1          PDAT,PDATV,TGRNUM,TGRPST,RIND,TSTEP,
     2          TGROUP,TBSDAT(6),TDAT(6),XDAT(6),NDAT(6),
     3          CURREC,CURBKS,CURPOS,CURTST,CURTUN,CURCMP,CURQUA,
     4          TSPTAD,I,MSFLG,DSTYP,GRCNT,LWDMFL,LDSN
      INTEGER(4)I4ZRO,I4NVAL,GRSPTR,GREPTR,NUMSKP,CURNOV
      REAL      TSFILL,TOLR
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO, TIMCHK
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPI, WDSCHA, WDRCGO, WTDSPM, TIMADD, WDPTSP, WDSKBK
      EXTERNAL  WBCWSP, WDATCP, WTEGRP, TIMCHK, TIMCNV, WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
      I4ZRO = 0
      TSTEP = 1
      RETCOD= 0
      I     = 6
      CALL ZIPI (I,RETCOD,SDAT)
      CALL ZIPI (I,RETCOD,EDAT)
C
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
C
      DSTYP = 1
      CALL WDSCHA (LWDMFL,LDSN,DSTYP,GPFLG,
     O             TDSFRC,GRCNT,RETCOD)
Caqt  IF (TDSFRC.EQ.0) THEN
      IF (TDSFRC.EQ.0 .AND. RETCOD.EQ.0) THEN
        WRITE(99,*)'WDM:WDTMS2:WTFNDT:',LWDMFL,LDSN,DSTYP,GPFLG,TDSFRC
Ckmf    write(*,*) 'WDM:WDTMS2:WTFNDT:',LWDMFL,LDSN,DSTYP,GPFLG,TDSFRC
        RETCOD= -6
      END IF
C
      IF (RETCOD.EQ.0) THEN
C       bring label into buffer
        RIND = WDRCGO(LWDMFL,TDSFRC)
        CALL WTDSPM (LWDMFL,WIBUFF(1,RIND),WRBUFF(1,RIND),
     O               TSFILL,TGROUP,TOLR,TBSDAT,TSPTAD)
C
C       calculate pointer to first group pointer
        PDAT  = WIBUFF(11,RIND)
        TGRPST= PDAT+ 2
C
C       calculate max number of group pointers
        PDATV = WIBUFF(12,RIND)
        TGRNUM= PDATV- PDAT- 2
C
C       look for first group with data
        GRPSTR= 0
        GRPIND= 0
        GRPEND= 0
        GRSPOS= TGRPST- 1
C
 10     CONTINUE
          GRPIND= GRPIND+ 1
          GRSPOS= GRSPOS+ 1
          IF (WIBUFF(GRSPOS,RIND).NE.I4ZRO) THEN
            GRPSTR= GRPIND
            GRSPTR= WIBUFF(GRSPOS,RIND)
          END IF
        IF (GRPSTR.EQ.0.AND.GRSPOS.LT.PDATV-1) GOTO 10
C
        IF (GRPSTR.GT.0) THEN
C         look for last group with data
          GREPOS= PDATV- 1
          GRPIND= TGRNUM+ 1
C
 20       CONTINUE
            GRPIND= GRPIND- 1
            IF (WIBUFF(GREPOS,RIND).NE.I4ZRO) THEN
              GRPEND= GRPIND
              GREPTR= WIBUFF(GREPOS,RIND)
            ELSE
              GREPOS= GREPOS- 1
            END IF
          IF (GRPEND.EQ.0) GOTO 20
C
C         calc exact starting date for date
          I4NVAL= GRPSTR- 1
C         find start date of beginning of group
          CALL TIMADD (TBSDAT,TGROUP,TSTEP,I4NVAL,
     O                 SDAT)
C         get starting record for data
          CALL WDPTSP (GRSPTR,
     O                 CURREC,CURPOS)
          RIND= WDRCGO (LWDMFL,CURREC)
C
          CURBKS= CURPOS
          NUMSKP= 1
C         loop to look for defined data
 30       CONTINUE
C           skip to next block control word
            CALL WDSKBK (LWDMFL,NUMSKP,
     M                   CURREC,CURBKS)
C           be sure record is in buffer
            RIND= WDRCGO (LWDMFL,CURREC)
C           split up block control word
            CALL WBCWSP (WIBUFF(CURBKS,RIND),
     O                   CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
            IF (CURQUA.EQ.31) THEN
C             skip this block
              CALL TIMADD (SDAT,CURTUN,CURTST,CURNOV,
     O                     TDAT)
              CALL WDATCP (TDAT,SDAT)
            END IF
            NUMSKP= 2
            IF (CURCMP.EQ.0) NUMSKP= CURNOV+ 1
          IF (CURQUA.EQ.31) GO TO 30
C
C         calc exact ending date for data
          MSFLG = 0
C         find start date of beginning of group
          I4NVAL= GRPEND- 1
          IF (GRPEND.NE.GRPSTR) THEN
C           ending record is not starting record
            CALL TIMADD (TBSDAT,TGROUP,TSTEP,I4NVAL,
     O                   XDAT)
C           get starting record for last group with data
            CALL WDPTSP (GREPTR,
     O                   CURREC,CURPOS)
            RIND  = WDRCGO (LWDMFL,CURREC)
            CURBKS= CURPOS
            NUMSKP= 1
          ELSE
C           we are looking in the starting group, from current date
            CALL TIMADD (SDAT,CURTUN,CURTST,CURNOV,
     O                   XDAT)
C           are we at the end of the starting group and data?
            CALL WTEGRP (SDAT,TGROUP,
     O                   NDAT)
            IF (TIMCHK(NDAT,XDAT).EQ.0) THEN
              MSFLG= -1
            END IF
          END IF
          IF (MSFLG.EQ.0) THEN
C           find start of next group
            CALL WTEGRP (XDAT,TGROUP,
     O                   NDAT)
C
C           loop to look for end of defined data
 40         CONTINUE
C             skip to next block control word
              CALL WDSKBK (LWDMFL,NUMSKP,
     M                     CURREC,CURBKS)
C             be sure record is in buffer
              RIND= WDRCGO (LWDMFL,CURREC)
C             split up block control word
              CALL WBCWSP (WIBUFF(CURBKS,RIND),
     O                     CURNOV,CURTST,CURTUN,CURCMP,CURQUA)
              IF (CURQUA.EQ.31.AND.MSFLG.EQ.0) THEN
C               save start of this block
                CALL WDATCP (XDAT,EDAT)
                MSFLG= 1
              ELSE
                MSFLG= 0
              END IF
C             skip this block
              CALL TIMADD (XDAT,CURTUN,CURTST,CURNOV,
     O                     TDAT)
              CALL WDATCP (TDAT,XDAT)
              NUMSKP= 2
              IF (CURCMP.EQ.0) THEN
                NUMSKP= CURNOV+ 1
              END IF
            IF (TIMCHK(XDAT,NDAT).EQ.1.AND.CURNOV.GT.I4ZRO) GO TO 40
          END IF
C
          IF (MSFLG.LE.0) THEN
            CALL WDATCP (XDAT,EDAT)
          END IF
C         convert ending date to old format
          CALL TIMCNV (EDAT)
        ELSE
C        no data present
         RETCOD= -6
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTDSCU
     I                    (SWDSFL,SDSN,TWDSFL,TDSN,
     I                     UPTFL,GSDAT,GEDAT,NRVAL,
     O                     RVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     copy from a data set to another any timeseries data between
C     start and end dates
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SWDSFL,SDSN,TWDSFL,TDSN,
     1          UPTFL,GSDAT(6),GEDAT(6),NRVAL,RETCOD
      REAL      RVAL(NRVAL)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SWDSFL - source watershed data management file unit number
C     SDSN   - source data-set number
C     TWDSFL - target watershed data management file unit number
C     TDSN   - target data-set number
C     UPTFL  - update file unit number
C     GSDAT  - copy start date array
C     GEDAT  - copy end date array
C     NRVAL  - intermediate storage buffer size (recommended size 1000)
C     RVAL   - intermediate storage buffer
C     RETCOD - return code
C                0 - everything is O.K.
C               -9 - data not present in current group
C              -10 - no data in this group
C              -11 - no non missing data, data has not started yet
C              -14 - date specified not within valid range for data set
C              -21 - date from WDM doesn't match expected date
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SDSFRC,STGRP,STSPT,SGPIND,SGPSEN,SGPSDT(6),
     1          SREC,SBKS,SPOS,STST,STUN,SCMP,SQUA,SCDAT(6),
     2          SGPEDT(6),SNGRP,LUPTFL,ALTERD,
     3          TDSFRC,TTGRP,TTSPT,TGPIND,TGPSEN,TGPSDT(6),
     4          TREC,TBKS,TPOS,TTST,TTUN,TCMP,TQUA,TCDAT(6),
     5          TGPEDT(6),TNGRP,TLSTGP,CGPEDT(6),
     6          UPFLG,         UTST,UTUN,     UQUA,UCSDAT(6),UCEDAT(6),
     7                         CTST,CTUN,     CQUA,
     8                         OTST,OTUN,     OQUA,
     9          GPFLG,XDAT(6),LTSTEP,LTUNIT,BADJFG,ADDAFG,CURDAT(6),
     A          TIMFLG,DONFG,CHK,RCNT,REMTUN,REMTST,TSPTAD,RIND,
     B          CARFLG,CSDAT(6),COMPFG,TSFORM,VBTIME,TSSTEP,TCODE
      INTEGER(4)SNOV,TNOV,SCNT,TCNT,NVAL,I4ONE,TGCNT,DPOS
      REAL      SVAL,STSFIL,STOLR,REMVAL,
     1          TVAL,TTSFIL,TTOLR,TPRVAL,
     2          UVAL,XVAL,CVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   TIMCHK, WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDATCP, TIMDFX, WTFNDG, WTEGRP, WTSKVL, WTGPCK, TIMADD
      EXTERNAL   TIMCHK, WTGTNV, TIMDIF, WTPTVL, WTDSPX, WDRCGO, TSBCLR
      EXTERNAL   WDMODT
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT (I6,5I3,I6,I7,F11.0,I7)
C
C     + + + END SPECIFICATIONS + + +
C
      LUPTFL= UPTFL
      RETCOD= 0
      ALTERD= 0
      BADJFG= 0
      I4ONE = 1
      DONFG = 0
      SNGRP = 1
      TNGRP = 1
      TLSTGP= 0
      CARFLG= 0
      IF (LUPTFL.EQ.0) THEN
C       no update file
        UPFLG = 0
      ELSE
        UPFLG = 1
C       be sure we are at start of update file
        REWIND LUPTFL
      END IF
      CALL WDATCP (GSDAT,CSDAT)
C
C     get units and timestep for copy
      CALL TIMDFX (CSDAT,GEDAT,
     O             NVAL,LTUNIT,LTSTEP)
C
C     get info about source data set
      GPFLG= 1
      CALL WTFNDG (SWDSFL,SDSN,GPFLG,CSDAT,LTSTEP,LTUNIT,NVAL,
     O             SDSFRC,STSFIL,STGRP,STOLR,STSPT,
     1             SGPIND,SGPSEN,SGPSDT,XDAT,RETCOD)
C
C     get info about target data set
      GPFLG= 2
      CALL WTFNDG (TWDSFL,TDSN,GPFLG,CSDAT,LTSTEP,LTUNIT,NVAL,
     O             TDSFRC,TTSFIL,TTGRP,TTOLR,TTSPT,
     1             TGPIND,TGPSEN,TGPSDT,XDAT,RETCOD)
C
      IF (RETCOD.EQ.0) THEN
C       get other info about target dsn
        RIND= WDRCGO(TWDSFL,TDSFRC)
        CALL WTDSPX (WIBUFF(1,RIND),
     O               COMPFG,TSFORM,VBTIME,TSSTEP,TCODE)
        CALL WDATCP (CSDAT,CURDAT)
C
        IF (VBTIME .EQ. 1) THEN
C         adjust local time units to match requirments of target dataset
          LTUNIT= TCODE
        END IF
C
 10     CONTINUE
C         group loop
          IF (SNGRP.GT.0) THEN
            IF (SNGRP.EQ.2) SGPIND= SGPIND+ 1
C           find out end of group
            CALL WTEGRP (SGPSDT,STGRP,
     O                   SGPEDT)
            IF (SGPIND.EQ.SGPSEN) THEN
C             this is last group
              CALL WDATCP (GEDAT,SGPEDT)
            END IF
C           skip values in source dsn, dont need source VBTIME since
            ADDAFG= 0
            CALL WTSKVL (SWDSFL,SGPIND,SGPSDT,CSDAT,
     I                   SDSFRC,STSFIL,STGRP,BADJFG,ADDAFG,ADDAFG,
     O                   SREC,SBKS,SPOS,SNOV,SVAL,XVAL,
     O                   STST,STUN,SCMP,SQUA,SCNT,SCDAT,
     O                   RETCOD)
            SNGRP= 0
          END IF
          IF (TNGRP.NE.0) THEN
            IF (TNGRP.EQ.2) THEN
              TGPIND= TGPIND+ 1
            END IF
C           find out end of group
            CALL WTEGRP (TGPSDT,TTGRP,
     O                   TGPEDT)
            IF (TGPIND.EQ.TGPSEN) THEN
C             this is last group
              TLSTGP= 1
CJK 6/94      dont go too far
              CALL WDATCP (GEDAT,CGPEDT)
            ELSE
C             ck group at end on target group
              CALL WDATCP (TGPEDT,CGPEDT)
            END IF
            TNGRP= 0
          END IF
C         skip values in target dsn
          CALL WTGPCK (TWDSFL,TGPIND,TGPSDT,CSDAT,LTUNIT,
     I                 TDSFRC,TTSFIL,TTGRP,VBTIME,
     O                 TREC,TBKS,TPOS,TNOV,TVAL,TPRVAL,
     O                 TTST,TTUN,TCMP,TQUA,TCNT,TCDAT,
     O                 RETCOD)
C
          RCNT= 0
          IF (CARFLG.EQ.1) THEN
C           fill in saved value
            RCNT= RCNT+ 1
            RVAL(RCNT)= CVAL
            CALL TIMADD (CURDAT,CTUN,CTST,I4ONE,
     O                   XDAT)
            CALL WDATCP (XDAT,CURDAT)
            CARFLG= 0
          END IF
C
 20       CONTINUE
C           loop to fill buffer of similar values for put
            IF (RETCOD.EQ.0.AND.UPFLG.NE.0) THEN
 30           CONTINUE
C               get current update file info
                READ (LUPTFL,1000,END=40) UCSDAT,UTST,UTUN,UVAL,UQUA
                CALL TIMADD (UCSDAT,UTUN,UTST,I4ONE,
     O                       UCEDAT)
C               check to see if update ends after current date
              IF (TIMCHK(UCEDAT,CURDAT).EQ.1) GO TO 30
              GO TO 50
 40           CONTINUE
C               end of update file, dont try to read more
                LUPTFL= 0
 50           CONTINUE
              UPFLG= 0
            END IF
C
            IF (RCNT.GT.0) THEN
C             save old values
              OTST= CTST
              OTUN= CTUN
              OQUA= CQUA
            END IF
C
C           now copy some data, which source
            IF (LUPTFL.GT.0) THEN
C             try update file
              TIMFLG= TIMCHK(CURDAT,UCSDAT)
            ELSE
C             no update file, use source data set
              TIMFLG= 1
            END IF
            IF (TIMFLG.LT.0) THEN
C             part of update interval is current
C             how much, what value, adjust UTUN,UTST,UVAL
C             ************* NOT YET IMPLEMENTED ************
              RETCOD= -5
            END IF
            IF (TIMFLG.LE.0) THEN
C             save current update value for target dsn
              CVAL= UVAL
              CTST= UTST
              CTUN= UTUN
              CQUA= UQUA
C             read more data from update file
              UPFLG= 1
            ELSE
              TIMFLG= TIMCHK(CURDAT,SCDAT)
              IF (TIMFLG.EQ.0) THEN
C               save current source value for target dsn
                CVAL= SVAL
                CTST= STST
                CTUN= STUN
                CQUA= SQUA
              ELSE
C               only part of source interval is needed
C               how much, what value, adjust SVAL,STUN,STST
C               *********** NOT YET IMPLEMENTED ***********
                RETCOD= -4
              END IF
            END IF
C
            IF (RCNT.EQ.0) THEN
C             first time thru
              CHK = 1
              OTST= CTST
              OTUN= CTUN
              OQUA= CQUA
            ELSE
              IF (OTST.EQ.CTST.AND.OTUN.EQ.CTUN.AND.OQUA.EQ.CQUA) THEN
C               this value has same characteristics as last one
                CHK= 1
              ELSE
C               set flag to stop filling buffer
                CHK= 0
              END IF
            END IF
C
            IF (CHK.EQ.1) THEN
              RCNT= RCNT+ 1
              RVAL(RCNT)= CVAL
              CALL TIMADD (CURDAT,CTUN,CTST,I4ONE,
     O                     XDAT)
              CALL WDATCP (XDAT,CURDAT)
C             check for end of buffer
              IF (RCNT.EQ.NRVAL) THEN
C               end of buffer
                CHK= -2
              END IF
C             check for end of group
              IF (TIMCHK(CURDAT,CGPEDT).LE.0) THEN
                CHK  = -1
                TNGRP= 2
C               set beginning of next group (is this needed?)
                CALL WDATCP (TGPEDT,TGPSDT)
              END IF
              IF (TLSTGP.EQ.1) THEN
                IF (TIMCHK(CURDAT,GEDAT).LE.0) THEN
C                 last group done, finished
                  DONFG= 1
                END IF
              END IF
            END IF
C
C           get next values(S) from source dsn
 60         CONTINUE
              SCNT= SCNT+ 1
              IF (SCNT.GT.SNOV) THEN
C               check for group boundary
                CALL TIMADD (SCDAT,STUN,STST,I4ONE,
     O                       XDAT)
                IF (TIMCHK(XDAT,SGPEDT).EQ.0) THEN
C                 end of group
                  SNGRP= 2
C                 set start of new group
                  CALL WDATCP (SGPEDT,SGPSDT)
                END IF
              END IF
              IF (SNGRP.EQ.0) THEN
                CALL WTGTNV (SWDSFL,SCNT,
     M                       SNOV,SCMP,SREC,SBKS,STST,
     1                       STUN,SQUA,SPOS,SCDAT,
     O                       SVAL,XDAT)
                CALL WDATCP (XDAT,SCDAT)
              END IF
C             with an updated value, get whole span
            IF (UPFLG.EQ.1.AND.TIMCHK(SCDAT,UCEDAT).EQ.1.AND.
     1          SNGRP.EQ.0) GO TO 60
C
          IF (CHK.EQ.1.AND.SNGRP.EQ.0) GO TO 20
C
          IF (RETCOD.EQ.0) THEN
C           fill in target dsn
            DPOS  = 1
            REMTUN= 0
            CALL TIMDIF (CSDAT,TGPEDT,OTUN,OTST,
     O                   TGCNT)
            TSPTAD= 0
            CALL WTPTVL (TWDSFL,RCNT,OTUN,OTST,
     1                   TDSFRC,TTSFIL,TTOLR,OQUA,RVAL,TGCNT,TSPTAD,
     2                   TGPEDT,COMPFG,
     M                   TREC,TBKS,TPOS,TNOV,TVAL,TPRVAL,
     1                   TTST,TTUN,TCMP,TQUA,TCDAT,
     2                   DPOS,REMTUN,REMTST,REMVAL)
Ckmf        IF (DPOS.LT.RCNT) WRITE (*,*) 'BIG PROBLEM WITH COPY PUT'
            IF (DPOS.LT.RCNT) THEN
              WRITE(99,*)'WDTMS2:WTDSCU:  BIG PROBLEM WITH COPY PUT'
              WRITE (*,*) 'BIG PROBLEM WITH COPY PUT'
            END IF
            CALL WDATCP (CURDAT,CSDAT)
            IF (SNGRP.EQ.0.AND.CHK.NE.-2) CARFLG= 1
C           clear modified data from time-series buffer
            CALL TSBCLR (TWDSFL,TDSN)
            ALTERD= 1
          END IF
        IF (DONFG.EQ.0.AND.RETCOD.EQ.0) GO TO 10
C
        IF (ALTERD .EQ. 1) THEN
C         set dataset modification date attribute for target dataset
          CALL WDMODT (TWDSFL,TDSN)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTDDEL
     I                    (WDMSFL,DSN,DELDAT,ALLFLG,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     delete all data following a specified date in the given
C     data set
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DELDAT(6),ALLFLG,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - watershed data management file unit number
C     DSN    - data-set number
C     DELDAT - delete from date array
C     ALLFLG - delete all flag, 0 - only delete group
C                               1 - all data after date
C     RETCOD - return code
C                0 - everything is O.K.
C               -6 - no data present
C              -10 - no data in this group
C              -11 - no non missing data, data has not started yet
C              -14 - date specified not within valid range for data set
C              -21 - date from WDM doesn't match expected date
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,DREC,NREC,SREC,SPOS,STST,STUN,SCMP,SQUA,SCNT,
     1          SDAT(6),SBKS,STSPT,SGRP,ADDAFG,BADJFG,I,GRDLCT,
     2          GRPIND,GRPDEL,GRPEND,GPSDAT(6),GPEDAT(6),PDAT,GPFLG,
     3          ENDDAT(6),VBTIME
      INTEGER(4)SFREE,SNOV,SGNOV,TNOV,LNOV,I4TMP,I4ZRO,GRPPTR
      REAL      SVAL,SFIL,STOLR
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO,WDRCDL,TIMCHK
      INTEGER(4)WDPTCL,WBCWCL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WTFNDT, TIMDFX, WTFNDG, TIMCHK, WDRCGO, WDPTSP, WTSKVL
      EXTERNAL   WBCWCL, WDRCUP, WTEGRP, WTNWBK, WDPTCL, WDRCDL, WDMODT
C
C     + + + END SPECIFICATIONS + + +
C
      ADDAFG= 0
      VBTIME= 0
      BADJFG= 0
      GPFLG = 2
      I4ZRO = 0
      GRDLCT= 0
C
C     get end date for data
      CALL WTFNDT (WDMSFL,DSN,GPFLG,
     O             DREC,SDAT,ENDDAT,RETCOD)
C     are we deleting any data
      I= TIMCHK(DELDAT,ENDDAT)
      IF (I.EQ.1) THEN
C       figure out how much time is being deleted
        CALL TIMDFX (DELDAT,ENDDAT,
     O               SGNOV,STUN,STST)
C
C       figure out which groups to delete
        CALL WTFNDG (WDMSFL,DSN,GPFLG,DELDAT,STST,STUN,SGNOV,
     O               DREC,SFIL,SGRP,STOLR,STSPT,
     O               GRPDEL,GRPEND,GPSDAT,SDAT,RETCOD)
C
        IF (RETCOD.EQ.0) THEN
C         lets do the delete
          IF (TIMCHK(DELDAT,GPSDAT).EQ.0.OR.ALLFLG.EQ.1) THEN
C           on group boundary or deleting everything,
C           delete whole group or first one with data
            RIND= WDRCGO(WDMSFL,DREC)
 10         CONTINUE
              GRPPTR= WIBUFF(GRPDEL,RIND)
              IF (GRPPTR.EQ.I4ZRO) THEN
C               nothing in current group, try next one
                GRPDEL= GRPDEL+ 1
              ELSE
                CALL WDPTSP (GRPPTR,
     O                       SREC,SPOS)
              END IF
            IF (GRPPTR.EQ.I4ZRO) GO TO 10
C           increment number of groups deleted counter
            GRPDEL= GRPDEL- 1
          ELSE
C           skip to where delete starts
            CALL WTSKVL (WDMSFL,GRPDEL,GPSDAT,DELDAT,
     1                   DREC,SFIL,SGRP,BADJFG,ADDAFG,VBTIME,
     O                   SREC,SBKS,SPOS,SNOV,SVAL,SVAL,
     1                   STST,STUN,SCMP,SQUA,SCNT,SDAT,
     2                   RETCOD)
            IF (RETCOD.EQ.0) THEN
              IF (SCNT.EQ.1) THEN
C               at beginning of block BLOCK, DELETE IT ALL
                SPOS= SBKS
              ELSE
C               save part of block
                SNOV= SCNT- 1
                RIND= WDRCGO(WDMSFL,SREC)
                WIBUFF(SBKS,RIND)= WBCWCL(SNOV,STST,STUN,SCMP,SQUA)
                CALL WDRCUP(WDMSFL,RIND)
                IF (SCMP .EQ. 1) SPOS = SPOS + 1
              END IF
C             fill rest of group with undefined values
C             find end of group
              CALL WTEGRP (SDAT,SGRP,
     O                     GPEDAT)
              SCMP= 1
              SQUA= 31
C             figure out how much time left in group
              CALL TIMDFX (SDAT,GPEDAT,
     O                     TNOV,STUN,STST)
              I4TMP= 32767
C
 20           CONTINUE
                LNOV= TNOV
                IF (LNOV.GT.I4TMP) LNOV= I4TMP
                CALL WTNWBK (WDMSFL,
     M                       SREC,SPOS,
     O                       SBKS)
                RIND= WDRCGO(WDMSFL,SREC)
                WIBUFF(SBKS,RIND)= WBCWCL(LNOV,STST,STUN,SCMP,SQUA)
                WRBUFF(SPOS,RIND)= SFIL
                SPOS= SPOS+ 1
                TNOV= TNOV- LNOV
              IF (TNOV.GT.I4ZRO) GO TO 20
C             write out revised record
              CALL WDRCUP(WDMSFL,RIND)
            END IF
          END IF
        END IF
C
        IF (RETCOD.EQ.0) THEN
C         fix directory
          RIND= WDRCGO(WDMSFL,DREC)
C         fix group pointers to show no data
          DO 70 GRPIND= GRPDEL+1,GRPEND
            IF (WIBUFF(GRPIND,RIND).GT.0) GRDLCT= GRDLCT+ 1
            WIBUFF(GRPIND,RIND)= 0
 70       CONTINUE
C         update free pos and number of groups
          SFREE= WDPTCL(SREC,SPOS)
          PDAT = WIBUFF(11,RIND)
          WIBUFF(PDAT,RIND)= WIBUFF(PDAT,RIND)- GRDLCT
          WIBUFF(PDAT+1,RIND)= SFREE
C         update directory
          CALL WDRCUP(WDMSFL,RIND)
C
C         get record where data to delete starts
          RIND= WDRCGO(WDMSFL,SREC)
C         zero out rest of current record
          DO 80 I= SPOS,512
            WIBUFF(I,RIND)= 0
 80       CONTINUE
C         update retcord
          CALL WDRCUP(WDMSFL,RIND)
          NREC= WIBUFF(4,RIND)
C
          IF (NREC.GT.0) THEN
C           delete any and all records which follow
 90         CONTINUE
              SREC= NREC
              NREC= WDRCDL(WDMSFL,SREC)
            IF (NREC.GT.0) GOTO 90
          END IF
        END IF
C
C       set dataset modification date attribute
        CALL WDMODT (WDMSFL,DSN)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTEGRP
     I                    (DAT,TGROUP,
     O                     EGRDAT)
C
C     + + + PURPOSE + + +
C     determines end of group which contains a given date,
C     if at group boundary, returns date of end of group
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DAT(6),TGROUP,EGRDAT(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DAT    - current date array
C     TGROUP - group time unit
C     EGRDAT - end of group date array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + INTRINSICS + + +
      INTRINSIC   MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPI, DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
      I= 6
      J= -999
      CALL ZIPI(I,J,EGRDAT)
C
      GO TO (10,20,30,40,50,60,70), TGROUP
 10   CONTINUE
C       second group pointers are not supported
        GO TO 90
C
 20   CONTINUE
C       minute group pointers are not supported
        GO TO 90
C
 30   CONTINUE
C       hour pointer
        EGRDAT(1)= DAT(1)
        EGRDAT(2)= DAT(2)
        EGRDAT(3)= DAT(3)
C       always increment hour for end of group
        EGRDAT(4)= DAT(4)+ 1
        IF (EGRDAT(4).GT.24) THEN
C         new day
          EGRDAT(4)= 1
          EGRDAT(3)= EGRDAT(3)+ 1
          IF (EGRDAT(3).GT.DAYMON(EGRDAT(1),EGRDAT(2))) THEN
C           new month
            EGRDAT(3)= 1
            EGRDAT(2)= EGRDAT(2)+ 1
            IF (EGRDAT(2).GT.12) THEN
C             new year
              EGRDAT(2)= 1
              EGRDAT(1)= EGRDAT(1)+ 1
            END IF
          END IF
        END IF
        GO TO 90
C
 40   CONTINUE
C       day pointer
        EGRDAT(1)= DAT(1)
        EGRDAT(2)= DAT(2)
        IF (DAT(4).EQ.24) THEN
C         on boundary
          EGRDAT(3)= DAT(3)+ 1
          IF (EGRDAT(3).GT.DAYMON(EGRDAT(1),EGRDAT(2))) THEN
C           new month
            EGRDAT(3)= 1
            EGRDAT(2)= EGRDAT(2)+ 1
            IF (EGRDAT(2).GT.12) THEN
C             new year
              EGRDAT(2)= 1
              EGRDAT(1)= EGRDAT(1)+ 1
            END IF
          END IF
        ELSE
          EGRDAT(3)= DAT(3)
        END IF
        EGRDAT(4)= 24
        GO TO 90
C
 50   CONTINUE
C       month pointer
        EGRDAT(1)= DAT(1)
        EGRDAT(2)= DAT(2)
        IF (DAT(3).EQ.DAYMON(DAT(1),DAT(2)).AND.DAT(4).EQ.24) THEN
C         on boundary
          EGRDAT(2)= EGRDAT(2)+ 1
          IF (EGRDAT(2).GT.12) THEN
C           new year
            EGRDAT(2)= 1
            EGRDAT(1)= EGRDAT(1)+ 1
          END IF
        END IF
        EGRDAT(3)= DAYMON(EGRDAT(1),EGRDAT(2))
        EGRDAT(4)= 24
        GO TO 90
C
 60   CONTINUE
C       year pointer
        EGRDAT(1)= DAT(1)
        IF (DAT(2).EQ.12.AND.DAT(3).EQ.31.AND.DAT(4).EQ.24) THEN
C         on boundary
          EGRDAT(1)= EGRDAT(1)+ 1
        END IF
        EGRDAT(2)= 12
        EGRDAT(3)= 31
        EGRDAT(4)= 24
        GO TO 90
C
 70   CONTINUE
C       century pointers
        IF (MOD(DAT(1)+1,100).EQ.0.AND.DAT(2).EQ.12.AND.
     1      DAT(3).EQ.31.AND.DAT(4).EQ.24) THEN
C         on boundary
          EGRDAT(1)= DAT(1)+ 100
        ELSE
          EGRDAT(1)= ((DAT(1)/100)+1)*100- 1
        END IF
        EGRDAT(2)= 12
        EGRDAT(3)= 31
        EGRDAT(4)= 24
        GO TO 90
C
 90   CONTINUE
      EGRDAT(5)= 0
      EGRDAT(6)= 0
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTSGRP
     I                    (DAT,TGROUP,
     O                     SGRDAT)
C
C     + + + PURPOSE + + +
C     determines start of group which contains given date,
C     if at group boundary, returns given date
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DAT(6),TGROUP,SGRDAT(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DAT    - current date array
C     TGROUP - group time unit
C     SGRDAT - start of group date array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + FUNCTIONS + + +
      INTEGER   DAYMON
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPI, DAYMON
C
C     + + + END SPECIFICATIONS + + +
C
      I= 6
      J= -999
      CALL ZIPI(I,J,SGRDAT)
C
      GO TO (10,20,30,40,50,60,70), TGROUP
 10   CONTINUE
C       second gorup pointers not supported
        GO TO 90
C
 20   CONTINUE
C       minute group pointers not supported
        GO TO 90
C
 30   CONTINUE
C       hour pointers
        SGRDAT(1)= DAT(1)
        SGRDAT(2)= DAT(2)
        SGRDAT(3)= DAT(3)
        SGRDAT(4)= DAT(4)
        IF (SGRDAT(4).EQ.0) THEN
C         back a day
          SGRDAT(4)= 24
          SGRDAT(3)= SGRDAT(3)- 1
          IF (SGRDAT(3).EQ.0) THEN
C           back a month
            SGRDAT(2)= SGRDAT(2)- 1
            IF (SGRDAT(2).EQ.0) THEN
C             back a year
              SGRDAT(2)= 12
              SGRDAT(1)= SGRDAT(1)- 1
            END IF
            SGRDAT(3)= DAYMON(SGRDAT(1),SGRDAT(2))
          END IF
        END IF
        GO TO 90
C
 40   CONTINUE
C       day pointers
        SGRDAT(1)= DAT(1)
        SGRDAT(2)= DAT(2)
        IF (DAT(4).EQ.24) THEN
C         on boundary
          SGRDAT(3)= DAT(3)
        ELSE
          SGRDAT(3)= DAT(3)- 1
          IF (SGRDAT(3).EQ.0) THEN
C           back a month
            SGRDAT(2)= SGRDAT(2)- 1
            IF (SGRDAT(2).EQ.0) THEN
C             back a year
              SGRDAT(2)= 12
              SGRDAT(1)= SGRDAT(1)- 1
            END IF
            SGRDAT(3)= DAYMON(SGRDAT(1),SGRDAT(2))
          END IF
        END IF
        SGRDAT(4)= 24
        GO TO 90
C
 50   CONTINUE
C       month pointers
        SGRDAT(1)= DAT(1)
        IF (DAT(3).EQ.DAYMON(DAT(1),DAT(2)).AND.DAT(4).EQ.24) THEN
C         on a boundary
          SGRDAT(2)= DAT(2)
        ELSE
          SGRDAT(2)= DAT(2)- 1
          IF (SGRDAT(2).EQ.0) THEN
C           back a year
            SGRDAT(2)= 12
            SGRDAT(1)= SGRDAT(1)- 1
          END IF
        END IF
        SGRDAT(3)= DAYMON(SGRDAT(1),SGRDAT(2))
        SGRDAT(4)= 24
        GO TO 90
C
 60   CONTINUE
C       year pointer
        IF (DAT(2).EQ.12.AND.DAT(3).EQ.31.AND.DAT(4).EQ.24) THEN
C         on year boundary
          SGRDAT(1)= DAT(1)
        ELSE
          SGRDAT(1)= DAT(1)- 1
        END IF
        SGRDAT(2)= 12
        SGRDAT(3)= 31
        SGRDAT(4)= 24
        GO TO 90
C
 70   CONTINUE
C       century pointer
        IF (MOD(DAT(1)+1,100).EQ.0.AND.DAT(2).EQ.12.AND.
     1      DAT(3).EQ.31.AND.DAT(4).EQ.24) THEN
C         on the boundary
          SGRDAT(1)= DAT(1)
        ELSE
          SGRDAT(1)= (DAT(1)/100)*100- 1
        END IF
        SGRDAT(2)= 12
        SGRDAT(3)= 31
        SGRDAT(4)= 24
        GO TO 90
C
 90   CONTINUE
C
      SGRDAT(5)= 0
      SGRDAT(6)= 0
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDATCP
     I                   (ODAT,NDAT)
C
C     copies an old array date into a new one
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   ODAT(6),NDAT(6)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ODAT   - from date array
C     NDAT   - to date array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      DO 10 I= 1,6
        NDAT(I)= ODAT(I)
 10   CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   WTDATE
     I                   (WDMFL, DSNCNT, DSN, CMMXFG,
     O                    SDATE, EDATE, ERRCOD)
C
C     + + + PURPOSE + + +
C     Find common or maximum period with data from a list of
C     time-series data sets on a WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SDATE(6), EDATE(6), DSNCNT, CMMXFG, WDMFL, ERRCOD
      INTEGER   DSN(DSNCNT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMFL  - WDM file unit number
C     DSNCNT - number of data sets
C     DSN    - array of data-set numbers for timeseries
C     CMMXFG - common(1) or maximum(2) period flag
C     SDATE  - starting date (yr...sec)
C     EDATE  - ending date (yr...sec)
C     ERRCOD - error code 0 = ok, 2 = end before start, other - bad date
C              return code
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RETCOD, ICK, N, L3, L0, GPFLG, DREC, FLG,
     &          SD(6,2), ED(6,2), L2, L6, TEMP(6)
C
C     + + + EXTERNALS + + +
      EXTERNAL  WTFNDT, DLIMIT, ZIPI, CKDATE, COPYI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   L0, L2, L3, L6
     &      / 0,  2,  3,  6/
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD= 0
      GPFLG = 0
      CALL ZIPI (L3, L0, SD(4,1))
      CALL ZIPI (L3, L0, ED(4,1))
      SD(1,1) = 1000
      ED(1,1) = 9999
      SD(2,1) = 1
      SD(3,1) = 1
      ED(2,1) = 12
      ED(3,1) = 31
C
      DO 30 N= 1, DSNCNT
C       determine start and end dates
        CALL WTFNDT (WDMFL,DSN(N),GPFLG,
     O               DREC,SD(1,2),ED(1,2),RETCOD)
        IF (RETCOD .EQ. 0) THEN
C         compare start dates
          IF (CMMXFG .EQ. 1 .OR. N .EQ. 1) THEN
C           common period or first time thru, later start date
            FLG= 2
          ELSE
C           max period, earlier start date
            FLG= 1
          END IF
          CALL DLIMIT (SD, L2, FLG, TEMP)
          CALL COPYI (L6, TEMP, SD(1,1))
C         compare end dates
          IF (CMMXFG .EQ. 1 .OR. N .EQ. 1) THEN
C           common period or first time thru, earlier end date
            FLG= 1
          ELSE
C           max period, later start date
            FLG= 2
          END IF
          CALL DLIMIT (ED, L2, FLG, TEMP)
          CALL COPYI (L6, TEMP, ED(1,1))
        ELSE
          ERRCOD= RETCOD
        END IF
 30   CONTINUE
C
C     check final
      IF (ERRCOD .EQ. 0) THEN
C       compare final start and end dates
        CALL CKDATE (SD(1,1), ED(1,1), ICK)
        IF (ICK .EQ. 1) THEN
C         end before start
          ERRCOD = 2
        END IF
      END IF
C
      CALL COPYI (L6,SD,SDATE)
      CALL COPYI (L6,ED,EDATE)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDATIM
     I                   ( WDMSFL, DSN, 
     O                     STRT, STOP, TSTEP, TCODE,
     O                     RETCOD )
C     
C     + + + PURPOSE + + +
C     Gets the start and end dates of the data in a time series data set
C     and the time step of the data.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, DSN, STRT(6), STOP(6), TSTEP, TCODE,
     $          RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data set number
C     STRT   - start of record
C     STOP   - end of record
C     TSTEP  - time step of data, in TCODE units
C     TCODE  - time units of data
C              1 - second        4 - day
C              2 - minute        5 - month
C              3 - hour          6 - year
C     RETCOD - return code
C                  0 - all information successfully retrieved
C                 -6 - no data in the data set
C                -81 - data set does not exist
C                -82 - data set is not a time-series data set
C               -107 - one or more attributes not present in data set
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GPFLG, DREC, RETC, LEN, ZERO, FLAG, INDX
      INTEGER   TMPTCODE(1), TMPTSTEP(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPI
      EXTERNAL  WTFNDT, WDBSGI
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  GPFLG, ZERO
     $     /   1,    0  /
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD = 0
C     get period of record
      CALL WTFNDT ( WDMSFL, DSN, GPFLG,
     O              DREC, STRT, STOP, RETC )
      IF (RETC .EQ. -81  .OR.  RETC .EQ. -82) THEN
C       data set does not exist or is wrong type
        RETCOD = RETC
        LEN = 6
        CALL ZIPI ( LEN, ZERO, STRT )
        CALL ZIPI ( LEN, ZERO, STOP )
        TSTEP = 0
        TCODE = 0
      ELSE
C       data set does exist
        IF (RETC .EQ. -6) THEN
C         no data in data set
          RETCOD = RETC
          LEN = 6
          CALL ZIPI ( LEN, ZERO, STRT )
          CALL ZIPI ( LEN, ZERO, STOP )
        END IF
        FLAG = 0
C       get time step
        LEN = 1
        INDX= 33
        CALL WDBSGI ( WDMSFL, DSN, INDX, LEN,
     $                TMPTSTEP, RETC )
        TSTEP = TMPTSTEP(1)
        IF (RETC .EQ. -107) THEN
C         time step not present
          TSTEP = 0
          FLAG = 1
        END IF
C       get time units 
        INDX = 17
        CALL WDBSGI ( WDMSFL, DSN, INDX, LEN,
     $                TMPTCODE, RETC )
        TCODE = TMPTCODE(1)
        IF (RETC .EQ. -107) THEN
C         time code not present
          TCODE = 0
          FLAG = 1
        END IF
        IF (FLAG .EQ. 1  .AND.  RETCOD .NE. -6) THEN
C         missing some attributes
          RETCOD = -107
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDAINF
     I                   ( WDMSFL, DSN, NUMI, NUMR, INDXI, INDXR,
     O                     DATES, ATRIBI, ATRIBR,
     O                     RETCOD )
C
C     + + + PURPOSE + + +
C     This routine gets general atribute information about a time-series
C     data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL, DSN, NUMI, NUMR, INDXI(*), INDXR(*),
     $          DATES(6,2), ATRIBI(*), RETCOD
      REAL      ATRIBR(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data set number
C     NUMI   - number of integer attributes to retrieve
C     NUMR   - number of real attributes to retrieve
C     INDXI  - array of index numbers of the integer attributes
C     INDXR  - array of index numbers of the real attributes
C     DATES  - period of available record
C              (_,1) - start of record
C              (_,2) - end of record
C     ATRIBI - array of retrieved integer attributes,
C              -999 returned if not present in data set
C     ATRIBR - array of retrieved real attributes
C              -999. returned if not present in data set
C     RETCOD - return code
C                  0 - all information successfully retrieved
C                 -6 - no data in the data set 
C                -81 - data set does not exist
C                -82 - data set is not a time-series data set
C               -107 - one or more attributes not present in data set
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GPFLG, DREC, RETC, LEN, ZERO, MISSI, FLAG, N
      REAL      MISSR
C
C     + + + EXTERNALS + + +
      EXTERNAL  ZIPI,   ZIPR
      EXTERNAL  WTFNDT, WDBSGI, WDBSGR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  GPFLG, ZERO, MISSI, MISSR
     $     /   1,    0,   -999, -999.  /
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD = 0
C     get period of record
      CALL WTFNDT ( WDMSFL, DSN, GPFLG,
     O              DREC, DATES(1,1), DATES(1,2), RETC )
      IF (RETC .EQ. -81  .OR.  RETC .EQ. -82) THEN
C       data set does not exist or is wrong type
        RETCOD = RETC
        LEN = 12
        CALL ZIPI ( LEN, ZERO, DATES )
        IF (NUMI .GT. 0) CALL ZIPI ( NUMI, MISSI, ATRIBI )
        IF (NUMR .GT. 0) CALL ZIPR ( NUMR, MISSR, ATRIBR )
      ELSE
C       data set does exist
        IF (RETC .EQ. -6) THEN
C         no data in data set
          LEN = 12
          CALL ZIPI ( LEN, ZERO, DATES )
          RETCOD = -6
        END IF
        FLAG = 0
        IF (NUMI .GT. 0) THEN
C         get integer attribute values
          LEN = 1
          DO 100 N = 1, NUMI
            CALL WDBSGI ( WDMSFL, DSN, INDXI(N), LEN,
     $                    ATRIBI(N), RETC )
            IF (RETC .EQ. -107) THEN
C             attribute not present on this data set
              ATRIBI(N) = -999
              FLAG = 1
            END IF
 100      CONTINUE
        END IF
        IF (NUMR .GT. 0) THEN
C         get real attribute values
          LEN = 1
          DO 200 N = 1, NUMR
            CALL WDBSGR ( WDMSFL, DSN, INDXR(N), LEN,
     O                    ATRIBR(N), RETC )
            IF (RETC .EQ. -107) THEN
C             attribute not present on this data set
              ATRIBR(N) = -999.
              FLAG = 1
            END IF
 200      CONTINUE
        END IF
        IF (FLAG .EQ. 1  .AND.  RETCOD .NE. -6) THEN
C         missing some attributes
          RETCOD = -107
        END IF
      END IF
C
      RETURN
      END

C
C
C
      SUBROUTINE   TSBTIM
     I                   (TUNIT,TSTEP,DTRANS,QUALFG)
C
C     + + + PURPOSE + + +
C     Set the current time units, time step, data transformation,
C     and data quality flag for the time-series data in use.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   TUNIT,TSTEP,DTRANS,QUALFG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     TUNIT  - time units of data,
C              1 - seconds          4 - days
C              2 - minutes          5 - months
C              3 - hours            6 - years
C     TSTEP  - time step of data
C     DTRANS - data transformation code,
C              0 - ave,same
C              1 - sum,div
C              2 - max
C              3 - min
C     QUALFG - allowed quality code
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CTSBUF.INC'
C
C     + + + END SPECIFICATIONS + + +
C
      CTU = TUNIT
      CTS = TSTEP
      CTRANS = DTRANS
      CQUAL  = QUALFG
C
      RETURN
      END
C
C
C
      SUBROUTINE   TSBWDS
     I                   (WDMSFL,DSN)
C
C     + + + PURPOSE + + +
C     Set the current WDM file unit number and data-set number
C     for the time-series data in use.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file containing data
C     DSN    - data-set number on WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CTSBUF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     LWDMFL,LDSN
C
C     + + + EXTERNALS + + +
      EXTERNAL    WID2UD
C
C     + + + END SPECIFICATIONS + + +
C
C     adjust wdm and dsn as needed
      CALL WID2UD (WDMSFL,DSN,
     O             LWDMFL,LDSN)
C
      CFILUN = LWDMFL
      CDSN   = LDSN
C
      RETURN
      END
C
C
C
      SUBROUTINE   TSBGET
     I                   (SDATE,NVAL,
     O                    RVAL,RETCOD)
C
C     + + + PURPOSE + + +
C     Retrieve the time-series data specified by the current
C     time-series specifications (in CTSBUF.INC).
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SDATE(6),NVAL,RETCOD
      REAL      RVAL(NVAL)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SDATE  - starting date of data being retrieved
C     NVAL   - number of values to retrieve
C     RVAL   - buffer of time-series data retrieved
C     RETCOD - return code
C                0 - everything O.K.
C               -8 - invalid date
C              -14 - date specified not within valid range for data set
C              -20 - problem with one or more of following:
C                    GPFLG, DXX, NVAL, QUALVL, LTSTEP, LTUNIT
C              -21 - date from WDM doesn't match expected date
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CTSBUF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,J,I1,I6,MID,CEDATE(6),OPOS,LNVAL,GNVAL,LSTART(6),
     $           TBSDAT(6),GRSDAT(6),GREDAT(6),LSDAT(6),LEDAT(6),
     $           MAXGRP,SOFF,EOFF,CDATID,DATFG,DELCNT,INSPTR,
     $           ENDREC,COPYFG,GPEREC,RECPGR,TGROUP,BPOS,IREC,IPOS
      REAL       NODAT
C
C     + + + INTRINSICS + + +
      INTRINSIC  ABS, MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDBASE, ZIPR, TIMADD, CKDATE, TIMDIF
      EXTERNAL   COPYI, COPYR, WDTGET, TIMCVT, TSBINI
C
C     + + + END SPECIFICATIONS + + +
C
      I1 = 1
      I6 = 6
      NODAT = -1.0E10
C
C     may need to initialize time-series buffer stuff
      CALL TSBINI
C
C     make copy of start date and be sure its midnight convention of 00:00
      CALL COPYI (I6,SDATE,LSTART)
      CALL TIMCVT (LSTART)
C     determine ending date for data requested
      CALL TIMADD (LSTART,CTU,CTS,NVAL,
     O             CEDATE)
C     get base/group dates and other info for data
      CALL WDBASE (CFILUN,CDSN,LSTART,
     O             TBSDAT,TGROUP,GRSDAT,GREDAT,MAXGRP,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       convert to midnight convention of 00:00
        CALL TIMCVT (GRSDAT)
        CALL TIMCVT (GREDAT)
        IF (TGROUP.EQ.6) THEN
C         use leap year to assure max number of values in group
          GRSDAT(1)= 1992
          GREDAT(1)= 1993
        ELSE IF (TGROUP.EQ.5) THEN
C         use January to assure max number of values in group
          GRSDAT(2)= 1
          GREDAT(1)= GRSDAT(1)
          GREDAT(2)= 2
        END IF
C       determine max number of values in group
        CALL TIMDIF (GRSDAT,GREDAT,CTU,CTS,
     O               GNVAL)
        IF (GNVAL.LT.BUFLEN) THEN
C         may fit more than 1 group on each record
          GPEREC= BUFLEN/GNVAL
          RECPGR= 1
        ELSE
C         how may records needed for each group
          RECPGR= GNVAL/BUFLEN+ 1
          GPEREC= 1
        END IF
        IF (GPEREC.GE.MAXGRP) THEN
C         don't exceed max number of groups allowable for data set
          GPEREC= MAXGRP- 1
        END IF
C
        IF (RECPGR.LT.MXID) THEN
C         use time-series buffer for data retrieval
          OPOS = 1
          DATFG= 0
C         start looping through data groups at base date
          CALL COPYI (I6,TBSDAT,GRSDAT)
 100      CONTINUE
C           loop through groups of data
            CALL TIMADD (GRSDAT,TGROUP,I1,GPEREC,
     O                   GREDAT)
            IF (DATFG.EQ.0) THEN
C             see if data group surrounds requested start date
              CALL CKDATE (GREDAT,LSTART,
     O                     DATFG)
              IF (DATFG.LT.0) THEN
C               end of group preceeds requested start date, set flag to skip
                DATFG= 0
              END IF
            ELSE
C             passed start date, is group after end date?
              CALL CKDATE (CEDATE,GRSDAT,
     O                     DATFG)
              IF (DATFG.EQ.0) THEN
C               group starts at requested end date, exit data get loop
                DATFG= -1
              END IF
            END IF
C
            IF (DATFG.EQ.1) THEN
C             this group needed for requested data, set current id
              IF (TGROUP.LT.6) THEN
C               need to include more than just year
                CDATID= 0
                DO 110 I= 1,7-TGROUP
                  J= 7- TGROUP- I
                  CDATID= CDATID+ GRSDAT(I)*100**J
 110            CONTINUE
              ELSE
C               only group starting year needed
                CDATID= GRSDAT(1)
              END IF
              MID= 0
              IF (NUMID.GT.0) THEN
C               data previously stored in buffer, look for match of current
                I= 0
 120            CONTINUE
C                 look through specs of previous data
                  I= I+ 1
                  IF (BFILUN(I).EQ.CFILUN .AND. BDSN(I).EQ.CDSN .AND.
     $                BTU(I).EQ.CTU .AND. BTS(I).EQ.CTS .AND.
     $                BDATID(I).EQ.CDATID .AND. BTRANS(I).EQ.CTRANS)THEN
                    MID = I
                  END IF
                IF (I.LT.NUMID .AND. MID.EQ.0) GO TO 120
              END IF
C
CTMP            if (mid.ne.0) write (*,*) 'match found for data at pos',MID
              IF (MID.EQ.0) THEN
C               needed data not found in buffer
                ENDREC= FREREC+ RECPGR- 1
                IF (ENDREC.GT.MXID) THEN
C                 at end of buffer records, go back to 1st record
CTMP           write (*,*) 'crossing max buffer boundary'
CTMP           write (99,*) 'crossing max buffer boundary'
                  FREREC= 1
                  ENDREC= RECPGR
                END IF
C
                DELCNT= 0
                INSPTR= 0
                IF (NUMID.GT.0) THEN
C                 clear out any IDs using needed buffer records
                  DO 140 I= 1,NUMID
C                   check each ID
                    IF (BSREC(I).GE.FREREC .AND. BSREC(I).LE.ENDREC)THEN
C                     this IDs records conflict with needed records, remove 'em
                      DELCNT= DELCNT+ 1
                      IF (INSPTR.EQ.0) THEN
C                       always insert at 1st ID being deleted
                        INSPTR= I
                      END IF
                    ELSE IF (INSPTR.EQ.0 .AND. I.LT.NUMID) THEN
C                     see if data is to be inserted here (when not deleting)
                      IF (FREREC.GE.BSREC(I)+BNREC(I) .AND.
     $                    FREREC.LE.BSREC(I+1)) THEN
C                       insert data at this position in ID arrays
                        INSPTR= I+ 1
                      END IF
                    END IF
 140              CONTINUE
                END IF
C
                IF (INSPTR.EQ.0) THEN
C                 not inserting, must be adding to end
                  INSPTR= NUMID+ 1
                END IF
C
                IF (DELCNT.GT.0) THEN
C                 need to remove some existing data IDs
CTMP                write (*,*) 'remove',DELCNT,' data IDs, starting at',INSPTR
                  NUMID= NUMID- DELCNT
                  DO 150 I= INSPTR,NUMID
C                   adjust positions in arrays
CTMP                write (*,*) 'removing data ID at position',I
                    BFILUN(I)= BFILUN(I+DELCNT)
                    BDSN(I)  = BDSN(I+DELCNT)
                    BTU(I)   = BTU(I+DELCNT)
                    BTS(I)   = BTS(I+DELCNT)
                    BTRANS(I)= BTRANS(I+DELCNT)
                    CALL COPYI (I6,BSDATE(1,I+DELCNT),BSDATE(1,I))
                    BNVAL(I) = BNVAL(I+DELCNT)
                    BQUAL(I) = BQUAL(I+DELCNT)
                    BSREC(I) = BSREC(I+DELCNT)
                    BNREC(I) = BNREC(I+DELCNT)
                    BDATID(I)= BDATID(I+DELCNT)
 150              CONTINUE
                END IF
C
                NUMID= NUMID+ 1
CTMP              write (*,*) 'inserting ID at position',INSPTR,' of',NUMID
                IF (INSPTR.LT.NUMID) THEN
C                 need to adjust arrays to insert data ID
CTMP          if (delcnt.eq.0) write (*,*)
CTMP         $         'insert ID into empty space at position',INSPTR
                  DO 160 I= NUMID,INSPTR+1,-1
C                   adjust positions in arrays
                    BFILUN(I)= BFILUN(I-1)
                    BDSN(I)  = BDSN(I-1)
                    BTU(I)   = BTU(I-1)
                    BTS(I)   = BTS(I-1)
                    BTRANS(I)= BTRANS(I-1)
                    CALL COPYI (I6,BSDATE(1,I-1),BSDATE(1,I))
                    BNVAL(I) = BNVAL(I-1)
                    BQUAL(I) = BQUAL(I-1)
                    BSREC(I) = BSREC(I-1)
                    BNREC(I) = BNREC(I-1)
                    BDATID(I)= BDATID(I-1)
 160              CONTINUE
                END IF
                BFILUN(INSPTR)= CFILUN
                BDSN(INSPTR)  = CDSN
                BTU(INSPTR)   = CTU
                BTS(INSPTR)   = CTS
                BTRANS(INSPTR)= CTRANS
                CALL COPYI (I6,GRSDAT,BSDATE(1,INSPTR))
                CALL TIMDIF (GRSDAT,GREDAT,CTU,CTS,
     O                       BNVAL(INSPTR))
                BQUAL(INSPTR) = CQUAL
                BSREC(INSPTR) = FREREC
                BNREC(INSPTR) = RECPGR
                BDATID(INSPTR)= CDATID
C               init buffer records to indicate no data retrieved
                I= RECPGR*BUFLEN
                CALL ZIPR (I,NODAT,TSBUF(1,FREREC))
                MID= INSPTR
                FREREC= FREREC+ BNREC(INSPTR)
              END IF
C
C             put requested data from this group into output data array
              CALL COPYI (I6,GRSDAT,LSDAT)
              BPOS  = 1
              IREC  = BSREC(MID)
              COPYFG= 0
              DO 200 I= 1,GPEREC
C               loop through data groups in this buffer ID
                CALL TIMADD (LSDAT,TGROUP,I1,I1,
     O                       LEDAT)
                IF (COPYFG.EQ.0) THEN
C                 see if data group surrounds requested start date
                  CALL CKDATE (LEDAT,LSTART,
     O                         COPYFG)
                  IF (COPYFG.LT.0) THEN
C                   end of group preceeds requested start date, set flag to skip
                    COPYFG= 0
                  END IF
                ELSE
C                 passed start date, is group after end date?
                  CALL CKDATE (CEDATE,LSDAT,
     O                         COPYFG)
                  IF (COPYFG.EQ.0) THEN
C                   group starts at requested end date, no copy
                    COPYFG= -1
                  END IF
                END IF
C
C               how many values in this data group
                CALL TIMDIF (LSDAT,LEDAT,CTU,CTS,
     O                       GNVAL)
                IF (COPYFG.EQ.1) THEN
C                 has this data group actually been retrieved
                  IF (ABS(TSBUF(BPOS,IREC)-NODAT).LT.1.0E-10) THEN
C                   1st data value of group is unitialized, get data group
CTMP           write (*,*) 'WDTGETing',GNVAL,' values from DSN',CDSN
                    CALL WDTGET (CFILUN,CDSN,CTS,LSDAT,GNVAL,
     I                           CTRANS,CQUAL,CTU,
     O                           TSBUF(BPOS,IREC),RETCOD)
                  END IF
C                 need to offset for start date?
                  CALL TIMDIF (LSDAT,LSTART,CTU,CTS,
     O                         SOFF)
C                 need to offset for end date?
                  CALL TIMDIF (CEDATE,LEDAT,CTU,CTS,
     O                         EOFF)
C                 copy data on record to output array
                  LNVAL= GNVAL- SOFF- EOFF
                  IPOS = BPOS+ SOFF
                  IF (IPOS.GT.BUFLEN) THEN
C                   need to adjust record and offset
                    IREC= IREC+ (IPOS/BUFLEN)
                    IPOS= MOD(IPOS,BUFLEN)
                    IF (IPOS.EQ.0) THEN
C                     position at end of previous record
                      IREC= IREC- 1
                      IPOS= BUFLEN
                    END IF
                  END IF
CTMP           write (*,*) 'putting',LNVAL,' values to output buffer'
CTMP           write (*,*) 'starting at position',SOFF+1,' of buffer record',I
                  CALL COPYR (LNVAL,TSBUF(IPOS,IREC),RVAL(OPOS))
                  OPOS= OPOS+ LNVAL
                END IF
C               increment to start of next data group
                CALL COPYI (I6,LEDAT,LSDAT)
C               increment position on buffer record
                BPOS= BPOS+ GNVAL
 200          CONTINUE
            END IF
C
C           increment to start of next data group
            CALL COPYI (I6,GREDAT,GRSDAT)
          IF (DATFG.GE.0 .AND. RETCOD.EQ.0) GO TO 100
        ELSE
C         too much data to fit in time-series buffer, use generic get
          CALL WDTGET (CFILUN,CDSN,CTS,LSTART,NVAL,CTRANS,CQUAL,CTU,
     O                 RVAL,RETCOD)
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBASE
     I                   (WDMSFL,DSN,SDATE,
     O                    TBSDAT,TGROUP,GRSDAT,GREDAT,MAXGRP,RETCOD)
C
C     + + + PURPOSE + + +
C     Get base date, start/end dates of group, time units,
C     time step, and variable time flag for WDM data.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER    WDMSFL,DSN,SDATE(6),TGROUP,TBSDAT(6),
     $           GRSDAT(6),GREDAT(6),MAXGRP,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data set number on WDM file
C     SDATE  - starting date of data
C     TBSDAT - base starting date
C     TGROUP - data group pointer
C     GRSDAT - starting date of data group
C     GREDAT - ending date of data group
C     MAXGRP - max number of data groups allowed for data set
C     RETCOD - return code,
C              -14 - requested start date preceeds base start date
C
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,I1,SAIND,SAVAL(1),IPOS,FREC,PDAT,PDATV
C
C     + + + FUNCTIONS + + +
      INTEGER    WDGIVL, TIMCHK
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDGIVL, TIMCHK, WDDSCK, WDBSGI, WTSGRP, WTEGRP
C
C     + + + END SPECIFICATIONS + + +
C
      I1 = 1
C
      CALL WDDSCK (WDMSFL,DSN,
     O             FREC,RETCOD)
      IF (RETCOD.EQ.0) THEN
C       get pointer to first group pointer
        IPOS= 11
        PDAT= WDGIVL(WDMSFL,FREC,IPOS)
C       get max number of group pointers
        IPOS= 12
        PDATV = WDGIVL(WDMSFL,FREC,IPOS)
C       determine max number of data groups on data set
        MAXGRP= PDATV- PDAT- 2
C
C       set default base date
        TBSDAT(1)= -999
        TBSDAT(2)= 1
        TBSDAT(3)= 1
        TBSDAT(4)= 0
        TBSDAT(5)= 0
        TBSDAT(6)= 0
C       get base date pointers
        DO 10 I= 1,4
          SAIND= I+ 26
          CALL WDBSGI (WDMSFL,DSN,SAIND,I1,
     O                 SAVAL,RETCOD)
          IF (RETCOD.EQ.0) THEN
C           valid attribute value exists
            TBSDAT(I)= SAVAL(1)
          END IF
 10     CONTINUE
C
C       get group pointer for data
        SAIND= 34
        CALL WDBSGI (WDMSFL,DSN,SAIND,I1,
     O               SAVAL,RETCOD)
        IF (RETCOD.EQ.0) THEN
C         group pointer found
          TGROUP= SAVAL(1)
        ELSE
C         group pointer not found, set to default
          TGROUP= 6
C         reset return code
          RETCOD= 0
        END IF
C
C       determine start of data group
        CALL WTSGRP (SDATE,TGROUP,
     O               GRSDAT)
C       determine end of 1st data group
        CALL WTEGRP (SDATE,TGROUP,
     O               GREDAT)
C
        IF (TIMCHK(TBSDAT,GRSDAT).EQ.-1) THEN
C         base year after start of data group requested
          RETCOD= -14
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   TSBCLR
     I                   (WDMSFL,DSN)
C
C     + + + PURPOSE + + +
C     Remove data from the time-series buffer which may have been
C     modified in the WDM file, but not in the buffer.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     DSN    - data-set number on WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CTSBUF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,I0,I6,ID
C
C     + + + EXTERNALS + + +
      EXTERNAL   COPYI, ZIPI
C
C     + + + END SPECIFICATIONS + + +
C
      I0 = 0
      I6 = 6
C
      IF (NUMID.GT.0) THEN
C       data stored in buffer
        DO 10 ID= 1,NUMID
C         see if input data set matches any data in buffer
          IF (BFILUN(ID).EQ.WDMSFL .AND. BDSN(ID).EQ.DSN) THEN
C           WDM file and data set match, remove them
            IF (ID.LT.NUMID) THEN
C             shift stored data information in buffer
              DO 50 I= ID,NUMID-1
C               move all info stored after this ID
                BFILUN(I)= BFILUN(I+1)
                BDSN(I)  = BDSN(I+1)
                BTU(I)   = BTU(I+1)
                BTS(I)   = BTS(I+1)
                BTRANS(I)= BTRANS(I+1)
                CALL COPYI (I6,BSDATE(1,I+1),BSDATE(1,I))
                BNVAL(I) = BNVAL(I+1)
                BQUAL(I) = BQUAL(I+1)
                BSREC(I) = BSREC(I+1)
                BNREC(I) = BNREC(I+1)
                BDATID(I)= BDATID(I+1)
 50           CONTINUE
            END IF
C           zero out last ID of information
            BFILUN(NUMID)= 0
            BDSN(NUMID)  = 0
            BTU(NUMID)   = 0
            BTS(NUMID)   = 0
            BTRANS(NUMID)= 0
            CALL ZIPI (I6,I0,BSDATE(1,NUMID))
            BNVAL(NUMID) = 0
            BQUAL(NUMID) = 0
            BSREC(NUMID) = 0
            BNREC(NUMID) = 0
            BDATID(NUMID)= 0
            NUMID= NUMID- 1
          END IF
 10     CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   TSBINI
C
C     + + + PURPOSE + + +
C     Initialize time-series buffer common variables.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CTSBUF.INC'
C
C     + + + SAVES + + +
      INTEGER    INITFG
      SAVE       INITFG
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I0
      REAL       R0
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPI, ZIPR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA INITFG /0/
C
C     + + + EXTERNALS + + +
C
      I0 = 0
      R0 = 0.0
C
      IF (INITFG.EQ.0) THEN
C       init data buffer specification parameters
        CALL ZIPI (MXID,I0,BFILUN)
        CALL ZIPI (MXID,I0,BDSN)
        CALL ZIPI (MXID,I0,BTU)
        CALL ZIPI (MXID,I0,BTS)
        CALL ZIPI (MXID,I0,BTRANS)
        CALL ZIPI (MXID,I0,BQUAL)
        CALL ZIPI (6*MXID,I0,BSDATE)
        CALL ZIPI (MXID,I0,BNVAL)
        CALL ZIPI (MXID,I0,BSREC)
        CALL ZIPI (MXID,I0,BNREC)
        CALL ZIPI (MXID,I0,BDATID)
C       init counter and free data buffer position
        NUMID = 0
        FREREC= 1
C       init actual data buffer
        CALL ZIPR (BUFLEN*MXID,R0,TSBUF)
C       indicate intialization has been performed
        INITFG= 1
      END IF
C
      RETURN
      END

C     -*- fortran -*-
C     This file is autogenerated with f2py (version:2)
C     It contains Fortran 77 wrappers to fortran functions.

      subroutine f2pywrapwdckdt (wdckdtf2pywrap, wdmsfl, dsn)
      external wdckdt
      integer wdmsfl
      integer dsn
      integer wdckdtf2pywrap, wdckdt
      wdckdtf2pywrap = wdckdt(wdmsfl, dsn)
      end


      subroutine f2pyinitcfbuff(setupfunc)
      external setupfunc
      integer(kind=4) wibuff(512,10)
      integer recno(10)
      integer wdmfun(10)
      integer nxtpos(10)
      integer prepos(10)
      integer frepos
      integer wdmcnt
      integer wdmopn(5)
      integer maxrec(5)
      common /cfbuff/ wibuff,recno,wdmfun,nxtpos,prepos,frepos,wdm
     &cnt,wdmopn,maxrec
      call setupfunc(wibuff,recno,wdmfun,nxtpos,prepos,frepos,wdmc
     &nt,wdmopn,maxrec)
      end

      subroutine f2pyinitcdrloc(setupfunc)
      external setupfunc
      integer pfname
      integer pmxrec
      integer pfrrec
      integer ptsnum
      integer pdirpt
      common /cdrloc/ pfname,pmxrec,pfrrec,ptsnum,pdirpt
      call setupfunc(pfname,pmxrec,pfrrec,ptsnum,pdirpt)
      end

C     utwdmd.f 2.1 9/4/91
C
C
C
      INTEGER   FUNCTION   WDRCGO
     I                           (WDMSFL,RREC)
C
C     + + + PURPOSE + + +
C     Determine the index of the user requested record within
C     the WDM in memory buffer of records.  The record is read
C     from the WDM file and pointers are updated, as required.
C     If the record is already in the buffer, the index is returned.
C     If the record is not in the buffer, the oldest record in
C     the buffer is replaced with the record read from the WDM file.
C     For a negative RREC, the index of an empty record is returned.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,RREC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of the WDM file
C     RREC   - record number to find and place in buffer
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + SAVES + + +
      INTEGER   BADCNT
      SAVE      BADCNT
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   IND,RIND,PIND,NIND,XIND,I,CWDM,DONFG
      CHARACTER(255)STR
      CHARACTER(255)WDNAME
      LOGICAL       OPEN           
C
C     + + + INTRINSICS + + +
      INTRINSIC IABS
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BADCNT/0/
C
C     + + + END SPECIFICATIONS + + +
C
C     WRITE(STR,*) 'ADWDM:UTWDMD:WDRCGO',wdmsfl,rrec
C     CALL LOG_MSG(STR)
C
      RIND = 0
      CWDM = 0
      DONFG= 0
C
 10   CONTINUE
        CWDM= CWDM+ 1
        IF (WDMOPN(CWDM).EQ.WDMSFL) THEN
C         we know about this wdm file
          DONFG= 1
        END IF
      IF (CWDM.LT.WDMCNT .AND. DONFG.EQ.0) GO TO 10
C
C     write(STR,*) 'ADWDM:UTWDMD:WDRCGO2',cwdm,donfg,wdmcnt
C     CALL LOG_MSG(STR)
C     write(STR,*) 'ADWDM:UTWDMD:WDRCGO3',maxrec(cwdm),wdmopn(cwdm)
C     CALL LOG_MSG(STR)
C
      IF (DONFG.EQ.1) THEN
C       working with a valid file
        IF (IABS(RREC).LE.MAXREC(CWDM)) THEN
C         record is within allowable range
          IF (RREC.GE.0) THEN
C           looking for an existing record
            IND = 0
 30         CONTINUE
C             look for desired record in currently avail records
              IND= IND+ 1
              IF (RECNO(IND).EQ.RREC .AND. WDMFUN(IND).EQ.WDMSFL) THEN
C               its already in memory
                RIND= IND
              END IF
            IF (IND.LT.CONREC.AND.RIND.EQ.0) GO TO 30
          END IF
C
          IF (RIND.EQ.0) THEN
C           record not found, allocate space for it
            RIND= FREPOS
            IF (RREC.GT.0) THEN
              INQUIRE(UNIT=WDMSFL,NAME=WDNAME,OPENED=OPEN)
              IF (OPEN) THEN
C               read existing record from file
                READ (WDMSFL,REC=RREC) (WIBUFF(I,RIND),I=1,512)
              ELSE
                WRITE(STR,*) 'UTWDMD:NotOpen:',WDMSFL,RREC,TRIM(WDNAME)
C               CALL LOG_MSG(STR)
              END IF
            ELSE
C             return an empty buffer
              DO 40 I= 1,512
                WIBUFF(I,RIND)= 0
 40           CONTINUE
            END IF
C
            FREPOS      = NXTPOS(FREPOS)
            RECNO(RIND) = IABS(RREC)
            WDMFUN(RIND)= WDMSFL
          ELSE
C           record found, update pointers to use this buffer space last
            IF (RIND.EQ.FREPOS .OR. PREPOS(FREPOS).EQ.RIND) THEN
C             pointers are ok
              IF (RIND.EQ.FREPOS) THEN
C               update frepos
                FREPOS= NXTPOS(RIND)
              END IF
            ELSE
C             forward pointer first
              NIND        = PREPOS(FREPOS)
              PIND        = PREPOS(RIND)
              XIND        = NXTPOS(RIND)
              NXTPOS(PIND)= NXTPOS(RIND)
              NXTPOS(RIND)= FREPOS
              NXTPOS(NIND)= RIND
C             now back pointers
              PREPOS(FREPOS)= RIND
              PREPOS(XIND)  = PREPOS(RIND)
              PREPOS(RIND)  = NIND
            END IF
          END IF
        END IF
      END IF
C
      IF (RIND .LT. 1 .OR. RIND .GT. CONREC) THEN
C       we have got a bad problem
        BADCNT = BADCNT + 1
        IF (BADCNT.LT.50) THEN
C         restrict the number of times this message is written
C         to avoid filling up the pipe
          WRITE(*,*) 'ADDWM:UTWDMD:WDRCGO:',WDMCNT,CWDM,DONFG,
     #                MAXREC(CWDM),RREC
          WRITE(*,*) '               want:',WDMSFL,' open:',
     #                (WDMOPN(I),I=1,WDMCNT)
        ELSEIF (BADCNT.EQ.50) THEN
          WRITE(*,*) 'ADDWM:UTWDMD:WDRCGO: write no more messages'
        END IF
        RIND = 1
      END IF
C
      WDRCGO= RIND
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFLCK
     I                   (WDMSFL,
     O                    RETCOD)
C
C     + + + PURPOSE + + +
C     Check directory of WDM for major errors.  Checks version number
C     and updates old version of WDM file to current version, when required.
C     Determines the number of records in the WDM file and adds that
C     value to the common block CFBUFF.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     RETCOD - return code
C               0 - everything ok
C             -89 - WDM file is invalid
C             -88 - no room for another WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,RIND,I,J
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO, WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
      I     = 0
C
      IF (WDMCNT.GT.0) THEN
C       see if file already open
 10     CONTINUE
          I= I+ 1
          IF (WDMOPN(I).EQ.WDMSFL) THEN
C           already open
            I= WDMCNT+ 1
          END IF
        IF (I.LT.WDMCNT) GO TO 10
      END IF
C
      IF (I.EQ.WDMCNT) THEN
C       is there room for another WDM file?
        IF (WDMCNT.LT.MXWDM) THEN
C         another file allowed, save info about wdm file
          WDMCNT= WDMCNT+ 1
          WDMOPN(WDMCNT)= WDMSFL
          MAXREC(WDMCNT)= 1
C         check new wdm file
          RREC= 1
          RIND= WDRCGO(WDMSFL,RREC)
C
C         check first position pointer
          IF (WIBUFF(1,RIND).EQ.-998) THEN
C           first position is ok, save max number of records
            MAXREC(WDMCNT)= WIBUFF(PMXREC,RIND)
          ELSE IF (WIBUFF(1,RIND).EQ.-999) THEN
C           old version, update first record
            DO 20 I= 439,40,-1
              J= I+ 73
              WIBUFF(J,RIND)= WIBUFF(I,RIND)
 20         CONTINUE
            DO 30 I= 40,112
              WIBUFF(I,RIND)= 0
 30         CONTINUE
C           indicate now new version
            WIBUFF(1,RIND)= -998
            CALL WDRCUP (WDMSFL,RIND)
            MAXREC(WDMCNT)= WIBUFF(PMXREC,RIND)
          ELSE
C           first position incorrect, return error
            RETCOD= -89
            WDMOPN(WDMCNT)= 0
            MAXREC(WDMCNT)= 0
            WDMCNT= WDMCNT- 1
          END IF
        ELSE
C         cant have another wdm file open
          RETCOD= -88
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFLCL
     I                   (WDMSFL,
     O                    RETCOD)
C
C     + + + PURPOSE + + +
C     Remove a WDM file from the open WDM buffer and adjust
C     buffer accordingly.
C
C     + + + HISTORY + + +
C     2005/06/30 JLK allow message file to be closed
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     RETCOD - return code
C                0 - everything ok
C              -87 - can't remove message WDM file from buffer
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I, J
C
C     + + + EXTERNALS + +
      EXTERNAL   WDFLNU
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
C
C     WRITE(99,*,ERR=10) 'WDFLCL:entry',WDMSFL,
C    #            ' count',WDMCNT,
C    #            ' open:',(WDMOPN(I),I=1,WDMCNT)
C10   CONTINUE
C
C     loop to thru open files
      I = 1
      DO WHILE (I .LE. WDMCNT)
        IF (WDMOPN(I) .NE. WDMSFL) THEN
C         try next one
          I = I+ 1
        ELSE
C         this file is open

C         check pointers in wdm file
C         TODO: how slow is this?
C         CALL WDMCHK(WDMSFL,RETCOD)

C         close the file
          CLOSE (UNIT=WDMSFL)
C
C         mark records in buffer as not usable
          CALL WDFLNU(WDMSFL)
C
          IF (I .LT. WDMCNT) THEN
C           move later wdm unit numbers
            DO 30 J= I+1, WDMCNT
              WDMOPN(J-1)= WDMOPN(J)
              MAXREC(J-1)= MAXREC(J)
 30         CONTINUE
C           reset the count
          ELSE
C           just reset last values
            WDMOPN(I)= 0
            MAXREC(I)= 0
          END IF
          WDMCNT= WDMCNT- 1
C         force exit from loop
          I= WDMCNT+ 1
        END IF
      END DO
C
C     WRITE(99,*,ERR=40) 'WDFLCL:exit:',WDMSFL,
C    #            ' count',WDMCNT,
C    #            ' open:',(WDMOPN(I),I=1,WDMCNT)
C40   CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDFLNU
     I                   (WDMSFL)
C
C     + + + PURPOSE + + +
C     mark records in buffer as not usable
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
C     mark records in buffer as not usable
      DO 30 I= 1,CONREC
        IF (WDMFUN(I).EQ.WDMSFL) THEN
C         unusable
          WDMFUN(I)= 0
          RECNO(I) = 0
        END IF
 30   CONTINUE      
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDRCUP
     I                   (WDMSFL,RIND)
C
C     + + + PURPOSE + + +
C     Write record index number RIND from the buffer of records
C     to the WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,RIND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     RIND   - buffer index number of record to write
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,I
      INTEGER(4)IOS
C
C     + + + END SPECIFICATIONS + + +
C
      RREC= RECNO(RIND)
      WRITE (WDMSFL,REC=RREC,ERR=10,IOSTAT=IOS) (WIBUFF(I,RIND),I=1,512)
      GO TO 20
 10   CONTINUE
C       big problem writing to wdm file
        WRITE (*,*) 'WDRCUP, ERROR ON WRITE, RREC, IOS:',RREC,IOS
C       STOP
 20   CONTINUE
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDRCGN
     I                           (WDMSFL,PRPRRC,SCPRRC)
C
C     + + + PURPOSE + + +
C     Get the next free record from the WDM file and add it to
C     the WDM buffer of records.  Update pointers on WDM file for
C     primary and secondary records and initialize new record pointers.
C     Returns index number in WDM buffer of records.  Returns 0 if no
C     record available.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,PRPRRC,SCPRRC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     PRPRRC - primary record pointer
C     SCPRRC - secondary record pointer
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,RIND,NEWREC,PPREC,PNREC,SPREC,SNREC,FNREC
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC   IABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
      WDRCGN= 0
C     get directory record
      RREC= 1
      RIND= WDRCGO(WDMSFL,RREC)
C     get next free record number
      NEWREC= WIBUFF(PFRREC,RIND)
      IF (NEWREC.NE.0) THEN
C       record is available, use it
        IF (PRPRRC.NE.0.OR.SCPRRC.NE.0) THEN
C         update previous records
          PPREC= IABS(PRPRRC)
          SPREC= SCPRRC
          IF (PRPRRC.GT.0) THEN
C           get primary previous record
            RIND= WDRCGO(WDMSFL,PPREC)
C           save old next record pointer
            PNREC= WIBUFF(2,RIND)
C           update next record pointer
            WIBUFF(2,RIND)= NEWREC
            IF (PPREC.NE.SCPRRC) THEN
C             write record
              CALL WDRCUP (WDMSFL,RIND)
            END IF
          ELSE
C           no primary previous record
            PNREC= 0
          END IF
C
          IF (SPREC.NE.0) THEN
C           get secondary previous record
            RIND= WDRCGO(WDMSFL,SPREC)
C           save old next record pointer
            SNREC= WIBUFF(4,RIND)
C           update next record pointer
            WIBUFF(4,RIND)= NEWREC
C           write record
            CALL WDRCUP(WDMSFL,RIND)
          ELSE
            SNREC= 0
          END IF
C
C         update next records
          IF (PNREC.NE.0) THEN
C           get primary previous next record
            RIND= WDRCGO(WDMSFL,PNREC)
C           update previous rec pointer
            WIBUFF(1,RIND)= NEWREC
            IF (PNREC.NE.SNREC) THEN
C             write record
              CALL WDRCUP(WDMSFL,RIND)
            END IF
          END IF
          IF (SNREC.GT.0) THEN
C           get secondary next record
            RIND= WDRCGO(WDMSFL,SNREC)
C           update previous record pointer
            WIBUFF (3,RIND)= NEWREC
C           write record
            CALL WDRCUP(WDMSFL,RIND)
          END IF
        ELSE
C         no pointers in use (directory record)
          PPREC= 0
          PNREC= 0
          SPREC= 0
          SNREC= 0
        END IF
C
C       initialize nex record
C       get next record pointer
        RIND= WDRCGO(WDMSFL,NEWREC)
        FNREC= WIBUFF(2,RIND)
C       fix pointers on new record
        WIBUFF(1,RIND)= PPREC
        WIBUFF(2,RIND)= PNREC
        WIBUFF(3,RIND)= SPREC
        WIBUFF(4,RIND)= SNREC
C       write new record
        CALL WDRCUP(WDMSFL,RIND)
C       update directory
        RREC= 1
        RIND= WDRCGO(WDMSFL,RREC)
        WIBUFF(PFRREC,RIND)= FNREC
        CALL WDRCUP(WDMSFL,RIND)
C       return index of new record
        WDRCGN= WDRCGO(WDMSFL,NEWREC)
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDRCGX
     I                           (WDMSFL,PRPRRC,SCPRRC)
C
C     + + + PURPOSE + + +
C     Get the next free record from the WDM file. If no free records
C     are available, add twenty records to the WDM file.  Add free
C     record to the WDM buffer of records.  Update pointers on WDM file
C     for primary and secondary records and initialize new record pointers.
C     Returns index number in WDM buffer of records.  Returns 0 if no
C     record available.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,PRPRRC,SCPRRC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     PRPRRC - primary record pointer
C     SCPRRC - secondary record pointer
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,NUMADD,FREREC
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGN
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGN, WDRCAD
C
C     + + + END SPECIFICATIONS + + +
C
C     try to get new record
      RIND= WDRCGN(WDMSFL,PRPRRC,SCPRRC)
      IF (RIND.EQ.0) THEN
C       no new records available, add some
        NUMADD= 20
        CALL WDRCAD(WDMSFL,NUMADD,
     O              FREREC)
        RIND  = WDRCGN(WDMSFL,PRPRRC,SCPRRC)
      END IF
C
      WDRCGX= RIND
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDRCAD
     I                   (WDMSFL,NUMADD,
     O                    FREREC)
C
C     + + + PURPOSE + + +
C     Add NUMADD records to the WDM file.  Update directory
C     record on the WDM file (record 1).  Returns record number
C     of the first free record in the WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,NUMADD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     NUMADD - number of records to add
C     FREREC - record number of first free record in the WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,RREC,FREREC,LMXREC,I
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDRCUP
C
C     + + + END SPECIFICATIONS + + +
C
C     get directory
      RREC= 1
      RIND= WDRCGO(WDMSFL,RREC)
C
      LMXREC= WIBUFF(PMXREC,RIND)
      FREREC= WIBUFF(PFRREC,RIND)
C
      IF (FREREC.EQ.0) THEN
C       no current free records, ok to add more
C       update free record value
        FREREC= LMXREC+ 1
        RREC  = LMXREC
        LMXREC= LMXREC+ NUMADD
C       update in memory buffer
        I= 0
 20     CONTINUE
          I= I+ 1
          IF (WDMOPN(I).EQ.WDMSFL) THEN
C           this is it
            MAXREC(I)= LMXREC
            I= WDMCNT
          END IF
        IF (I.LT.WDMCNT) GO TO 20
C       loop to add new records
 10     CONTINUE
          RREC= RREC+ 1
          RIND= WDRCGO(WDMSFL,-RREC)
C         fix primary forward pointer
          IF (RREC.LT.LMXREC) WIBUFF(2,RIND)= RREC+ 1
C         write record
          CALL WDRCUP(WDMSFL,RIND)
          RREC= RECNO(RIND)
        IF (RREC.LT.LMXREC.AND.RREC.GT.0) GO TO 10
C
C       update directory
        RREC= 1
        RIND= WDRCGO(WDMSFL,RREC)
        WIBUFF(PMXREC,RIND)= LMXREC
        WIBUFF(PFRREC,RIND)= FREREC
        CALL WDRCUP(WDMSFL,RIND)
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDDRRC
     I                           (WDMSFL,DSN,OPT)
C
C     + + + PURPOSE + + +
C     Determine WDM file directory record number for data-set
C     number DSN.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,OPT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data-set number
C     OPT    - option flag
C              1 - add a directory record
C              2 - delete a directory record
C              other (0) - neither
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,RIND,PREC,DPT,DIND,DREC
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO,WDRCGX
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDRCUP, WDRCGX
C
C     + + + END SPECIFICATIONS + + +
C
C     write(*,*) 'ADWDM:UTWDMD:WDDRRC',wdmsfl,dsn,opt
      RREC= 1
      RIND= WDRCGO(WDMSFL,RREC)
      DPT = PDIRPT+((DSN-1)/500)
      IF (DPT.GT.512) DPT= 512
      IF (OPT.EQ.2) THEN
C       delete reference to record
        WIBUFF(DPT,RIND)= 0
C       update file def record
        CALL WDRCUP(WDMSFL,RIND)
C       need a dummy value to return
        DREC= 0
      ELSE
        DREC= WIBUFF(DPT,RIND)
        IF (DREC.EQ.0.AND.OPT.EQ.1) THEN
C         add new directory record
          PREC= 0
          DIND= WDRCGX(WDMSFL,PREC,PREC)
          DREC= RECNO(DIND)
          RIND= WDRCGO(WDMSFL,RREC)
          WIBUFF(DPT,RIND)= DREC
          CALL WDRCUP(WDMSFL,RIND)
        END IF
      END IF
C
      WDDRRC= DREC
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSCHK
     I                    (WDMSFL,DSN,DSTYP,
     O                     LREC,GRCNT,RETCOD)
C
C     + + + PURPOSE + + +
C     Check WDM data set existance and type.  Return first
C     record number and number of groups in data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DSTYP,LREC,GRCNT,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data-set number
C     DSTYP  - data-set type
C              1 - time series      6 - rastor
C              2 - table            7 - space-time
C              3 - schematic        8 - attribute
C              4 - project          9 - message
C              5 - vector
C     LREC   - record number of first record in data set (contains label)
C     GRCNT  - number of groups in data set
C     RETCOD - return code
C                0 - data set exists and is correct DSTYP
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   GPFLG
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDSCHA
C
C     + + + END SPECIFICATIONS + + +
C
C     default is to assume read only
      GPFLG= 1
C
      CALL WDSCHA (WDMSFL,DSN,DSTYP,GPFLG,
     O             LREC,GRCNT,RETCOD)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDSCHA
     I                    (WDMSFL,DSN,DSTYP,GPFLG,
     O                     LREC,GRCNT,RETCOD)
C
C     + + + PURPOSE + + +
C     Check WDM data set existance, type and ability to update.
C     Return first record number and number of groups in data set.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DSTYP,GPFLG,LREC,GRCNT,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data-set number
C     DSTYP  - data-set type
C              1 - time series      6 - rastor
C              2 - table            7 - space-time
C              3 - schematic        8 - attribute
C              4 - project          9 - message
C              5 - vector
C     GPFLG  - read(1)/write(2) flag
C     LREC   - record number of first record in data set (contains label)
C     GRCNT  - number of groups in data set
C     RETCOD - return code
C                0 - data set exists and is correct DSTYP
C              -81 - data set does not exist
C              -82 - data set exists, but is wrong DSTYP
C              -84 - data set number out of range
C              -85 - trying to write to a read-only data set
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   LIND,PDAT,SAIND,POS
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO, WDSASV
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO, WDSASV
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
C     write(*,*) 'ADWDM:UTWDMD:WDSCHA',wdmsfl,dsn,dstyp,gpflg
C     does dataset exist
      CALL WDDSCK(WDMSFL,DSN,
     O            LREC,RETCOD)
C     write(*,*) 'ADWDM:UTWDMD:WDSCHA',lrec,retcod
      IF (RETCOD.EQ.0) THEN
C       data set exists, get label
        LIND = WDRCGO(WDMSFL,LREC)
C       check data-set type
        IF (DSTYP.NE.WIBUFF(6,LIND)) THEN
C         not expected type of data-set
          RETCOD= -82
        ELSE
C         calculate number of groups in data set
          PDAT = WIBUFF(11,LIND)
          GRCNT= WIBUFF(PDAT,LIND)
        END IF
      END IF
      IF (RETCOD.EQ.0 .AND. GPFLG.EQ.2) THEN
C       check read/write flag
        SAIND= 35
        POS  = WDSASV(SAIND,WIBUFF(1,LIND))
        IF (POS.GT.0) THEN
C         read/write flag available
          IF (WIBUFF(POS,LIND).EQ.1) THEN
C           trying to write to a read only data set
            RETCOD= -85
          END IF
        END IF
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDCKDT
     I                           (WDMSFL,DSN)
C
C     + + + PURPOSE + + +
C     Check data set for existance and type, returns:
C         0 - data set does not exist
C     or data-set type
C         1 - time series      6 - rastor
C         2 - table            7 - space-time
C         3 - schematic        8 - attribute
C         4 - project          9 - message
C         5 - vector
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data-set number to be checked
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,DSNFRC,DSTYPE,RETCOD
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSCK, WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WDDSCK(WDMSFL,DSN,
     O            DSNFRC,RETCOD)
      IF (DSNFRC.GT.0) THEN
C       data set exists
        RIND  = WDRCGO(WDMSFL,DSNFRC)
        DSTYPE= WIBUFF(6,RIND)
      ELSE
C       data set does not exist
        DSTYPE= 0
      END IF
C
      WDCKDT= DSTYPE
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDDSCK
     I                   (WDMSFL,DSN,
     O                    DREC,RETCOD)
C
C     + + + PURPOSE + + +
C     Check data set for existance and return record number of
C     first record in data set (contains label)
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN,DREC,RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - data-set number to be checked
C     DREC   - record number of first record in data set
C     RETCOD - return code
C                0 - data set exists
C              -81 - data set does not exist
C              -84 - data set number out of range
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RIND,I,OPT,DIRREC
C     LOGICAL   OPN
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO, WDDRRC
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDRRC, WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
C     INQUIRE(UNIT=99,OPENED=OPN)
C     IF (OPN) WRITE(99,*) 'ADWDM:UTWDMD:WDDSCK',wdmsfl,dsn
C
      RETCOD= 0
      IF (DSN.LT.1 .OR. DSN.GT.32000) THEN
C       dataset number out of range
        RETCOD= -84
      END IF
      IF (RETCOD.EQ.0) THEN
C       get directory record number
        OPT   = 0
        DIRREC= WDDRRC(WDMSFL,DSN,OPT)
C
C       IF (OPN) WRITE(99,*) 'ADWDM:UTWDMD:WDDSCK:dirrec',dirrec
C
        IF (DIRREC.GT.0) THEN
C         directory exists, get it
          RIND= WDRCGO(WDMSFL,DIRREC)
C         calculate offset within record for our dsn
          I= MOD(DSN,500)+ 4
          IF (I.EQ.4) I= 504
C         get record dsn begins on
          DREC= WIBUFF(I,RIND)
        ELSE
C         no directory, dsn cant exist
          DREC= 0
        END IF
C       IF (OPN) THEN
C         WRITE(99,*) 'ADWDM:UTWDMD:WDDSCK:',WDMSFL,DSN,DIRREC,DREC
C       END IF
C
        IF (DREC.EQ.0) THEN
C         data set does not exist
          RETCOD= -81
        END IF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDBFIN
C
C     + + + PURPOSE + + +
C     Initialize pointers and counters for WDM buffer of records.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize  common CFBUFF variables as required
      DO 10 I= 1, CONREC
        NXTPOS(I)= I+ 1
        PREPOS(I)= I- 1
        RECNO(I) = 0
        WDMFUN(I)= 0
 10   CONTINUE
C
      NXTPOS(CONREC)= 1
      PREPOS(1)= CONREC
      FREPOS= 1
      WDMCNT= 0
      DO 20 I= 1,MXWDM
        WDMOPN(I)= 0
        MAXREC(I)= 0
 20   CONTINUE
C
C     initialize  CDRLOC
      PFNAME= 9
      PMXREC= 29
      PFRREC= 31
      PTSNUM= 32
      PDIRPT= 113
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDCREA
     I                    (WDMSFL)
C
C     + + + PURPOSE + + +
C     Adds directory record and 19 empty records to a new WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
      INCLUDE 'CDRLOC.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   RREC,FREREC,I,NUMADD,RIND,LMXREC,RETCOD
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDRCGO, WDRCUP, WDRCAD
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
      I= 0
 10   CONTINUE
        I= I+ 1
        IF (WDMOPN(I).EQ.WDMSFL) THEN
C         its already open, can't create it
          RETCOD= -83
          I     = WDMCNT
        END IF
      IF (I.LT.WDMCNT) GO TO 10
C
      IF (RETCOD.EQ.0) THEN
C       ok to create a new file
        WDMCNT= WDMCNT+ 1
        WDMOPN(WDMCNT)= WDMSFL
        MAXREC(WDMCNT)= 1
C
        RREC= -1
        RIND= WDRCGO(WDMSFL,RREC)
C
C       fill in values, previous record pointer
        WIBUFF(1,RIND)= -998
C       last record
        LMXREC= 1
        WIBUFF(PMXREC,RIND)= LMXREC
C       write the first record
        CALL WDRCUP(WDMSFL,RIND)
C       now fill in the other records with all zero except for pointers
        NUMADD= 19
        CALL WDRCAD (WDMSFL,NUMADD,
     O               FREREC)
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDSASV (SAIND,TIBUFF)
C
C     + + + PURPOSE + + +
C     determines where values for particular search attribute
C     start within data-set label, returns 0 if attribute is
C     not present
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   SAIND
      INTEGER(4)TIBUFF(512)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SAIND  - index of particular search attribute
C     TIBUFF - buffer of search attributes
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,PSA,POS,SAMAX
C
C     + + + END SPECIFICATIONS + + +
C
      PSA  = TIBUFF(10)
      SAMAX= TIBUFF(PSA)
      POS  = 0
      I    = 0
C     loop to look for desired attribute index number in label
 10   CONTINUE
        I= I+ 1
        J= PSA+ I* 2
        IF (TIBUFF(J).EQ.SAIND) THEN
C         attribute is present
          POS= TIBUFF(J+1)
        END IF
      IF (I.LT.SAMAX.AND.POS.EQ.0) GO TO 10
C
      WDSASV= POS
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   WDGIVL
     I                           (WDMSFL,REC,POS)
C
C     + + + PURPOSE + + +
C     Returns the integer value stored in the WDM
C     file at the specified position.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,REC,POS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of the WDM file
C     REC    - record number
C     POS    - position within record
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   IND,IVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      IND= WDRCGO(WDMSFL,REC)
      IF (IND .GT. 0) THEN
C       valid record
        IVAL= WIBUFF(POS,IND)
      ELSE
C       problem record
        IVAL= -999
      END IF
C
      WDGIVL= IVAL
C
      RETURN
      END
C
C
C
      REAL   FUNCTION   WDGRVL
     I                        (WDMSFL,REC,POS)
C
C     + + + PURPOSE + + +
C     Returns the real value stored in the WDM
C     file at the specified position.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,REC,POS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of the WDM file
C     REC    - record number
C     POS    - position within record
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   IND
      REAL      RVAL
C
C     + + + FUNCTIONS + + +
      INTEGER   WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      IND= WDRCGO(WDMSFL,REC)
      IF (IND .GT. 0) THEN
C       valid record
        RVAL= WRBUFF(POS,IND)
      ELSE
C       problem record
        RVAL= -999.0
      END IF
C
      WDGRVL= RVAL
C
      RETURN
      END
C
C
C
      CHARACTER(4)  FUNCTION   WDGCVL
     I                               (WDMSFL,REC,POS)
C
C     + + + PURPOSE + + +
C     Returns the character value stored in the WDM
C     file at the specified position.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,REC,POS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of the WDM file
C     REC    - record number
C     POS    - position within record
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     IND,IVAL
      CHARACTER(4)CVAL
C
C     + + + FUNCTIONS + + +
      INTEGER     WDRCGO
C
C     + + + EXTERNALS + + +
      EXTERNAL    WDRCGO
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (A4)
C
C     + + + END SPECIFICATIONS + + +
C
      IND= WDRCGO(WDMSFL,REC)
      IF (IND .GT. 0) THEN
C       valid record
        IVAL= WIBUFF(POS,IND)
        WRITE (CVAL,2000) IVAL
      ELSE
C       problem record
        CVAL= ' '
      END IF
C
      WDGCVL= CVAL
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDGDRT
     O                   (LPTSNM)
C
C     + + + PURPOSE + + +
C     returns pointer to position where count of timeseries datasets
C     is stored in WDM file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   LPTSNM
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LPTSNM - value of pointer
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CDRLOC.INC'
C
C     + + + END SPECIFICATIONS + + +
C
      LPTSNM= PTSNUM
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDDSNX
     I                   (WDMSFL,
     M                    DSN)
C
C     + + + PURPOSE + + +
C     Calls WDDSNP to search for the next data set greater than
C     or equal to DSN.
C 
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSN    - input:  first data set to be checked
C                      valid range is 1 to 32000, inclusive
C              output: -1 if the input DSN is outside the valid range
C                  or, the input DSN if it exists
C                  or, the next existing data set after DSN
C                  or, -1 if no data sets >= the input DSN exist
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   INCR
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDSNP
C
C     + + + END SPECIFICATIONS + + +
C
      INCR = 1
      CALL WDDSNP (WDMSFL, INCR,
     M             DSN)
C
      RETURN
      END
C
C
C
      SUBROUTINE   AWVRSN
C
C     + + + PURPOSE + + +
C     Dummy routine to include unix what version information for the
C     adwdm library.
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER(64) VERSN
C
C     + + + END SPECIFICATIONS + + +
C
      INCLUDE 'FVERSN.INC'
C
      RETURN
      END
C
C
C
      SUBROUTINE   WDDSNP
     I                   (WDMSFL, INCR,
     M                    DSN)
C
C     + + + PURPOSE + + +
C     Checks the wdm file directory records for existing data sets.
C     Beginning with data set DSN, and incrementing or decrementing by 
C     INCR, the directory records are checked for an existing data set. 
C     The first existing data set is returned in DSN.  If no data set 
C     greater than or equal to (or less than or equal to) the input DSN 
C     is found, a value of -1 is returned for DSN.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,INCR,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     INCR   - value by which DSN is incremented/decremented in looking
C              for next/previous data set
C     DSN    - input:  first data set to be checked
C                      valid range is 1 to 32000, inclusive
C              output: -1 if the input DSN is outside the valid range
C                  or, the input DSN if it exists
C                  or, the next existing data set after/before DSN
C                  or, -1 if no data sets >= (or <=) the input DSN exist
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CFBUFF.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   DIFF,NUMINC,DIRDSN,DIRREC,DONFG,OPT,DIND,DOFF,RINDX,
     $          RINDX2
C
C     + + + FUNCTIONS + + +
      INTEGER   WDDRRC,WDRCGO
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL  WDDRRC,WDRCGO
C
C     + + + END SPECIFICATIONS + + +
C
      DONFG= 0
 10   CONTINUE
        IF (DSN.LT.1 .OR. DSN.GT.32000) THEN
C         not in range
          DONFG = 1
          DSN   = -1
        ELSE
C         might be ok, get directory record
          OPT   = 0
          DIRREC= WDDRRC(WDMSFL,DSN,OPT)
          IF (DIRREC .GT. 0) THEN
C           directory exists
            DIND= WDRCGO(WDMSFL,DIRREC)
            RINDX = (DSN-1)/500 + 1
 20         CONTINUE
C             calculate offset within record for dsn
              DOFF= MOD(DSN,500)+ 4
              IF (DOFF.EQ.4) THEN
C               last position on the directory record
                DOFF= 504
              END IF
              IF (WIBUFF(DOFF,DIND) .GT. 0) THEN
C               it's a dataset
                DONFG = 1
              ELSE
C               no data set here, try another
                DSN= DSN+ INCR
                IF (DSN.GT.0 .AND. DSN.LT.32001) THEN
                  RINDX2 = (DSN-1)/500 + 1
                ELSE
                  RINDX2 = 0
                END IF
              END IF
C             look more on this directory record?
            IF (DONFG.EQ.0 .AND. RINDX.EQ.RINDX2) GO TO 20
          ELSE
C           no directory
            IF (INCR .GT. 0) THEN
C             skip to next possible directory
              DIRDSN= (((DSN-1)/500)+ 1)* 500+ 1
            ELSE IF (INCR .LT. 0) THEN
C             skip to previous directory, if any
              DIRDSN= ((DSN-1)/500)* 500
            END IF
C           find next dsn w/in that directory based on INCR
            DIFF = DIRDSN - DSN
            NUMINC = DIFF/INCR
            IF (MOD(DIFF,INCR) .NE. 0) NUMINC = NUMINC + 1
            DSN = DSN + INCR*NUMINC
          END IF
        END IF
      IF (DONFG .EQ. 0) GO TO 10
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDIINI
C
C     + + + PURPOSE + + +
C     initialize CWDMID common block
C
C     + + + COMMON BLOCKS + + +
      INCLUDE   'CWDMID.INC'
C
C     + + + END SPECIFICATIONS + + +
C
      WIDCNT   = 0
      WIDBSE(1)= 0
C
      RETURN
      END
C
C
C
      SUBROUTINE   WIDADD
     I                   (WDMSFL,MXDSN,WDID)
C
C     + + + PURPOSE + + +
C     save information about a wdm file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,MXDSN
      CHARACTER(4)WDID
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - unit number of new wdm file
C     MXDSN  - maximum allowed dataset number in new file
C     WDID   - identifier of new wdm file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE   'CWDMID.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   IPOS,I
C
C     + + + END SPECIFICATIONS + + +
C
      IPOS = 0
      IF (WIDCNT.GT.0) THEN
C       first make sure this label hasnt already been assigned
        DO 10 I = 1,WIDCNT
          IF (WIDNAM(I).EQ.WDID) THEN
C           already assigned
            IPOS = I
          END IF
 10     CONTINUE
      END IF
C
      IF (IPOS.EQ.0) THEN
C       go ahead and add new one
        WIDCNT        = WIDCNT+ 1
        WIDFUN(WIDCNT)= WDMSFL
        WIDNAM(WIDCNT)= WDID
        IF (WIDCNT .LT. MXWDID) THEN
          WIDBSE(WIDCNT+1)= WIDBSE(WIDCNT) + MXDSN
        END IF
      ELSE
C       just update info for this wdm id
        WIDFUN(IPOS)= WDMSFL
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WUD2ID
     I                   (WDMSFL,DSN,
     O                    ID)
C
C     + + + PURPOSE + + +
C     convert a wdm unit number and dsn to an id
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,DSN,ID
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - unit number of wdm file
C     DSN    - dataset number
C     ID     - id for unit number and dsn
C
C     + + + COMMON BLOCKS + + +
      INCLUDE   'CWDMID.INC'
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER(4) WDID
C
C     + + + EXTERNALS + + +
      EXTERNAL     WUA2ID
C
C     + + + END SPECIFICATIONS + + +
C
      WDID = '    '
      CALL WUA2ID (WDMSFL,DSN,WDID,
     O             ID)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WUA2ID
     I                   (WDMSFL,DSN,WDID,
     O                    ID)
C
C     + + + PURPOSE + + +
C     convert a wdm unit number or 4 char id and dsn to an id
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL,DSN,ID
      CHARACTER(4)WDID
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - unit number of wdm file
C     DSN    - dataset number
C     ID     - id for unit number and dsn
C     WDID   - wdm file identifier
C
C     + + + COMMON BLOCKS + + +
      INCLUDE   'CWDMID.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (WDID.EQ.'    ') THEN
C       calculate id based on wdm file unit number
        I = 0
        ID= 0
 10     CONTINUE
          I = I+ 1
          IF (WDMSFL .EQ. WIDFUN(I)) THEN
            ID = WIDBSE(I)+ DSN
          END IF
        IF (ID.EQ.0 .AND. I.LT.WIDCNT) GO TO 10
      ELSE
C       calculate id based on 4 character identifier
        I = 0
        ID= 0
 20     CONTINUE
          I = I+ 1
          IF (WDID .EQ. WIDNAM(I)) THEN
            ID = WIDBSE(I)+ DSN
          END IF
        IF (ID.EQ.0 .AND. I.LT.WIDCNT) GO TO 20
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WID2UD
     I                   (WDFLG,ID,
     O                    WDMSFL,DSN)
C
C     + + + PURPOSE + + +
C     convert an id to a wdm unit number and dsn
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDFLG,ID,WDMSFL,DSN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDFLG  - wdm unit number flag, > 0 means id is actual dsn
C     ID     - id for unit number and dsn
C     WDMSFL - unit number of wdm file
C     DSN    - dataset number
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER(4)WDID
C
C     + + + EXTERNALS + + +
      EXTERNAL    WID2UA
C
C     + + + END SPECIFICATIONS + + +
C
      CALL WID2UA (WDFLG,ID,
     O             WDMSFL,DSN,WDID)
C
      RETURN
      END
C
C
C
      SUBROUTINE   WID2UA
     I                   (WDFLG,ID,
     O                    WDMSFL,DSN,WDID)
C
C     + + + PURPOSE + + +
C     convert an id to a wdm unit number and dsn and return text id
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDFLG,ID,WDMSFL,DSN
      CHARACTER(4)WDID
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDFLG  - wdm unit number flag, > 0 means id is actual dsn
C     ID     - id for unit number and dsn
C     WDMSFL - unit number of wdm file
C     DSN    - dataset number
C     WDID   - character identifier for wdm file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE   'CWDMID.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + END SPECIFICATIONS + + +
C
      IF (WDFLG .GT. 0) THEN
C       not using this scheme
        WDMSFL= WDFLG
        DSN   = ID
        WDID  = '    '
      ELSE
C       figure out what id
        I  = 0
        J  = 0
 10     CONTINUE
          I = I+ 1
          IF (I .LT. WIDCNT) THEN
            IF (ID .LT. WIDBSE(I+1)) THEN
              J= 1
            END IF
          ELSE
            J= 1
          END IF
          IF (J .EQ. 1) THEN
            WDMSFL= WIDFUN(I)
            DSN   = ID - WIDBSE(I)
            WDID  = WIDNAM(I)
          END IF
        IF (J .EQ. 0) GO TO 10
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   WCH2UD
     I                   (WDID,
     O                    WDMSFL)
C
C     + + + PURPOSE + + +
C     given a 4 character wdm file id, find the wdm file unit number
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     WDMSFL
      CHARACTER(4)WDID
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - unit number of wdm file
C     WDID   - character identifier for wdm file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE   'CWDMID.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + END SPECIFICATIONS + + +
C
      I  = 0
      J  = 0
 10   CONTINUE
        I = I+ 1
        IF (WDID.EQ.WIDNAM(I)) THEN
C         this is the wdm id
          WDMSFL= WIDFUN(I)
          J= 1
        END IF
      IF (J.EQ.0 .AND. I.LT.MXWDID) GO TO 10
C
      RETURN
      END

C
C
C
      SUBROUTINE   WDBOPN
     I                    (WDMSFL,WDNAME,RONWFG,
     O                     RETCOD)
C
C     + + + PURPOSE + + +
C     Open a WDM file.  File is opened as new or old, depending on
C     the value of RONWFG.  The common block related to the WDM record
C     buffer are initialized the first time this routine is called.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      WDMSFL,RONWFG,RETCOD
      CHARACTER(LEN=*) WDNAME
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of the WDM file
C     WDNAME - name of the WDM file
C     RONWFG - read only/new file flag
C              0- normal open of existing WDM file,
C              1- open WDM file as read only (system dependent),
C              2- open new WDM file
C     RETCOD - return code
C               0 - successful open
C               1 - successful open, but invalid WDM file
C              <0 - error on open, -IOSTAT, compiler specific
C
C     + + + SAVES + + +
      INTEGER   INITFG
      SAVE INITFG
      INTEGER   RECRDL
      SAVE RECRDL
C
C     + + + LOCAL VARIABLES + + +
      INTEGER(4)IOS
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDBFIN, WDFLCK, WDCREA
C
C     + + + DATA INITIALIZATIONS + + +
      DATA INITFG/0/
      DATA RECRDL/0/
C
C     + + + END SPECIFICATIONS + + +
C
      RETCOD= 0
C
      IF (RECRDL.EQ.0) THEN
C       first time called, determine compiler flag specific
C       definition of RECL units in OPEN
C
C       create a small file and try to write different size strings
!        OPEN(UNIT=WDMSFL,STATUS='SCRATCH',ACCESS='DIRECT',
!     1       FORM='UNFORMATTED',RECL=4)
        open (unit=WDMSFL, file="temporary.wdm01",
     1    status='REPLACE', form='UNFORMATTED', access='DIRECT', recl=4)

        WRITE(WDMSFL,REC=1,ERR=110) '1234567890123456'
        RECRDL= 512
        GOTO 100
 110    CONTINUE
        WRITE(WDMSFL,REC=1,ERR=120) '12345678'
        RECRDL= 1024
        GOTO 100
 120    CONTINUE
        WRITE(WDMSFL,REC=1,ERR=100) '1234'
        RECRDL= 2048
 100    CONTINUE
        CLOSE(WDMSFL,STATUS='DELETE')
      END IF
C
      IF (RONWFG.EQ.1) THEN
C       open file as 'read only'
        OPEN (UNIT=WDMSFL,FILE=WDNAME,STATUS='OLD',
     1        ACCESS='DIRECT',FORM='UNFORMATTED',RECL=RECRDL,
     2        ERR=10,IOSTAT=IOS)
      ELSE IF (RONWFG.EQ.2) THEN
C       open new wdm file
        OPEN (UNIT=WDMSFL,FILE=WDNAME,STATUS='NEW',
     1        ACCESS='DIRECT',FORM='UNFORMATTED',RECL=RECRDL,
     2        ERR=10,IOSTAT=IOS)
      ELSE
C       open file w/out 'read only'
        OPEN (UNIT=WDMSFL,FILE=WDNAME,STATUS='OLD',
     1        ACCESS='DIRECT',FORM='UNFORMATTED',RECL=RECRDL,
     2        ERR=10,IOSTAT=IOS)
      END IF
C     WDM file opened successfully
      IF (INITFG.EQ.0) THEN
C       first time called, initialize WDM record buffer
        CALL WDBFIN
        INITFG= 1
      END IF
      IF (RONWFG.EQ.2) THEN
C       new file, need to initialize it
        CALL WDCREA (WDMSFL)
      END IF
      IF (RETCOD.EQ.0) THEN
C       check WDM directory records
        CALL WDFLCK (WDMSFL,
     O               RETCOD)
      END IF
      GO TO 20
 10   CONTINUE
C       error on open, exact value of retcod may vary by system,
C       set it to a negative value for consistancy
        RETCOD= IOS
        IF (RETCOD.GT.0) RETCOD= -RETCOD
        IF (RETCOD.EQ.0) RETCOD= -1
 20   CONTINUE
C
      RETURN
      END

C     utchar.f 2.1 9/4/91
C
C
C
      SUBROUTINE   CARVAR
     I                    (LENA, CARY, LENV,
     O                     CVAR)
C
C     + + + PURPOSE + + +
C     Convert a character*1 array of size LENA
C     to a character variable of length LEN.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       LENA, LENV
      CHARACTER(1)  CARY(LENA)
      CHARACTER*(*) CVAR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LENA   - size of input character*1 array
C     CARY   - input character array of size LENA
C     LENV   - length of output character variable
C     CVAR   - output character variable of length LENV
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     L, L1
      CHARACTER(1)BLNK
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  BLNK / ' ' /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (LENA .GE. LENV) THEN
C       copy input array to output string, truncate if necessary
        DO 100 L = 1, LENV
          CVAR(L:L) = CARY(L)
 100    CONTINUE
      ELSE
C       copy input array to output string, pad with blanks as needed
        DO 200 L = 1, LENA
          CVAR(L:L) = CARY(L)
 200    CONTINUE
        L1 = LENA + 1
        DO 220 L = L1, LENV
          CVAR(L:L) = BLNK
 220    CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHDECE
     I                   (LEN,STR,
     O                    RVAL,ERRFLG)
C
C     + + + PURPOSE + + +
C     Convert a character array to its real equivalent.  The
C     real is expected to be right justified in STR.  For an
C     invalid real, ERRFLG is set to 1.  Valid characters are
C     '0' - '9', '+', '-', '.', 'D', and 'E'.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,ERRFLG
      REAL        RVAL
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     STR    - character array containing real value
C     RVAL   - real value
C     ERRFLG - flag indicating success of conversion
C              0 - successful
C              1 - unsuccessful
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      REAL       ERRREA
C
C     + + + FUNCTIONS + + +
      REAL       CHRDEC
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRDEC, NUMINI
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init maching dependent numeric constants (CONST.INC)
      CALL NUMINI
C
      ERRREA = -R0MAX
      RVAL  = CHRDEC (LEN,STR)
      ERRFLG= 0
      IF (RVAL.LE.ERRREA) THEN
C       ivalid real
        ERRFLG= 1
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHINTE
     I                   (LEN,STR,
     O                    IVAL,ERRFLG)
C
C     + + + PURPOSE + + +
C     Convert a character array to its integer equivalent.
C     The integer is expected to be right justified in STR.
C     For an invalid integer, ERRFLG is set to 1.
C     Valid characters are '0' - '9', '+', and '-'.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,ERRFLG,IVAL
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     STR    - character array containing an integer value
C     IVAL   - integer value
C     ERRFLG - flag indicating success of conversion
C              0 - successful
C              1 - unsuccessful
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     DIG,I,SIGN
      CHARACTER(1)CDIG
C
C     + + + FUNCTIONS + + +
      INTEGER     CHRDIG
C
C     + + + EXTERNALS + + +
      EXTERNAL    CHRDIG
C
C     + + + DATA INITIALIZATIONS + + +
C
C     + + + END SPECIFICATIONS + + +
C
      IVAL  = 0
      ERRFLG= 0
      SIGN  = 1
      I = 1
  10  CONTINUE
        CDIG = STR(I)
        IF ((CDIG.EQ.'-' .OR. CDIG.EQ.'+' .OR. CDIG.EQ.' ') .AND.
     1       IVAL.EQ.0) THEN
C         replace blank, - sign, or + sign with a 0 if no number yet
          IF (CDIG.EQ.'-') THEN
C           change sign
            SIGN = -1
          END IF
          CDIG = '0'
        END IF
        DIG = CHRDIG(CDIG)
        IVAL= IVAL* 10+ DIG
        I = I + 1
      IF (I.LE.LEN .AND. DIG.GE.0) GO TO 10
C
      IF (DIG.EQ.-1) THEN
C       invalid integer
        ERRFLG= 1
      END IF
C
      IVAL= IVAL* SIGN
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CHKSTR
     I                           (LEN,NSTR,STR1,STR2)
C
C     Search thru STR2 for a match to the character array STR1.
C     Return the array location of the match, or a zero if there
C     is no match.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,NSTR
      CHARACTER(1)STR1(LEN),STR2(LEN,NSTR)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     NSTR   - number of strings to be compared
C     STR1   - character array of size LEN to search for
C     STR2   - character array of size LEN,NSTR
C              to be searched for a match
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,MAT
C
C     + + + END SPECIFICATIONS + + +
C
      CHKSTR = 0
      J = 1
C
  10  CONTINUE
        I = 1
        MAT = 1
  20    CONTINUE
          IF (STR1(I).NE.STR2(I,J)) MAT = 0
          I = I + 1
        IF (I.LE.LEN.AND.MAT.EQ.1) GO TO 20
        IF (MAT.EQ.1) CHKSTR = J
        J = J + 1
      IF (J.LE.NSTR.AND.CHKSTR.EQ.0) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHRCHR
     I                    (LEN,STR1,
     O                     STR2)
C
C     + + + PURPOSE + + +
C     Copy LEN characters from array STR1 to array STR2.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR1(LEN),STR2(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character arrays
C     STR1   - input character array
C     STR2   - output character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      DO 10 I = 1,LEN
        STR2(I) = STR1(I)
 10   CONTINUE
C
      RETURN
      END
C
C
C
      REAL   FUNCTION   CHRDEC
     I                         (LEN,STR)
C
C     + + + PURPOSE + + +
C     Convert a character array to its real equivalent.  Return
C     a -R0MAX for an invalid array.  The real is expected to
C     be right justified in the array.  Leading blanks are ignored.
C     Trailing blanks are treated as a zero.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of array
C     STR    - character array containing a real value
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     CHKORD(6,6),ERFLG,EXPFLG,KIND,OKIND,POS,FRCFLG
      REAL        DECSGN,EXPSGN,EXPON,FRC,SUM,TEN,TVAL,ERRREA
      CHARACTER(1)DIG
C
C     + + + FUNCTIONS + + +
      REAL      RNOP
      INTEGER   CHRDIG
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRDIG, NUMINI
C
C     + + + DATA INITIALIZATIONS + + +
C
C                   DOWN OKIND, ACROSS KIND
      DATA CHKORD /
     1              1, 2, 0, 4, 0, 6,
     2              1, 2, 0, 4, 0, 6,
     3              1, 2, 3, 0, 0, 6,
     4              0, 0, 3, 4, 0, 6,
     5              1, 2, 0, 0, 0, 6,
     6              0, 0, 0, 0, 0, 0/
C
C     + + + STATEMENT FUNCTION DEFINITIONS + + +
C     No OPperation, used to keep Ryan/McFarland optimization honest
      RNOP(ERRREA) = ERRREA
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init maching dependent numeric constants (CONST.INC)
      CALL NUMINI
C
      ERRREA = -R0MAX
      ERFLG = 0
      EXPFLG = 0
      FRCFLG = 0
      OKIND = 6
      POS = 1
      EXPSGN = 1.0
      DECSGN = 1.0
      TEN = 10.
      FRC = 1.0
      SUM = 0.0
      EXPON = 0.0
C
  10  CONTINUE
        DIG = STR(POS)
        KIND = 0
        IF (DIG.EQ.'+') KIND = 1
        IF (DIG.EQ.'-') KIND = 2
        IF (DIG.EQ.'.') KIND = 3
        IF (DIG .EQ. 'D' .OR. DIG .EQ. 'd' .OR.
     1      DIG .EQ. 'E' .OR. DIG .EQ. 'e') KIND = 4
C       treat a blank as a zero
        IF (DIG.EQ.' ') THEN
          IF (OKIND.EQ.6) THEN
C           leading blank
            KIND = 6
          ELSE
C           not a leading blank - assume zero
            KIND = 5
            TVAL = 0
          END IF
        END IF
C
        IF (KIND.EQ.0) THEN
          TVAL = CHRDIG(DIG)
          IF (TVAL.GE.0.0) KIND = 5
        END IF
C
        IF (KIND.EQ.0) THEN
          ERFLG = 5
        ELSE
          ERFLG = CHKORD(KIND,OKIND)
        END IF
C
 40     CONTINUE
        IF (ERFLG.NE.0) THEN
C         this is a quick exit
          CHRDEC = ERRREA
          RETURN
        END IF
C
        GO TO (110,120,130,140,150,160),KIND
C
 110    CONTINUE
C         process a plus sign
          GO TO 200
C
 120    CONTINUE
C         process a minus sign
          IF (EXPFLG.EQ.0) THEN
            DECSGN = -1.0
          ELSE
            EXPSGN = -1.0
          END IF
          GO TO 200
C
 130    CONTINUE
C         process a decimal point
          IF (EXPFLG.EQ.1) THEN
            ERFLG = 3
            GO TO 40
          END IF
C
C         no fractional exponents allowed
          IF (FRCFLG.EQ.1) THEN
            ERFLG = 3
            GO TO 40
          END IF
C
C         no double decimal point
          FRCFLG = 1
          GO TO 200
C
 140    CONTINUE
C         process an exponent (E, e, D, or d)
          IF (EXPFLG.EQ.1) THEN
            ERFLG = 4
            GO TO 40
          END IF
C
C         no double exponent
          EXPFLG = 1
          GO TO 200
C
 150    CONTINUE
C         process a number
          IF (EXPFLG.EQ.0) THEN
            IF (FRCFLG.EQ.0) THEN
              SUM = (SUM* TEN) + TVAL
            ELSE
              FRC = FRC/ TEN
              FRC = RNOP(FRC)
              SUM = SUM + (FRC* TVAL)
            END IF
          ELSE
            EXPON = (EXPON* TEN) + TVAL
          END IF
          GO TO 200
C
 160    CONTINUE
C         process a leading blank
          GO TO 200
C
 200    CONTINUE
C       repeat until finished
        OKIND = KIND
        POS = POS + 1
      IF (POS.LE.LEN) GO TO 10
      CHRDEC = DECSGN* SUM* TEN** (EXPSGN* EXPON)
C
      RETURN
      END
C
C
C
      DOUBLE PRECISION   FUNCTION   CHRDPR
     I                                    (LEN,STR)
C
C     + + + PURPOSE + + +
C     Convert a character array to its double precision equivalent.
C     Return a -D0MAX for an invalid array.  The double precision
C     is expected to be right justified in the array.  Leading blanks
C     are ignored.  Trailing blanks are treated as a zero.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of array
C     STR    - character array containing a real value
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      REAL(8)     DECSGN,EXPSGN,EXPON,FRC,SUM,TEN,TVAL
      INTEGER     CHKORD(6,6),ERFLG,EXPFLG,KIND,OKIND,POS,FRCFLG
      CHARACTER(1)DIG
      DOUBLE PRECISION  ERRREA
C
C     + + + FUNCTIONS + + +
      INTEGER   CHRDIG
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRDIG, NUMINI
C
C                   DOWN OKIND, ACROSS KIND
      DATA CHKORD /
     1              1, 2, 0, 4, 0, 6,
     2              1, 2, 0, 4, 0, 6,
     3              1, 2, 3, 0, 0, 6,
     4              0, 0, 3, 4, 0, 6,
     5              1, 2, 0, 0, 0, 6,
     6              0, 0, 0, 0, 0, 0/
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init maching dependent numeric constants (CONST.INC)
      CALL NUMINI
C
      ERRREA = -D0MAX
      ERFLG = 0
      EXPFLG = 0
      FRCFLG = 0
      OKIND = 6
      POS = 1
      EXPSGN = 1.0
      DECSGN = 1.0
      TEN = 10.
      FRC = 1.0
      SUM = 0.0
      EXPON = 0.0
C
  10  CONTINUE
        DIG = STR(POS)
        KIND = 0
        IF (DIG.EQ.'+') KIND = 1
        IF (DIG.EQ.'-') KIND = 2
        IF (DIG.EQ.'.') KIND = 3
        IF (DIG .EQ. 'D' .OR. DIG .EQ. 'd' .OR.
     1      DIG .EQ. 'E' .OR. DIG .EQ. 'e') KIND = 4
C       treat a blank as a zero
        IF (DIG.EQ.' ') THEN
          IF (OKIND.EQ.6) THEN
C           leading blank
            KIND = 6
          ELSE
C           not a leading blank - assume zero
            KIND = 5
            TVAL = 0
          END IF
        END IF
C
        IF (KIND.EQ.0) THEN
          TVAL = CHRDIG(DIG)
          IF (TVAL.GE.0.0) KIND = 5
        END IF
C
        IF (KIND.EQ.0) THEN
          ERFLG = 5
        ELSE
          ERFLG = CHKORD(KIND,OKIND)
        END IF
C
 40     CONTINUE
        IF (ERFLG.NE.0) THEN
C         this is a quick exit
          CHRDPR = ERRREA
          RETURN
        END IF
C
        GO TO (110,120,130,140,150,160),KIND
C
 110    CONTINUE
C         process a plus sign
          GO TO 200
C
 120    CONTINUE
C         process a minus sign
          IF (EXPFLG.EQ.0) THEN
            DECSGN = -1.0
          ELSE
            EXPSGN = -1.0
          END IF
          GO TO 200
C
 130    CONTINUE
C         process a decimal point
          IF (EXPFLG.EQ.1) THEN
            ERFLG = 3
            GO TO 40
          END IF
C
C         no fractional exponents allowed
          IF (FRCFLG.EQ.1) THEN
            ERFLG = 3
            GO TO 40
          END IF
C
C         no double decimal point
          FRCFLG = 1
          GO TO 200
C
 140    CONTINUE
C         process an exponent (E, e, D, or d)
          IF (EXPFLG.EQ.1) THEN
            ERFLG = 4
            GO TO 40
          END IF
C
C         no double exponent
          EXPFLG = 1
          GO TO 200
C
 150    CONTINUE
C         process a number
          IF (EXPFLG.EQ.0) THEN
            IF (FRCFLG.EQ.0) THEN
              SUM = (SUM* TEN) + TVAL
            ELSE
              FRC = FRC/ TEN
              SUM = SUM + (FRC* TVAL)
            END IF
          ELSE
            EXPON = (EXPON* TEN) + TVAL
          END IF
          GO TO 200
C
 160    CONTINUE
C         process a leading blank
          GO TO 200
C
 200    CONTINUE
C       repeat until finished
        OKIND = KIND
        POS = POS + 1
      IF (POS.LE.LEN) GO TO 10
      CHRDPR = DECSGN* SUM* TEN** (EXPSGN* EXPON)
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHRDEL
     I                    (LEN,POS,
     M                     STRING)
C
C     + + + PURPOSE + + +
C     Delete the character in array position POS and shift
C     the rest of the array left one position.  The last
C     character in the array is set to blank.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,POS
      CHARACTER(1)STRING(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     POS    - array position of the character to be deleted from STRING
C     STRING - character array of size LEN
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
      IF (POS.LT.LEN) THEN
C       no problem with array dimensions
        DO 10 I = POS,LEN-1
          STRING(I) = STRING(I + 1)
 10     CONTINUE
        STRING(LEN) = ' '
      ELSE IF (POS.EQ.LEN) THEN
C       just delete last character
        STRING(LEN) = ' '
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CHRDIG
     I                           (CHR)
C
C     Convert a single character to an integer. Valid characters
C     are '0' - '9'.  Return -1 for an invalid character.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER(1)CHR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CHR    - a single character
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I
      CHARACTER(1)TDIG(10)
C
C     + + + DATA INITIALIZATIONS + + +
      DATA TDIG  /'0','1','2','3','4','5','6','7','8','9'/
C
C     + + + END SPECIFICATIONS + + +
C
      CHRDIG = -1
      I = 1
  10  CONTINUE
        IF (CHR.EQ.TDIG(I)) CHRDIG = I- 1
        I = I + 1
      IF (CHRDIG.EQ.-1.AND.I.LE.10) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   CHRINS
     I                    (LEN,COL,CHAR,
     M                     STRING)
C
C     + + + PURPOSE + + +
C     Insert the character CHAR into position COL in the
C     array STRING.  First shift the characters in
C     positions COL thru LEN-1 one position to the right.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,COL
      CHARACTER(1)CHAR,STRING(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - output length of character string
C     COL    - position in STRING that CHAR is to be inserted
C     CHAR   - character to be inserted in STRING
C     STRING - character string
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + END SPECIFICATIONS + + +
C
      IF (COL.EQ.LEN) THEN
C       just fill last position
        STRING(LEN) = CHAR
      ELSE IF (COL.EQ.1 .AND. LEN.EQ.2) THEN
C       trap weird dimension case
        STRING(2) = STRING(1)
        STRING(1) = CHAR
      ELSE
C       all ok
        DO 10 I = COL,LEN-1
          J = LEN + COL- I- 1
          STRING(J+1) = STRING(J)
 10     CONTINUE
        STRING(COL) = CHAR
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CHRINT
     I                           (LEN,STR)
C
C     + + + PURPOSE + + +
C     Convert a character array to its integer equivalent.  Return
C     a 0 for an invalid array.  The integer is expected to be
C     right justified in the array.  Leading blanks are ignored.
C     Trailing blanks are treated as a zero.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     STR    - character array containing an integer value
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     ERRINT
C
C     + + + FUNCTIONS + + +
      INTEGER     CRINTE
C
C     + + + EXTERNALS + + +
      EXTERNAL   CRINTE
C
C     + + + END SPECIFICATIONS + + +
C
      ERRINT= 0
      CHRINT= CRINTE(ERRINT,LEN,STR)
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CKNBLK
     I                           (LEN,CBUF)
C
C     + + + PURPOSE + + +
C     Check character array CBUF for all blanks.  Return
C     a zero if all blanks, otherwise return a one.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)CBUF(LEN)
C
C     + + + ARGUMENT DEFINITION + + +
C     LEN    - size of character array
C     CBUF   - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + END SPECIFICATIONS + + +
C
      J = 0
      DO 10 I = 1,LEN
        IF (CBUF(I) .NE. ' ') J = 1
 10   CONTINUE
C
      CKNBLK = J
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CRINTE
     I                           (ERRINT,LEN,STR)
C
C     + + + PURPOSE + + +
C     Convert a character array to its integer equivalent.
C     The integer is expected to be right justified in STR.
C     For an invalid integer, return ERRINT.  Valid characters
C     are '0' - '9', '+', '-', '.', 'D', and 'E'.  Leading
C     blanks are ignored.  Trailing blanks are treated as 0.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER(4)    ERRINT,LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ERRINT - value to be returned fo an invalid array
C     LEN    - size of character array
C     STR    - character array containing an integer value
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     DIG,I,SIGN,ITMP
      CHARACTER(1)CDIG
      LOGICAL     NEARMAX
C
C     + + + FUNCTIONS + + +
      INTEGER     CHRDIG
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRDIG
C
C     + + + END SPECIFICATIONS + + +
C
      ITMP= 0
      SIGN= 1
      I   = 0
      NEARMAX = .FALSE.
  10  CONTINUE
        I   = I + 1
        CDIG= STR(I)
C       replace a blank with a zero
        IF ((CDIG.EQ.'-' .OR. CDIG.EQ.'+' .OR. CDIG.EQ.' ') .AND.
     1       ITMP.EQ.0) THEN
C         replace blank, - sign, or + sign with a 0 if no number yet
          IF (CDIG.EQ.'-') THEN
C           change sign
            SIGN= -1
          END IF
          CDIG = '0'
        END IF
        DIG = CHRDIG(CDIG)
        IF (NEARMAX) THEN
          IF ((DIG .GT. 8) .OR. (DIG .EQ. 8 .AND. SIGN .EQ. 1)) THEN
C            the last digit cannot be greater than 8, and it can only
C            be 8 if the number is negative.
             I = I - 1
             GO TO 20
          END IF
        END IF
        ITMP= ITMP* 10+ DIG
        IF (I.LT.LEN .AND. DIG.GE.0) THEN
          IF (ITMP .EQ. 214748364) THEN
C            right at the border, an additional digit may be possible
             NEARMAX = .TRUE.
          ELSE IF (ITMP .GT. 214748364) THEN
C            no room for another digit, no matter what it is
             GO TO 20
          END IF
          GO TO 10
        END IF
C
 20   CONTINUE
C
      IF (DIG.EQ.-1 .OR. I.LT.LEN) THEN
C       bad conversion
        CRINTE = ERRINT
      ELSE
C       ok conversion
        CRINTE = ITMP* SIGN
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CRINTX
     I                           (LEN,STR)
C
C     + + + PURPOSE + + +
C     Convert a character array to its integer equivalent.
C     The integer is expected to be right justified in STR.
C     For an invalid integer, -999 is returned.  Valid characters
C     are '0' - '9', '+', and '-' .  Leading blanks are ignored.
C     Trailing blanks are treated as 0.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     STR    - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     ERRINT
C
C     + + + FUNCTIONS + + +
      INTEGER     CRINTE
C
C     + + + EXTERNALS + + +
      EXTERNAL   CRINTE
C
C     + + + END SPECIFICATIONS + + +
C
      ERRINT= -999
      CRINTX= CRINTE(ERRINT,LEN,STR)
C
      RETURN
      END
C
C
C
      SUBROUTINE   CTRSTR
     I                    (LEN,
     M                     TITLE)
C
C     + + + PURPOSE + + +
C     Center the characters within the array TITLE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)TITLE(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array, 1 <= LEN <= 132
C     TITLE  - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     L,IE,IS,I,J,K,B,TLEN
      CHARACTER(1)BUFF(132),BLNK
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK/' '/
C
C     + + + END SPECIFICATIONS + + +
C
      TLEN = LEN
      IF (TLEN.GT.132) TLEN = 132
      I = 0
 10   CONTINUE
        I = I + 1
      IF (TITLE(I).EQ.BLNK.AND.I.LT.TLEN) GO TO 10
      IS = I
C     found beginning of non-blanks
C
      I = TLEN + 1
 20   CONTINUE
        I = I - 1
      IF (TITLE(I).EQ.BLNK.AND.I.GT.1) GO TO 20
      IE = I
C     found end of non-blanks
C
      IF (IE.GE.IS) THEN
C       title not all blanks
        L = IE - (IS-1)
        B = (TLEN-L)/2
        DO 30 I = 1,TLEN
          BUFF(I) = TITLE(I)
          TITLE(I) = BLNK
 30     CONTINUE
        DO 40 I = 1,L
          J = B + I
          K = IS + I - 1
          TITLE(J) = BUFF(K)
 40     CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   CVARAR
     I                    (LENV, CVAR, LENA,
     O                     CARY)
C
C     + + + PURPOSE + + +
C     Convert a character variable of length LENV to
C     a character array of size LENA.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       LENV, LENA
      CHARACTER*(*) CVAR
      CHARACTER(1)  CARY(LENA)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LENV   - length of input character variable
C     CVAR   - input character variable of length LENV
C     LENA   - size of output character array
C     CARY   - output character array of size LENA
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   L, L1
      CHARACTER(1)BLNK
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  BLNK  / ' ' /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (LENV .GE. LENA) THEN
C       copy variable to array, truncate if needed
        DO 100 L = 1, LENA
          CARY(L) = CVAR(L:L)
 100    CONTINUE
      ELSE
C       copy variable to array, padding with blanks
        DO 200 L = 1, LENV
          CARY(L) = CVAR(L:L)
 200    CONTINUE
        L1 = LENV + 1
        DO 220 L = L1, LENA
          CARY(L) = BLNK
 220    CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DATCHR
     I                    (YR, MO, DY,
     O                     OLEN, DBUFF)
C
C     + + + PURPOSE + + +
C     Put a date into a character array.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     YR, MO, DY, OLEN
      CHARACTER(1)DBUFF(10)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YR     - year
C     MO     - month
C     DY     - day
C     OLEN   - actual output size of character array
C     DBUFF  - output character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     LEN, LOC, JUST
      CHARACTER(1)SLSH,BLNK
C
C     + + + EXTERNALS + + +
      EXTERNAL    ZIPC, INTCHR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SLSH,BLNK  / '/',' ' /
C
C     + + + END SPECIFICATIONS + + +
C
      JUST= 1
      LOC = 1
      LEN = 10
      CALL ZIPC (LEN,BLNK,DBUFF)
      LEN = 4
      CALL INTCHR( YR, LEN, JUST, OLEN, DBUFF(LOC) )
      LOC = LOC + OLEN
      IF(MO .GT. 0  .AND.  MO .LT. 13) THEN
        DBUFF(LOC) = SLSH
        LOC = LOC + 1
        LEN = 2
        CALL INTCHR( MO, LEN, JUST, OLEN, DBUFF(LOC) )
        LOC = LOC + OLEN
        IF(DY .GT. 0  .AND. DY .LT. 32) THEN
          DBUFF(LOC) = SLSH
          LOC = LOC + 1
          LEN = 2
          CALL INTCHR( DY, LEN, JUST, OLEN, DBUFF(LOC) )
          LOC = LOC + OLEN
        END IF
      END IF
      OLEN = LOC - 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   DATLST
     I                    (DATE,
     O                     DSTRNG,LEN,ERRCOD)
C
C     + + + PURPOSE + + +
C     Put DATE into the character array DSTRNG in the
C     format 1986 FEB. 14 10:30:00.  If hours, minutes,
C     and seconds are all zero, the format is 1986 FEB. 14.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     DATE(6),LEN,ERRCOD
      CHARACTER(1)DSTRNG(21)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE   - date
C     DSTRNG - output character array
C     LEN    - actual number of characters output to character array
C     ERRCOD - flag indicating valid date
C              0 - valid date
C              1 - invalid year
C              2 - invalid month
C              3 - invalid day
C              4 - invalid hour
C              5 - invalid minute
C              6 - invalid second
C              the ERRCOD for the smallest invalid date element is
C              returned, if day and hour are both invalid, a 4 is
C              returned
C
C     + + +   LOCAL VARIABLES   + + +
      INTEGER     JUST,OLEN,LOC,MO,J
      CHARACTER(1)MOCHAR(39),BLNK
C
C     + + + FUNCTIONS + + +
      INTEGER     DAYMON
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR, DAYMON, INTCHR, ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA MOCHAR/'J','A','N',    'F','E','B',    'M','A','R',    'A',
     1            'P','R',    'M','A','Y',    'J','U','N',    'J','U',
     2            'L',    'A','U','G',    'S','E','P',    'O','C','T',
     3                'N','O','V',    'D','E','C',    'E','R','R'    /
      DATA BLNK  /' '/
C
C     + + + END SPECIFICATIONS + + +
C
C     check values
      J= 21
      CALL ZIPC (J,BLNK,DSTRNG)
      ERRCOD = 0
C
      IF (DATE(1).LE.0.OR.DATE(1).GT.2100) ERRCOD = 1
      IF (DATE(2).LE.0.OR.DATE(2).GT.12) ERRCOD = 2
C
      IF (ERRCOD.EQ.0) THEN
        IF (DATE(3).LE.0.OR.DATE(3).GT.DAYMON(DATE(1),DATE(2)))
     1                                                 ERRCOD = 3
        IF (DATE(4).LT.0.OR.DATE(4).GT.24) ERRCOD = 4
        IF (DATE(5).LT.0.OR.DATE(5).GT.60) ERRCOD = 5
        IF (DATE(6).LT.0.OR.DATE(6).GT.60) ERRCOD = 6
C
      END IF
      IF (ERRCOD.EQ.0) THEN
C
C       put date in character array
C       add year
        JUST = 1
        LEN = 4
        LOC = 1
        IF (DATE(1).GT.9999.OR.DATE(1).LT.-999) DATE(1) = 9999
        CALL INTCHR (DATE(1),LEN,JUST,OLEN,DSTRNG(LOC))
        LOC = LOC + OLEN + 1
C
C       add month
        LEN = 3
        MO = 3*(DATE(2)-1) + 1
        IF (MO.LT.1.OR.MO.GT.34) MO = 37
        CALL CHRCHR (LEN,MOCHAR(MO),DSTRNG(LOC))
        LOC = LOC + LEN + 1
C
C       add day
        LEN = 2
        IF (DATE(3).GT.99.OR.DATE(3).LT.-9) DATE(3) = 99
        CALL INTCHR (DATE(3),LEN,JUST,OLEN,DSTRNG(LOC))
        LOC = LOC + OLEN + 1
C
C       add hour
        IF (DATE(4)+DATE(5)+DATE(6) .GT. 0) THEN
          LEN = 2
          IF (DATE(4).GT.99.OR.DATE(4).LT.0) DATE(4) = 99
          IF (DATE(4).LT.10) LEN = 1
          IF (LEN.EQ.1) THEN
            DSTRNG(LOC)= '0'
            LOC = LOC + 1
          END IF
          CALL INTCHR (DATE(4),LEN,JUST,OLEN,DSTRNG(LOC))
          LOC = LOC + OLEN
C
C         add colon
          DSTRNG(LOC)= ':'
          LOC = LOC + 1
C
C         add minute
          LEN = 2
          IF (DATE(5).GT.99.OR.DATE(5).LT.0) DATE(5) = 99
          IF (DATE(5).LT.10) LEN = 1
          IF (LEN.EQ.1) THEN
            DSTRNG(LOC)= '0'
            LOC = LOC + 1
          END IF
          CALL INTCHR (DATE(5),LEN,JUST,OLEN,DSTRNG(LOC))
          LOC = LOC + OLEN
C
C         add colon
          DSTRNG(LOC)= ':'
          LOC = LOC + 1
C
C         add second
          LEN = 2
          IF (DATE(6).GT.99.OR.DATE(6).LT.0) DATE(6) = 99
          IF (DATE(6).LT.10) LEN = 1
          IF (LEN.EQ.1) THEN
            DSTRNG(LOC)= '0'
            LOC = LOC + 1
          END IF
          CALL INTCHR (DATE(6),LEN,JUST,OLEN,DSTRNG(LOC))
          LOC = LOC + OLEN + 1
        END IF
        LEN = LOC - 2
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   DECCHR
     I                    (REAIN, LENGTH,
     M                     JUST,
     O                     JLEN, STR)
C
C
C     + + + PURPOSE + + +
C     This routine converts a real number to a character string.
C     The number is right justified in the string if the flag
C     JUST is zero or if the number requires an exponent,
C     otherwise it is left justified.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      LENGTH, JUST, JLEN
      REAL         REAIN
      CHARACTER(1) STR(LENGTH)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     REAIN  - real value to be converted to a character string
C     LENGTH - available length for output character string
C     JUST   - output justification
C              0 - right justified
C              1 - left justified
C              will be forced to 0 if an exponent is required
C     JLEN   - actual length of output character string
C     STR    - output character string
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C 
C     + + + LOCAL VARIABLES + + + 
      INTEGER      I0, I1, I2, I, J, K, L, M, PREC, EXPO, WHDIGS, 
     $             EXDIGS, FDIGS, NOCNT, KLEN
      REAL         R1, R2, R3, ARTMP, RSUB, MINFIX, MAXFIX, X
      CHARACTER(1) FMTBUF(12), BUF(79),  ZERO,  BLNK,  POINT,  STAR
      CHARACTER(12)FMT
      CHARACTER(79)BUFSTR
      LOGICAL      FLOAT, FRAC, NEG, KILL, NOFIT
C
C     + + + LOCAL DEFINITIONS + + +
C     NOCNT  - for real values less than 1.0, NOCNT is the number of
C              zeros immediately following the decimal point (which
C              "don't count" in terms of the number of significant
C              digits representable by the machine); for real values
C              greater than or equal to 1.0, NOCNT = 0
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (BUF,BUFSTR)
      EQUIVALENCE (FMT,FMTBUF)
C
C     + + + FUNCTIONS + + +
      INTEGER      RWDIGS
      REAL         FPART, RNOP
      LOGICAL      NONZER, NZFRAC
C
C     + + + INTRINSICS + + +
      INTRINSIC    IABS, ABS, ALOG10, REAL, LEN, INDEX, 
     $             INT, AINT, ANINT, NINT
C
C     + + + EXTERNALS + + +
      EXTERNAL     INTCHR, NUMINI, RWDIGS
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  I0, I1, I2, ZERO, BLNK, POINT, STAR
     .    /  0,  1,  2,  '0',  ' ',   '.',  '*' /
C
C     + + + STATEMENT FUNCTION DEFINITIONS + + +
C     absolute value of the FRACtional PART (of a real number)
      FPART(X)  = ABS(X) - ABS(AINT(X))
C     NON-ZERo real number? - true or false  N.B. X should not be < 0.0
      NONZER(X) = X .GT. 0.0
C     Non-Zero FRACtional part of a real number? - true or false
      NZFRAC(X) = NONZER(FPART(X))
C     number of Whole DIGitS - for X > 0;
C     double precision needed in the following to ensure correct calc.
C     of log for DG/UX
Cmyg  WDIGS(X)  = IDINT(DLOG10(DBLE(X*RP1MIN))) + 1 
C     to keep Ryan/McFarland optimization honest
      RNOP(X) = X
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init machine-dependent numeric constants (CONST.INC)
      CALL NUMINI
C
C     save time with the common case of REAIN .eq. 0
      IF (ABS(REAIN) .LE. R0MIN) THEN
         IF (LENGTH .GE. 3) THEN
            BUFSTR = '0.0'
         ELSE IF (LENGTH .EQ. 2) THEN
            BUFSTR = '0.'
         ELSE IF (LENGTH .EQ. 1) THEN
            BUFSTR = '0'
         ELSE
            NOFIT = .TRUE.
         END IF
      ELSE
C
C        the number of decimal digits of precision offered can be found
C        in the variable RPREC of the ICONST common block.
         PREC = RPREC
C
C        is the number negative?  set NEG and define MAXFIX/MINFIX
         IF (REAIN .LT. 0.0) THEN
            NEG = .TRUE.
            MAXFIX = 10.0**(LENGTH-1)
            MINFIX = 1.0/10.0**(LENGTH-1)
         ELSE
            NEG = .FALSE.
            MAXFIX = 10.0**LENGTH
            MINFIX = 1.0/10.0**LENGTH
         END IF
C
C        this copy of the absolute value of the number is used frequently
         ARTMP = ABS(REAIN)
C
C        using scientific notation, how many digits will be in the exponent?
C        the answer will be in EXDIGS.
         R1 = ALOG10(ARTMP*RP1MIN)
C        (RNOP must be used to keep Ryan/McFarland optimization from causing
C        problems.  If RNOP is not used, and RM optimization is turned on,
C        then R1 is left on the stack as an 80-bit number instead of being
C        popped and pushed.)
         R1 = RNOP(R1)
         EXPO = INT(R1)
         IF (R1 .LT. 0.0) THEN
            IF (NZFRAC(R1)) THEN
               EXPO = EXPO - 1
            END IF
         END IF
         IF (EXPO .EQ. 0) THEN
            EXDIGS = 1
         ELSE
            EXDIGS = INT(ALOG10(REAL(IABS(EXPO))*RP1MIN)) + 1
         END IF
C
C        how many digits in the whole part of the number?
         IF (ARTMP .GE. 1.0) THEN
            WHDIGS = RWDIGS(ARTMP)
         ELSE
C           one digit to allow room for 0
            WHDIGS = 1
         END IF
C
         IF (ARTMP.LT.MINFIX .OR. ARTMP.GT.MAXFIX 
     $       .OR. WHDIGS.GT.PREC) THEN
C           use scientific notation
            FLOAT = .FALSE.
C           force right justification with scientific notation
            JUST = 0
         ELSE
C           use floating point notation
            FLOAT  = .TRUE.
C           does the number have a non-zero fractional part?
            FRAC   = NZFRAC(REAIN)
C           here, in the context of a floating point number, EXDIGS is
C           a count of EXtra whole DIGits (not digits in the exponent).
            EXDIGS = 0
            NOCNT  = 0
            IF (FRAC) THEN
C              if the fractional part were rounded, would the number of
C              of whole digits increase?  (EXtra whole DIGitS)
               IF (ANINT(FPART(REAIN)) .GT. 0.0) THEN
C                  IF ((ARTMP+1.0) .GE. 1.0) THEN
                     IF (RWDIGS(ARTMP+1.0) .GT. WHDIGS) EXDIGS = 1
C                  END IF
               END IF
               IF (ARTMP .LT. 1.0) THEN
C                 since there is a non-zero fractional part (FRAC = TRUE),
C                 and the absolute value of the number is less than 1.0,
C                 how many consecutive zeros immediately follow the decimal
C                 point?  The NOCNT (no count) zeros don't count against the
C                 precision available.
                  R1 = ABS(ALOG10(ARTMP*RP1MIN))
                  IF (NZFRAC(R1)) THEN
                     NOCNT = INT (R1)
                  ELSE
                     NOCNT = INT (R1) - 1
                  END IF
               END IF
            END IF
         END IF
C
         IF (FLOAT) THEN
C           using floating point notation
            RSUB = REAIN
C
C           first, assume it's not negative, taking into account the '.':
            FDIGS = LENGTH - (WHDIGS + 1)
            IF (FDIGS-NOCNT .GT. PREC) FDIGS = PREC+NOCNT
C           if it is negative, there will be less room for fractional digits
            IF (NEG) FDIGS = FDIGS - 1
C           if the number of WHole digits is one, it might just be a zero
C           in which case, for purposes of precision, we can consider the
C           number of whole digits to be zero.
            IF (WHDIGS .EQ. 1) THEN
C              if the whole number IS a zero, then maybe it would be better
C              to add an extra digit of precision to the fraction rather than
C              display the zero whole number.  However, don't do this if
C              the precision would be exceeded.
               IF (AINT(ARTMP) .LE. 0.0 .AND. FDIGS.LT.PREC+NOCNT) THEN
                  WHDIGS = 0
C                 we could just add that extra digit of precision to the
C                 fraction, but if it's just zero too, it looks better to
C                 keep the zero to the left of the decimal.
                  IF (FRAC) THEN
C                    r1 gets the number that we had planned to display, but
C                    raised to a power of 10 such that it is a whole number.
                     R1 = ANINT(ARTMP*10.0**FDIGS)
C                    r2 gets a fraction representing digits which we had
C                    not planned to display and r3 is that fraction times 10.
                     R2 = (ARTMP*10.0**FDIGS) - R1
                     R3 = R2*10
C                    now, if 1) the number we were not going to display is,
C                    when rounded, non-zero, or if 2) the number passed in
C                    is negative, but everything we had planned on displaying
C                    was zero, then we add the extra digit of precision.
C                    in the first case, we just end up dropping the zero to
C                    the left of the decimal and adding an extra digit of
C                    precision; in the second case, the extra digit of
C                    precision is added only if the digits that were to be
C                    displayed previously were all zeros and the number
C                    itself is negative, so if the extra digit is zero, it
C                    is displayed to make up for the fact that the negative
C                    sign (for which room has been given) won't be displayed,
C                    but if the extra digit is non-zero, the negative sign
C                    will be displayed and the zero before the decimal will
C                    be lost.
                     IF (NINT(R3).NE.0 .OR. 
     $                  (NEG .AND. R1.LE.1.0E-20)) THEN
                           FDIGS  = FDIGS + 1
                     END IF
                  END IF
C                 if nocnt, the number of zero digits immediately
C                 following the decimal point (which don't count against the
C                 number of digits of precision representable by the machine),
C                 is greater than zero (this can only be the case if the
C                 absolute value of the number is less than one, as here)
C                 then we must ensure that the number of digits displayed
C                 does not exceed the actual machine precision
               END IF
            END IF
C
            IF ((WHDIGS + FDIGS - NOCNT) .GT. PREC) THEN
               FDIGS = PREC - WHDIGS + NOCNT
            END IF
C
            NOFIT = .FALSE.
            FMT = '(F  .  )'
            IF (FDIGS .GT. 0) THEN
C               expensive internal write replaced, but this is what it did
C               WRITE(FMT,96) LENGTH,FDIGS
               CALL INTCHR (LENGTH,I2,I0,KLEN,FMTBUF(3))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(6))
            ELSE IF (FDIGS .EQ. 0) THEN
               RSUB = ANINT (RSUB)
C               expensive internal write replaced, but this is what it did
C               WRITE(FMT,96) LENGTH,FDIGS
               CALL INTCHR (LENGTH,I2,I0,KLEN,FMTBUF(3))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(6))
            ELSE IF (FDIGS .EQ. -1) THEN
               RSUB = ANINT (RSUB)
               FDIGS = 0
C               expensive internal write replaced, but this is what it did
C               WRITE(FMT,96) LENGTH+1,FDIGS
               I = LENGTH + 1
               CALL INTCHR (I,I2,I0,KLEN,FMTBUF(3))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(6))
            ELSE
               NOFIT = .TRUE.
            END IF
C
         ELSE
C           using scientific notation
            RSUB  = REAIN
            NOFIT = .FALSE.
            IF (NEG) THEN
               IF (EXDIGS+5 .LE. LENGTH) THEN
                  FDIGS = LENGTH-(EXDIGS+5)
                  IF (FDIGS+1 .GT. PREC) FDIGS = PREC - 1
               ELSE
                  NOFIT = .TRUE.
               END IF
            ELSE
               IF (EXDIGS+4 .LE. LENGTH) THEN
                  FDIGS = LENGTH-(EXDIGS+4)
                  IF (FDIGS+1 .GT. PREC) FDIGS = PREC - 1
               ELSE
                  NOFIT = .TRUE.
               END IF
            END IF
C            expensive internal write replaced, but this is what it did
C            IF (.NOT. NOFIT) WRITE(FMT,95) LENGTH,FDIGS,EXDIGS
            IF (.NOT. NOFIT) THEN
               FMT = '(1PE  .  E )'
               CALL INTCHR (LENGTH,I2,I0,KLEN,FMTBUF(5))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(8))
               CALL INTCHR (EXDIGS,I1,I0,KLEN,FMTBUF(11))
            END IF
         END IF
C
C        here we either put asterisks or use 'write' to convert the number
         IF (NOFIT) THEN
            JLEN = 0
            DO 400 I = 1,LENGTH
               BUF(I) = STAR
  400       CONTINUE
         ELSE
C           some compilers don't like blanks embedded in the format string
C           as they are now, so first squeeze it together, and then use it
C           to format the given number.
            I = INDEX(FMT,BLNK)
            IF (I .GT. 0) THEN
               J = I
               L = LEN(FMT)
               DO 420 K = I,L
                  IF (FMTBUF(K) .NE. BLNK) THEN
                     FMTBUF(J) = FMTBUF(K)
                     J = J + 1
                  END IF
  420          CONTINUE
               DO 430 K = J,L
                  FMTBUF(K) = BLNK
  430          CONTINUE
            END IF
C
            I = INDEX(FMT,BLNK)
            IF (I .EQ. 0) I = LEN(FMT)
C
            WRITE(BUFSTR,FMT(1:I)) RSUB
C
         END IF
C
C        in either form, at most 1 trailing zero should be left.
C        make J point to the '.' if there is one
         J = INDEX (BUFSTR,POINT)
         IF (FLOAT) THEN
            IF (J .NE. 0) THEN
C              kludge to change " .0" to "0.0" in some cases on some 'chines
               IF ((J-1) .GT. 0) THEN
                  IF (BUF(J-1) .EQ. BLNK) THEN
                     BUF(J-1) = ZERO
                  END IF
               END IF
C              we don't want to truncate any zeros if there's no '.'
C              make K point to the last zero (if there is one)
               I = 0
               K = 0
  510          CONTINUE
               I = INDEX (BUFSTR(K+1:79),ZERO)
               IF (I .NE. 0) THEN
                  K = K + I
                  GO TO 510
               END IF
               KILL = .TRUE.
               IF (K .NE. 79) THEN
C                 only kill zeros that are not significant.  if the last
C                 zero is followed by something other than a blank,
C                 then you can't get rid of it.
                  IF (BUF(K+1) .NE. BLNK) KILL = .FALSE.
               END IF
               IF (K .GT. J+1 .AND. KILL) THEN
C                 only truncate zeros if they're to the right of the decimal
C                 and don't get rid of a zero that is immediately to the
C                 right of the decimal point.
                  DO 520 I = K,J+2,-1
                     IF (BUF(I) .EQ. ZERO) THEN
                        BUF(I) = BLNK
                     ELSE
C                       once a non-zero is found, get out of the loop
                        GO TO 525
                     END IF
  520             CONTINUE
  525             CONTINUE
               END IF
            END IF
         ELSE
C           get rid of trailing zeros in scientific notation
            IF (J .NE. 0) THEN
C              we don't won't to truncate any zeros if there's no '.'
C              make L point to the 'E'
               L = INDEX (BUFSTR,'E')
               IF (L .NE. 0) THEN
C                 make K point to the last digit before the 'E'
                  K = L - 1
                  IF (K .GT. J+1) THEN
C                    only truncate zeros between '.' and 'E', and don't
C                    get rid of the zero (if there is one) immediately to the
C                    right of the decimal.
                     M = J+2
                     DO 620 I = K,J+2,-1
                        IF (BUF(I) .EQ. ZERO) THEN
C                          don't truncate the last trailing zero
                           BUF(I) = BLNK
                        ELSE
                           M = I + 1
                           GO TO 625
                        END IF
  620                CONTINUE
  625                CONTINUE
C                    a non-zero was found, slide the exponent down to
C                    fill in the gap left by the truncated zeros.
                     DO 630 I = M,LENGTH
                        IF (L .LE. LENGTH) THEN
                           BUF(I) = BUF(L)
                        ELSE
                           BUFSTR(I:LENGTH) = BLNK
                           GO TO 635
                        END IF
                        L = L + 1
  630                CONTINUE
  635                CONTINUE
                  END IF
               END IF
            END IF
         END IF
      END IF
C
C     copy the final string, blanks and all
      IF (JUST .NE. 0) THEN
C        left justified (i.e., JUST != 0)
         J = 1
         DO 710 I = 1,LENGTH
            IF (BUF(J) .NE. BLNK) GO TO 715
            J = J + 1
  710    CONTINUE
  715    CONTINUE
         JLEN = INDEX (BUFSTR(J:LENGTH),BLNK)
         IF (JLEN .EQ. 0) THEN
            JLEN = LENGTH - J + 1
         ELSE
            JLEN = JLEN - 1
         END IF
         K = 1
         DO 720 I = J,LENGTH
            STR(K) = BUF(I)
            K = K + 1
  720    CONTINUE
         DO 730 I = K,LENGTH
            STR(I) = BLNK
  730    CONTINUE
      ELSE
C        right justified (i.e., JUST == 0)
         J = LENGTH
         DO 810 I = LENGTH,1,-1
            IF (BUF(J) .NE. BLNK) GO TO 815
            J = J - 1
  810    CONTINUE
  815    CONTINUE
         DO 820 I = 1,LENGTH-J
            STR(I) = BLNK
  820    CONTINUE
         K = 1
         DO 830 I = LENGTH-J+1,LENGTH
            STR(I) = BUF(K)
            K = K + 1
  830    CONTINUE
C        with right justified strings, JLEN is always LENGTH
         JLEN = LENGTH
      END IF
C
      RETURN
C
C      expensive internal writes were replaced, but this is what they did
C  95  FORMAT('(1PE',I2,'.',I2,'E',I1,')')
C  96  FORMAT('(F',I2,'.',I2,')')
C
      END
C
C
C
      SUBROUTINE   DPRCHR
     I                    (DPRIN, LENGTH,
     M                     JUST,
     O                     JLEN, STR)
C
C
C     + + + PURPOSE + + +
C     This routine converts a double precision number to a
C     character string.  The number is right justified in the
C     string if the flag JUST is zero or if the number requires
C     an exponent, otherwise it is left justified.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      LENGTH, JUST, JLEN
      DOUBLE PRECISION  DPRIN
      CHARACTER(1) STR(LENGTH)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DPRIN  - double precision value to be converted to a character string
C     LENGTH - available length for output character string
C     JUST   - output justification
C              0 - right justified
C              1 - left justified
C              will be forced to 0 if an exponent is required
C     JLEN   - actual length of output character string
C     STR    - output character string
C
C     + + + COMMON BLOCKS + + +
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I0, I1, I2, I, J, K, L, M, PREC, EXPO, WHDIGS, 
     $             EXDIGS, FDIGS, NOCNT, KLEN
      DOUBLE PRECISION  R1, R2, R3, ARTMP, RSUB, MINFIX, MAXFIX, X
      CHARACTER(1) FMTBUF(12), BUF(79),  ZERO,  BLNK,  POINT,  STAR
      CHARACTER(12)FMT
      CHARACTER(79)BUFSTR
      LOGICAL      FLOAT, FRAC, NEG, KILL, NOFIT
C
C     + + + LOCAL DEFINITIONS + + +
C     NOCNT  - for values less than 1.0, NOCNT is the number of
C              zeros immediately following the decimal point (which
C              "don't count" in terms of the number of significant
C              digits representable by the machine); for values
C              greater than or equal to 1.0, NOCNT = 0
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (BUF,BUFSTR)
      EQUIVALENCE (FMT,FMTBUF)
C
C     + + + FUNCTIONS + + +
      INTEGER      DWDIGS
      DOUBLE PRECISION  FPART
      LOGICAL      NONZER, NZFRAC
C
C     + + + INTRINSICS + + +
      INTRINSIC    IABS, DABS, DLOG10, DBLE, LEN, INDEX, 
     $             IDINT, DINT, DNINT, IDNINT
C
C     + + + EXTERNALS + + +
      EXTERNAL     INTCHR, NUMINI, DWDIGS
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  I0, I1, I2,  ZERO, BLNK, POINT, STAR
     .    /  0,  1,  2,   '0',  ' ',   '.',  '*' /
C
C     + + + STATEMENT FUNCTION DEFINITIONS + + +
C     absolute value of the FRACtional PART (of a real number)
      FPART(X)  = DABS(X) - DABS(DINT(X))
C     NON-ZERo real number? - true or false  N.B. X should not be < 0.0
      NONZER(X) = X .GT. 0.0
C     Non-Zero FRACtional part of a real number? - true or false
      NZFRAC(X) = NONZER(FPART(X))
C     number of Whole DIGitS - for X > 0
Cmyg  WDIGS(X)  = IDINT(DLOG10(X*DP1MIN)) + 1
C
C     + + + END SPECIFICATIONS + + +
C
C     may need to init machine-dependent numeric constants (CONST.INC)
      CALL NUMINI
C
C     save time with the common case of DPRIN .eq. 0
      IF (DABS(DPRIN) .LE. D0MIN) THEN
         IF (LENGTH .GE. 3) THEN
            BUFSTR = '0.0'
         ELSE IF (LENGTH .EQ. 2) THEN
            BUFSTR = '0.'
         ELSE IF (LENGTH .EQ. 1) THEN
            BUFSTR = '0'
         ELSE
            NOFIT = .TRUE.
         END IF
      ELSE
C
C        the number of decimal digits of precision offered can be found
C        in the variable DPREC of the ICONST common block.
         PREC = DPREC
C
C        is the number negative?  set NEG and define MAXFIX/MINFIX
         IF (DPRIN .LT. 0.0) THEN
            NEG = .TRUE.
            MAXFIX = DBLE(10.0)**(LENGTH-1)
            MINFIX = DBLE(1.0/10.0)**(LENGTH-1)
         ELSE
            NEG = .FALSE.
            MAXFIX = DBLE(10.0)**LENGTH
            MINFIX = DBLE(1.0/10.0)**LENGTH
         END IF
C
C        this copy of the absolute value of the number is used frequently
         ARTMP = DABS(DPRIN)
C
C        using scientific notation, how many digits will be in the exponent?
C        the answer will be in EXDIGS.
         R1 = DLOG10(ARTMP*DP1MIN)
         EXPO = IDINT(R1)
         IF (R1 .LT. 0.0) THEN
            IF (NZFRAC(R1)) THEN
               EXPO = EXPO - 1
            END IF
         END IF
         IF (EXPO .EQ. 0) THEN
            EXDIGS = 1
         ELSE
            EXDIGS = IDINT(DLOG10(DBLE(IABS(EXPO))*DP1MIN)) + 1
         END IF
C
C        how many digits in the whole part of the number?
         IF (ARTMP .GE. 1.0) THEN
            WHDIGS = DWDIGS(ARTMP)
         ELSE
C           one digit to allow room for 0
            WHDIGS = 1
         END IF
C
         IF (ARTMP.LT.MINFIX .OR. ARTMP.GT.MAXFIX
     .      .OR. WHDIGS.GT.PREC) THEN
C           use scientific notation
            FLOAT = .FALSE.
C           force right justification with scientific notation
            JUST = 0
         ELSE
C           use floating point notation
            FLOAT  = .TRUE.
C           does the number have a non-zero fractional part?
            FRAC   = NZFRAC(DPRIN)
C           here, in the context of a floating point number, EXDIGS is
C           a count of EXtra whole DIGits (not digits in the exponent).
            EXDIGS = 0
            NOCNT  = 0
            IF (FRAC) THEN
C              if the fractional part were rounded, would the number of
C              of whole digits increase?  (EXtra whole DIGitS)
               IF (DNINT(FPART(DPRIN)) .GT. 0.0) THEN
C                  IF ((ARTMP+DBLE(1.0)) .GE. 1.0) THEN
                     IF (DWDIGS(ARTMP+DBLE(1.0)) .GT. WHDIGS) EXDIGS = 1
C                  END IF
               END IF
               IF (ARTMP .LT. 1.0) THEN
C                 since there is a non-zero fractional part (FRAC = TRUE),
C                 and the absolute value of the number is less than 1.0,
C                 how many consecutive zeros immediately follow the decimal
C                 point?  The NOCNT (no count) zeros don't count against the
C                 precision available.
                  R1 = DABS(DLOG10(ARTMP*DP1MIN))
                  IF (NZFRAC(R1)) THEN
                     NOCNT = IDINT (R1)
                  ELSE
                     NOCNT = IDINT (R1) - 1
                  END IF
               END IF
            END IF
         END IF
C
         IF (FLOAT) THEN
C           using floating point notation
            RSUB = DPRIN
C
C           first, assume it's not negative, taking into account the '.':
            FDIGS = LENGTH - (WHDIGS + 1)
            IF (FDIGS-NOCNT .GT. PREC) FDIGS = PREC+NOCNT
C           if it is negative, there will be less room for fractional digits
            IF (NEG) FDIGS = FDIGS - 1
C           if the number of WHole digits is one, it might just be a zero
C           in which case, for purposes of precision, we can consider the
C           number of whole digits to be zero.
            IF (WHDIGS .EQ. 1) THEN
C              if the whole number IS a zero, then maybe it would be better
C              to add an extra digit of precision to the fraction rather than
C              display the zero whole number.  However, don't do this if
C              the precision would be exceeded.
               IF (DINT(ARTMP) .LE. 0.0 .AND. FDIGS.LT.PREC+NOCNT) THEN
                  WHDIGS = 0
C                 we could just add that extra digit of precision to the
C                 fraction, but if it's just zero too, it looks better to
C                 keep the zero to the left of the decimal.
                  IF (FRAC) THEN
C                    r1 gets the number that we had planned to display, but
C                    raised to a power of 10 such that it is a whole number.
                     WRITE(99,*) 'ARTMP =',ARTMP
                     WRITE(99,*) 'LENGTH=',LENGTH
                     WRITE(99,*) 'FDIGS =',FDIGS 
                     WRITE(99,*) 'DBLE(10.0)**FDIGS =',DBLE(10.0)**FDIGS
                     WRITE(99,*) 'ARTMP*DBLE(10.0)**FDIGS =',
     $                            ARTMP*DBLE(10.0)**FDIGS
                     WRITE(99,*) 'DNINT(ARTMP*DBLE(10.0)**FDIGS) =',
     $                            DNINT(ARTMP*DBLE(10.0)**FDIGS)
                     WRITE(99,*) '--'
                     WRITE(99,*) ' '
                     R1 = DNINT(ARTMP*DBLE(10.0)**FDIGS)
C                    r2 gets a fraction representing digits which we had
C                    not planned to display and r3 is that fraction times 10.
                     R2 = (ARTMP*DBLE(10.0)**FDIGS) - R1
                     R3 = R2*10
C                    now, if 1) the number we were not going to display is,
C                    when rounded, non-zero, or if 2) the number passed in
C                    is negative, but everything we had planned on displaying
C                    was zero, then we add the extra digit of precision.
C                    in the first case, we just end up dropping the zero to
C                    the left of the decimal and adding an extra digit of
C                    precision; in the second case, the extra digit of
C                    precision is added only if the digits that were to be
C                    displayed previously were all zeros and the number
C                    itself is negative, so if the extra digit is zero, it
C                    is displayed to make up for the fact that the negative
C                    sign (for which room has been given) won't be displayed,
C                    but if the extra digit is non-zero, the negative sign
C                    will be displayed and the zero before the decimal will
C                    be lost.
                     IF (IDNINT(R3).NE.0 .OR. 
     .                  (NEG .AND. R1.LE.1.0D-20)) THEN
                           FDIGS  = FDIGS + 1
                     END IF
                  END IF
C                 if nocnt, the number of zero digits immediately
C                 following the decimal point (which don't count against the
C                 number of digits of precision representable by the machine),
C                 is greater than zero (this can only be the case if the
C                 absolute value of the number is less than one, as here)
C                 then we must ensure that the number of digits displayed
C                 does not exceed the actual machine precision
               END IF
            END IF
C
            IF ((WHDIGS + FDIGS - NOCNT) .GT. PREC) THEN
               FDIGS = PREC - WHDIGS + NOCNT
            END IF
C
            NOFIT = .FALSE.
            FMT = '(F  .  )'
            IF (FDIGS .GT. 0) THEN
C               expensive internal write replaced, but this is what it did
C               WRITE(FMT,96) LENGTH,FDIGS
               CALL INTCHR (LENGTH,I2,I0,KLEN,FMTBUF(3))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(6))
            ELSE IF (FDIGS .EQ. 0) THEN
               RSUB = DNINT (RSUB)
C               expensive internal write replaced, but this is what it did
C               WRITE(FMT,96) LENGTH,FDIGS
               CALL INTCHR (LENGTH,I2,I0,KLEN,FMTBUF(3))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(6))
            ELSE IF (FDIGS .EQ. -1) THEN
               RSUB = DNINT (RSUB)
               FDIGS = 0
C               expensive internal write replaced, but this is what it did
C               WRITE(FMT,96) LENGTH+1,FDIGS
               I = LENGTH + 1
               CALL INTCHR (I,I2,I0,KLEN,FMTBUF(3))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(6))
            ELSE
               NOFIT = .TRUE.
            END IF
C
         ELSE
C           using scientific notation
            RSUB  = DPRIN
            NOFIT = .FALSE.
            IF (NEG) THEN
               IF (EXDIGS+5 .LE. LENGTH) THEN
                  FDIGS = LENGTH-(EXDIGS+5)
                  IF (FDIGS+1 .GT. PREC) FDIGS = PREC - 1
               ELSE
                  NOFIT = .TRUE.
               END IF
            ELSE
               IF (EXDIGS+4 .LE. LENGTH) THEN
                  FDIGS = LENGTH-(EXDIGS+4)
                  IF (FDIGS+1 .GT. PREC) FDIGS = PREC - 1
               ELSE
                  NOFIT = .TRUE.
               END IF
            END IF
C            expensive internal write replaced, but this is what it did
C            IF (.NOT. NOFIT) WRITE(FMT,95) LENGTH,FDIGS,EXDIGS
            IF (.NOT. NOFIT) THEN
               FMT = '(1PE  .  E )'
               CALL INTCHR (LENGTH,I2,I0,KLEN,FMTBUF(5))
               CALL INTCHR (FDIGS,I2,I0,KLEN,FMTBUF(8))
               CALL INTCHR (EXDIGS,I1,I0,KLEN,FMTBUF(11))
            END IF
         END IF
C
C        here we either put asterisks or use 'write' to convert the number
         IF (NOFIT) THEN
            JLEN = 0
            DO 400 I = 1,LENGTH
               BUF(I) = STAR
  400       CONTINUE
         ELSE
C           some compilers don't like blanks embedded in the format string
C           as they are now, so first squeeze it together, and then use it
C           to format the given number.
            I = INDEX(FMT,BLNK)
            IF (I .GT. 0) THEN
               J = I
               L = LEN(FMT)
               DO 420 K = I,L
                  IF (FMTBUF(K) .NE. BLNK) THEN
                     FMTBUF(J) = FMTBUF(K)
                     J = J + 1
                  END IF
  420          CONTINUE
               DO 430 K = J,L
                  FMTBUF(K) = BLNK
  430          CONTINUE
            END IF
C
            I = INDEX(FMT,BLNK)
            IF (I .EQ. 0) I = LEN(FMT)
C
            WRITE(BUFSTR,FMT(1:I)) RSUB
C
         END IF
C
C        in either form, at most 1 trailing zero should be left.
C        make J point to the '.' if there is one
         J = INDEX (BUFSTR,POINT)
         IF (FLOAT) THEN
            IF (J .NE. 0) THEN
C              kludge to change " .0" to "0.0" in some cases on some 'chines
               IF ((J-1) .GT. 0) THEN
                  IF (BUF(J-1) .EQ. BLNK) THEN
                     BUF(J-1) = ZERO
                  END IF
               END IF
C              we don't want to truncate any zeros if there's no '.'
C              make K point to the last zero (if there is one)
               I = 0
               K = 0
  510          CONTINUE
               I = INDEX (BUFSTR(K+1:79),ZERO)
               IF (I .NE. 0) THEN
                  K = K + I
                  GO TO 510
               END IF
               KILL = .TRUE.
               IF (K .NE. 79) THEN
C                 only kill zeros that are not significant.  if the last
C                 zero is followed by something other than a blank,
C                 then you can't get rid of it.
                  IF (BUF(K+1) .NE. BLNK) KILL = .FALSE.
               END IF
               IF (K .GT. J+1 .AND. KILL) THEN
C                 only truncate zeros if they're to the right of the decimal
C                 and don't get rid of a zero that is immediately to the
C                 right of the decimal point.
                  DO 520 I = K,J+2,-1
                     IF (BUF(I) .EQ. ZERO) THEN
                        BUF(I) = BLNK
                     ELSE
C                       once a non-zero is found, get out of the loop
                        GO TO 525
                     END IF
  520             CONTINUE
  525             CONTINUE
               END IF
            END IF
         ELSE
C           get rid of trailing zeros in scientific notation
            IF (J .NE. 0) THEN
C              we don't won't to truncate any zeros if there's no '.'
C              make L point to the 'E'
               L = INDEX (BUFSTR,'E')
               IF (L .NE. 0) THEN
C                 make K point to the last digit before the 'E'
                  K = L - 1
                  IF (K .GT. J+1) THEN
C                    only truncate zeros between '.' and 'E', and don't
C                    get rid of the zero (if there is one) immediately to the
C                    right of the decimal.
                     M = J+2
                     DO 620 I = K,J+2,-1
                        IF (BUF(I) .EQ. ZERO) THEN
C                          don't truncate the last trailing zero
                           BUF(I) = BLNK
                        ELSE
                           M = I + 1
                           GO TO 625
                        END IF
  620                CONTINUE
  625                CONTINUE
C                    a non-zero was found, slide the exponent down to
C                    fill in the gap left by the truncated zeros.
                     DO 630 I = M,LENGTH
                        IF (L .LE. LENGTH) THEN
                           BUF(I) = BUF(L)
                        ELSE
                           BUFSTR(I:LENGTH) = BLNK
                           GO TO 635
                        END IF
                        L = L + 1
  630                CONTINUE
  635                CONTINUE
                  END IF
               END IF
            END IF
         END IF
      END IF
C
C     copy the final string, blanks and all
      IF (JUST .NE. 0) THEN
C        left justified (i.e., JUST != 0)
         J = 1
         DO 710 I = 1,LENGTH
            IF (BUF(J) .NE. BLNK) GO TO 715
            J = J + 1
  710    CONTINUE
  715    CONTINUE
         JLEN = INDEX (BUFSTR(J:LENGTH),BLNK)
         IF (JLEN .EQ. 0) THEN
            JLEN = LENGTH - J + 1
         ELSE
            JLEN = JLEN - 1
         END IF
         K = 1
         DO 720 I = J,LENGTH
            STR(K) = BUF(I)
            K = K + 1
  720    CONTINUE
         DO 730 I = K,LENGTH
            STR(I) = BLNK
  730    CONTINUE
      ELSE
C        right justified (i.e., JUST == 0)
         J = LENGTH
         DO 810 I = LENGTH,1,-1
            IF (BUF(J) .NE. BLNK) GO TO 815
            J = J - 1
  810    CONTINUE
  815    CONTINUE
         DO 820 I = 1,LENGTH-J
            STR(I) = BLNK
  820    CONTINUE
         K = 1
         DO 830 I = LENGTH-J+1,LENGTH
            STR(I) = BUF(K)
            K = K + 1
  830    CONTINUE
C        with right justified strings, JLEN is always LENGTH
         JLEN = LENGTH
      END IF
C
      RETURN
C
C      expensive internal writes were replaced, but this is what they did
C  95  FORMAT('(1PE',I2,'.',I2,'E',I1,')')
C  96  FORMAT('(F',I2,'.',I2,')')
C
      END
C
C
C
      INTEGER   FUNCTION   RWDIGS
     I                           (RVAL)
C
C     + + + PURPOSE + + +
C     Determines number of whole digits in input argument.  Used
C     for real values greater than zero.
C
C     + + + DUMMY ARGUMENTS + + +
      REAL         RVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RVAL   - real value
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      LOGVAL
C
C     + + + INTRINSICS + + +
      INTRINSIC    INT, ALOG10
C
C     + + + END SPECIFICATIONS + + +
C
      LOGVAL = INT(ALOG10(RVAL))
      IF (.NOT. (RVAL.GE.10.**LOGVAL .AND. RVAL.LT.10.**(LOGVAL+1)))
     $  LOGVAL = LOGVAL + 1
C
      RWDIGS = LOGVAL + 1
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   DWDIGS
     I                           (DVAL)
C
C     + + + PURPOSE + + +
C     Determines number of whole digits in input argument.  Used
C     for double precision values greater than zero.
C
C     + + + DUMMY ARGUMENTS + + +
      DOUBLE PRECISION  DVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DVAL   - double precision value
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      LOGVAL
C
C     + + + INTRINSICS + + +
      INTRINSIC    IDINT, DLOG10
C
C     + + + END SPECIFICATIONS + + +
C
      LOGVAL = IDINT(DLOG10(DVAL))
      IF (.NOT. (DVAL.GE.10.D0**LOGVAL .AND. DVAL.LT.10.D0**(LOGVAL+1)))
     $  LOGVAL = LOGVAL + 1
C
      DWDIGS = LOGVAL + 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   DECCHX
     I                    (REAIN,LEN,SIGDIG,DECPLA,
     O                     STR)
C
C     + + + PURPOSE + + +
C     Right justifies the real number REAIN into the
C     character array STR of size LEN.  The number will have
C     SIGDIG significant digits and DECPLA decimal places.
C     If the number will not fit into STR as specified, it
C     will be output using an exponent.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,SIGDIG,DECPLA
      REAL        REAIN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     REAIN  - real value to be converted to a character array
C     LEN    - available size for output character array
C     SIGDIG - significant digits for output
C     DECPLA - number of decimal places for output
C               0 - no decimal places
C              <0 - force exponential output
C     STR    - output character array
C
C     + + + COMMON BLOCKS + + +
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I,J,K,L,JUST,TSDIG,DPTFG,LDZRO,ITMP,MCRY,FORCE,
     1             LDECPL,EXPFLG,FRSTD,L20,L1
      REAL         RWRIT
      CHARACTER(20)UBBUF
      CHARACTER(9) UFMTL
      CHARACTER(1) UFMT(9),USBUF(20),C1
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (UBBUF,USBUF),(UFMTL,UFMT)
C
C     + + + FUNCTIONS + + +
      INTEGER      CHRDIG
      CHARACTER(1) DIGCHR
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR, CHRDIG, DIGCHR, INTCHR, CHRDEL, CHRINS
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  L1,L20/1,20/,  C1/'1'/
C
C     + + + END SPECIFICATIONS + + +
C
      TSDIG= SIGDIG
      IF (TSDIG.EQ.0) TSDIG= 5
C
      IF (DECPLA.LT.0) THEN
C       force exponential instead of zero
        FORCE = 1
        LDECPL= -DECPLA
      ELSE
C       dont force exponential
        FORCE = 0
        LDECPL= DECPLA
      END IF
      JUST= 0
C
      UFMT(1)= '('
      UFMT(2)= ' '
      UFMT(3)= ' '
      UFMT(4)= 'F'
      I= 2
      CALL INTCHR (LEN,I,JUST,J,UFMT(5))
      UFMT(7)= '.'
      UFMT(8)= DIGCHR(LDECPL)
      UFMT(9)= ')'
C
      WRITE (UBBUF,UFMTL) REAIN
      IF (CHRDIG(USBUF(1)).LT.0.AND.USBUF(1).NE.' '.AND.
     1    USBUF(1).NE.'.'     .AND.USBUF(1).NE.'-') THEN
C       real number didn't fit in user specified format, try E
        EXPFLG = 1
      ELSE IF (FORCE.EQ.1) THEN
C       check to see if value written is zero
        READ (UBBUF,UFMTL) RWRIT
Chnb is following condition appropriate (for extremely large magnitude numbers
Chnb that might have a large absolute difference?)
        IF ((ABS(RWRIT).LT.1.0E-10).OR.ABS(RWRIT-REAIN).GT.1.E-6)
     1    EXPFLG= 1
      ELSE
C       no exponent needed here
        EXPFLG = 0
      END IF
      IF (EXPFLG.EQ.1) THEN
C       try exponential format
        UFMT(2)= '1'
        UFMT(3)= 'P'
        UFMT(4)= 'E'
        I= LEN- 6
        IF (REAIN.LT.0) I= I- 1
        IF (TSDIG-1.LT.I) THEN
C         don't want too many digits in exp output
          I= TSDIG- 1
        END IF
        UFMT(8)= DIGCHR(I)
        WRITE (UBBUF,UFMTL) REAIN
      ELSE IF (TSDIG.GT.0) THEN
C       it fit, remove insignificant digits, if any
        I= 0
        J= 0
        DPTFG= 0
        LDZRO= 1
        FRSTD= 0
 10     CONTINUE
          I= I+ 1
C         have we passed the decimal point
          IF (USBUF(I).EQ.'.') THEN
            DPTFG= I
          ELSE
C           are we on a digit?
            ITMP= CHRDIG(USBUF(I))
            IF (ITMP.GT.0.OR.(ITMP.EQ.0.AND.LDZRO.EQ.0)) THEN
C             set counter for first 0-9 digit
              IF (FRSTD .EQ. 0) FRSTD= I
              LDZRO= 0
C             J is counter for significant digits
              J= J+ 1
              IF (J.GT.TSDIG) THEN
C               we have enough significant digits
                IF (ITMP.GE.5.AND.J.EQ.TSDIG+1) THEN
C                 we need to carry from the first insig digit
                  K= I- 1
C                 K is next digit back
 20               CONTINUE
                    IF (K.EQ.DPTFG) K= K-1
                    L= CHRDIG(USBUF(K))+ 1
                    IF (L.EQ.10) THEN
                      IF (K .EQ. FRSTD) THEN
C                       need to shift over since 9 rounded to 10
                        CALL CHRINS (L20,K,C1,USBUF)
                        MCRY = 0
                        L = 0
                        IF (USBUF(1) .EQ. ' ') THEN
C                         shift back if 1st char blank
                          CALL CHRDEL (L20, L1, USBUF)
                          FRSTD = FRSTD - 1
                        ELSE
C                         can't shift so reset pointers
                          I = I + 1
                          K = K + 1
                        END IF
                      ELSE
                        MCRY= 1
                        L= 0
                      END IF
                    ELSE
                      MCRY= 0
                    END IF
                    USBUF(K)= DIGCHR(L)
                    K= K- 1
                  IF (MCRY.EQ.1) GO TO 20
                END IF
C               now get rid of insig digits
                IF (DPTFG.EQ.0) THEN
C                 before the decimal point
                  USBUF(I)= '0'
                ELSE
C                 after the decimal point
                  USBUF(I)= ' '
                END IF
              END IF
            END IF
          END IF
        IF (I.LT.LEN) GO TO 10
      END IF
C
C     fill in output buffer
      CALL CHRCHR (LEN,USBUF,STR)
C
      RETURN
      END
C
C
C
      CHARACTER(1)FUNCTION   DIGCHR
     I                             (DIG)
C
C     Convert a single digit to a character.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DIG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DIG    - digit to be converted to a character
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I
      CHARACTER(1)TDIG(9),TZERO
C
C     + + + DATA INITIALIZATIONS + + +
      DATA TDIG  /'1','2','3','4','5','6','7','8','9'/
      DATA TZERO /'0'/
C
C     + + + END SPECIFICATIONS + + +
C
      I = 1
      DIGCHR = TZERO
  10  CONTINUE
        IF (I.EQ.DIG) DIGCHR = TDIG(I)
        I = I + 1
      IF (I.LT.10.AND.DIGCHR.EQ.TZERO) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   INTCHR
     I                    (INTIN,LENA,JUST,
     O                     JLEN,STRNG)
C
C     + + + PURPOSE + + +
C     Convert the integer number INTIN to a character array.
C     The number will be right justified in the array if the
C     flag JUST is zero, otherwise is will be left justified.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LENA,INTIN,JLEN,JUST
      CHARACTER(1)STRNG(LENA)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INTIN  - integer value to be converted to a character array
C     LENA   - available size for output character array
C     JUST   - output justification
C              0 - right justified in the field
C              1 - left justified in the field
C     JLEN   - actual number of characters output to character array
C     STRNG  - output character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,IM,IST,NUMCHR, LEN
      INTEGER(4)  JTMP1,JTMP2,PTEN,CHKSIZ,REMTMP,INTTMP
      CHARACTER(1)BLNK,ZERO,MINUS,FILCHR,STR(9)
C
C     + + + FUNCTIONS + + +
      CHARACTER(1)DIGCHR
C
C     + + + INTRINSICS + + +
      INTRINSIC   ALOG10, INT, MOD, REAL
C
C     + + + EXTERNALS + + +
      EXTERNAL    DIGCHR, ZIPC, COPYC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  MINUS, BLNK, ZERO, FILCHR
     &     /  '-',  ' ',  '0',    '*' /
C
C     + + + END SPECIFICATIONS + + +
C
      INTTMP = INTIN
      LEN  = LENA
      IF (LEN.GT.9) LEN = 9
      CALL ZIPC (LEN,BLNK,STR)
      IF (INTTMP.EQ.0) THEN
C       process zero
        IF (JUST.EQ.0) THEN
          STR(LEN) = ZERO
          JLEN = LEN
        ELSE
          STR(1) = ZERO
          JLEN = 1
        END IF
      ELSE
        IST = 1
        IF (INTTMP.LT.0) THEN
          IST   = 2
          INTTMP= -INTTMP
          STR(1)= MINUS
        END IF
Chnb  guess what, the integral portion of the log base 10 of a number
Chnb  like 9,999,999 is different than that for 9,999,999*1.00001
Chnb  (therefore, the following code won't work!)
        NUMCHR = INT (ALOG10(REAL(INTTMP)*1.00001))
        IF (JUST.EQ.0) THEN
          JLEN = LEN
        ELSE
          JLEN = NUMCHR + IST
          IF (JLEN.GT.LEN) JLEN = LEN
        END IF
C                 **** ADDED BECAUSE OF HP BUG IN SSB #5838 ***
        JTMP1 = 10
        JTMP2 = (JLEN - IST + 1)
C       IF (JTMP2.GT.4) WRITE (*,'("INTCHR,JTMP2:",I8)') JTMP2
        PTEN = JTMP1** JTMP2
        CHKSIZ = INTTMP- PTEN
        IF (CHKSIZ.GE.0) THEN
C         resulting string will be too long- fill with stars
          CALL ZIPC (JLEN,FILCHR,STR)
        ELSE
Chnb  Enough is enough.  I hadn't said anything to this point, but
Chnb  filling the character array with the most significant digit
Chnb  first is just too ridiculous.  Change this to
Chnb  "DO 130 I = JLEN,IST,-1" or something like that.
          DO 130 I = IST, JLEN
            PTEN = PTEN/ 10
            REMTMP = MOD(INTTMP,PTEN)
            IM = (INTTMP-REMTMP)/PTEN
            STR(I) = DIGCHR(IM)
            IM = I- 1
            IF (IM.GT.0) THEN
              IF (STR(I).EQ.ZERO) THEN
                IF (STR(IM).EQ.BLNK.OR.STR(IM).EQ.MINUS) THEN
                  STR(I) = STR(IM)
                  STR(IM)= BLNK
                END IF
              END IF
            ELSE
              IF (STR(1).EQ.ZERO) STR(1) = BLNK
            END IF
            INTTMP = REMTMP
 130      CONTINUE
        END IF
      END IF
C
      CALL ZIPC ( LENA, BLNK, STRNG )
      IF (LEN .EQ. LENA) THEN
C       available field length within max allowed length
        CALL COPYC ( LEN, STR, STRNG )
      ELSE IF (JUST .NE. 0) THEN
C       available field length bigger than max, left justify
        CALL COPYC ( LEN, STR, STRNG )
      ELSE
C       available field length bigger than max, right justify
        I = LENA - LEN + 1
        CALL COPYC (LEN, STR, STRNG(I) )
      END IF
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   LENSTR
     I                           (LEN,STR)
C
C     Return the actual length of the character array,
C     excluding trailing blanks.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array
C     STR    - character array
C
C     + + + LOCAL VARIALBES + + +
      INTEGER     LENT,DONE
C
C     + + + END SPECIFICATIONS + + +
C
      DONE = 0
      LENT = LEN
  10  CONTINUE
        IF (STR(LENT).EQ.' ') THEN
          LENT = LENT- 1
        ELSE
          DONE = 1
        END IF
      IF (LENT.GT.0.AND.DONE.EQ.0) GO TO 10
C
      LENSTR= LENT
C
      RETURN
      END
C
C
C
      SUBROUTINE   LFTSTR
     I                    (LEN,
     M                     TITLE)
C
C     + + + PURPOSE + + +
C     Left justify characters in the array TITLE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)TITLE(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array, 1 <= LEN <= 132
C     TITLE  - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     L,IS,I,K,TLEN
      CHARACTER(1)BUFF(132),BLNK
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK/' '/
C
C     + + + END SPECIFICATIONS + + +
C
      TLEN = LEN
      IF (TLEN.GT.132) TLEN = 132
      I = 0
 10   CONTINUE
        I = I + 1
      IF (TITLE(I).EQ.BLNK.AND.I.LT.TLEN) GO TO 10
      IF (TITLE(I).EQ.BLNK.AND.I.EQ.TLEN) I= I+ 1
      IS = I
C     found beginning of non-blanks
C
      IF (IS.LE.TLEN .AND. IS.NE.1) THEN
C       title not all blanks and not currently left justified
        L = TLEN - (IS-1)
        DO 30 I = 1,TLEN
          BUFF(I) = TITLE(I)
          TITLE(I)= BLNK
 30     CONTINUE
        DO 40 I = 1,L
          K = IS + I - 1
          TITLE(I) = BUFF(K)
 40     CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTLIN
     I                    (DATE,NUMDSN,DATA,WDTH,SGFD,DPLA,THRSH,
     O                     OLEN,TBUFF)
C
C     + + + PURPOSE + + +
C     Convert DATE and an array of real numbers into a character array.
C
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     NUMDSN,DATE(6),WDTH,OLEN,SGFD,DPLA
      REAL        DATA(NUMDSN), THRSH(2)
      CHARACTER(1)TBUFF(250)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE   - date
C     NUMDSN - number of data values to output ( 1 <= NUMDSN <= 30 )
C     DATA   - array of NUMDSN data values to be output
C     WDTH   - output width ( <= 250 )
C     SGFD   - significant digits for output
C     DPLA   - number of decimal places for output
C     THRSH  - limits for output
C              (1) - minimum value
C              (2) - maximum value
C     OLEN   - actual number of characters output to TBUFF
C     TBUFF  - output character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,IPOS,ERRFLG,JUST,J,LEN,ID
      CHARACTER(1)BLNK, STAR
C
C     + + + EXTERNALS + + +
      EXTERNAL   DATLST, DECCHR, DECCHX
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK/' '/,  STAR/'*'/
C
C     + + + END SPECIFICATIONS + + +
C
      DO 10 I = 1,WDTH
        TBUFF(I) = BLNK
 10   CONTINUE
      ID = 23
C     ID is position date end and data starts in ID+1
      JUST = 0
      IPOS = 2
      CALL DATLST (DATE,TBUFF(IPOS),OLEN,ERRFLG)
C
      IF (DATE(3).LT.10) THEN
C       shift date string if day  < 10
        DO 12 I = 1,11
          J = ID - I
          TBUFF(J) = TBUFF(J-1)
 12     CONTINUE
        TBUFF(11) = BLNK
      END IF
C
      IPOS = ID
      LEN = (WDTH-22)/NUMDSN
      IF (LEN.GT.12) LEN = 12
      DO 20 I = 1,NUMDSN
        IF (DATA(I).LT.THRSH(1).OR.DATA(I).GT.THRSH(2)) THEN
C         DO 16 J = 2,LEN
C           TBUFF(IPOS-2+J) = BLNK
C16       CONTINUE
          TBUFF(IPOS-2+LEN) = STAR
        ELSE
          IF (DPLA .LT. 0) THEN
            CALL DECCHR (DATA(I),LEN,JUST,OLEN,TBUFF(IPOS))
          ELSE
            CALL DECCHX (DATA(I),LEN,SGFD,DPLA,TBUFF(IPOS))
          END IF
        END IF
        IPOS = IPOS + LEN
 20   CONTINUE
      OLEN = IPOS - 1
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTLNO
     I                    (DATE,NUMDSN,DATA,WDTH,SGFD,DPLA,DTFG,
     O                     OLEN,TBUFF)
C
C     + + + PURPOSE + + +
C     Convert DATE and an array of real numbers into a character array.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     NUMDSN,DATE(6),WDTH,OLEN,SGFD,DPLA,DTFG(NUMDSN)
      REAL        DATA(NUMDSN)
      CHARACTER(1)TBUFF(250)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DATE   - date
C     NUMDSN - number of data values to output ( 1 <= NUMDSN <= 30 )
C     DATA   - array of NUMDSN data values to be output
C     WDTH   - output width ( <= 250 )
C     SGFD   - significant digits for output
C     DPLA   - number of decimal places for output
C     DTFG   - array of indicator flag to include data value
C              0 - leave field blank
C              1 - convert data to character
C     OLEN   - actual number of characters output to TBUFF
C     TBUFF  - output character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,IPOS,ERRFLG,JUST,J,LEN,ID
      CHARACTER(1)BLNK
C
C     + + + EXTERNALS + + +
      EXTERNAL   DATLST, DECCHR, DECCHX, ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  BLNK
     #    /  ' '/
C
C     + + + END SPECIFICATIONS + + +
C
      CALL ZIPC ( WDTH, BLNK, TBUFF )
      ID = 23
C     ID is position date end and data starts in ID+1
      JUST = 0
      IPOS = 2
      CALL DATLST (DATE,TBUFF(IPOS),OLEN,ERRFLG)
C
      IF (DATE(3).LT.10) THEN
C       shift date string if day  < 10
        DO 12 I = 1,11
          J = ID - I
          TBUFF(J) = TBUFF(J-1)
 12     CONTINUE
        TBUFF(11) = BLNK
      END IF
C
      IPOS = ID
      LEN = (WDTH-22)/NUMDSN
      IF (LEN.GT.12) LEN = 12
      DO 20 I = 1,NUMDSN
        IF (DTFG(I) .EQ. 0) THEN
          TBUFF(IPOS-2+LEN) = BLNK
        ELSE
          IF (DPLA .LT. 0) THEN
            CALL DECCHR (DATA(I),LEN,JUST,OLEN,TBUFF(IPOS))
          ELSE
            CALL DECCHX (DATA(I),LEN,SGFD,DPLA,TBUFF(IPOS))
          END IF
        END IF
        IPOS = IPOS + LEN
 20   CONTINUE
      OLEN = IPOS - 1
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   STRFND
     I                          (LEN,STR,FLEN,FSTR)
C
C     Return the position in the array STR of size LEN that
C     the array FSTR of size FLEN occurs.  If FSTR is not
C     found, a zero is returned.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN,FLEN
      CHARACTER(1)STR(LEN),FSTR(FLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array being searched
C     STR    - character array to be searched
C     FLEN   - size of character array to search for
C     FSTR   - character array to be searched for
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,FNDPOS
C
C     + + + END SPECIFICATIONS + + +
C
      FNDPOS= 0
      IF (FLEN.LE.LEN) THEN
        I= 0
        J= 0
 10     CONTINUE
          J= 0
 20       CONTINUE
            I= I+ 1
            J= J+ 1
            IF (J.EQ.FLEN.AND.STR(I).EQ.FSTR(J)) FNDPOS= I- FLEN+ 1
          IF (STR(I).EQ.FSTR(J).AND.FNDPOS.EQ.0.AND.J.LT.FLEN) GO TO 20
          I= I- J+ 1
        IF (I.LT.LEN-FLEN+1.AND.FNDPOS.EQ.0) GO TO 10
      END IF
C
      STRFND= FNDPOS
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   STRLNX
     I                           (NPTS,BUFF)
C
C     Return the number of characters in the array BUFF, including
C     imbedded blanks and excluding leading and trailing blanks.
C     A value of 1 is returned for all blanks.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     NPTS
      CHARACTER(1)BUFF(NPTS)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NPTS   - size of the character array
C     BUFF   - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     K,KE,KB
      CHARACTER(1)BLNK
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK/' '/
C
C     + + + END SPECIFICATIONS + + +
C
      K = 1
 5    CONTINUE
        IF (BUFF(K).NE.BLNK) GO TO 6
        K = K + 1
      IF (K.LE.NPTS) GO TO 5
 6    CONTINUE
      KB = K -1
C
      K = NPTS
 7    CONTINUE
        IF (BUFF(K).NE.BLNK) GO TO 8
        K = K - 1
      IF (K.GE.1) GO TO 7
 8    CONTINUE
      KE = K
C
      K= KE- KB
      IF (K.LE.0) K=1
      STRLNX = K
C
      RETURN
      END
C
C
C
      SUBROUTINE   ZLJUST
     M                   (STRING)
C
C     + + + PURPOSE + + +
C     Remove leading blanks from a character variable.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER STRING*(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     STRING - character variable to left jusfify
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J,K,L
C
C     + + + INTRINSICS + + +
      INTRINSIC   LEN
C
C     + + + END SPECIFICATIONS + + +
C
      IF (STRING(1:1) .EQ. ' ') THEN
C       has at least 1 leading blank
        L = LEN(STRING)
        I = 0
 10     CONTINUE
C         loop to look for other leading blanks
          I= I+ 1
        IF (I.LT.L .AND. STRING(I:I).EQ.' ') GO TO 10
C       remove leading blanks
Chnb  some compilers (OTG) complain about "STRING= STRING(I:L)", so ...
        K = 1
        DO 15, J=I,L
           STRING(K:K) = STRING(J:J)
           K = K + 1
 15     CONTINUE
        STRING(K:) = ' '
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTSTR
     I                    (FUNIT,LEN,STR)
C
C     + + + PURPOSE + + +
C     Write a character array to the given file unit.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     FUNIT,LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FUNIT  - Fortran unit number for output
C     LEN    - size of character array
C     STR    - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J
C
C     + + + FUNCTIONS + + +
      INTEGER     LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL   LENSTR
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (250A1)
C
C     + + + END SPECIFICATIONS + + +
C
      IF (LEN.GT.0) THEN
C       output string, then cr/lf
        J = LENSTR( LEN, STR )
        WRITE (FUNIT,2000) (STR(I),I=1,J)
      ELSE
C       only write a cr/lf
        WRITE (FUNIT,2000)
      END IF
C
      RETURN
      END
C
C
C
      INTEGER FUNCTION   ZLNTXT
     I                          (STRING)
C
C     + + + PURPOSE + + +
C     Determine length of text in a character variable,
C     i.e., the index of the last non-blank or non-null character.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER STRING*(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     STRING - character variable
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,DONFG
      CHARACTER(1)NULL,CTMP
C
C     + + + INTRINSICS + + +
      INTRINSIC   LEN, CHAR
C
C     + + + END SPECIFICATIONS + + +
C
      NULL = CHAR(0)
      I    = LEN(STRING)
      DONFG= 0
      IF (I.GT.0) THEN
C       string is not all blanks
 10     CONTINUE
          CTMP= STRING(I:I)
          IF (CTMP.EQ.' ' .OR. CTMP.EQ.NULL) THEN
C           still nothing useful
            I= I- 1
          ELSE
C           a character
            DONFG= 1
          END IF
        IF (I.GT.0 .AND. DONFG.EQ.0) GOTO 10
      END IF
C
      ZLNTXT= I
C
      RETURN
      END
C
C
C
      SUBROUTINE   ZTRIM
     M                  (STRING)
C
C     + + + PURPOSE + + +
C     Remove embeded blanks in a character variable
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER STRING*(*)
C
C      + + + ARGUMENT DEFINITIONS + + +
C     STRING - character variable having blanks removed
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
      CHARACTER(255) TEMP
C
C     + + + INTRINSICS + + +
      INTRINSIC   LEN
C
C     + + + END SPECIFICATIONS + + +
C
      J = 0
      DO 100 I = 1, LEN(STRING)
C       look at each char
        IF (STRING(I:I) .NE. ' ') THEN
C         not blank, save it
          J = J + 1
          TEMP(J:J) = STRING(I:I)
        END IF
 100  CONTINUE
C
      IF (J .GT. 0) THEN
C       not all blank, return string with no blanks
        STRING = TEMP(1:J)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   QUPCAS
     I                    (LEN,
     M                     STRING)
C
C     + + + PURPOSE + + +
C     To convert a character string from lower case to upper case
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STRING(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - length of character string
C     STRING - character string to be made upper case
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,ICH
C
C     + + + INTRINSICS + + +
      INTRINSIC  ICHAR, MOD, CHAR
C
C     + + + END SPECIFICATIONS + + +
C
      DO 10 I = 1, LEN
        ICH= ICHAR(STRING(I))
        ICH= MOD(ICH,128)
        IF (ICH.GE.97 .AND. ICH.LE.122) THEN
C         character is lower case
          STRING(I)= CHAR(ICH-32)
        END IF
 10   CONTINUE
C
      RETURN
      END
C
C
C
      INTEGER   FUNCTION   CKNBLV
     I                           (LEN,CBUF)
C
C     + + + PURPOSE + + +
C     Check character array CBUF for all blanks.  Return
C     a zero if all blanks, otherwise return position in
C     character array of first non-blank character.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)CBUF(LEN)
C
C     + + + ARGUMENT DEFINITION + + +
C     LEN    - size of character array
C     CBUF   - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I,J
C
C     + + + END SPECIFICATIONS + + +
C
      I = 0
      J = 0
 10   CONTINUE
        I = I+ 1
        IF (CBUF(I) .NE. ' ') J = I
      IF (I.LT.LEN .AND. J.EQ.0) GO TO 10
C
      CKNBLV = J
C
      RETURN
      END
C
C
C
      SUBROUTINE   RHTSTR
     I                    (LEN,
     M                     TITLE)
C
C     + + + PURPOSE + + +
C     Right justify characters in the array TITLE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)TITLE(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - size of character array, 1 <= LEN <= 132
C     TITLE  - character array
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     IS,I,TLEN,I1,I2
      CHARACTER(1)BLNK
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK/' '/
C
C     + + + END SPECIFICATIONS + + +
C
C     find number of blanks on the right
      TLEN = LEN
      IF (TLEN.GT.132) TLEN = 132
      I = TLEN + 1
 10   CONTINUE
        I = I - 1
      IF (TITLE(I).EQ.BLNK.AND.I.GT.1) GO TO 10
      IS = I
C     found end of non-blanks
C
      IF (IS.LT.TLEN) THEN
C       title not currently right justified
        DO 30 I = 1,IS
          I1 = TLEN - I + 1
          I2 = IS - I + 1
          TITLE(I1) = TITLE(I2)
 30     CONTINUE
        DO 40 I = 1,TLEN-IS
          TITLE(I) = BLNK
 40     CONTINUE
      END IF
C
      RETURN
      END   
C
C
C
      SUBROUTINE   ADCOMA
     I                   (LEN,
     M                    STR)
C
C     + + + PURPOSE + + +
C     This routine places a comma(s) in the real number in the string
C     every 3 digits.  String may include sign, decimal point, and
C     decimal digits.  If there is not enough room in the string, the
C     string is returned as it was entered.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     LEN
      CHARACTER(1)STR(LEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LEN    - length of the string
C     STR    - character string of a decimal number
C
C     + + + PARAMETERS + + + 
      INTEGER   MAXTMP
      PARAMETER (MAXTMP=50)
C 
C     + + + LOCAL VARIABLES + + + 
      INTEGER   LOC,I1,NEG,SHFT,OLEN,I,IDIG,IOLD,INEW,JUST
      CHARACTER(1)TEMP(MAXTMP),DOT,MINUS,BLNK
C
C     + + + FUNCTIONS + + + 
      INTEGER  LENSTR, STRFND
C
C     + + + EXTERNAL + + + 
      EXTERNAL  LENSTR, LFTSTR, RHTSTR, STRFND, ZIPC, COPYC
C
C     + + + DATA INITIALIZATIONS + + + 
      DATA MINUS/'-'/,  DOT/'.'/,  BLNK/' '/, I1/1/
C
C     + + + END SPECIFICATIONS + + + 
C
C     check if right of left justified
      IF (STR(LEN) .EQ. ' ') THEN
C       assume string was left justified
        JUST = 0
      ELSE
        JUST = 1
      END IF
C     shift to left
      CALL LFTSTR (LEN,STR)
C     locate position of decimal point if any
      LOC = STRFND (LEN,STR,I1,DOT)
C     check for minus sign
      IF (STR(1) .EQ. MINUS) THEN               
        NEG = 1
      ELSE
        NEG = 0
      END IF
C     determine length of string
      OLEN = LENSTR (LEN,STR) 
C     reset LOC for cases of no decimal point
      IF (LOC .LE. 0) LOC = OLEN + 1
C     determine number of commas needed, 10000 or greater
      SHFT = (LOC-2-NEG)/3
C     blank out temp buffer
      CALL ZIPC (MAXTMP,BLNK,TEMP)        
C
      IF (OLEN+SHFT .LE. LEN) THEN
C       sufficient room for commas
        IF (OLEN+SHFT .LE. MAXTMP) THEN
C         sufficient room for temp buffer
          IDIG = 0
          DO 10 I = 1,OLEN
C           loop thru the character string, right to left
C           IOLD is position in string without commas
C           INEW is position in string with commas
            IOLD = OLEN - I + 1
            INEW = IOLD + SHFT
            IF (IOLD .GE. LOC) THEN
C             found decimal digit or point, just shift over
              TEMP(INEW) = STR(IOLD)
            ELSE IF (STR(IOLD) .EQ. '-') THEN
C             INEW should be equal to IOLD because SHFT should be 0
              TEMP(INEW) = STR(IOLD)
            ELSE IF (IDIG  .LT. 3) THEN
C             within cluster of 3, not ready to add comma
              TEMP(INEW) = STR(IOLD)
C             count digits
              IDIG = IDIG + 1
            ELSE
C             must be time to add a comma, IDIG = 3
              TEMP(INEW) = ','
              TEMP(INEW-1) = STR(IOLD)
              IDIG = 1
              SHFT = SHFT - 1
            END IF
 10       CONTINUE
C
C         replace with new string
          CALL COPYC (LEN,TEMP,STR)
          IF (JUST .EQ. 1 .AND. LEN .GT. SHFT+OLEN) THEN
C           was right justified and blank spaces remain
C           so right justify
            CALL RHTSTR (LEN,STR)
          END IF
        END IF
      END IF
C
      RETURN
      END                   

f2py3.6 --overwrite-signature -m _wdm_lib -h wdm_template.pyf \
                   DTTM90.f TSBUFR.f UTCHAR.f UTCP90.f UTDATE.f UTNUMB.f \
                   UTWDMD.f UTWDMF.f UTWDT1.f WDATM1.f WDATM2.f WDATRB.f \
                   WDBTCH.f WDMESS.f WDMID.f WDOP.f WDTMS1.f WDTMS2.f    \
                   only: \
                   timcvt timdif wdbopn wdbsac wdbsai wdbsar wdbsgc wdbsgi \
                   wdbsgr wdckdt wdflcl wdlbax wdtget wdtput wtfndt wddsrn \
                   wddsdl wddscl

## Need to tell f2py which subroutine arguments are actually output.
#sed -i -e 's/integer :: retcod/integer intent(out) :: retcod/g' \
#       -e 's/integer :: psa/integer intent(out) :: psa/g' \
#       -e 's/integer, optional,check(len(saval)>=salen),depend(saval) :: salen=len(saval)/integer depend(saval) :: salen/g' \
#       -e 's/integer :: tdsfrc/integer intent(out) :: tdsfrc/g' \
#       -e 's/integer dimension(6) :: sdat/integer intent(out), dimension(6) :: sdat/g' \
#       -e 's/integer dimension(6) :: edat/integer intent(out), dimension(6) :: edat/g' \
#       -e 's/integer :: nvals/integer intent(out) :: nvals/g' \
#       -e 's/real dimension(nval) :: rval/real intent(out), dimension(nval), depend(nval) :: rval/g' \
#       -e 's/integer depend(saval) :: salen/integer intent(in) :: salen/g' \
#       -e 's/dimension(salen) :: saval/intent(in), dimension(salen) :: saval/g' \
#       wdm.pyf
